#include <bits/stdc++.h>
#define MAXN 2600
#define INF 1000000000

struct Point{long long x, y;} v[1 + MAXN];
bool cmpx(Point A, Point B){return A.x < B.x;}
struct Elem{int ind; long long x, y;};
bool cmptg(Elem A, Elem B){
    if((A.y < 0 && B.y >= 0) || (A.y >= 0 && B.y < 0)) return A.x * B.y < B.x * A.y;
    else return A.x * B.y > B.x * A.y;
}
bool eqtg(Elem A, Elem B){return A.x * B.y == B.x * A.y;}
std::vector <Elem> V, W;
int main(){
    FILE*fi,*fo;
    //fi = fopen("a.in","r");
    //fo = fopen("a.out","w");
    fi = stdin;
    fo = stdout;
    int n;
    fscanf(fi,"%d", &n);
    for(int i = 1; i <= 2 * n; i++) fscanf(fi,"%lld%lld", &v[i].x, &v[i].y);
    int p = 1, q, r, s;
    for(int q = 2; q <= 2 * n; q++){
        if(q == 2) r = 3;
        else r = 2;
        for(int s = 1; s <= 2 * n; s++) if(p != s && q != s && r != s){
            Point a = v[p], b = v[q], c = v[r], d = v[s];
            ///x * e + f = g
            long long e = (b.y - a.y) * (d.x - c.x) - (d.y - c.y) * (b.x - a.x);
            long long f = -a.x * (b.y - a.y) * (d.x - c.x) + c.x * (d.y - c.y) * (b.x - a.x);
            long long g = (c.y - a.y) * (b.x - a.x) * (d.x - c.x);
            g -= f;
            if(e == 0 || g % e != 0) continue;
            else{
                long long x = g / e;
                if(((x - a.x) * (b.y - a.y)) % (b.x - a.x) != 0) continue;
                long long y = a.y + ((x - a.x) * (b.y - a.y)) / (b.x - a.x);

                W.clear();
                int ok = 1;
                for(int j = 1; j <= 2 * n; j++){
                    long long xrel = v[j].x - x;
                    long long yrel = v[j].y - y;
                    if(xrel == 0 && yrel == 0) ok = 0;
                    if(yrel != 0) W.push_back({j, xrel, yrel});
                    else if(xrel > 0) W.push_back({j, INF, 1});
                    else W.push_back({j, INF, 1});
                }
                std::sort(W.begin(), W.end(), cmptg);
                for(int i = 0; i + 1 <= W.size() - 1 && ok; i += 2){
                    if(!eqtg(W[i], W[i + 1])) ok = 0;
                    if(i + 1 < W.size() - 1 && eqtg(W[i + 1], W[i + 2])) ok = 0;
                }
                if(ok){
                    fprintf(fo,"Yes\n%lld %lld", x, y);
                    return 0;
                }
            }
        }
    }

    /*std::sort(v + 1, v + 2 * n + 1, cmpx);
    Point leftmost = v[1];
    for(int i = 2; i <= 2 * n; i++){
        long long xrel = v[i].x - leftmost.x;
        long long yrel = v[i].y - leftmost.y;
        if(yrel != 0) V.push_back({i, xrel, yrel});
        else if(xrel > 0) V.push_back({i, INF, 1});
        else V.push_back({i, -INF, 1});
    }
    std::sort(V.begin(), V.end(), cmptg);
    auto leftmostpair = V[n - 1];
    if(eqtg(V[n - 2], V[n - 1]) || eqtg(V[n - 1], V[n])){
        fprintf(fo,"No");
        return 0;
    }
    printf("%lld %lld\n", leftmost.x, leftmost.y);
    printf("%lld %lld\n", v[leftmostpair.ind].x, v[leftmostpair.ind].y);
    Point a = v[1], b = v[leftmostpair.ind];
    for(int i = 0; i < n - 1; i++){
        Point c = v[V[n].ind], d = v[V[i].ind];
        ///x * e + f = g
        long long e = (b.y - a.y) * (d.x - c.x) - (d.y - c.y) * (b.x - a.x);
        long long f = -a.x * (b.y - a.y) * (d.x - c.x) + c.x * (d.y - c.y) * (b.x - a.x);
        long long g = (c.y - a.y) * (b.x - a.x) * (d.x - c.x);
        g -= f;
        if(g % e != 0) continue;
        else{
            long long x = g / e;
            if(((x - a.x) * (b.y - a.y)) % (b.x - a.x) != 0) continue;
            long long y = a.y + ((x - a.x) * (b.y - a.y)) / (b.x - a.x);
            W.clear();
            for(int j = 1; j <= 2 * n; j++){
                long long xrel = v[j].x - x;
                long long yrel = v[j].y - y;
                if(yrel != 0) W.push_back({i, xrel, yrel});
                else if(xrel > 0) W.push_back({i, INF, 1});
                else W.push_back({i, INF, 1});
            }
            std::sort(W.begin(), W.end(), cmptg);
            //for(int i = 0; i < W.size(); i++) printf("%lld %lld\n", W[i].x, W[i].y);
            int ok = 1;
            for(int i = 0; i + 1 <= W.size() - 1 && ok; i += 2){
                if(!eqtg(W[i], W[i + 1])) ok = 0;
                if(i + 1 < W.size() - 1 && eqtg(W[i + 1], W[i + 2])) ok = 0;
            }
            if(ok){
                fprintf(fo,"Yes\n%lld %lld", x, y);
                return 0;
            }
        }
    }*/
    fprintf(fo,"No");
    return 0;
}
