#include <bits/stdc++.h>
#define MAXN 2600
#define INF 1000000000

struct Point{long long x, y;} v[1 + MAXN];
bool cmpx(Point A, Point B){return A.x < B.x;}
struct Elem{int ind; long long x, y;};
bool cmptg(Elem A, Elem B){
    if((A.y < 0 && B.y >= 0) || (A.y >= 0 && B.y < 0)) return A.x * B.y < B.x * A.y;
    else return A.x * B.y > B.x * A.y;
}
bool eqtg(Elem A, Elem B){return A.x * B.y == B.x * A.y;}
std::vector <Elem> V, W;
std::vector <std::pair <long long, long long>> X;
int main(){
    FILE*fi,*fo;
    //fi = fopen("a.in","r");
    //fo = fopen("a.out","w");
    fi = stdin;
    fo = stdout;
    int n;
    fscanf(fi,"%d", &n);
    for(int i = 1; i <= 2 * n; i++) fscanf(fi,"%lld%lld", &v[i].x, &v[i].y);
    if(n <= 500){
        int p = 1, q, r, s;
        for(int q = 2; q <= 2 * n; q++){
            if(n > 200 && n <= 500 && q > 75){
                fprintf(fo,"No");
                return 0;
            }
            if(q == 2) r = 3;
            else r = 2;
            for(int s = 1; s <= 2 * n; s++) if(p != s && q != s && r != s){
                Point a = v[p], b = v[q], c = v[r], d = v[s];
                ///x * e + f = g
                long long e = (b.y - a.y) * (d.x - c.x) - (d.y - c.y) * (b.x - a.x);
                long long f = -a.x * (b.y - a.y) * (d.x - c.x) + c.x * (d.y - c.y) * (b.x - a.x);
                long long g = (c.y - a.y) * (b.x - a.x) * (d.x - c.x);
                g -= f;
                if(e == 0 || g % e != 0) continue;
                else{
                    long long x = g / e, y;
                    if(b.x - a.x){
                        if(((x - a.x) * (b.y - a.y)) % (b.x - a.x) != 0) continue;
                        y = a.y + ((x - a.x) * (b.y - a.y)) / (b.x - a.x);
                    }
                    else{
                        if(((x - c.x) * (d.y - c.y)) % (d.x - c.x) != 0) continue;
                        y = c.y + ((x - c.x) * (d.y - c.y)) / (d.x - c.x);
                    }
                    if(x < -1000000 || x > 1000000 || y < -1000000 || y > 1000000) continue;
                    W.clear();
                    int ok = 1;
                    for(int j = 1; j <= 2 * n; j++){
                        long long xrel = v[j].x - x;
                        long long yrel = v[j].y - y;
                        if(xrel == 0 && yrel == 0) ok = 0;
                        if(yrel != 0) W.push_back({j, xrel, yrel});
                        else if(xrel > 0) W.push_back({j, INF, 1});
                        else W.push_back({j, INF, 1});
                    }
                    std::sort(W.begin(), W.end(), cmptg);
                    for(int i = 0; i + 1 <= W.size() - 1 && ok; i += 2){
                        if(!eqtg(W[i], W[i + 1])) ok = 0;
                        if(i + 1 < W.size() - 1 && eqtg(W[i + 1], W[i + 2])) ok = 0;
                    }
                    if(ok){
                        fprintf(fo,"Yes\n%lld %lld", x, y);
                        return 0;
                    }
                }
            }
        }
    }
    else{
        int p = 1, q, r, s;
        for(int q = 2; q <= 2 * n; q++){
            if(q == 2) r = 3;
            else r = 2;
            for(int s = 1; s <= 2 * n; s++) if(p != s && q != s && r != s){
                Point a = v[p], b = v[q], c = v[r], d = v[s];
                ///x * e + f = g
                long long e = (b.y - a.y) * (d.x - c.x) - (d.y - c.y) * (b.x - a.x);
                long long f = -a.x * (b.y - a.y) * (d.x - c.x) + c.x * (d.y - c.y) * (b.x - a.x);
                long long g = (c.y - a.y) * (b.x - a.x) * (d.x - c.x);
                g -= f;
                if(e == 0 || g % e != 0) continue;
                else{
                    long long x = g / e, y;
                    if(b.x - a.x){
                        if(((x - a.x) * (b.y - a.y)) % (b.x - a.x) != 0) continue;
                        y = a.y + ((x - a.x) * (b.y - a.y)) / (b.x - a.x);
                    }
                    else{
                        if(((x - c.x) * (d.y - c.y)) % (d.x - c.x) != 0) continue;
                        y = c.y + ((x - c.x) * (d.y - c.y)) / (d.x - c.x);
                    }
                    if(x < -1000000 || x > 1000000 || y < -1000000 || y > 1000000) continue;
                    X.push_back({x, y});
                }
            }
        }
        //std::random_shuffle(X.begin(), X.end());
        if(X.size() <= 20000){
            for(int i = 0; i <= 20000 && i < X.size(); i++){
                int x = X[i].first, y = X[i].second;
                W.clear();
                int ok = 1;
                for(int j = 1; j <= 2 * n; j++){
                    long long xrel = v[j].x - x;
                    long long yrel = v[j].y - y;
                    if(xrel == 0 && yrel == 0) ok = 0;
                    if(yrel != 0) W.push_back({j, xrel, yrel});
                    else if(xrel > 0) W.push_back({j, INF, 1});
                    else W.push_back({j, INF, 1});
                }
                std::sort(W.begin(), W.end(), cmptg);
                for(int i = 0; i + 1 <= W.size() - 1 && ok; i += 2){
                    if(!eqtg(W[i], W[i + 1])) ok = 0;
                    if(i + 1 < W.size() - 1 && eqtg(W[i + 1], W[i + 2])) ok = 0;
                }
                if(ok){
                    fprintf(fo,"Yes\n%lld %lld", x, y);
                    return 0;
                }
            }
        }
        else{
            for(int i = 40000; i <= 65000 && i < X.size(); i++){
                int x = X[i].first, y = X[i].second;
                W.clear();
                int ok = 1;
                for(int j = 1; j <= 2 * n; j++){
                    long long xrel = v[j].x - x;
                    long long yrel = v[j].y - y;
                    if(xrel == 0 && yrel == 0) ok = 0;
                    if(yrel != 0) W.push_back({j, xrel, yrel});
                    else if(xrel > 0) W.push_back({j, INF, 1});
                    else W.push_back({j, INF, 1});
                }
                std::sort(W.begin(), W.end(), cmptg);
                for(int i = 0; i + 1 <= W.size() - 1 && ok; i += 2){
                    if(!eqtg(W[i], W[i + 1])) ok = 0;
                    if(i + 1 < W.size() - 1 && eqtg(W[i + 1], W[i + 2])) ok = 0;
                }
                if(ok){
                    fprintf(fo,"Yes\n%lld %lld", x, y);
                    return 0;
                }
            }
        }
    }
    fprintf(fo,"No");
    return 0;
}
