# include <cstdio>
# include <vector>
# include <queue>
# include <algorithm>

using namespace std;

const int MAX_N = 2e5 + 10;

int n;

int c[MAX_N];

vector <int> v[MAX_N];

int mi[MAX_N], sum[MAX_N], sz[MAX_N];

long long ans;

bool cmp (pair <int, int> aa, pair <int, int> bb)
{
	return (aa.first > bb.first || (aa.first == bb.first && aa.second < bb.second));
}

void dfs (int x)
{
	if (!v[x].size ())
	{
		sz[x] = 1;
		sum[x] = c[x];
		mi[x] = c[x];
		return;
	}
	
	priority_queue <pair <int, int>> pq;
	
	int i, j, mi1 = v[x][0], mi2 = v[x][0];
	for (i = 0; i < (int) v[x].size (); i ++)
	{
		dfs (v[x][i]);
		sum[x] += sum[v[x][i]];
		sz[x] += sz[v[x][i]];
		pq.push ({sz[v[x][i]], v[x][i]});
		if (mi[v[x][i]] < mi[v[x][mi1]])
			mi1 = v[x][i];
	}

	if (mi1 == v[x][0])
		mi2 = v[x][1];
	for (i = 0; i < (int) v[x].size (); i ++)
		if (mi[v[x][i]] < mi[v[x][mi2]] && v[x][i] != mi1)
			mi2 = v[x][i];
	
	ans += sum[x];		
	
	while (pq.size () >= 2)
	{
		pair <int, int> a = pq.top ();
		pq.pop ();
		pair <int, int> b = pq.top ();
		
		///printf ("%d %d %d %d -+-+\n", a.first, a.second, b.first, b.second);
		pq.pop ();
		a.first -= b.first;
		if (a.first)
			pq.push (a);
	}
	
	
	///printf ("%d %lld --- %d %d %d %d %d %d\n", x, ans, mi1, mi2, sz[mi1], sz[x], mi[mi1], mi[mi2]);
	///printf ("%lld\n", ans);
	
	if (!pq.empty ())
	{
		pair <int, int> xx = pq.top ();
		///printf ("### %d %d\n", xx.first, xx.second);
		
		pq.pop ();
		
		if (xx.second != mi1)
			ans += xx.first * mi[mi1];
		else
		{
			long long var1 = xx.first * mi[mi2];
			long long var2 = 0;
			
			sz[mi1] --;
			vector <pair <int, int>> t;
			for (i = 0; i < (int) v[x].size (); i ++)
				if (v[x][i] != mi1)
					t.push_back ({sz[v[x][i]], v[x][i]});
			t.push_back ({0, 0});
			
			sort (t.begin (), t.end (), cmp);
			
			long long csum = 0;
			
			
			for (i = 0; i < (int) t.size (); i ++)
			{
				csum += t[i].first;
				if (csum - (i + 1) * t[i].first > sz[mi1])
					break;
			}
			
			if (i == t.size ())
				var2 += (sz[mi1] + 1) * mi[mi2];
			else
			{
				int ff = 0;
				for (j = 0; j < i; j ++)
				{
					ff += t[j].first - t[i - 1].first;
					t[j].first = t[i - 1].first;
				}
				int kk = (sz[mi1] - ff) / i;
				for (j = 0; j < i; j ++)
					t[j].first -= kk;
				
				ff += i * kk;
				
				while (!pq.empty ())
					pq.pop ();
				
				for (j = 0; j < i && ff > 0; j ++, ff --)
					t[j].first --;
				
				for (i = 0; i < (int) t.size (); i ++)
					if (t[j].first)
						pq.push (t[j]);
					
				while (pq.size () >= 2)
				{
					pair <int, int> a = pq.top ();
					pq.pop ();
					pair <int, int> b = pq.top ();
					pq.pop ();
					a.first -= b.first;
					if (a.first)
						pq.push (a);
				}
				
				if (pq.empty ())
					var2 += mi[mi2];
				else
					var2 += (pq.top ()).first * mi[mi1];
				sz[mi1] ++;
			}
			
			if (var1 < var2)
				ans += var1;
			else
				ans += var2;
		}
	}
	
	///printf ("--- %d %lld\n", x, ans);
	
	mi[x] = min (c[x], mi[mi1]);
	sum[x] += c[x];
	sz[x] ++;
	
	
}

int main ()
{
	int i, p;
	scanf ("%d", &n);
	for (i = 2; i <= n; i ++)
	{
		scanf ("%d", &p);
		v[p].push_back (i);
	}
	for (i = 2; i <= n; i ++)
		scanf ("%d", &c[i]);
		
	dfs (1);
	printf ("%lld\n", ans);
	
	return 0;	
}
