#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 5e5 + 5;
const int REAL_MAX_N = 5e6 + 5;

int prefSums[MAX_N][26], totalCnt[26];
int prefSumsAB[REAL_MAX_N][2];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	string s;
	cin >> s;

	bool hasOnlyAB = true;
	int n = s.size();
	for(int i = 0; i < n; i++) {
		if(s[i] != 'a' && s[i] != 'b') {
			hasOnlyAB = false;
			break;
		}
	}
	
	for(int i = 0; i < n; i++) {
		if(i != 0) {
			if(!hasOnlyAB) {
				for(int j = 0; j < 26; j++) {
					prefSums[i][j] = prefSums[i - 1][j];
				}
			}
			else {
				for(int j = 0; j < 2; j++) {
					prefSumsAB[i][j] = prefSumsAB[i - 1][j];
				}
			}
		}
	
		totalCnt[s[i] - 'a']++;
		
		if(!hasOnlyAB) {
			prefSums[i][s[i] - 'a']++;
		}
		else {
			prefSumsAB[i][s[i] - 'a']++;
		}
	}

	int sq = sqrt(n);
	vector< int > divs;
	for(int i = 1; i <= sq; i++) {
		if(n % i == 0) {
			divs.push_back(i);
			if(i * i != n) {
				divs.push_back(n / i);
			}
		}
	}

	sort(divs.begin(), divs.end());
	
	if(!hasOnlyAB) {
		for(int i = divs.size() - 1; i >= 0; i--) {
			int aux = divs[i];
			int partSize = n / aux;

			bool isPossible = true;
			for(int i = partSize - 1; i < n; i += partSize) {
				bool isOk = true;
				for(int j = 0; j < 26; j++) {
					if(totalCnt[j] % aux != 0) {
						isOk = false;
						break;
					}

					int currCnt = prefSums[i][j] - (i == partSize - 1 ? 0 : prefSums[i - partSize][j]);

					if(currCnt != totalCnt[j] / aux) {
						isOk = false;
						break;
					}
				}

				if(!isOk) {
					isPossible = false;
					break;
				}
			}

			if(isPossible) {
				cout << aux << endl;
				return 0;
			}
		}
	}
	else {
		for(int i = divs.size() - 1; i >= 0; i--) {
			int aux = divs[i];
			int partSize = n / aux;

			bool isPossible = true;
			for(int i = partSize - 1; i < n; i += partSize) {
				bool isOk = true;
				for(int j = 0; j < 2; j++) {
					if(totalCnt[j] % aux != 0) {
						isOk = false;
						break;
					}

					int currCnt = prefSumsAB[i][j] - (i == partSize - 1 ? 0 : prefSumsAB[i - partSize][j]);

					if(currCnt != totalCnt[j] / aux) {
						isOk = false;
						break;
					}
				}

				if(!isOk) {
					isPossible = false;
					break;
				}
			}

			if(isPossible) {
				cout << aux << endl;
				return 0;
			}
		}

	}

	return 0;
}
