#include<iostream>

using namespace std;

const int MAXN = 5*(1e5) + 5;

int n;
string s;

int prefix[MAXN][30];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    bool fail = false;
    int letter, index;

    cin >> s;
    n = s.size();

    prefix[0][ s[0] - 'a' ] = 1;
    for(int i = 1;i<n;i++)
    {
        for(letter = 0;letter<28;letter++)
        {
            prefix[i][letter] = prefix[i-1][letter];
        }

        prefix[i][ s[i] - 'a' ]++;
    }

    for(int len = 1;len<=n/2;len++)
    {
        if(n%len!=0) continue;

        fail = false;
        index = len*2 - 1;

        while(index<n)
        {
            for(letter = 0;letter<30;letter++)
            {
                if(prefix[index][letter] - prefix[index-len][letter]!=prefix[len-1][letter])
                {
                    fail = true;
                    break;
                }
            }

            if(fail==true) break;
            index += len;
        }

        if(fail==false)
        {
            cout << n/len << '\n';
            return 0;
        }
    }

    cout << "1" << '\n';
}
