#include <iostream>
#include <unordered_map>
using namespace std;
typedef long long ll;
//unordered_map <double,int> ma,mb,mc;
long long glfl=0;

struct Point
{
    ll x,y;

    Point(){}

    bool operator==(Point b)
    {
        return x==b.x && y==b.y;
    }

    Point(ll x,ll y):x(x),y(y){}

} zv[10001];

ll cross(Point a,Point b)
{
    return a.x*b.y - a.y*b.x;
}

struct Lin
{
    Point p1,p2;
    ll a,b,c;
    double tan;

    void calc()
    {
        a = p1.y - p2.y;
        b = p2.x - p1.x;
        c = cross(p1,p2);
   //     cout<<a<<" "<<b<< endl;
        if(b==0) tan=0.1e-10;
        else tan = -a/(double)b;
    }
    Lin(Point p1,Point p2):p1(p1),p2(p2)
        {calc();}

};
ll n;

void solve1(int i1,int i2,int spec)
{
    Point a1,b1;
    a1 = zv[i1];
    b1 = zv[i2];
    int i,j,k;
    for(i=0; i<2*n; i++)
    {
        Lin l1(a1,zv[i]);
        if(i==i1 || i==i2) continue;
        if(spec && i>1) break;
        for(j=0; j<2*n; j++)
        {
            if(i==i1 || i==i2 || i==j) continue;
            Lin l2(b1,zv[j]);
            ll d = cross( Point(l1.a,l2.a) , Point(l1.b,l2.b) );
            ll dy = cross( Point(l1.a,l2.a) , Point(-l1.c,-l2.c) );
            ll dx = cross( Point(-l1.c,-l2.c) , Point(l1.b,l2.b) );
            if(d==0) continue;
            if(dx%d!=0) continue;
            if(dy%d!=0) continue;
            Point pres(dx/d,dy/d);
            if(pres.x>1e6 || pres.x<-1e6 || pres.y>1e6 || pres.y<-1e6) continue;
            int br=0,fl=0;
            unordered_map<double,int> prov;
            for(k=0; k<2*n; k++)
            {
                if(pres==zv[k]) {fl=1;break;}
                Lin l(pres,zv[k]);
                int t=++prov[l.tan];
                if(t == 2) br++;
                if(t==3) {fl=1; break;}
            }
            if(fl) continue;
            if(br==n)
            {
                cout<<"Yes"<< endl;
                glfl=1;
                cout<<pres.x<<" "<<pres.y<< endl;
                return;
            }
        }
    }
}

void solve()
{
    solve1(0,1,0);
    if(glfl) return;
    solve1(0,2,1);
    if(glfl) return;
    cout<<"No"<< endl;
    return;

}

void prov()
{
int i,j;
    for(i=0; i<2*n; i++)
    {
        unordered_map<double,int> prov;
        for(j=i+1; j<2*n; j++)
        {
            Lin l(zv[i],zv[j]);
            cout<<i<<" "<<j<<" "<<l.tan<< endl;
            if(prov[l.tan]==1) {cout<<"No"<<i<<" "<<j<< endl; return;}
            else prov[l.tan]=1;
        }
    }
}

void input()
{
    cin>>n;
    int i;
    for(i=0; i<2*n; i++) cin>>zv[2*n-i-1].x>>zv[2*n-i-1].y;
}

int main()
{
    input();
  //  prov();
    solve();
    return 0;
}