#include<bits/stdc++.h>
using namespace std;
int n;
int x[6000];
int y[6000];
long long int inf=1000001;
double a[6000];
double xi[10];
double yi[10];
double eps=1e-12;
double pi;
pair<long long int,long long int> presek(int i,int j,int k,int l)
{
    double k1,k2,m1,m2;
    xi[0]=x[i];
    yi[0]=y[i];
    xi[1]=x[j];
    yi[1]=y[j];
    xi[2]=x[k];
    yi[2]=y[k];
    xi[3]=x[l];
    yi[3]=y[l];
    long long int xp,yp;
    double xp1,yp1;
    double tx,ty;
    if(x[i]==x[j])
    {
        if(x[k]==x[l]) return make_pair(inf,inf);
        xp=x[i];
        xp1=x[i];
        k2=(yi[3]-yi[2])/(xi[3]-xi[2]);
        m2=yi[2]-xi[2]*k2;
        yp1=xp1*k2+m2;
        yp=round(yp1);
    }
    else
    {
        if(x[k]==x[l])
        {
            xp=x[k];
            xp1=x[k];
            k1=(yi[1]-yi[0])/(xi[1]-xi[0]);
            m1=yi[0]-xi[0]*k1;
            yp1=xp1*k1+m1;
            yp=round(yp1);
            //cout<<"OK"<<endl;
            //cout<<xp1<<" "<<yp1<<endl;
        }
        else
        {
            //cout<<"OK"<<endl;
            k1=(yi[1]-yi[0])/(xi[1]-xi[0]);
            m1=yi[0]-xi[0]*k1;
            k2=(yi[3]-yi[2])/(xi[3]-xi[2]);
            m2=yi[2]-xi[2]*k2;
            //cout<<k1<<" "<<m1<<" "<<k2<<" "<<m2<<endl;
            if(abs(k1-k2)<eps) return  make_pair(inf,inf);
            xp1=-(m1-m2)/(k1-k2);
            xp=round(xp1);
            yp1=xp1*k1+m1;
            yp=round(yp1);
            //cout<<xp<<" "<<yp<<endl;
        }
    }
    tx=xp;
    ty=yp;
    //cout<<xp1<<" "<<yp1<<endl;
    if(fabs(xp1-tx)<eps && fabs(yp1-ty)<eps && abs(xp)<inf && abs(yp)<inf) return make_pair(xp,yp);
    else return make_pair(inf,inf);
}
bool test(int i,int j,int k,int l)
{
    long long int xp,yp;
    xp=presek(i,j,k,l).first;
    yp=presek(i,j,k,l).second;
    //cout<<xp<<" "<<yp<<endl;
    if(xp>=inf || yp>=inf) return false;
    for(int i=0;i<n;i++)
    {
        if(xp==x[i] && yp==y[i]) return false;
    }
    for(int i=0;i<n;i++)
    {
        xi[0]=x[i];
        xi[1]=xp;
        yi[0]=y[i];
        yi[1]=yp;
        a[i]=atan2(yi[1]-yi[0],xi[1]-xi[0]);
        //cout<<a[i]<<endl;
        while(a[i]<-eps) a[i]+=pi;
        while(a[i]-pi>-eps) a[i]-=pi;
    }
    sort(a,a+n);
    //for(int i=0;i<n;i++) cout<<a[i]<<endl;
    for(int i=0;i<n;i=i+2)
    {
        if(fabs(a[i+1]-a[i])>eps) return false;
    }
    for(int i=2;i<n;i=i+2)
    {
        if(fabs(a[i]-a[i-1])<eps) return false;
    }
    printf("Yes\n");
    printf("%lld %lld",xp,yp);
    return true;
}
int main()
{
    scanf("%d",&n);
    n=n*2;
    pi=acos(-1);
    for(int i=0;i<n;i++)
    {
        scanf("%d %d",&x[i],&y[i]);
    }
    if(n==2)
    {
        printf("Yes\n");
        printf("%d %d",2*x[1]-x[0],2*y[1]-y[0]);
        return 0;
    }
    /*
    Part 1:
    Probamo za 0 i 1 u razlicitim pravama, pretpostavili smo njih, sada im pretpostavimo
    parove
    */
    //test(0,1,2,3);
    //return 0;
    for(int i=2;i<n;i++)
    {
        for(int j=2;j<n;j++)
        {
            if(i!=j && test(0,i,1,j))
            {
                //printf("Yes\n");
                //printf("%d %d",presek(0,i,1,j).first,presek(0,i,1,j).second);
                return 0;
            }
        }
    }
    /*
    Part 2
    Probamo da su 0 i 1 u istoj pravi a 2 u drugoj
    */
    for(int i=3;i<n;i++)
    {
        if(test(0,1,2,i))
        {
            //printf("Yes\n");
            //printf("%d %d",presek(0,1,2,i).first,presek(0,1,2,i).second);
            return 0;
        }
    }
    /*
    Part 3
    U suprotonom nije moguce
    */
    printf("No");
    return 0;
}
