#include <cstdio>

FILE *fin = fopen("input.txt", "r"), *fout = fopen("output.txt", "w");

#define B 29
#define MOD 1000000009
#define MAXN 5000009

int n, val[MAXN], put[26];
char s[MAXN + 10];

inline bool ok(int a) {
    for (int i = a; i <= n; i += a)
        if (val[i] - val[i - a] != val[a] && val[i] - val[i - a] + MOD != val[a])
            return 0;
    return 1;
}

int main() {
    fgets(s, MAXN, fin);
    put[0] = 1;
    for (int i = 1; i < 26; i++)
        put[i] = 1LL * B * put[i - 1] % MOD;
    while ('a' <= s[n] && s[n] <= 'z') {
        n++;
        val[n] = put[s[n - 1] - 'a'] + val[n - 1];
        if (val[n] >= MOD)
            val[n] -= MOD;
    }

    int a = 1;
    while (n % a || !ok(a))
        a++;

    fprintf(fout, "%d", n / a);
    fclose(fin);
    fclose(fout);
    return 0;
}
