#include <bits/stdc++.h>

using namespace std;

const int MAX_S = 5000005;
const int BASE = MAX_S+1;
const int MOD = 1000000123;
const int MOD2 = 1000000181;
const int SIGMA = 26;
char str[1+MAX_S+1];
int pb[SIGMA], pb2[SIGMA];
int smec[MAX_S+1], smec2[MAX_S+1];

void initstuff(int n) {
  pb[0] = 1;
  for(int i = 1; i < SIGMA; ++i) {
    pb[i] = (long long)pb[i - 1] * BASE % MOD;
    pb2[i] = (long long)pb2[i - 1] * BASE % MOD2;
  }
  for(int i = 1; i <= n; ++i) {
    smec[i] = (smec[i - 1] + pb[str[i] - 'a']) % MOD;
    smec2[i] = (smec2[i - 1] + pb2[str[i] - 'a']) % MOD;
  }
}

bool check(int n, int piece) {
  for(int i = 2 * piece; i <= n; i += piece)
    if((smec[i] + MOD - smec[i - piece]) % MOD != smec[piece] ||
       (smec2[i] + MOD2 - smec2[i - piece]) % MOD2 != smec2[piece])
      return false;
  return true;
}

int main() {
#ifdef HOME
  FILE *fin = fopen("leo.in", "r");
  FILE *fout = fopen("leo.out", "w");
#else
  FILE *fin = fopen("input.txt", "r");
  FILE *fout = fopen("output.txt", "w");
#endif
  int i, n = 0;
  bool ok;
  fgets(str+1, MAX_S+1, fin);
  while(isalpha(str[n + 1]))
    ++n;
  initstuff(n);
  i = 1;
  do {
    ok = false;
    if(n % i == 0)
      ok = check(n, i);
    if(!ok)
      i++;
  } while(!ok);
  fprintf(fout, "%d", n / i);
  return 0;
}

