#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 200000;
int c[1+MAX_N], minc[1+MAX_N], sizearb[1+MAX_N];
long long sum[1+MAX_N];

vector<int> graph[1+MAX_N];

long long rez;
void dfs(int nod) {
  int n = graph[nod].size();
  long long s = -c[nod];
  minc[nod] = c[nod];
  sizearb[nod] = 1;
  sum[nod] = c[nod];
  for(auto it: graph[nod]) {
    dfs(it);
    sizearb[nod] += sizearb[it];
    minc[nod] = min(minc[nod], minc[it]);
    sum[nod] += sum[it];
  }
  if(n > 1) {
    s += sum[nod];
    long long bestcost = 1000000000000000000LL;
    for(int i = 0; i < n; ++i) {//graph[nod][i] este componenta selectata
      int maxs = 0, mincost = 1000000000;
      for(int j = 0; j < n; ++j)
        if(i != j) {
          maxs = max(maxs, sizearb[graph[nod][j]]);
          mincost = min(mincost, minc[graph[nod][j]]);
        }
      if(maxs <= s / 2) {
        bestcost = min(bestcost, (long long)mincost * (sizearb[graph[nod][i]] - (sizearb[nod] - sizearb[graph[nod][i]] - 1) % 2) + s);
      }
    }
    rez += bestcost;
  }
}

int main() {
#ifdef HOME
  FILE *fin = fopen("rapha.in", "r");
  FILE *fout = fopen("rapha.out", "w");
#else
  FILE *fin = fopen("input.txt", "r");
  FILE *fout = fopen("output.txt", "w");
#endif
  int n, p;
  fscanf(fin, "%d", &n);
  for(int i = 2; i <= n; ++i) {
    fscanf(fin, "%d", &p);
    graph[p].push_back(i);
  }
  for(int i = 2; i <= n; ++i)
    fscanf(fin, "%d", &c[i]);
  dfs(1);
  fprintf(fout, "%lld", rez);
  return 0;
}

