#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 200000;
int c[1+MAX_N], minc[1+MAX_N], sizearb[1+MAX_N];
long long sum[1+MAX_N];

vector<int> graph[1+MAX_N];

long long rez;
void dfs(int nod) {
  int heaviest = -1, bestcost1, bestcost2;
  minc[nod] = 1000001;
  bestcost1 = bestcost2 = 1000001;
  for(auto it: graph[nod]) {
    dfs(it);
    sizearb[nod] += sizearb[it];
    minc[nod] = min(minc[nod], minc[it]);
    sum[nod] += sum[it];
    if(heaviest == -1 || sizearb[it] > sizearb[heaviest])
      heaviest = it;
    if(minc[it] < bestcost1) {
      bestcost2 = bestcost1;
      bestcost1 = minc[it];
    } else if(minc[it] < bestcost2)
      bestcost2 = minc[it];
  }
  if(graph[nod].size() > 1) {
    if(sizearb[heaviest] <= sizearb[nod] / 2) //nu exista element majoritar
      rez += sum[nod] + (sizearb[nod] % 2) * minc[nod];
    else { //exista element majoritar, atunci restul din majoritar ii cuplez cu cel mai prost ca ceilalti
      if(minc[heaviest] == bestcost1)
        bestcost1 = bestcost2;
      rez += (long long)bestcost1 * (2 * sizearb[heaviest] - sizearb[nod]) + sum[nod];
    }
  }
  sizearb[nod]++;
  minc[nod] = min(minc[nod], c[nod]);
  sum[nod] += c[nod];
}

int main() {
#ifdef HOME
  FILE *fin = fopen("rapha.in", "r");
  FILE *fout = fopen("rapha.out", "w");
#else
  FILE *fin = fopen("input.txt", "r");
  FILE *fout = fopen("output.txt", "w");
#endif
  int n, p;
  fscanf(fin, "%d", &n);
  for(int i = 2; i <= n; ++i) {
    fscanf(fin, "%d", &p);
    graph[p].push_back(i);
  }
  for(int i = 2; i <= n; ++i)
    fscanf(fin, "%d", &c[i]);
  dfs(1);
  fprintf(fout, "%lld", rez);
  return 0;
}

