#include <bits/stdc++.h>

using namespace std;

const int N = int(5e6);

char s[N];
int n, cnt[26], ans = 0;
vector<char> used;

bool check(int m)
{
    for(int i = 0; i < n; i += m)
    {
        int new_cnt[26];
        memset(new_cnt, 0, sizeof(new_cnt));
        for(int j = i; j < i + m; ++j)
        {
            new_cnt[s[j] - 'a']++;
        }
        for(int j = 0; j < 26; ++j)
        {
            if(new_cnt[j] * (n / m) != cnt[j])
            {
                return false;
            }
        }
    }

    return true;
}

int main()
{
    scanf("%s", s);
    n = int(strlen(s));
    memset(cnt, 0, sizeof(cnt));
    for(int i = 0; s[i]; ++i)
    {
        cnt[s[i] - 'a']++;
    }
    for(int i = 0; i < 26; ++i)
    {
        if(cnt[i] == n)
        {
            printf("%d", n);
            return 0;
        }
    }
    int new_cnt[26];
    memset(new_cnt, 0, sizeof(new_cnt));
    vector<int> arr;
    for(int i = 1; i <= n; ++i)
    {
        if(n % i == 0)
        {
            bool yes = true;
            int u = n / i;
            for(int j = 0; j < 26; ++j)
            {
                if(cnt[j] % u > 0)
                {
                    yes = false;
                    break;
                }
            }
            if(yes)
            {
                arr.push_back(i);
            }
        }
    }
    int l = 0,
        r = int(arr.size()) - 1;
    while(l != r)
    {
        int mid = (l + r) / 2;
        if(check(arr[mid]))
        {
            r = mid;
        } else
        {
            l = mid + 1;
        }
    }
    printf("%d", n / arr[l]);

    return 0;
}
