#include<bits/stdc++.h>
#define int long long
using namespace std;
typedef double coord;

int gcd(int a, int b){
    if(b == 0) return a;
    return gcd(b, a % b);
}

struct V{
    coord x, y;
};

coord operator *(V a, V b){
    return a.x * b.x + a.y * b.y;
}

coord operator ^(V a, V b){
    return a.x * b.y - a.y * b.x;
}

struct L{
    coord a, b, c;
    L(V f, V s){
        a = s.y - f.y;
        b = f.x - s.x;
        c = -1 * (a * f.x + b * f.y);
    }
};

V operator ^(L f, L s){
    if(f.a * s.b == s.a * f.b) return {-1e9, -1e9};
    return{
        (s.c * f.b - f.c * s.b) / (f.a * s.b - s.a * f.b),
        (f.a * s.c - f.c * s.a) / (f.b * s.a - s.b * f.a)
    };
}

const double EPS = 1e-8;

signed main(){
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    n *= 2;
    vector<V> q(n);
    for(int i = 0; i < n; i++){
        cin >> q[i].x >> q[i].y;
    }
    for(int j = 1; j < n; j++){
        for(int k = 1; k < n; k++){
            for(int l = k + 1; l < n; l++){
                if(j == k || j == l) continue;
                L a(q[0], q[j]);
                L b(q[k], q[l]);
                V cross = a ^ b;
                if(cross.x == -1e9) continue;
                if(abs(cross.x - round(cross.x)) > EPS || abs(cross.y - round(cross.y)) > EPS) continue;
                map<pair<int, int>, int> cnt;
                for(int m = 0; m < n; m++){
                    V cur = {q[m].x - cross.x, q[m].y - cross.y};
                    if(cur.x < 0 || cur.x == 0 && cur.y < 0) {
                        cur.x *= -1;
                        cur.y *= -1;
                    }
                    int g = gcd((int)cur.x, (int)cur.y);
                    cur.x /= g;
                    cur.y /= g;
                    cnt[{cur.x, cur.y}]++;
                }
                bool ok = 1;
                for(auto it : cnt){
                    if(it.second != 2) ok = 0;
                }
                if(ok){
                    cout << "Yes\n";
                    cout << round(cross.x) << ' ' << round(cross.y);
                    return 0;
                }
            }
        }
    }
    cout << "No";
    return 0;
}
