#include <bits/stdc++.h>

#define mp make_pair

typedef std::pair<int, int> pii;

std::mt19937 rnd;

inline int gcd(int a, int b)
{
    if (b < 0)
        b = -b;
    while (b != 0)
    {
        a %= b;
        std::swap(a, b);
    }
    return a;
}

inline pii hlp(int a, int b)
{
    if (a == 0)
        return std::mp(0, 1);
    if (b == 0)
        return std::mp(1, 0);
    if (a < 0)
    {
        a = -a;
        b = -b;
    }         
    int gc = gcd(a, b);
    return std::mp(a / gc, b / gc);
}

int check(pii ans, pii p)
{
    return ans != p && ans.first <= 1000000 && ans.first >= -1000000 && ans.second <= 1000000 && ans.second >= -1000000;
}

void get_ans(int n)
{
    rnd.seed(time(NULL));
    n *= 2;
    int x[n], y[n];
    for (int i = 0; i < n; ++i)
        scanf("%d %d", x + i, y + i);
    if (n == 2)
    {
         pii p = hlp(x[1] - x[0], y[1] - y[0]);
         pii ans = std::mp(x[0] + p.first, y[0] + p.second);
         if (check(ans, std::mp(x[1], y[1])))
         {
            printf("Yes\n%d %d\n", ans.first, ans.first);
            return;
         }
         ans = std::mp(x[0] + 2 * p.first, y[0] + 2 * p.second);
         if (check(ans, std::mp(x[1], y[1])))
         {
            printf("Yes\n%d %d\n", ans.first, ans.first);
            return;
         }
         ans = std::mp(x[0] - p.first, y[0] - p.second);
         if (check(ans, std::mp(x[1], y[1])))
         {
            printf("Yes\n%d %d\n", ans.first, ans.first);
            return;
         }
         ans = std::mp(x[0] - 2 * p.first, y[0] - 2 * p.second);
         if (check(ans, std::mp(x[1], y[1])))
         {
            printf("Yes\n%d %d\n", ans.first, ans.first);
            return;
         }
         printf("No\n");
         return;
    }
    int fr = rnd() % n;
    int sc = rnd() % n;
    while (sc == fr)
        sc = rnd() % n;
    int trh = rnd() % n;
    while (sc == trh || trh == fr)
        trh = rnd() % n;
    std::swap(x[0], x[fr]);
    std::swap(y[0], y[fr]);
    std::swap(x[1], x[sc]);
    std::swap(y[1], y[sc]);
    std::swap(x[2], x[trh]);
    std::swap(y[2], y[trh]);
    for (int i = 1; i < n; ++i)
    {
        int v = 1;
        if (i == 1)
            v = 2;
        for (int j = 1; j < n; ++j)
        if (v != j && i != j)
        {
            //0 i
            //v j
            int a = y[i] - y[0];
            int b = x[0] - x[i];
            long long int c = -a * 1LL * x[0] - b * 1LL * y[0];
            int a1 = y[v] - y[j];
            int b1 = x[j] - x[v];
            long long int c1 = -a1 * 1LL * x[v] - b1 * 1LL * y[v];
            long long int zn = a * 1LL * b1 - a1 * 1LL * b;
            if (zn != 0 && (c1 * b - c * b1) % zn == 0 && (c1 * a - c * a1) % zn == 0)
            {
                long long nx = (c1 * b - c * b1) / zn;
                long long ny = (c * a1 - c1 * a) / zn;
                if (-1000000 <= nx && nx <= 1000000 && -1000000 <= ny && ny <= 1000000)
                {
                    std::unordered_map<long long int, int> dir;
                    int do_it = 1;
                    for (int k = 0; k < n && do_it && dir.size() <= n / 2; ++k)
                    {
                        pii p = hlp(x[k] - nx, y[k] - ny);
                        long long int pp = ((1LL * p.first) << 32) + p.second;
                        if (x[k] == nx && y[k] == ny)
                            do_it = 0;
                        else if (!dir.count(pp))
                            dir[pp] = 1;
                        else if (dir[pp] == 2)
                            do_it = 0;
                        else
                            ++dir[pp];                        
                    }
                    if (do_it && dir.size() == n / 2)
                    {
                        std::cout << "Yes\n" << nx << " " << ny << "\n";
                        return;
                    }
                }   
            }
        }
    }
    printf("No\n");
}

int main()
{
    int n;
    while (scanf("%d", &n) == 1)
        get_ans(n);
    return 0;
}