#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

#define F first
#define S second

#define en end()
#define bg begin()

#define mp make_pair
#define pb push_back

#define rev reverse
#define y1 y0123456789
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()
#define len(x) (int)strlen(x)

#define sqr(x) ((x) * 1ll * (x))
#define sqrd(x) ((x) * 1.0 * (x))

#define forn(i, x) for (int i = 1; i <= x; i++)

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int N = 51;

int n;
bool u[N];

inline ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

struct pt {
	ll x, y;
	pt(){};
	pt(ll a, ll b) : x(a), y(b) {};
	inline void in() {
		cin >> x >> y;
	}
	inline void out() {
		cout << x << " " << y << endl;
	}
} p[N];

struct ln {
	ll a, b, c;
	ln(){};
	ln(ll x, ll y, ll z) : a(x), b(y), c(z) {};
	ln(pt p1, pt p2) {
		a = p2.y - p1.y;
		b = p1.x - p2.x;
		c = -b * p1.y - a * p1.x;
	}
	inline bool par(ln l) {
		return (a * l.b - b * l.a == 0);
	}
	inline pt cross(ln l) {
		pt res;
		ll A = b * l.c - c * l.b;
		ll B = c * l.a - a * l.c;
		ll C = a * l.b - b * l.a;
		res.x = A / C;
		res.y = B / C;
		if (res.x * C != A || res.y * C != B)
			return pt(inf, inf);
		return res;
	}
	inline bool check(pt p) {
		return (a * p.x + b * p.y + c == 0);
	}
	inline bool operator ==(ln l) {
		return (a == l.a && b == l.b && c == l.c);
	}
	inline bool operator !=(ln l) {
		return (a != l.a || b != l.b || c != l.c);
	}
	inline bool operator <(ln l) {
		if (a == l.a) {
			if (b == l.b)
				return (c < l.c);
			return (b < l.b);
		}
		return (a < l.a);
	}
} L[N];

inline bool check(pt moon) {
	for (int i = 1; i <= n; i++)
		if (moon.x == p[i].x && moon.y == p[i].y)
			return 0;
	memset(u, 0, sizeof(u));
	for (int i = 1; i < n; i++) {
		if (u[i])
			continue;
		u[i] = 1;
		int cnt = 0;
		ln cur = ln(moon, p[i]);
		for (int j = i + 1; j <= n; j++) {
			if (u[j])
				continue;
			if (cur.check(p[j])) {
				cnt++;
				u[j] = 1;
				if (cnt > 1)
					return 0;
			}
		}
		if (cnt != 1)
			return 0;
	}
	return 1;
}

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	//srand(time(NULL));
	
	//cin.tie(NULL);
	//cout.tie(NULL);
	//ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;

	cin >> n;

	n <<= 1;

	for (int i = 1; i <= n; i++) {
		p[i].in();
		p[i].x += (ll)1e6;
		p[i].y += (ll)1e6;
	}

	for (int it = 2; it <= n; it++) {
		ll deltaX = p[1].x - p[it].x;
		ll deltaY = p[1].y - p[it].y;
		ll g = gcd(abs(deltaX), abs(deltaY));
		deltaX /= g;
		deltaY /= g;
		for (ll x = p[1].x, y = p[1].y, xx = p[1].x, yy = p[1].y; 0 <= x && x <= (ll)2e6 && 0 <= y && y <= (ll)2e6 && 0 <= xx && xx <= (ll)2e6 && 0 <= yy && yy <= (ll)2e6; x += deltaX, y += deltaY, xx -= deltaX, yy -= deltaY) {
			if (check(pt(x, y))) {
				cout << "Yes" << endl;
				cout << x - (ll)1e6 << " ";
				cout << y - (ll)1e6;
				return 0;
			}
			if (check(pt(xx, yy))) {
				cout << "Yes" << endl;
				cout << xx - (ll)1e6 << " ";
				cout << yy - (ll)1e6;
				return 0;
			}
		}
	}

	cout << "No";
	
	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;

	return 0;
}
