#include <bits/stdc++.h>


using namespace std;
//#define int int64_t

typedef pair<int, int> pii;
const int INF = 1e18;
typedef long long ll;

vector<int> alldel(int n) {
    vector<int> ans;
    //ans.push_back(1);
    int p = 2;
    while (p * p <= n) {
        if (n % p == 0) {
            ans.push_back(p);
            if (n / p != p) {
                ans.push_back(n / p);
            }
        }
        p++;
    }
    ans.push_back(n);
    sort(ans.rbegin(), ans.rend());
    return ans;
}

signed main() {

    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    srand(time(NULL));
    int A = 26;
    string s;
    cin >> s;
    if (s.size() > 500000) {
        A = 2;
    }
    int n = s.size();
    vector<int> cnt(A);
    vector<vector<int>> pr(A, vector<int>(2));
    for (auto el : s) {
        cnt[el - 'a']++;
    }
    pr[s[0] - 'a'][0]++;
    for (int i = 1; i < (n + 1) / 2; ++i) {
        for (int ch = 0; ch < A; ++ch) {
            pr[ch][i] = pr[ch][i];
        }
        pr[s[i] - 'a'][i]++;
    }
    int gcd = cnt[0];
    for (int i = 1; i < A; ++i) {
        gcd = __gcd(gcd, cnt[i]);
    }
    if (gcd == 1) {
        cout << 1;
        return 0;
    }

    //gcd = n / gcd;

    vector<int> fact = alldel(gcd);
    vector<int> pat(A);
    int prev = 0;
    for (auto deli : fact) {
        bool ok = true;
        int part = n / deli;
        for (int i = prev; i < part; ++i) {
            pat[s[i] - 'a']++;
        }
        prev = part;
        for (int i = part; i < n; i+= part) {
            vector<int> curr(A);
            for (int j = 0; j < A; ++j) {
                curr[j] = pr[j][i + part - 1] - pr[j][i - 1];
            }
            if (curr != pat) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << n / part << endl;
            return 0;
        }
    }
    cout << 1 << endl;
    return 0;
}


/*
tests

 abbabbbab

 aabb







 9
1 1 2 2 2 3 3 3
1 1 1 1 1 1 1 1

5
1 2 3 4
1 1 1 1



5
1 2 2 1
1 1 1 1

 */