/* #include <bits/stdc++.h>


using namespace std;
#define int int64_t

typedef pair<int, int> pii;
const int INF = 1e18;
typedef long long ll;

vector<vector<int>> g;
vector<int> c;
vector<int> dp;
vector<int> sz;

void dfs(int v) {
    dp[v] = 0;
    sz[v] = 1;
    for (auto u : g[v]) {
        dfs(u);
        dp[v] += dp[u];
        sz[v] += sz[u];
        dp[v] += (sz[u] - 1) * 2;
    }
    dp[v] += (g[v].size() + 1) / 2 * 2;
}


signed main() {

    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    srand(time(NULL));

    int n;
    cin >> n;
    g.resize(n);
    c.resize(n);
    dp.resize(n);
    sz.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        cin >> c[i];
    }
    dfs(0);
    //cout << "KEK";
    cout << dp[0] << endl;

    return 0;
}
*/

/*
tests

 9
1 1 2 2 2 3 3 3
1 1 1 1 1 1 1 1

5
1 2 3 4
1 1 1 1



5
1 2 2 1
1 1 1 1

 */












#include <bits/stdc++.h>


using namespace std;
#define int int64_t

typedef pair<int, int> pii;
const int INF = 1e18;
typedef long long ll;

vector<vector<int>> g;
vector<int> c;
vector<int> dp;
vector<int> sz;

void dfs(int v) {
    dp[v] = 0;
    sz[v] = 1;
    vector<int> s;
    for (auto u : g[v]) {
        dfs(u);
        dp[v] += dp[u];
        sz[v] += sz[u];
        s.push_back(sz[u]);
    }
    int add = 0;
    int cnt = 0;

    for (int i = 0; i < s.size() && cnt < (int)s.size(); ++i) {
        sort(s.rbegin(), s.rend());
        int j = 1;
        while (j < s.size() && s[j] != 0 && s[0] >= s[j]) {
            if (s[0] == s[j]) {
                cnt++;
            }
            add += s[j] * 2;

            s[0] -= s[j];
            s[j] = 0;
            cnt++;
            j++;
        }
    }
    if (s.size()) {
        sort(s.rbegin(), s.rend());
        if (s[0] != 0) {
            add += s[0] * 2;
        }
        dp[v] += add;
    }

}


signed main() {

    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    srand(time(NULL));

    int n;
    cin >> n;
    g.resize(n);
    c.resize(n);
    dp.resize(n);
    sz.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        cin >> c[i];
    }
    dfs(0);
    //cout << "KEK";
    cout << dp[0] << endl;

    return 0;
}


/*
tests

 14
 1 1 2 2 3 3 3 3 3 9 9 11 11
 1 1 1 1 1 1 1 1 1 1 1 1 1

 8
 1 1 2 2 2 3 3
 1 1 1 1 1 1 1


 7
 1 1 2 2 3 3
 1 1 1 1 1 1



 11
 1 1 1 1 2 2 3 3 4 4
 1 1 1 1 1 1 1 1 1 1

 9
1 1 2 2 2 3 3 3
1 1 1 1 1 1 1 1

5
1 2 3 4
1 1 1 1



5
1 2 2 1
1 1 1 1

 */


