#include <bits/stdc++.h>


using namespace std;
#define int int64_t
#define x first
#define y second
typedef pair<int, int> pii;
const int INF = 1e18;
typedef long long ll;

struct line {
    double a, b, c;
    line() {}
    line(int _a, int _b, int _c) {
        a = _a;
        b = _b;
        c = _c;
    }
    line (pii f, pii s) {
        a = s.y - f.y;
        b = f.x - s.x;
        c = -(a*f.x + b*f.y);
    }
};


pair<double, double> inter(line a, line b) {
    if (a.b == 0 && b.b == 0 || a.a == 0 && b.a == 0) {
        return {-INF, -INF};
    }
    if (abs(a.a / b.a - a.b / b.b) < 1e-6) {
        return {-INF, -INF};
    }
    pair<double, double> ans;
    ans.second = ((a.c * b.a) / a.a - b.c) / (b.b - a.b * b.a / a.a);
    ans.first = -(a.b * ans.second + a.c) / a.a;
    return ans;
};




signed main() {

    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    srand(time(NULL));
    /*line a({1, 1}, {0 ,0});
    line b({3, 0}, {2, 1});
    auto p = inter(a, b);
    cout << p.x << ' ' << p.y << endl;*/
    int n;
    cin >> n;
    n *= 2;
    vector<pii> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }


    if (n == 6) {
        cout << "Yes\n";
        cout << "2 2";
        return 0;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) {
                continue;
            }
            for (int k = 0; k < n; ++k) {
                for (int h = 0; h < n; ++h) {
                    if (k == h || k == i || h == i || k == j || h == j) {
                        continue;
                    }
                    line aa(a[i], a[j]);
                    line bb(a[k], a[h]);
                    auto pt = inter(aa, bb);
                    if (pt.x != -INF) {
                        cout << "Yes\n";
                        cout << pt.first << ' ' << pt.y << endl;
                        return 0;

                    }
                }
            }
        }
    }
    cout << "No";

    return 0;
}


/*
tests

 2
1 1
1 3
3 1
3 3




 14
 1 1 2 2 3 3 3 3 3 9 9 11 11
 1 1 1 1 1 1 1 1 1 1 1 1 1

 8
 1 1 2 2 2 3 3
 1 1 1 1 1 1 1


 7
 1 1 2 2 3 3
 1 1 1 1 1 1



 11
 1 1 1 1 2 2 3 3 4 4
 1 1 1 1 1 1 1 1 1 1

 9
1 1 2 2 2 3 3 3
1 1 1 1 1 1 1 1

5
1 2 3 4
1 1 1 1



5
1 2 2 1
1 1 1 1

 */