#include <bits/stdc++.h>

using namespace std;

template<typename T>
T gcd(T a, T b) {
    while(a && b) (a > b ? a %= b : b %= a);
    return a + b;
}

set<int> lengths;

int cnt[500001][26];

int get(int ch, int l, int r) {
    return cnt[r][ch] - cnt[l - 1][ch];
}

int main() {
#ifndef ONLINE_JUDJE
    freopen("input.txt", "r", stdin);
#endif

    string s;
    cin >> s;
    int n = s.size();

    for(int i = 1; i <= n; ++i) {
        for(int j = 0; j < 26; ++j)
            cnt[i][j] = cnt[i - 1][j];
        cnt[i][s[i - 1] - 'a']++;
    }

    int maxSize = 0;
    for(int i = 0; i < 26; ++i)
        maxSize = gcd(maxSize, cnt[n][i]);

    for(int i = 1; 1ll * i * i <= n; ++i) {
        if (n % i == 0) {
            lengths.insert(i);
            lengths.insert(n / i);
        }
    }
    lengths.insert(n);

    for(int x : lengths) {
        int blockCnt = n / x;
        if(maxSize % blockCnt == 0) {
            bool can = true;
            for(int j = 0; can && j < blockCnt; ++j)
                for(int ch = 0; ch < 26; ++ch)
                    can &= get(ch, j * x + 1, (j + 1) * x) == cnt[n][ch] / blockCnt;
            if(can) {
                cout << blockCnt << "\n";
                return 0;
            }
        }
    }

    return 1;
}