#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct s {
    int c, v;
    s() {};
    s(int c, int v) : c(c), v(v) {};
    bool operator == (const s &other) const {
        return v == other.v;
    }
};
const s INF(-1010101010, -1);

const int MAXN = 100001;
vector<int> g[MAXN];

int n;
int c[MAXN];
int sz[MAXN];
ll res = 0;

void dfs(int v, int p = -1) {
    vector<int> sizes;

    sz[v] = 1;
    for(int e : g[v]) {
        if(e != p) {
            dfs(e);
            sz[v] += sz[e];
            sizes.push_back(sz[e]);
        }
    }

    int j = sizes.size() - 1;
    while(j >= 1) {
        int can = min(sizes[j], sizes[j - 1]);
        sizes[j] -= can;
        sizes[j - 1] -= can;
        res += can;
        if(sizes[j] == 0) {
            j--;
        } else if(sizes[j - 1] == 0) {
            sizes[j - 1] = sizes[j];
            j--;
        }
    }
    if(sizes.size() > 0)
        res += sizes[0];
}

int main() {
#ifndef ONLINE_JUDJE
    freopen("input.txt", "r", stdin);
#endif

    cin >> n;

    int x;
    for(int i = 1; i < n; ++i) {
        cin >> x;
        g[x - 1].push_back(i);
    }

    for(int i = 0; i < n; ++i)
        cin >> c[i];

    dfs(0);

    cout << res * 2;
}
