#include <iostream>
#include <vector>
#include <set>
#include <climits>
#include <algorithm>

using namespace std;

vector <vector <int > > g;
//vector <bool> used1, used2;
vector <int> sum_c;
vector <int> min_c;
vector <int> c;
vector <int> children;
vector <bool> end;

int64_t ans = 0;

void dfs1(int v) {
	//used1[v] = true;
	min_c[v] = c[v];
	sum_c[v] = c[v];
	children[v] = 0;
	for (auto i:g[v]) {
		dfs1(i);
		children[v] += children[i] + 1; 
		min_c[v] = min(min_c[v], min_c[i]);
		sum_c[v] += sum_c[i];
	}
}

void dfs2(int v) {
	//used2[v] = true;
	int pos1 = -1, pos2 = -1, pos_max = -1;
	if (g[v].size() == 0) return;
	for (auto i:g[v]) {
		dfs2(i);
		if ((pos_max == -1) || (children[pos_max] < children[i])) {
			pos_max = i;
		}
		if (pos1 == -1 || min_c[pos1] > min_c[i]) {
			pos2 = pos1;
			pos1 = i;
			continue;
		}
		if (pos2 == -1 || min_c[pos2] > min_c[i]) {
			pos2 = i;
		}
	}
	//cout << v << ' ' << pos_max << endl;
	if (children[v] - (children[pos_max] + 1)  >= (children[pos_max] + 1)) {
		ans += sum_c[v] - c[v] + min_c[pos1] * (children[v] % 2);
	} else {
		int64_t ost = (children[pos_max] + 1) - (children[v] - (children[pos_max] + 1));
		//cout << v<< ' ' << ost << endl;
		ans += sum_c[v] - c[v];
		if (pos_max == pos1) {
			ans += ost * min_c[pos2];
		} else {
			ans += ost * min_c[pos1];
		}
	}
	
}

int main() {
	int n;
	cin >> n;
	g.resize(n + 1);// used1.resize(n + 1, false); used2.resize(n + 1, false);
	children.resize(n + 1);
	sum_c.resize(n + 1, 0); min_c.resize(n + 1, 0); c.resize(n + 1, INT_MAX);
	for (int x, i = 2; i <= n; i++) {
		cin >> x;
		g[x].push_back(i);
	}
	c[1] = 0;
	for (int i = 2; i <= n; i++) {
		cin >> c[i];
	}
	dfs1(1);

	/*for (int i = 1; i <= n; i++) {
		cout << i << ':'  << min_c[i] << ' ' << sum_c[i] << endl;
	}*/
	dfs2(1);
	cout << ans;
}
