#ifndef home
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,unroll-all-loops")
#pragma GCC target("abm,mmx,popcnt,avx,tune=native,sse,sse2")
#endif

//#include <bits/extc++.h>
#include <ext/numeric>
#include <iomanip>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <bitset>
#include <deque>
#include <map>
#include <iostream>
#include <queue>
#include <set>
#include <string>
#include <stack>
#include <vector>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <climits>
#include <tuple>
#include <cassert>

using namespace __gnu_cxx;
using namespace std;
#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define foru(i, l, r) for(auto i=l;i<r;++i)
#define forn(i, n) foru(i,0,n)
#define ford(i, r, l) for(auto i=r;i>=l;--i)
#define bcnt __builtin_popcount
using ll = long long;
using lint = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
const int inf = INT_MAX;
const ll linf = LLONG_MAX;
template<class X, class C=less<X>, class Y=__gnu_pbds::null_type> using ordered_set=
__gnu_pbds::tree<X, Y, C, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
template<class X, class C=greater<X>> using heap=__gnu_pbds::priority_queue<X, C>;

template<class X>
inline void mini(X &x, X y) {
    if (x > y)x = y;
}

template<class X>
inline void maxi(X &x, X y) {
    if (x < y)x = y;
}

//#define fast_memory 2e8
#ifdef fast_memory
char allmem[(size_t) fast_memory];
size_t allpos;

inline void *operator new(size_t n) {
    char *res = allmem + allpos;
    allpos += n;
    assert(allpos <= (size_t) fast_memory);
    return (void *) res;
}

inline void operator delete(void *)noexcept {}

inline void operator delete(void *, size_t)noexcept {}

#endif
int c[200002];
ll ans;
vector<int> g[200020];
ll s[200020];
int cnt[200020];

pair<lint, int> dfs(int v) {
    s[v] = c[v];
    cnt[v] = 1;
    if (g[v].empty()) {
        return {s[v], c[v]};
    }
    int m1 = inf, m2 = inf;
    int v1;
    assert(g[v].size() > 1);
    for (auto x:g[v]) {
        auto val = dfs(x);
        cnt[v] += cnt[x];
        s[v] += val.first;
        if (val.second < m1) {
            v1 = x;
            m2 = m1;
            m1 = val.second;
        } else if (val.second < m2)m2 = val.second;
    }
    ll cur = 0;
    ll p = 0;
    ll fl = 0;
    int vfl;
    for (auto x:g[v]) {
        if (cnt[x] > (cnt[v] - 1 - cnt[x])) {
            fl = cnt[x];
            vfl = x;
        }
    }
    ans += s[v] - c[v];
//    cout << ans << endl;
    if (fl) {
        if (vfl == v1) {
            ans += (2 * fl - cnt[v] + 1) * m2;
        } else ans += (2 * fl - cnt[v] + 1) * m1;
    } else ans += 1ll * ((cnt[v] - 1) % 2) * m1;
//    cout << v << ' ' << ans << ' ' << s[v] << ' ' << cnt[v] << ' ' << m1 << ' ' << m2 << endl;
    return {s[v], min(c[v], m1)};
}

int main() {
#ifdef home
    assert(freopen("../input.txt", "r", stdin));
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(11) << fixed;
    int n;
    cin >> n;
    forn(i, n - 1) {
        int p;
        cin >> p;
        g[p - 1].push_back(i + 1);
    }
    forn(i, n - 1)cin >> c[i + 1];
    dfs(0);
    cout << ans;

    return 0;
}

