#include <iostream>
#include <vector>
#include <string>
#include <cmath>
using namespace std;

const int mod = 1e9 + 7;

int main()
{
    string s;
    cin >> s;
    int n = s.length();
    int p = 5000011;
    vector <long long> pow(26);
    pow[0] = p;
    for(int i = 1; i < 26; i++)
    {
        pow[i] = pow[i - 1] * p;
        pow[i] %= mod;
    }
    vector <long long> prf(n);
    prf[0] = pow[s[0] - 'a'];
    for(int i = 1; i < n; i++)
        prf[i] = prf[i - 1] + pow[s[i] - 'a'];
    for(int i = 1; i <= n / 2; i++)
        if(n % i == 0 && prf[n - i - 1] == prf[n - 1] - prf[i - 1])
        return cout << i, 0;
    cout << 1;
}
