#define NDEBUG
#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
#define all(x) begin(x), end(x)
typedef int ll;
template<class A>void addlog(A a)
{ cerr<<a<<endl; }
template<class A,class... B>void
addlog(A a,B... b){ cerr<<a<<' ';addlog(b...); }

const ll MAX_MEM = 64e7;
char mem[MAX_MEM];
char* curMem = mem;

void *operator new (size_t n) {
    char *res = curMem;
    curMem += n;
    return (void *)res;
}
void operator delete (void *) noexcept {}
void operator delete (void *, size_t) {}

string s;
ll freq[256], curf[256];
deque<ll> potFrags;


void start () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> s;
    for (char c : s)
        ++ freq[(ll)c];
    /// 1e7
    ll g = s.size();
    for (ll i = 0; i < 256; ++ i)
        if (freq[i])
            g = __gcd(g, freq[i]);
    /// 257 * log 1e6 < 1e4
    for (ll i = int(sqrt(g)); i; -- i) //////////////////
    if (g % i == 0) {
        potFrags.push_back(i);
        if (i * i != g)
            potFrags.push_front(g / i);
    }
    /// 2 * sqrt(1e6) = 1e4
}


bool goodSub (ll b, ll e, ll k) {
    fill(all(curf), 0);
    for (ll i = b; i < e; ++ i) ++ curf[(ll)s[i]];
    for (ll i = 'a'; i <= 'z'; ++ i)
        if (curf[i] * k != freq[i])
            return false;
    return true;
}

bool check (ll k) {
    ll d = (ll)s.size() / k;
    for (ll i = 0; i < (ll)s.size(); i += d) {
        if (!goodSub(i, i + d, k))
            return false;
    }
    return true;
}

int main () {
    start();

    potFrags.erase(unique(all(potFrags)), end(potFrags));
    for (ll k : potFrags)
    if (check(k)) {
        cout << k << endl;
        return 0;
    }
    assert(0);
    return 0;
}

