#include <bits/stdc++.h>
using namespace std;
#define all(x) begin(x), end(x)
typedef long ll;
template<class A>void addlog(A a)
{ cerr<<a<<endl; }
template<class A,class... B>void
addlog(A a,B... b){ cerr<<a<<' ';addlog(b...); }

const ll MAX_N = 3e5;
ll N, timer = 0;
ll p[MAX_N], c[MAX_N], used[MAX_N], taken[MAX_N], tin[MAX_N], tout[MAX_N];
vector<ll> G[MAX_N], R[MAX_N];
vector< pair<ll, ll> > answer;

void ancestDfs (ll v) {
    tin[v] = ++ timer;
    for (ll u : G[v])
        if (tin[u] == 0)
            ancestDfs(u);
    tout[v] = ++ timer;
}

void connect (ll i, ll j) {
    taken[i] = taken[j] = true;
    answer.emplace_back(i, j);
}
inline bool ancest (ll i, ll j)
{return tin[i]<tin[j]&&tout[i]>tout[j];}

inline bool untakenLight (ll a, ll b) {
    if (taken[a] == taken[b])
        return c[a] < c[b];
    return taken[a] < taken[b];
}

void recSol (ll v) {
    used[v] = true;
    addlog("recSol:", v + 1);
    for (ll u : G[v])
    if (!used[u]) {
        addlog(v + 1, "->", u + 1);
        recSol(u);
    }
    fill(all(taken), false);
    for (ll u = 0; u < N; ++ u)
    if (ancest(v, u)) {
        ll best = -1;
        for (ll i = 0; i < N; ++ i) if (i != u)
        if (ancest(v, i) && !ancest(u, i)) {
            if (best < 0 || untakenLight(i, best))
                best = i;
        }
        if (best >= 0) {
            addlog("Good:", v + 1, u + 1, best + 1);
            connect(u, best);
        }
        else {
            addlog("Bad:", v + 1, u + 1);
        }
    }
}

void start () {
    freopen("input.txt", "r", stdin);
    cin >> N;
    for (ll i = 1; i < N; ++ i) {
        cin >> p[i]; -- p[i];
        R[i].push_back(p[i]);
        G[p[i]].push_back(i);
    }
    c[0] = 0;
    for (ll i = 1; i < N; ++ i) {
        cin >> c[i];
    }
}

int main () {
    start();
    ancestDfs(0);

    recSol(0);

    ll sum = 0;
    for (auto p : answer) {
        sum += c[p.first] + c[p.second];
        addlog(p.first + 1, p.second + 1);
    }
    cout << sum  / 2 << endl;

    return 0;
}

