#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 2e5, INF = 1e9;

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    string s; cin >> s; int n = sz(s);
    bool ab = true;
    for(char ch : s) ab &= (ch == 'a' || ch == 'b');
    if(!ab) {
        vector<vector<int>> cnt(n, vector<int>(26, 0));
        for(int i = 0; i < n; i++) {
            if(i) cnt[i] = cnt[i - 1];
            cnt[i][s[i] - 'a']++;
        }
        for(int len = 1; len <= n; len++) {
            if(n % len) continue;
            vector<int> v = cnt[len - 1];
            int pos = len;
            bool ok = true;
            while(ok && pos < n) {
                for(int i = 0; ok && i < 26; i++) ok &= (cnt[pos + len - 1][i] - cnt[pos - 1][i] == v[i]);
                pos += len;
            }
            if(ok) return cout << n / len, 0;
        }
    } else {
        vector<vector<int>> cnt(n, vector<int>(2, 0));
        for(int i = 0; i < n; i++) {
            if(i) cnt[i] = cnt[i - 1];
            cnt[i][s[i] - 'a']++;
        }
        for(int len = 1; len <= n; len++) {
            if(n % len) continue;
            vector<int> v = cnt[len - 1];
            int pos = len;
            bool ok = true;
            while(ok && pos < n) {
                for(int i = 0; ok && i < 2; i++) ok &= (cnt[pos + len - 1][i] - cnt[pos - 1][i] == v[i]);
                pos += len;
            }
            if(ok) return cout << n / len, 0;
        }
    }
}



/*
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 2e5, INF = 1e9;

struct segTree {
    int n; vector<int> t;
    segTree(vector<int> &a) {
        n = sz(a);
        t.resize(2 * n);
        for(int i = 0; i < n; i++) t[i + n] = a[i];
        for(int i = n - 1; i; i--) t[i] = min(t[i * 2], t[i * 2 + 1]);
    }
    int get(int l, int r) {
        int ret = INF;
        for(l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
            if(l & 1) ret = min(ret, t[l]);
            if(!(r & 1)) ret = min(ret, t[r]);
        }
        return ret;
    }
};

int n, a[maxn], b1[maxn], b2[maxn], tik_tak = -1, tsz[maxn];
vector<int> g[maxn];
vector<int> ord;
ll ans, sum[maxn];

void dfs(int v) {
    b1[v] = ++tik_tak;
    ord.push_back(v);
    sum[v] = a[v];
    tsz[v] = 1;
    for(int to : g[v]) dfs(to), sum[v] += sum[to], tsz[v] += tsz[to];
    b2[v] = tik_tak;
}

void dfs2(int v, segTree &t) {
    if(g[v].empty()) return;
    int kid = g[v][0];
    for(int to : g[v]) {
        dfs2(to, t);
        if(tsz[to] > tsz[kid]) kid = to;
    }
    ans += sum[v] - a[v];
    if(2 * tsz[kid] > tsz[v] - 1) {
        ll lo = min(t.get(b1[v] + 1, b1[kid] - 1), t.get(b2[kid] + 1, b2[v]));
        ans += (2 * tsz[kid] - tsz[v] + 1) * lo;
    } else if((tsz[v] - 1) & 1) ans += t.get(b1[v] + 1, b2[v]);
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    cin >> n;
    for(int i = 1; i < n; i++) {
        int x; cin >> x; x--; g[x].push_back(i);
    }
    for(int i = 1; i < n; i++) cin >> a[i];
    dfs(0);
    vector<int> vals(n);
    for(int i = 0; i < n; i++) vals[i] = a[ord[i]];
    segTree t(vals);
    dfs2(0, t);
    cout << ans;
}
*/
