#include<iostream>
#include<vector>
#include<string>
#include<cmath>

using namespace std;

int con;

class elem{
public:
    vector<int> A;
    int l, r;
};

void build(vector<elem> &A, string &s){
    con= (int)sqrt((double)s.size());
    if (s.size() % con == 0){
        A.resize(s.size() / con);
        for (int i= 0; i < A.size(); i++){
            A[i].A.resize(26);
            A[i].l= i * con;
            A[i].r= i * con + con - 1;
            for (int j= A[i].l; j <= A[i].r; j++){
                A[i].A[s[j] - 97]++;
            }
        }
    }else{
        A.resize(s.size() / con + 1);
        for (int i= 0; i < A.size() - 1; i++){
            A[i].A.resize(26);
            A[i].l= i * con;
            A[i].r= i * con + con - 1;
            for (int j= A[i].l; j <= A[i].r; j++){
                A[i].A[s[j] - 97]++;
            }
        }
        A[A.size() - 1].A.resize(26);
        A[A.size() - 1].l= (A.size() - 1) * con;
        A[A.size() - 1].r= s.size() - 1;
        for (int j= A[A.size() - 1].l; j <= A[A.size() - 1].r; j++){
            A[A.size() - 1].A[s[j] - 97]++;
        }
    }
}

bool f(vector<int> &A, vector<elem> &M, int left, int right, string &s){
    vector<int> B(A.size());
    int i= 0, j;
    while (M[i].r < left){
        i++;
    }
    j= i;
    while (M[j].r < right){
        j++;
    }
    for (int q= i; q <= j; q++){
        for (int w= 0; w < A.size(); w++){
            B[w]+= M[q].A[w];
        }
    }
    for (int q= M[i].l; q < left; q++){
        B[s[q] - 97]--;
    }
    for (int q= M[j].r; q > right; q--){
        B[s[q] - 97]--;
    }

    return A == B;
}

int main(){a
    string s;
    cin >> s;
    vector<elem> M;
    build(M, s);

    int k;
    bool ind= false;
    for (int i= 1; i <= s.size(); i++){
        if (s.size() % i == 0){
            if (i >= con){
                vector<int> A(26);
                for (int j= 0; j < i; j++){
                    A[s[j] - 97]++;
                }
                ind= true;

                for (int j= 0; j < s.size(); j+= i){
                    ind= f(A, M, j, j + i - 1, s);
                    if (!ind){
                        break;
                    }
                }
            }else{
                vector<int> A(26);
                for (int j= 0; j < i; j++){
                    A[s[j] - 97]++;
                }
                ind= true;

                for (int j= 0; j < s.size(); j+= i){
                    vector<int> B(26);
                    for (int q= j; q < j + i; q++){
                        B[s[q] - 97]++;
                    }
                    if (A != B){
                        ind= false;
                        break;
                    }
                }
            }
            if (ind){
                k= s.size() / i;
                break;
            }
        }
    }
    if (ind){
        cout << k;
    }else{
        cout << 1;
    }

    return 0;
}