#include <bits/stdc++.h>
#pragma GCC optimize("O3")


typedef long long ll;

#define forn(i, n) for (ll i = 0; i < n; ++i)
#define x first
#define y second
#define point pair<int, int>

using namespace std;

const int N = 1e5 + 3, BIG = 1e9 + 7, MOD = 1e9 + 7, P = 'z' - 'a' + 1, K = 3;

// code2

ll n, ans;
vector<ll> c, min_son, sz, sum;
vector<vector<int>> gr;

void dfs(ll v) {
	ll min1 = BIG, min2 = BIG, sz_min1 = BIG;
	sz[v] = 0;
	for (auto &to : gr[v]) {
		dfs(to);
		sz[v] += sz[to];
		sum[v] += sum[to];
		if (min1 > min_son[to]) {
			min2 = min1;
			min1 = min_son[to];
			sz_min1 = sz[to];
		} else if (min2 > min_son[to])
			min2 = min_son[to];
	}

	if (sz[v] > 0) {
	/*/
	cout << v << " : \n";
	cout << min1 << " " << sz_min1 << "  " << min2 << "\n";
	cout << sz[v] << " * " << min1 << ", " << min2 << "\n";
	cout << v << " -> + " << (sz[v] - sz_min1) * min1 << " + " 
		<< min2 * (sz_min1 - 1) << " + " << sum[v] - min1 - min2 << "\n";
	//*/
	ans += (sz[v] - sz_min1) * min1 - min2 + min2 * (sz_min1 - 1) + sum[v];
	// cout << ans << " - ans\n";
	}
	sum[v] += c[v];
	min_son[v] = min(min_son[v], c[v]);
	++sz[v];
}


int main() {
	// freopen("a.in", "r", stdin), freopen("a.out", "w", stdout);
	// code 2
	ios_base:: sync_with_stdio(0), cin.tie(0), cout.tie(0);
	cin >> n;
	c.resize(n);
	gr.resize(n);
	int p;
	forn(i, (n - 1)) {
		cin >> p, --p;
		gr[p].push_back(i + 1);
	}
	forn(i, (n - 1))
		cin >> c[i + 1];

	min_son.resize(n, BIG);
	sz.resize(n);
	sum.resize(n);
	dfs(0);
	cout << ans;
	return 0;
}