#include <fstream>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <map>
#include <set>

using namespace std;

ifstream cin("input.txt"); ofstream cout("output.txt");

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    vector <ll> a(n * 2-1, 0);
    for (ll i = 1; i <= n; i++)
        a[i * 2 - 2] = i;
    vector <ll> z(n-1);
    for (ll i = 0; i < n - 1; i++)
        z[i] = i * 2+1;
    for (ll i = n * 2 - 2; i >= 0; i--) {
        if (z.size()==0)
            break;
        a[z[z.size() - 1]] = a[i];
        a[i] = 0;
        z.pop_back();
    }
    int q;
    cin >> q;
    while (q--) {
        ll x;
        cin >> x;
        cout << a[--x] << "\n";
    }
    return 0;
}

