#include <iostream>

using namespace std;

  const int N = 5e6;

  int n, cnt[N][26];

  bool check(int d, int a, int b) {
    for (int i = 0; i < 26; i++) {
      if (cnt[b][i] - cnt[a - 1][i] != cnt[d][i]) {
        return false;
      }
    }
    return true;
  }

  bool solve(int d) {
    for (int i = d; i < n; i += d) {
      if (!check(d - 1, i, i + d - 1)) {
        return false;
      }
    }
    return true;
  }

  void solve() {
    string s;
    cin >> s;
    n = s.size();
    cnt[0][s[0] - 'a'] = 1;
    for (int i = 1; i < n; i++) {
      for (int j = 0; j < 26; j++) {
        cnt[i][j] = cnt[i - 1][j];
      }
      cnt[i][s[i] - 'a']++;
    }
    for (int i = 1; ; i++) {
      if (n % i == 0 && solve(i)) {
        cout << n / i << "\n";
        return;
      }
    }
  }


signed main() {
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  solve();
  return 0;
}
