#include <bits/stdc++.h>

using namespace std;

const int N = 1e2;

int n;
int cnt[N], dp[N];
bool is_root[N];
vector<int> g[N];

int get_root() {
  for (int i = 0; ; i++) {
    if (is_root[i]) {
      return i;
    }
  }
}

void dfs(int v) {
  cnt[v] = 1;
  int mul = g[v].size() > 1;
  for (auto u : g[v]) {
    dfs(u);
    mul *= cnt[u];
    dp[v] += dp[u];
    cnt[v] += cnt[u];
  }
  dp[v] += mul;
}

signed main() {
  cin >> n;
  fill(is_root, is_root + n, true);
  for (int i = 1; i < n; i++) {
    int v;
    cin >> v;
    v--;
    g[v].emplace_back(i);
    is_root[i] = false;
  }
  int root = get_root();
  /*cout << "root: " << root + 1 << "\n";
  for (int i = 0; i < n; i++) {
    cout << i + 1 << ":";
    for (auto j : g[i]) {
      cout << " " << j + 1;
    }
    cout << "\n";
  }
  cout << "\n";*/
  dfs(root);
  /*for (int i = 0; i < n; i++) {
    cout << "cnt[" << i + 1 << "] = " << cnt[i] << "\n";
  }
  cout << "\n";*/
  /*for (int i = 0; i < n; i++) {
    cout << "dp[" << i + 1 << "] = " << dp[i] << "\n";
  }
  cout << "\n";*/
  cout << dp[root] * 2 << "\n";
  return 0;
}
