#include<bits/stdc++.h>
#define ll long long
#define dbl long double
#define x first
#define y second
#define pii pair<int, int>
using namespace std;
vector<pair<int, int>> dots;
pair<int, int> sun;

bool construct_sun(int a, int b, int c, int d){
    int x1 = dots[a].x, x2 = dots[b].x;
    int y1 = dots[a].y, y2 = dots[b].y;

    int x3 = dots[c].x, x4 = dots[d].x;
    int y3 = dots[c].y, y4 = dots[d].y;

    int a1 = y2 - y1, b1 = x1 - x2, c1 = - x1 * (y2 - y1) + y1 * (x2 - x1);

    int a2 = y4 - y3, b2 = x3 - x4, c2 = - x3 * (y4 - y3) + y3 * (x4 - x3);
    if(a1 * b2 == a2 * b1) return false;

    int y_up = a2 * c1 - c2 * a1;
    int y_dow = a1 * b2 - a2 * b1;
    if(y_up % y_dow) return false;

    sun.y = y_up / y_dow;
    if(a1 != 0) {
        int x_up = - b1 * sun.y - c1;
        if(x_up % a1) return false;
        sun.x = x_up / a1;
    } else {
        int x_up = - b2 * sun.y - c2;
        if(x_up % a2) return false;
        sun.x = x_up / a2;
    }
    if(abs(sun.x) <= 1e6 && abs(sun.y) <= 1e6)
        return true;
    else
        return false;
}
bool cmp(pii &a, pii &b) {
    return atan2(a.y, a.x) > atan2(b.y, b.x);
}
const dbl EPS = 1e-6;
bool check(){
//    auto s = sun;
    map<dbl, int> vc;
    for(auto i : dots) {
        if(i.x == sun.x && i.y == sun.y) return false;
        pii v = {i.x - sun.x, i.y - sun.y};
        if(v.y <= 0) {
            v.x *= -1;
            v.y *= -1;
        }
        dbl angle = atan2(v.y, v.x);
        if(M_PI - angle < EPS) angle = 0;
        vc[angle]++;
    }
    for(auto i : vc) {
        if(i.second != 2) return false;
    }
    return true;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int n;
    cin >> n;
    dots.resize(2 * n);
    for(int i = 0; i < 2 * n; ++i) {
        cin >> dots[i].x >> dots[i].y;
    }
    if(n == 1) {
        int dx = dots[0].x - dots[1].x;
        int dy = dots[0].y - dots[1].y;
        cout << "Yes\n";
        if(abs(dots[0].x + dx) > 1e6){
            dx *= -2;
        }if (abs(dots[0].y + dy) > 1e6) {
            dy *= -2;
        }
        cout << dots[0].x + dx << " " << dots[0].y + dy;
        return 0;
    }
    for (int i = 0; i < 2 * n; ++i) {
        for (int j = 0; j < 2 * n; ++j) {
            if(i == j) continue;
            for (int k = 0; k < 2 * n; ++k) {
                if(k == j || k == i) continue;
                for (int l = 0; l < 2 * n; ++l) {
                    if(l == i || l == j || l == k) continue;
                    if(construct_sun(i, j, k, l) && check()) {
                        cout << "Yes\n";
                        cout << sun.x << " " << sun.y << "\n";
                        return 0;
                    }
                }
            }
        }
    }
    cout << "No";
}