#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimaze("Ofast");
#pragma target("sse3,sse4");

#define int long long
#define ll long long
#define ld long double
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define pb push_back

const int INF = 1e18;
const int MAXN = 1e6;

ll power(int a, int n, int MOD = INF) {
    if (n == 0) return 1;
    if (n & 1) {
        return (a * power(a, n - 1, MOD)) % MOD;
    } else {
        int b = power(a, n >> 1, MOD);
        return (b * b) % MOD;
    }
}

ll gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

string s;
int n;

vector<int> cnt(26, 0);

bool check(int len) {
    unordered_map<char, int> a, b;
    for (int i = 0; i < len; i++) {
        a[s[i]]++;
    }
    for (int i = 1; i < n / len; i++) {
        b.clear();
        for (int j = len * i; j < len * (i + 1); j++) {
            b[s[j]]++;
        }
        if (a != b) return 0;
    }
    return 1;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
//-------------------------------------------------------------
    cin >> s;
    n = s.size();
    set<int> g;
    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            g.insert(i);
            g.insert(n / i);
        }
    }
    for (int x: g) {
        if (check(x)) {
            cout << n / x << '\n';
            return 0;
        }
    }

}