#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <fstream>
#include <string>
#include <math.h>

using namespace std;

class pt
{
public:
    long long x, y;
    int num;
};

class ln
{
public:
    long long a, b, c;
};

class item
{
public:
    ln l;
    pt a, b;
};

void showln(ln l)
{
    cout << l.a << "x + " << l.b << "y + " << l.c << " = 0";
}

ln getln(pt a, pt b)
{
    ln l;
    l.a = b.y - a.y;
    l.b = a.x - b.x;
    l.c = a.y * b.x - a.x * b.y;
    return l;
}

int ptonl(pt p, ln l)
{
    long long t = l.a * p.x + l.b * p.y + l.c;
    if (t == 0) {
        return 0;
    }
    if ((t > 0 && l.b > 0) || (t < 0 && l.b < 0)) {
        return 1;
    }
    return -1;
}

pt inter(ln l1, ln l2)
{
    long long k1 = l1.a * l2.b - l2.a * l1.b;
    long long k2 = l1.b * l2.c - l2.b * l1.c;/*
    showln(l1);
    cout << "   ||   ";
    showln(l2);
    cout << endl;
    cout << k1 << ' ' << k2 << endl;*/
    pt p;
    p.x = 10000000;
    p.y = 10000000;
    if (k1 == 0) {
        return p;
    }
    if (abs(k2) % abs(k1) == 0) {
        p.x = k2 / k1;
        if (abs(p.x) > 1000000) {
            return p;
        }
        long long k3 = l1.a * p.x + l1.c;
        if (abs(k3) % abs(l1.b) == 0) {
            p.y = -k3 / l1.b;
        }
    }
    if (abs(p.x) > 1000000 || abs(p.y) > 1000000) {
        p.x = 10000000;
        p.y = 10000000;
    }
    return p;
}

bool comppt(pt a, pt b)
{
    if (a.x == b.x) {
        return a.y < b.y;
    }
    return a.x < b.x;
}

bool eqlp(pt a, pt b)
{
    return (a.x == b.x) && (a.y == b.y);
}

int main()
{
    ifstream fin("input.txt");
    int n;
    fin >> n;
    n *= 2;
    vector<pt> p(n);
    for (int i = 0; i < n; i++) {
        pt pt1;
        fin >> pt1.x >> pt1.y;
        pt1.num = i;
        p[i] = pt1;
    }
    vector<item> ls;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            item it;
            it.a = p[i];
            it.b = p[j];
            it.l = getln(it.a, it.b);
            ls.push_back(it);
        }
    }/*cout << ls[i].l.a << "x + " << ls[i].l.b << "y + " << ls[i].l.c << " = 0"
    for (int i = 0; i < ls.size(); i++) {
        cout << "(" << ls[i].a.x << ", " << ls[i].a.y << ") - (";
        cout << ls[i].b.x << ", " << ls[i].b.y << "): ";
        cout << ls[i].l.a << "x + " << ls[i].l.b << "y + " << ls[i].l.c << " = 0" <<endl;
    }*/
    vector<pt> nt;
    for (int j = 0; j < n; j++) {
        nt.clear();
        int n1 = ls[j].a.num, n2 = ls[j].b.num;
        for (int i = 1; i < ls.size(); i++) {
            if (ls[i].a.num != n1 && ls[i].a.num != n2 && ls[i].b.num != n1 && ls[i].b.num != n2) {
                pt pnt = inter(ls[j].l, ls[i].l);
                if (pnt.x <= 1000000) {
                    nt.push_back(pnt);
                }
            }
        }
        if (nt.size() < n / 2 - 1) {
            continue;
        }
        sort(nt.begin(), nt.end(), comppt);
        pt p0;
        p0.x = 10000000;
        p0.y = 10000000;
        nt.push_back(p0);
        int ind = 0;
        while (ind < nt.size()) {
            int i1 = ind;
            ind++;
            while (ind < nt.size() && eqlp(nt[i1], nt[ind])) {
                ind++;
            }
            if (ind - i1 >= n / 2 - 1) {
                cout << "Yes" << endl;
                cout << nt[i1].x << ' ' << nt[i1].y;
                return 0;
            }
        }
        /*
        for (int i = 0; i < nt.size(); i++) {
            cout << nt[i].x << ' ' << nt[i].y << endl;
        }
        cout << "===" << endl;*/
    }
    cout << "No";
    /*
    while (true) {
        pt p;
        ln l;
        cin >> l.a >> l.b >> l.c >> p.x >> p.y;
        cout << ptonl(p, l) << endl;
    }*/
}
