#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string.h>
using namespace std;
typedef long long ll;

const int maxn = 500010;
char s[maxn];
int cnt[26], pref[26][maxn], biggcd;
vector <int> divs;

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int main() {
	scanf("%s", &s);
	int len = strlen(s);
	int lets = 26;
	for (int i = 0; i < len; i++) {
		cnt[s[i] - 'a']++;
		for (int j = 0; j < lets; j++) {
			pref[j][i + 1] = pref[j][i];
		}
		pref[s[i] - 'a'][i + 1]++;
	}
	biggcd = cnt[0];
	for (int i = 1; i < lets; i++) {
		biggcd = gcd(biggcd, cnt[i]);
	}
	for (int i = 1; i * i <= biggcd; i++) {
		if (biggcd % i == 0) {
			divs.push_back(i);
			if (i * i != biggcd) {
				divs.push_back(biggcd / i);
			}
		}
	}
	sort(divs.begin(), divs.end());
	for (int i = divs.size() - 1; i >= 0; i--) {
		bool ok = true;
		for (int j = 0; j < lets; j++) {
			int need = cnt[j] / divs[i];
			int sz = len / divs[i];
			for (int p = 0; p < len; p += sz) {
				if (pref[j][p + sz] - pref[j][p] != need) {
					ok = false;
					break;
				}
			}
			if (!ok) {
				break;
			}
		}
		if (ok) {
			printf("%d", divs[i]);
			return 0;
		}
	}
	return 0;
}