#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string.h>
using namespace std;
typedef long long ll;

const int maxn = 5000010, block = 100;
char s[maxn];
int cnt[26], biggcd, cntcur[26], pref[26][50010];
vector <int> divs;

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int main() {
	scanf("%s", &s);
	int len = strlen(s);
	int lets = 26;
	for (int i = 0; i < len; i++) {
		cnt[s[i] - 'a']++;
		if ((i + 1) % block == 0) {
			for (int j = 0; j < lets; j++) {
				int t = (i + 1) / block;
				pref[j][t] = cnt[j];
			}
		}
	}
	biggcd = cnt[0];
	for (int i = 1; i < lets; i++) {
		biggcd = gcd(biggcd, cnt[i]);
	}
	for (int i = 1; i * i <= biggcd; i++) {
		if (biggcd % i == 0) {
			divs.push_back(i);
			if (i * i != biggcd) {
				divs.push_back(biggcd / i);
			}
		}
	}
	sort(divs.begin(), divs.end());

	vector <int> let;
	for (int j = 0; j < lets; j++) {
		if (cnt[j] != 0) {
			let.push_back(j);
		}
	}

	for (int i = divs.size() - 1; i >= 0; i--) {
		int sz = len / divs[i];
		bool ok = true;
		
		for (int j = 0; j < lets; j++) {
			cntcur[j] = 0;
		}

		for (int p = 0; p < len; p++) {
			cntcur[s[p] - 'a']++;
			if ((p + 1) % block == 0 && p / sz == (p + block) / sz && p + block < len) {
				for (int q = 0; q < let.size(); q++) {
					int j = let[q];
					cntcur[j] = pref[j][(p + 1 + block) / block];
				}
				p += block;
			}
			if ((p + 1) % sz == 0) {
				for (int q = 0; q < let.size(); q++) {
					int j = let[q];
					int need = cnt[j] / divs[i];
					if (cntcur[j] != (p + 1) / sz * need) {
						ok = false;
						break;
					}
				}
				if (!ok) {
					break;
				}
			}
		}
		if (ok) {
			printf("%d", divs[i]);
			return 0;
		}
	}
	return 0;
}