#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
typedef long long ll;

const int maxn = 300000, inf = 1e9;
int p[maxn];
ll c[maxn], answer[maxn];
ll minc[maxn], summ[maxn], sz[maxn];
vector <int> v [maxn];

void dfs(int k) {
	answer[k] = 0;
	sz[k] = 0;
	summ[k] = 0;
	minc[k] = c[k];
	ll minim = inf, maxsz = 0;
	int indsz = -1;
	for (int i = 0; i < v[k].size(); i++) {
		dfs(v[k][i]);
		sz[k] += sz[v[k][i]];
		summ[k] += summ[v[k][i]];
		answer[k] += answer[v[k][i]];
		minc[k] = min(minc[k], minc[v[k][i]]);
		minim = min(minim, minc[v[k][i]]);
		if (maxsz < sz[v[k][i]]) {
			maxsz = sz[v[k][i]];
			indsz = i;
		}
	}
	if (2 * maxsz <= sz[k]) {
		answer[k] += summ[k] + (sz[k] % 2) * minim;
	}
	else {
		ll minn = inf;
		for (int i = 0; i < v[k].size(); i++) {
			if (i != indsz) {
				minn = min(minn, minc[v[k][i]]);
			}
		}
		answer[k] += summ[k] + (2 * maxsz - sz[k]) * minn;
	}
	summ[k] += c[k];
	sz[k]++;
}

int main() {
	int n;
	scanf("%d", &n);
	for (int i = 1; i <= n - 1; i++) {
		scanf("%d", &p[i]); p[i]--;
		v[p[i]].push_back(i);
	}
	for (int i = 1; i <= n - 1; i++) {
		scanf("%d", &c[i]);
	}
	dfs(0);
	printf("%lld", answer[0]);
	return 0;
}