#include <bits/stdc++.h>
#define double long double
using namespace std;
vector<pair<int, int> > stars;
struct Line{double k; double b; bool vert;};
struct Point{double x; double y;};
bool good, ans;
double ra, rb;
double eps = 0.0000001, PI = 3.1415926535;
Line per(int a, int b){
    Line res;
    if (stars[a].first == stars[b].first){
        res = {(double) stars[a].first, (double) -1, true};
        return res;
    }
    res.k = (double) (stars[a].second - stars[b].second) / (double) (stars[a].first - stars[b].first);
    int yf = res.k * (double) stars[a].first;
    res.b = (double) stars[a].second - (double) yf;
    res.vert = false;
    return res;
}
Point inter(Line a, Line b){
    Point deflt = {-1, -1};
    good = true;
    if (a.vert){
        if (!b.vert){
            double Y = b.k * a.k + b.b;
            Point np = {a.k, Y};
            return np;
        }
        else{
            good = false;
            return deflt;
        }
    }
    if (b.vert){
        double Y = a.k * b.k + a.b;
        Point np = {b.k, Y};
        return np;
    }
    if (a.k == b.k) {
        good = false;
        return deflt;
    }
    double X = (b.b - a.b) / (a.k - b.k);
    double Y = a.k * X + a.b;
    double xx = (double) ((int) X);
    double yy = (double) ((int) Y);
    if (abs(X-xx) > eps) good = false;
    if (abs(Y-yy) > eps) good = false;
    Point np = {X, Y};
    return np;
}
void check(int a, int b){
    Line f = per(a, b);
    int c = rand() % stars.size();
    while (c == a || c==b) c = rand() % stars.size();
    vector<Point> what;
    for (int i=0; i < stars.size(); i++){
        if (i==c) continue;
        Line th = per(i, c);
        Point p = inter(f, th);
        if (good) what.push_back(p);
    }
    for (int i=0; i < what.size(); i++){
        bool could = true;
        vector<double> na;
        for (int j=0; j < stars.size(); j++){
            double Dy = stars[j].second - what[i].y;
            double Dx = stars[j].first - what[i].x;
            if (abs(Dx) < eps && abs(Dy) < eps){
                could = false;
                break;
            }
            double ang = atan2(Dy, Dx);
            if (ang < 0) ang += PI;
            na.push_back(ang);
        }
        sort(na.begin(), na.end());
        for (int j=1; j < na.size(); j+=2){
            if (abs(na[j] - na[j-1]) > eps) could = false;
            if (j + 1 < na.size()){
                if (abs(na[j] - na[j+1]) < eps) could = false;
            }
        }
        if (could){
            ans = true;
            ra = what[i].x, rb = what[i].y;
        }
    }
}
signed main()
{
    //freopen("1.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i=0; i < 2*n; i++){
        int x, y;
        cin >> x >> y;
        stars.push_back(make_pair(x, y));
    }
    int point = rand() % (2*n);
    ans = false;
    for (int i=0; i < 2*n; i++){
        if (i==point) continue;
        check(i, point);
        if (ans){
            cout << "Yes" << endl;
            cout << ra << " " << rb << endl;
            return 0;
        }
    }
    cout << "No" << endl;
}
