#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <string>
#include <set>
#include <map>
#define ll long long
using namespace std;
vector <vector <short> > k_ch;
int n;
string s;

int check(int l) {
	for (int j = 2; j <= n / l; j++) {
		for (int i = 0; i < 26; i++) {
			if (k_ch[l][i] != (k_ch[j * l][i] - k_ch[(j - 1) * l][i]))
				return 0;
		}
	}
	return 1;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> s;
	 n = s.size();
	k_ch.resize(n + 1, vector <short>(26, 0));

	for (int i = 0; i < n; i++) {
		for (int c = 0; c < 26; c++) {
			k_ch[i + 1][c] = k_ch[i][c];
		}
		k_ch[i + 1][s[i] - 'a']++;
	}
	int ans = 1;
	for (int i = 1; i < n; i++) {
		if ((n % i == 0) && (check(i))) {
			ans = n / i;
			break;
		}
	}
	cout << ans;
	return 0;
}