#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define sz(x) ((int)(x).size())

namespace pbds = __gnu_pbds;

template <class K>
using ordered_set = pbds::tree <K,
                                pbds::null_type,
                                std::less<K>,
                                pbds::rb_tree_tag,
                                pbds::tree_order_statistics_node_update>;

const int INF = 1228228228;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, q;

    cin >> n >> q;

    vector<int> ans(2*n + 1, 0);
    ans[0] = INF;

    for(int i = 1; i <= n; ++i) {
        ans[2*i - 1] = i;
    }

    int black = 2*n - 1;
    for(int i = 2*n - 1; i > 1; --i) {
        if(ans[i] == 0) {
            ans[i] = ans[black];
            black--;
        }
    }

    while(q--) {
        int x;
        cin >> x;
        cout << ans[x] << endl;
    }
    return 0;
}
