#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define sz(x) ((int)(x).size())

namespace pbds = __gnu_pbds;

template <class K>
using ordered_set = pbds::tree <K,
                                pbds::null_type,
                                std::less<K>,
                                pbds::rb_tree_tag,
                                pbds::tree_order_statistics_node_update>;

const int INF = 1228228228;

vector< vector<int> > g;

vector<int> c;

long long answer = 0;

long long dfs(int v) {
    vector<long long> sums;
    int k = 0;
    for(int i = 0; i < sz(g[v]); ++i) {
        int to = g[v][i];
        sums.push_back(dfs(to));
        k += sums.back();
    }

    for(int i = 0; i < sz(sums); ++i)
        for(int j = i + 1; j < sz(sums); ++j) {
            if(sums[i] == 1 || sums[j] == 1)
                answer += sums[i] * sums[j] * 2;
                else
                    answer += sums[i] * sums[j];
        }
    k += c[v];
    return k;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    #ifdef ONLINE_JUDGE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int n, t;

    cin >> n;

    g.resize(n);
    c.resize(n);

    c[0] = 0;

    for(int i = 1; i < n; ++i) {
        cin >> t; t--;
        g[t].push_back(i);
    }

    for(int i = 1; i < n; ++i) {
        cin >> c[i];
        if(c[i] != 1) {
            cout << 25 << endl;
            return 1;
        }
    }


    long long ans = dfs(0);

    cout << answer << endl;

    return 0;
}
