#include <bits/stdc++.h>
using namespace std;

#define vec vector
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;

int n;
vec<vec<int> > g;
vec<int> sz, c;

ll dfs(int v) {
    sz[v] = 1;
    vec<int> arr;
    ll ans = 0;
    for (int u : g[v]) {
        ans += dfs(u);
        sz[v] += sz[u];
        arr.pb(sz[u]);
    }
    ans += sz[v] - 1;
    sort(arr.begin(), arr.end());
    int l = 0, r = arr.size() - 1;
    while (l < r) {
        int t = arr[r];
        arr[r] = max(arr[r] - arr[l], 0);
        arr[l] -= (t - arr[r]);
        if (!arr[l]) { l++; }
        if (!arr[r]) { r--; }
    }
    if (l == r) { ans += arr[l]; }
    return ans;
}


int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    g = vec<vec<int> >(n);
    sz = c = vec<int>(n);
    for (int k = 1; k < n; k++) {
        int x;
        cin >> x;
        g[x - 1].pb(k);
    }
    for (int k = 1; k < n; k++) {
        cin >> c[k];
        if (c[k] != 1) {
            cout << "25\n"; return 0;
        }
    }
    cout << dfs(0);

    return 0;
}
