#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <string>
#include <algorithm>

#define ll long long 
#define fi(n) for (int i = 0; i < (n); i++) 
#define FOR(i, k, n) for (int i = (k); i < (n); i++) 
#define all(v) v.begin(), v.end()

const int INF = 1e6 + 10;

using namespace std;

const int ALP = 'z' - 'a' + 1;

ll gcd(int a, int b)
{
    while (a > 0 && b > 0)
        if (a > b)
            a %= b;
        else
            b %= a;
    return a + b;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);

    string s;
    cin >> s;
    if (s.length() <= 500000)
    {
        vector<array<int, ALP>> v(s.length());
        v[0][s[0] - 'a']++;
        FOR(i, 1, s.length())
        {
            FOR(j, 0, ALP)
                v[i][j] += v[i - 1][j];
            v[i][s[i] - 'a']++;
        }

        int st = 0;

        FOR(j, 0, ALP)
            st = gcd(st, v.back()[j]);

        for (int i = 1; i <= st; i++)
        {
            if (st % i != 0)
                continue;
            st /= i;
            bool answ = true;
            for (int j = s.length() / st - 1; j < s.length(); j += s.length() / st)
            {
                bool pos = true;
                for (int k = 0; k < ALP; k++)
                    if (v.back()[k] > 0 && (v[j][k] / (v.back()[k] / st) != (j + 1) / (s.length() / st)))
                    {
                        pos = false;
                        break;
                    }
                if (!pos)
                {
                    answ = false;
                    break;
                }
            }
            if (answ)
                return cout << st << endl, 0;
            st *= i;
        }
    }
    else
    {
        const int ALP = 2;
        vector<array<int, ALP>> v(s.length());
        v[0][s[0] - 'a']++;
        FOR(i, 1, s.length())
        {
            FOR(j, 0, ALP)
                v[i][j] += v[i - 1][j];
            v[i][s[i] - 'a']++;
        }

        int st = 0;

        FOR(j, 0, ALP)
            st = gcd(st, v.back()[j]);

        for (int i = 1; i <= st; i++)
        {
            if (st % i != 0)
                continue;
            st /= i;
            bool answ = true;
            for (int j = s.length() / st - 1; j < s.length(); j += s.length() / st)
            {
                bool pos = true;
                for (int k = 0; k < ALP; k++)
                    if (v.back()[k] > 0 && (v[j][k] / (v.back()[k] / st) != (j + 1) / (s.length() / st)))
                    {
                        pos = false;
                        break;
                    }
                if (!pos)
                {
                    answ = false;
                    break;
                }
            }
            if (answ)
                return cout << st << endl, 0;
            st *= i;
        }
    }
    return 0;
}

