#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <string>
#include <algorithm>

#define ll long long 
#define fi(n) for (int i = 0; i < (n); i++) 
#define FOR(i, k, n) for (int i = (k); i < (n); i++) 
#define all(v) v.begin(), v.end()

const int INF = 1e6 + 10;

using namespace std;

vector<vector<int>> g;
vector<array<ll, 3>> d;
vector<ll> c;

ll answ = 0;

void dfs(int v)
{
    d[v][0] = c[v];
    d[v][1] = 1;
    d[v][2] = INF;

    ll cnt = 0;

    sort(all(g[v]), [](int a, int b) {return g[a].size() > g[b].size(); });

    for (auto u : g[v])
    {
        dfs(u);
        d[v][0] += d[u][0];
        d[v][1] += d[u][1];
        d[v][2] = min(d[v][2], d[u][2]);
        answ += d[u][0];
        cnt = abs(d[u][1] - cnt) - 2;
    }
    answ += cnt * d[v][2];
    d[v][2] = min(d[v][2], c[v]);
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    g.resize(n);
    d.resize(n);
    c.resize(n);

    FOR(i, 1, n)
    {
        int v;
        cin >> v;
        g[v - 1].push_back(i);
    }
    FOR(i, 1, n)
        cin >> c[i];
    dfs(0);
    cout << answ << endl;
    return 0;
}

