#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <string>
#include <algorithm>

#define ll long long 
#define fi(n) for (int i = 0; i < (n); i++) 
#define FOR(i, k, n) for (int i = (k); i < (n); i++) 
#define all(v) v.begin(), v.end()

const int INF = 1e6 + 10;

using namespace std;

vector<vector<int>> g;
vector<array<ll, 2>> d;
vector<ll> c;
vector<ll> sz;

ll answ = 0;

void getSz(int v)
{
    sz[v] = 1;
    for (auto u : g[v])
    {
        getSz(u);
        sz[v] += sz[u];
    }
}

void dfs(int v)
{
    if (g[v].size() == 0)
    {
        d[v][1] = c[v];
        d[v][0] = c[v];
        return;
    }

    d[v][0] = 0;
    d[v][1] = INF;

    ll cnt = 0;

    sort(all(g[v]), [](int a, int b) {return sz[a] > sz[b]; });
   
    ll allsz = 0;

    bool frst = true;
    for (auto u : g[v])
    {
        dfs(u);
        d[v][0] += d[u][0];
    }
    
    FOR(i, 1, g[v].size())
        allsz += sz[g[v][i]];

    for (auto u : g[v])
    {
        if (frst && (allsz < sz[u]))
        {
            frst = false;
            continue;
        }
        d[v][1] = min(d[v][1], d[u][1]);
        frst = false;
    }
    if (allsz < sz[g[v][0]])
        answ += (sz[g[v][0]] - allsz) * d[v][1];
    else
    {
        if ((allsz + sz[g[v][0]]) % 2)
            answ += d[v][1];
    }
    answ += d[v][0];
    d[v][1] = min(d[v][1], c[v]);
    d[v][0] += c[v];
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    g.resize(n);
    d.resize(n);
    c.resize(n);
    sz.resize(n);

    FOR(i, 1, n)
    {
        int v;
        cin >> v;
        g[v - 1].push_back(i);
    }

    FOR(i, 1, n)
        cin >> c[i];
    
    getSz(0);
    dfs(0);
    
    cout << answ << endl;
    return 0;
}

