#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <string>
#include <algorithm>

#define ll long long 
#define fi(n) for (int i = 0; i < (n); i++) 
#define FOR(i, k, n) for (int i = (k); i < (n); i++) 
#define all(v) v.begin(), v.end()

const int INF = 1e6 + 10;

using namespace std;

vector<vector<int>> g;
vector<array<ll, 2>> d;
vector<ll> c;
vector<ll> sz;

unsigned ll answ = 0;

void dfs(int v)
{
    if (g[v].size() == 0)
    {
        d[v][1] = c[v];
        d[v][0] = c[v];
        sz[v] = 1;
        return;
    }

    d[v][0] = 0;
    d[v][1] = INF;
    sz[v] = 0;
    ll mx = g[v][0];

    for (auto u : g[v])
    {
        dfs(u);
        d[v][0] += d[u][0];
        sz[v] += sz[u];
        if (sz[u] > sz[mx])
            mx = u;
    }

    ll allsz = sz[v] - sz[mx];

    for (auto u : g[v])
    {
        if (allsz < sz[u])
            continue;
        d[v][1] = min(d[v][1], d[u][1]);
    }

    if (allsz < sz[mx])
        answ += (sz[mx] - allsz) * d[v][1];
    else
        if ((allsz + sz[mx]) % 2)
            answ += d[v][1];
    
    answ += d[v][0];
    d[v][1] = min(d[v][1], c[v]);
    d[v][0] += c[v];
    sz[v]++;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    g.resize(n);
    d.resize(n);
    c.resize(n);
    sz.resize(n);

    FOR(i, 1, n)
    {
        int v;
        cin >> v;
        g[v - 1].push_back(i);
    }

    FOR(i, 1, n)
        cin >> c[i];
    
    dfs(0);
    
    cout << answ << endl;
    return 0;
}

