#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
ll sqr(ll a) {
    return a * a;
}

vector < vector < int > > g;
ll ans;

int dfs(int v) {
    vector < int > cnt;
    for (auto to: g[v]) {
        cnt.push_back(dfs(to));
    }
    int sz = 0;
    for (auto p: cnt ) sz += p;
    sort(all(cnt));
    if (!cnt.empty()) {
        int sum = 0;
        for(auto p: cnt) sum += p;
        int sum1 = 0;
        for (int i = 0; i < cnt.size(); i++) {
            sum1 += cnt[i];
            sum -= cnt[i];
            if (sum1 >= sum) {
                ans += sum1 * 2;
                break;
            }
        }
    }
    return sz + 1;
}


int main() {
//    freopen("a.txt", "r", stdin);
//    freopen("b.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    int n;
    cin >> n;
    vector < int > sz(n);
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[--p].push_back(i);
        sz[i] = 1;
        sz[p] += sz[i];
    }

    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
    }

//    dfs(0);

    for (int v = 0; v < n; v++) {
        if (!g[v].empty()) {
            int cnt = 0;
            for (auto &to: g[v]) {
                to = sz[to];
                cnt = max(cnt, to);
            }
            if (2 * cnt > sz[v] + 1) {
                ans += 2 * cnt;
            }
            else {
                ans += sz[v] - (sz[v] % 2);
            }
        }
    }

    cout << ans;
}
