#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(s) s.begin(), s.end()

#define bp __builtin_popcountll
#define b_clz __builtin_clzll
#define b_ctz __builtin_ctzll

typedef long long llong;
typedef unsigned long long ullong;

typedef vector <int> vi;
typedef vector <llong> vl;

typedef pair <int, int> pii;

const int MXN = 1e6 + 1;
const int MNN = 1e3 + 1;
const int INF = 1e9;
const llong MOD = 1e9 + 7;
const llong LINF = 1e18;

llong log2 (llong x) {return 64 - b_clz (x) - 1;};
llong __lcm (llong x, llong y) {return x / __gcd (x, y) * y;};

string s;

int N;
int sums[(int)(sqrt (5 * MXN)) + 5][26];

int get (int l, int r, int j) {
	int sum1 = 0;
	for (int i = l; i <= r;) {
		if (i % N == 0 && i + N <= r) {
			sum1 += sums[i / N][j];
			i += N;
		}
		else {
			sum1 += ((s[i] - 'a') == j);
			++ i;
		}
	}
	return sum1;
}

int main () {
	//freopen ("input.txt", "r", stdin);
	cin >> s;
	int n = s.size ();
	N = sqrt (n);
	for (int i = 0; i < n; ++ i) {
		++ sums[i / N][s[i] - 'a'];
	}
	vi d;
	for (int i = 1; i * i <= n; ++ i) {
		if (n % i == 0) {
			d.pb (i);
			if (i * i != n) d.pb (n / i);
		}
	}
	bool good = 0;
	for (int j = 0; j < 26; ++ j) {
		if (get (0, n - 1, j) == n) good = 1;
	}
	if (good) {
		cout << n;
		return 0;
	}
	sort (all (d));
	for (int it : d) {
		bool ok = 1;
		for (int i = 2 * it - 1; i < n; i += it) {
			for (int j = 0; j < 26; ++ j) {
				if (get (i - it + 1, i, j) != get (i - 2 * it + 1, i - it, j)) ok = 0;
			}
		}
		if (ok == 1) {
			cout << n / it;
			return 0;
		}
	}
	return 0;
}