//By Don4ick
//#define _GLIBCXX_DEBUG

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

typedef long long ll;

#define pb push_back
#define all(x) x.begin(), x.end()
#define y1 rrtwertwe
#define forn(i, n) for (int i = 1; i <= n; i++)

const double PI = acos(-1.0);
const int DIR = 4;
const int X[] = {1, 0, -1, 0};
const int Y[] = {0, 1, 0, -1};

const int N = (int)5e5 + 228;
const int A = 26;
const int M = (int)6e5 + 228;

using namespace std;

int pref[N][A], n, p[M];
string s;

void solve1()
{
	//~precalc p
	forn(i, n)
	{
		p[i] = p[i - 1] + (s[i] == 'b');
	}		
	//~precalc blocks
	int val = min(p[n], n - p[n]);
	vector < int > blocks;
	for (int block = 1; block * block <= val; block++)
	{
		if (val % block == 0)
		{
			blocks.pb(block);
			if (val / block != block)
				blocks.pb(val / block);
		}
	}
	//~solve
	sort(all(blocks));
	for (auto block : blocks)
	{
		bool good = true;
		for (int i = (block << 1); i <= n; i += block)
		{
			if (p[i] - p[i - block] != p[block])
			{
				good = false;
				break;
			}
		}
		if (good)
		{
			cout << n / block << endl;
			exit(0);	
		}
	}
	assert(false);
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie();
	cout.tie();

	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);

	//~read
	cin >> s;
	n = (int)s.size();
	s = '#' + s;
	//~case a, b
	if (n >= N)
	{	
		solve1();
	}
	//~precalc pref
	forn(i, n)
	{
		for (int j = 0; j < A; j++)
			pref[i][j] = pref[i - 1][j];
		pref[i][s[i] - 'a']++;	
	}
	//~precalc blocks
	vector < int > blocks;
	for (int block = 1; block * block <= n; block++)
	{
		if (n % block == 0)
		{
			blocks.pb(block);
			if (n / block != block)
				blocks.pb(n / block);
		}
	}
	//~solve
	sort(all(blocks));
	for (auto block : blocks)
	{
		bool good = true;
		for (int i = (block << 1); i <= n; i += block)
		{
			for (int j = 0; j < A; j++)
			{
				if (pref[i][j] - pref[i - block][j] != pref[block][j])
				{
					good = false;
					break;
				}
			}
			if (!good)
				break;
		}
		if (good)
		{
			cout << n / block << endl;
			return 0;	
		}
	}
	assert(false);

	return 0;
}