#include <iostream>
#include <vector>

using namespace std;

vector <vector <int> > p;
int n;

const int INF = 1e9;

bool check(int k) {
    bool f = true;
    for (int i = k; i <= n; i+= k) {
        for (int j = 0; j < 26; j++) {
            f &= (p[i][j] - p[i - k][j] == p[k][j]);
        }
    }
    return f;
}

int main()
{
    string s;
    cin >> s;
    n = s.size();
    p.resize(n + 1, vector <int>(26, 0));
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < 26; j++) {
            p[i][j] = p[i - 1][j] + (s[i - 1] - 'a' == j);
        }
    }
    int mn = INF;
    for (int i = 1; i * i <= n; i++) {
        if (n % i) continue;
        if (check(i)) {
            mn = min(mn, i);
        }
        if (check(n / i)) {
            mn = min(mn, n / i);
        }
    }
    cout << n / mn;
    return 0;
}
