#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define fi first
#define se second
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

vector <int> get(int n) {
    vector <int> arr(2 * n, 0);
    for (int i = 0; i < 2 * n; i += 2)
        arr[i] = i / 2 + 1;
    stack <int> pos;
    for (int i = 1; i < 2 * n; i += 2)
        pos.push(i);
    pos.pop();
    for (int i = 2 * n - 1; i >= n; --i) {
        if (arr[i] == 0)
            continue;
        swap(arr[i], arr[pos.top()]);
        pos.pop();
    }
    arr.resize(n);
    return arr;
}

signed main()
{
    int n, q;
    cin >> n >> q;
    auto arr = get(n);
    for (int i = 0; i < q; ++i) {
        int x;
        cin >> x;
        --x;
        cout << arr[x] << endl;
    }
    return 0;
}
