#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> sub;
vector<vector<int> > g;
vector<vector<int> > r;

int ans = 0;

void dfs(int u) {
    sub[u] = 0;
    for (int i = 0; i < g[u].size(); i++) {
        dfs(g[u][i]);
        sub[u] += sub[g[u][i]] + 1;
        r[u].push_back(sub[g[u][i]] + 1);
    }
    if (g[u].size() > 0) {
        sort(r[u].begin(), r[u].end());
        int k = r[u].back();
        ans += 2 * k;
        for (int i = r[u].size() - 2; i >= 0; i--) {
            if (k < r[u][i]) {
                k = r[u][i] - k;
                ans += 2 * k;
            }
            else {
                k -= r[u][i];
            }
        }
    }
}

int main()
{
    int n;
    cin >> n;
    vector<int> p(n, 0);
    g.resize(n);
    r.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    sub.resize(n);
    dfs(0);
    cout << ans << endl;
    return 0;
}
