#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define re return
#define pb push_back

#define all(v) (v).begin(), (v).end()

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int run();

int run2();

void run_stress();

int main() {
#ifdef home
  freopen("i", "r", stdin);
  freopen("d", "w", stderr);
#endif
  ios::sync_with_stdio(0);
  cout.tie(0);
  cin.tie(0);

  run();

  return 0;
}

const int MOD = 1000000007;
const int INT_INF = (int) 2e9;
const ll LL_INF = (ll) 4e18;

ll x[6000];
ll y[6000];

pair<ld, ld> find_line(int a, int b) {
  double r = 1. * (y[a] - y[b]) / (x[a] - x[b]);
  double m = y[a] - x[a] * r;
  re {r, m};
};

pair<ll, ll> find_coord(int a, ll ox, ll oy) {
  ll xx = x[a] - ox;
  ll yy = y[a] - oy;
  ll gcd = __gcd(xx, yy);
  xx /= gcd;
  yy /= gcd;
  if (xx == 0) {
    yy = 1;
  }
  if (xx < 0) {
    xx = -xx;
    yy = -yy;
  }
  re {xx, yy};
}

pair<bool, pair<ll, ll> > find_inter(int a, int b, int c, int d) {
  auto line1 = find_line(a, b);
  auto line2 = find_line(c, d);

  ld ldx = (line2.se - line1.se) / (line1.fi - line2.fi);
  ld ldy = line1.fi * ldx + line1.se;

  if (abs(line1.fi) > 1e9) {
    if (abs(line2.fi) > 1e9) {
      re {false, {-1, -1}};
    }
    ldx = x[a];
    ldy = line2.fi * ldx + line2.se;
  }

  if (abs(line2.fi) > 1e9) {
    ldx = x[c];
    ldy = line1.fi * ldx + line1.se;
  }

  if (abs(line1.fi) < 1e9 && abs(line2.fi) < 1e9 && (abs(line1.fi - line2.fi) < 1e-9)) {
    re {false, {-1, -1}};
  }

  ll whole_x, whole_y;
  if (ldx > 0) {
    whole_x = ll(ldx + .01);
  } else {
    whole_x = ll(ldx - .01);
  }
  if (ldy > 0) {
    whole_y = ll(ldy + .01);
  } else {
    whole_y = ll(ldy - .01);
  }


//  if (a == 0 && b == 3 && c == 1 && d == 2) {
//    cerr << line1.fi << ' ' << line1.se << '\n';
//    cerr << line2.fi << ' ' << line2.se << '\n';
//    cerr << setprecision(30) << ' ' << ldx << ' ' << ldy << ' ' << whole_x << ' ' << whole_y << '\n';
//  }

  if ((whole_x == x[a] && whole_y == y[a]) ||
      (whole_x == x[b] && whole_y == y[b]) ||
      (whole_x == x[c] && whole_y == y[c]) ||
      (whole_x == x[d] && whole_y == y[d])) {
    re {false, {-1, -1}};
  }

//  if (a == 0 && b == 1 && c == 2 && d == 3) {
//    cerr << find_coord(a, whole_x, whole_y).fi << ' ' << find_coord(a, whole_x, whole_y).se << '\n';
//    cerr << find_coord(b, whole_x, whole_y).fi << ' ' << find_coord(b, whole_x, whole_y).se << '\n';
//    cerr << find_coord(c, whole_x, whole_y).fi << ' ' << find_coord(c, whole_x, whole_y).se << '\n';
//    cerr << find_coord(d, whole_x, whole_y).fi << ' ' << find_coord(d, whole_x, whole_y).se << '\n';
//  }


  if (find_coord(a, whole_x, whole_y) != find_coord(b, whole_x, whole_y) ||
      find_coord(c, whole_x, whole_y) != find_coord(d, whole_x, whole_y)) {
    re {false, {-1, -1}};
  }
  re {true, {whole_x, whole_y}};
};

map<pii, int> cnt;
int n;

void check_line(int a, int i, int b, int j) {
  auto res = find_inter(a, i, b, j);
  if (res.fi == 0) {
    re;
  }
  ll ox = res.se.fi;
  ll oy = res.se.se;
  if (abs(ox) > 1000000 || abs(oy) > 1000000) {
    re;
  }
  cnt.clear();
  f(k, n) {
    if (x[k] == ox && y[k] == oy) {
      re;
    }
    auto c = find_coord(k, ox, oy);
//    if (a == 0 && i == 3 && b == 1 && j == 2) {
//      cerr << ' ' << k << ' ' << c.fi << ' ' << c.se << '\n';
//    }
    cnt[c]++;
  }
  bool ok = true;
  for (auto c : cnt) {
//    if (a == 0 && i == 1 && b == 2 && j == 3) {
//      cerr << c.fi.fi << ' ' << c.fi.se << ' ' << c.se << '\n';
//    }
    if (c.se != 2) {
      ok = false;
      break;
    }
  }
  if (ok) {
    cout << "Yes\n" << ox << ' ' << oy << '\n';
    exit(0);
  }
}

int p[6005];

vector<pair<pii, pii> > ca;

int run() {
  cin >> n;

  double t0 = clock();

  n *= 2;

  f(i, n) {
    p[i] = i;
  }

  random_shuffle(p, p + n);

  f(i, n) {
    cin >> x[p[i]] >> y[p[i]];
  }

  int a = 0;
  int b = 1;
  ca.reserve(n * (n + 1));
  for (int i = 2; i < n; i++) {
    for (int j = 2; j < n; j++) {
      if (i == j) continue;
      ca.pb({{a, i}, {b, j}});
    }
  }

  b = 2;

  for (int i = 3; i < n; i++) {
    ca.pb({{0, 1}, {2, i}});
  }

  random_shuffle(all(ca));

  f(i, ca.size()) {
    if ((i & 8095) == 0) {
      if (clock() - t0 > CLOCKS_PER_SEC * 4.9) {
        break;
      }
    }
    auto x = ca[i];
    check_line(x.fi.fi, x.fi.se, x.se.fi, x.se.se);
  }


  cout << "No";

  re 0;
}

int run2() {
  re 0;
}

void run_stress() {
  while (true) {
    auto res1 = run();
    auto res2 = run2();
    if (res1 != res2) {
      cerr << res1 << ' ' << res2 << '\n';
      cerr << "--------------\n";
      re;
    }
  }
}