#include<iostream>
#include<vector>
#include<stack>
#include<algorithm>
#include<unordered_set>
#include<unordered_map>
#include<set>

using namespace std;

int gcd(int a, int b) {
    if (a == 0)return b;
    return gcd(b%a, a);
}

struct point {
    int x, y;
    point(){}
    point(int x, int y) {
        this->x = x;
        this->y = y;
    }
};

const int MINPOS = -1e6;
const int MAXPOS = 1e6;

double EPSILAN = 1e-9;


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

    int n;
    cin >> n;

    set<pair<int, int>> used;
    vector<point> inp(2 * n);
    int x, y;
    for (int i = 0; i < 2*n; i++) {
        cin >> x >> y;
        inp[i] = point(x, y);
        used.insert({ x, y });
    }

    x = inp[0].x;
    y = inp[0].y;

    for (int oth = 1; oth < 2*n; oth++) {
        //cout << "oth: " << oth << '\n';
        //ot
        int movex = inp[oth].x - inp[0].x;
        int movey = inp[oth].y - inp[0].y;
        int gc = max(1, abs(gcd(movex, movey)));
        movex /= gc; movey /= gc;

        int maxx = 0;
        if (movex != 0)
        {
            if (movex < 0)
                maxx = (-MINPOS + x) / (-movex);
            else
                maxx = (MAXPOS - x) / movex;
        }

        int maxy = 0;
        if (movey != 0) {
            if (movey < 0)
                maxy = (-MINPOS + y) / (-movey);
            else
                maxy = (MAXPOS - y) / movey;

            int maxmove = min(maxx, maxy);
        }
        int xp = x + movex * maxx;
        int yp = y + movey * maxy;

        while (abs(xp) <= MAXPOS && abs(yp) <= MAXPOS) {

            //cout << xp << ' ' << yp << '\n';

            if (used.find({xp, yp}) == used.end()) {
                //used.insert({ xp, yp });
                vector<pair<int, int>> cf;
                for (int i = 0; i < 2*n; i++) {
                    gc = max(abs(gcd(inp[i].x - xp, inp[i].y - y)), 1);
                    //cout << gc << '\n';
                    cf.push_back({ (inp[i].x - xp) / gc, (inp[i].y - yp) / gc });
                    //cout << "CF: " << cf[i].first << ' ' << cf[i].second << '\n';
                    if (cf[i].first < 0) {
                        cf[i].first *= -1;
                        cf[i].second *= -1;
                    }
                    if (cf[i].first == 0 && cf[i].second < 0) {
                        cf[i].first *= -1;
                        cf[i].second *= -1;
                    }
                }
                sort(cf.begin(), cf.end());
                bool flag = true;
                for (int i = 0; i < n; i++) {
                    if (cf[2*i] != cf[2*i + 1])
                        flag = false;
                    if (i != n - 1 && cf[2 * i] == cf[2 * (i + 1)])
                        flag = false;
                }
                if (flag) {
                    cout << "Yes\n";
                    cout << xp << ' ' << yp << '\n';
                    system("pause");
                    return 0;
                } 
            }
            xp -= movex;
            yp -= movey;
            //system("pause");
        }
    }

    cout << "No\n";
	//system("pause");
	return 0;
}