#include<iostream>
#include<vector>
#include<stack>
#include<algorithm>
#include<unordered_set>
#include<unordered_map>
#include<set>
#include<ctime>

using namespace std;

//#define int long long

int gcd(int a, int b) {
    if (a == 0)return b;
    return gcd(b%a, a);
}

int gcr(int a, int b) {
    a = abs(a);
    b = abs(b);
    if (a == 0 && b==0) return 1;
    if (a == 0)return b;
    if (b == 0) return a;
    return gcd(a, b);
}

struct point {
    int x, y;
    point(){}
    point(int x, int y) {
        this->x = x;
        this->y = y;
    }
    bool operator==(point other) {
        return x == other.x && y == other.y;
    }
};

const int MINPOS = -1e6;
const int MAXPOS = 1e6;

double EPSILAN = 1e-9;


signed main() {
    //int srt = clock();

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

    int n;
    cin >> n;

    set<pair<int, int>> used;
    vector<point> inp(2 * n);
    int x, y;
    for (int i = 0; i < 2*n; i++) {
        cin >> x >> y;
        inp[i] = point(x, y);
        used.insert({ x, y });
    }

    x = inp[0].x;
    y = inp[0].y;

    //int cnt = 0;

    for (int oth = 1; oth < 2*n; oth++) {

        if (clock() > 4000000)
        {
            cout << "No\n";
            return 0;
        }
        //cerr << clock() - srt<<' '<<clock() << '\n';
        //cout << "oth: " << oth << '\n';
        //ot
        int movex = inp[oth].x - inp[0].x;
        int movey = inp[oth].y - inp[0].y;
        int gc = gcr(movex, movey);
        movex /= gc; movey /= gc;


        int xp = x;
        int yp = y;

        while (abs(xp) <= MAXPOS && abs(yp) <= MAXPOS) {
            //if (used.find({xp, yp}) == used.end()) {
                //cout << xp<< ' ' << yp << '\n';
                //used.insert({ xp, yp });
            vector<pair<int, int>> cf;
            bool flag = true;
            for (int i = 0; i < 2 * n; i++) {
                if (inp[i] == point(xp, yp)) {
                    flag = false; break;
                }
                gc = gcr(inp[i].x - xp, inp[i].y - yp);
                //cout << gc << '\n';
                cf.push_back({ (inp[i].x - xp) / gc, (inp[i].y - yp) / gc });
                //cout << "CF: " << cf[i].first << ' ' << cf[i].second << '\n';
                if (cf[i].first < 0) {
                    cf[i].first *= -1;
                    cf[i].second *= -1;
                }
                if (cf[i].first == 0 && cf[i].second < 0) {
                    cf[i].first *= -1;
                    cf[i].second *= -1;
                }
            }
            if (!flag) {
                xp += movex;
                yp += movey;
                continue;
            }
            sort(cf.begin(), cf.end());
            for (int i = 0; i < n; i++) {
                if (cf[2 * i] != cf[2 * i + 1]) {
                    flag = false;
                    break;
                }
                if (i != n - 1 && cf[2 * i] == cf[2 * (i + 1)]) {
                    flag = false;
                    break;
                }
            }
            if (flag) {
                cout << "Yes\n";
                cout << xp << ' ' << yp << '\n';
                //system("pause");
                return 0;
            }
            //}
            xp += movex;
            yp += movey;
            //system("pause");
        }

        xp = x;
        yp = y;

        while (abs(xp) <= MAXPOS && abs(yp) <= MAXPOS) {
            //if (used.find({ xp, yp }) == used.end()) {
                //used.insert({ xp, yp });
            vector<pair<int, int>> cf;
            bool flag = true;
            for (int i = 0; i < 2 * n; i++) {
                if (inp[i] == point(xp, yp)) {
                    flag = false; break;
                }
                gc = gcr(inp[i].x - xp, inp[i].y - yp);
                //cout << gc << '\n';
                cf.push_back({ (inp[i].x - xp) / gc, (inp[i].y - yp) / gc });
                //cout << "CF: " << cf[i].first << ' ' << cf[i].second << '\n';
                if (cf[i].first < 0) {
                    cf[i].first *= -1;
                    cf[i].second *= -1;
                }
                if (cf[i].first == 0 && cf[i].second < 0) {
                    cf[i].first *= -1;
                    cf[i].second *= -1;
                }
            }
            if (!flag) {
                xp -= movex;
                yp -= movey;
                continue;
            }
            sort(cf.begin(), cf.end());
            for (int i = 0; i < n; i++) {
                if (cf[2 * i] != cf[2 * i + 1]) {
                    flag = false;
                    break;
                }
                if (i != n - 1 && cf[2 * i] == cf[2 * (i + 1)]) {
                    flag = false;
                    break;
                }
            }
            if (flag) {
                cout << "Yes\n";
                cout << xp << ' ' << yp << '\n';
                //system("pause");
                return 0;
            }
            // }
            xp -= movex;
            yp -= movey;
            //system("pause");
        }
    }

    cout << "No\n";
	//system("pause");
	return 0;
}