#include <bits/stdc++.h>

#define ld long double
#define fs first
#define sc second
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define mp make_pair
#define len(v) ((int)v.size())
#define vc vector
#define pr pair
#define endd "\n"; return 0;
#define all(v) v.begin(), v.end()
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#pragma GCC target("avx,tune=native")

using namespace std;

const int MAXN = 5e6;
const int INF = 1e9;
const int MOD = 1e9 + 7;
const int BLOCK = 1000;

string s;
int prefix[MAXN / BLOCK + 100][27];
int x[27];

int zap(int first, int last, int col){
    int kek = 0;
    last--;
    for (; first % BLOCK != 0 && first <= last; first++){
        if (s[first] == col + 'a'){
            kek++;
        }
    }
    for (; first + BLOCK - 1 <= last; first += BLOCK){
        kek += prefix[first / BLOCK][col];
    }
    for (; first <= last; first++){
        if (s[first] == col + 'a'){
            kek++;
        }
    }
    return kek;
}

bool prav(int v){
    for (int i = 0; i < 27; i++){
        x[i] = zap(0, v, i);
    }
    for (int i = 0; i + v <= len(s); i += v){
        for (int j = 0; j < 27; j++){
            if (x[j] != zap(i, i + v, j)){
                return 0;
            }
        }
    }
    return 1;
}

class TaskC {
public:
    void solve(std::istream &in, std::ostream &out) {
        in >> s;
        int n = len(s);
        for (int i = 0; i * BLOCK <= n; i++){
            for (int j = i * BLOCK; j < min(n, (i + 1) * BLOCK); j++){
                prefix[i][s[j] - 'a']++;
            }
        }
        vc<int> tocheck;
        for (int i = 1; i * i <= n; i++){
            if (n % i == 0){
                tocheck.pb(i);
            }
        }
        for (int i = 1; i * i <= n; i++){
            if (n % i == 0){
                tocheck.pb(n / i);
            }
        }
        sort(all(tocheck));
        reverse(all(tocheck));
        vc<int> checked;
        int ans = 0;
        //int provop = 0;
        for (auto v : tocheck){
            for (auto to : checked){
                //provop++;
                if (to % v == 0){
                    break;
                }
            }
            //provop += n / v;
            if (prav(v)){
                ans = v;
            }
            else{
                checked.pb(v);
            }
        }
        out << n / ans;
    }
};


main() {
    TaskC solver;
    std::istream &in(std::cin);
    std::ostream &out(std::cout);
    in.tie(0);
    ios_base::sync_with_stdio(0);
    solver.solve(in, out);
    return 0;
}