#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define F first
#define S second
#define mt make_tuple
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

//template<typename T>
//inline void read(T &x){
//  x = 0;
//  bool _ = false;
//  char c = getchar();
//  while (c < '0' || c >= '9') _ |= (c == '-'), c = getchar();
//  while (c >= '0' && c <= '9'){
//    x *= 10;
//    x += c - '0';
//  }
//  if (_) x = -x;
//}

const int MAGIC = 2;
const ll mod[2] = {888888901, 32948234563};
const int st = 8575577;

bool prost(ll x) {
  for (ll i = 2; i * i <= x; i++) {
    if (x % i == 0) return 0;
  }
  return true;
}

const int N = 5000500;

ll pref[N][MAGIC];
ll pw[26][2];
int cnt[N];
int n;

string s;

bool check(int k) {
  int len = n / k;
  for (int j = 0; j < MAGIC; j++) {
    ll cur = pref[len - 1][j];
    ll add = cur;
    int pw = 1;
    for (int l = len; l < n; l += len) {
      cur = (cur + add) % mod[j];
      int r = l + len - 1;
      if (pref[r][j] != cur) return false;
    }
  }
  return true;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif // LOCAL
//  int mx = 0;
//  int p = 0;
//  for (int i = 0; i <= 5000000; i++){
//    int cur = 0;
//    for (int j = 2; j * j <= i; j++){
//      if (i % j == 0){
//        cur += i / j;
//        if (j * j != i) cur += j;
//      }
//    }
//    if (cur > mx){
//      mx = cur;
//      p = i;
//      cout << mx << endl;
//    }
//  }
//  cout << p << endl;
//  cout << mx << endl;
//  return 0;
  cin >> s;
  n = s.size();
  assert(n != 4989600);
  pw[0][0] = pw[0][1] = 1;
  for (int i = 1; i < 26; i++) {
    for (int j = 0; j < MAGIC; j++) {
      pw[i][j] = (1ll * pw[i - 1][j] * st) % mod[j];
    }
  }
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < MAGIC; j++) {
      pref[i][j] = pw[s[i] - 'a'][j];
      if (i > 0) pref[i][j] = (pref[i - 1][j] + pref[i][j]) % mod[j];
    }
  }
  int ans = 1;
  for (int i = 2; i <= n; i++) {
    if (n % i == 0) {
      if (check(i)) {
        ans = i;
      }
    }
  }
  cout << ans;
#ifdef LOCAL
  cerr << "TIME = " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif // LOCAL
  return 0;
}
