#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

int cnt[31];

vector<int> cur1(31), cur2(31);

int tmm;

int gcd(int a, int b) {
	while (b) a %= b, swap(a, b);
	return a;
}

bool check(int len, string &s) {
	int n = (int)s.size();

	cur1.assign(31, 0);
	cur2.assign(31, 0);
	
	int zero1 = 31;
	int zero2 = 31;
	
	for (int i = 0; i < n; i += len) {
		
		//err("i = %d\n", i);
		//err("cur1 = "); for (int j =0;  j < 3; j++) err("%d, ", cur1[j]); err("\n");
		//err("cur2 = "); for (int j =0;  j < 3; j++) err("%d, ", cur2[j]); err("\n");
	
		for (int j = i; j < i + len; j++) {
    		if (++cur1[s[j] - 'a'] == 1) zero1--;
    		if (i > 0) {
    			if (--cur2[s[j] - 'a'] == 0) zero2++;
    		}
		}
		
		if (i > 0 && zero2 < 31) return false;
		swap(zero1, zero2);
		cur1.swap(cur2);
	}
	return true;
}

int main() {
	string s;
	cin >> s;
	
	int n = (int)s.size();
	for (char c : s) cnt[c - 'a']++;
	
	int t = n;
	for (int i = 0; i < 31; i++) t = gcd(t, cnt[i]);
	
	int ans = 1;
	for (int x = 1; x * x <= t; x++) if (t % x == 0) {
		if (check(n / t, s)) ans = max(ans, t);
		if (check(n / (t / x), s)) ans = max(ans, (t / x));
	}
	cout << ans << "\n";
	
	return 0;
} 