#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

int cnt[31];
int cur1[31], cur2[31];
char s[(int)5e6 + 7];
char good[(int)5e6 + 7];
int  n;

int gcd(int a, int b) {
	while (b) a %= b, swap(a, b);
	return a;
}

char check(int len) {

	if (2 * len <= n && good[2 * len] == 2) return good[len] = 2;
	if (3 * len <= n && good[3 * len] == 2) return good[len] = 2;
	
	memset(cur1, 0, sizeof(cur1));
	memset(cur2, 0, sizeof(cur2));
	
	int zero1 = 31;
	int zero2 = 31;
	
	for (int i = 0; i < n; i += len) {
		for (int j = i; j < i + len; j++) {
    		if (++cur1[s[n - j - 1] - 'a'] == 1) zero1--;
    		if (i > 0 && --cur2[s[n - j - 1] - 'a'] == 0) zero2++;
    		if (i > 0 && (i + len - j - 1) + zero2 < 31) return good[len] = 2;
		}	
		swap(zero1, zero2);
		swap(cur1, cur2);
	}
	return good[len] = 1;
}

int main() {
	scanf("%s", s);
	
	n = strlen(s);
	for (int i = 0; i < n; i++) cnt[s[i] - 'a']++;
	
	int t = n;
	for (int i = 0; i < 31; i++) t = gcd(t, cnt[i]);
	
	vector<int> divs;
	for (int x = 1; x * x <= t; x++) if (t % x == 0) {
		divs.push_back(x);
		if (x * x != t) divs.push_back(t / x);
	}
	
	int ans = 1;
	for (int x : divs) {
		int len = n / x;
		if (x > ans && check(len) == 1) ans = max(ans, x);
	}
	printf("%d\n", ans);
	return 0;
} 