#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

ll cur = 0;

vector<vector<int> > E;
const int dd = (int)2e5 + 7;
int c[dd], p[dd];

int dfs(int v) {
	int sz = 1;
	vector<int> t;
	for (int to : E[v]) {
		t.push_back(dfs(to));
		sz += t.back();
	}
	
	while (t.size()) {
		sort(t.rbegin(), t.rend());
		
		if (t[0] == 0) break;
		if ((int)t.size() == 1 || t[1] == 0) {
			cur += 2 * t[0];
			break;
		}
		
		for (int i = 1; i < (int)t.size(); i++) if (t[i] && t[0]) {
			t[0]--, t[i]--;
			cur += 2;
		}
	}
	return sz;
}

int main() {
	int n;
	cin >> n;
	
	E.resize(n);
	
	for (int i = 1; i < n; i++) {
		cin >> p[i];
		p[i]--;
		E[p[i]].push_back(i);
	}
	
	int ok = 1;
	for (int i = 1; i < n; i++) {
		cin >> c[i];
		ok &= (c[i] == 1);
	}
	
	if (ok) {
		dfs(0);
		cout << cur << "\n";
		return 0;
	}
	
	assert(0);
	
	return 0;
} 