#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second
#define m_p make_pair
#define endl '\n'
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0)

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
/*order_of_key, find_by_order*/

typedef long long ll;
const int MAXN = 512345;
const int MAXINT = 2146483648;
const ll MAXLL = 9223372035854775808LL;

int pf[27][MAXN];
int n;

bool check(int how) {
    for (int j = how; j < n; j += how) {
        for (int k = 'a'; k <= 'z'; ++k) if (pf[j + how][k - 'a'] - pf[j][k - 'a'] != pf[j][k - 'a'] - pf[j - how][k - 'a']) return 0;
    }
    return 1;
}

int main()
{
    fast_io;

    string s;

    cin >> s;
    n = s.size();
    for (int i = 1; i <= n; ++i) {
        for (int j = 'a'; j <= 'z'; ++j) pf[i][j - 'a'] = pf[i - 1][j - 'a'];
        pf[i][s[i - 1] - 'a']++;
    }
    int ans = -1;
    for (int how = 1; how * how <= n; ++how) if (n % how == 0) {
        if (check(how)) ans = max(ans, n / how);
        if (check(n / how)) ans = max(ans, how);
    }
    cout << ans << endl;
    return 0;
}
