#include <stdio.h>
#include <bits/stdc++.h>
#define pb push_back
#define pp pop_back
#define mp make_pair
#define f first
#define s second
#define all(x) x.begin(), x.end()
typedef long long ll;

using namespace std;

const int N = 3e5 + 111, inf = 1e9, mod = 1e9 + 7;
const double pi = acos(-1.0), eps = 1e-9;
const ll INF = 1e18;

int n, p[N], cnt[N], mn[N];
ll c[N], sum[N], ans;
vector <int> g[N];

bool cmp(int x, int y){
	return cnt[x] > cnt[y];
}

void dfs(int v){
	if(!g[v].size()){
		mn[v] = v;
		cnt[v] = 1;
		sum[v] = c[v];
		return;
	}
	int mx = g[v][0];
	cnt[v] = 1;
	for(auto to : g[v]){
		dfs(to);
		if(cnt[mx] < cnt[to])
			mx = to;
		cnt[v] += cnt[to];
		sum[v] += sum[to];
	}
	int mn1 = mn[g[v][0]], mn2 = mn[g[v][1]];
	if(c[mn1] > c[mn2])
		swap(mn1, mn2);
	for(int i = 2; i < g[v].size(); ++i){
		int to = g[v][i];
		if(c[mn[to]] < c[mn2])
			mn2 = mn[to];
		if(c[mn1] > c[mn2])
			swap(mn1, mn2);
	}
	mn[v] = mn1;
	sort(all(g[v]), &cmp);
	if(c[v] < c[mn1])
		mn[v] = v;
	if(cnt[mx] * 2 <= (cnt[v] - 1)){
		ans += sum[v];
		if(cnt[v] % 2 == 0)
			ans += c[mn1];
	}else{
		int cntr = cnt[g[v][0]] - (cnt[v] - cnt[g[v][0]] - 1);
		int mna = g[v][1];
		for(int i = 1; i < g[v].size(); ++i){
			if(c[mn[g[v][i]]] < c[mn[mna]])
				mna = g[v][i];
		}
		ans += sum[v];
		ans += c[mn[mna]] * cntr;
	}
	sum[v] += c[v];
}

int main(){
	srand(time(NULL));
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	cout << setprecision(10) << fixed;

	cin >> n;
	
	for(int i = 2, pr; i <= n; ++i){
		cin >> pr;
		g[pr].pb(i);
	}

	for(int i = 2; i <= n; ++i)
		cin >> c[i];

	dfs(1);

	cout << ans;
               
	//cout << (clock() + 0.0) / CLOCKS_PER_SEC;
	return 0;
}