#include <bits/stdc++.h>

using namespace std;

void dfs (int u, vector <vector <int>> & g, vector <int> & p, vector <int> & c) {
    p.push_back(u);
    for (auto elem : g[u]) {
        dfs(elem, g, p, c);
    }
}

int minimum (vector <int> & a, vector <int> & c) {
    int ans = 1e9 + 7;
    for (auto elem : a)
        ans = min(ans, c[elem]);
    return ans;
}

bool cmp (vector <int> a, vector <int> b) {
    return (int)a.size() < (int)b.size();
}

long long get_res (int i, vector <vector <int>> & g, vector <int> & c) {
     vector <vector <int>> p((int)g[i].size());
     int k = 0;
     set <int> unused;
     for (int j = 0; j < (int)g[i].size(); ++j) {
        dfs(g[i][j], g, p[j], c);
        for (auto elem : p[j])
            unused.insert(elem);
     }
     sort(p.rbegin(), p.rend(), cmp);

     long long res = 0;
     for (int k = 0; k < (int)p.size(); ++k) {
            vector <int> curr;
     for (auto elem : p[k])
        if (unused.count(elem)) {
            curr.push_back(elem);
            unused.erase(elem);
        }

     for (auto elem : curr) {
        if (!unused.empty()) {
        res += c[elem] + c[*(unused.begin())];
        unused.erase(unused.begin());
        }
        else {
            int mi = 1e9 + 7;
            for (int t = 0; t < (int)p.size(); ++t)
            if (t != k)
            mi = min(mi, minimum(p[t], c));
            unused.erase(mi);
            res += c[elem] + c[mi];
        }
     }
     }

     return res;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n; cin >> n;
    vector <vector <int>> g(n);
    for (int i = 1; i < n; ++i) {
        int v; cin >> v; --v;
        g[v].push_back(i);
    }

    vector <int> c(n);
    for (int i = 1; i < n; ++i)
        cin >> c[i];

    long long res = 0;
    for (int i = 0; i < n; ++i)
    {
    res += get_res(i, g, c);
    }
    cout << res << endl;

    return 0;
}