#pragma gcc optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <set>
#define ll long long
using namespace std;

const int N = 2e5;

bool check(vector<string>& vec) {
	vector<vector<char> > ch(vec.size(), vector<char>(26));
	for (int j = 0; j < vec.size(); ++j) {
		string s = vec[j];
		for (int i = 0; i < s.length(); ++i) {
			ch[j][s[i]-'a']++;
		}
	}
	vector<char> vect = ch[0];
	for (int i = 1; i < ch.size(); ++i) {
		for (int j = 0; j < 26; ++j) {
			if (ch[i][j] != vect[j])
				return false;
		}
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	int n = s.length();
	vector<int> v;
	for (int i = 1; i <= n; ++i) {
		if (n % i == 0)
			v.push_back(i);
	}
	for (int k : v) {
		vector<string> vec;
		for (int i = 0; i+k-1 < n; i += k) {
			vec.push_back(s.substr(i, k));
		}
		if (check(vec)) {
			return !(cout << n/k);
		}
	}
	return 0;
}