#include <iostream>
#include <vector>

using namespace std;

pair<pair<int, int>, int> dfs(vector<int>* graph, int i, int& ans, int* strengths)
{
    int max_cnt = 0;
    int total_cnt = 0;
    int max_min = (1 << 31) - 1;
    int first_min = (1 << 31) - 1;
    int second_min = (1 << 31) - 1;
    int total_sum = 0;
    for(int j : graph[i])
    {
        pair<pair<int, int>, int> cur = dfs(graph, j, ans, strengths);
        total_cnt += cur.second;
        total_sum += cur.first.first;
        if(cur.second > max_cnt)
        {
            max_cnt = cur.second;
            max_min = cur.first.second;
        }
        if(cur.first.second < first_min)
        {
            second_min = first_min;
            first_min = cur.first.second;
        }
        else if(cur.first.second < second_min)
            second_min = cur.first.second;
    }
    if(max_cnt > total_cnt - max_cnt)
    {
        if(max_min == first_min)
            ans += total_sum + (2 * max_cnt - total_cnt) * second_min;
        else
            ans += total_sum + (2 * max_cnt - total_cnt) * first_min;
    }
    else if(total_cnt % 2)
        ans += total_sum + second_min;
    else
        ans += total_sum;
    return make_pair(make_pair(total_sum + strengths[i], min(first_min, strengths[i])), total_cnt + 1);
}

int main()
{
    int n;
    cin >> n;
    vector<int> graph[n];
    for(int i = 1; i < n; i++)
    {
        int cur;
        cin >> cur;
        graph[cur - 1].push_back(i);
    }
    int strengths[n];
    for(int i = 1; i < n; i++)
        cin >> strengths[i];
    int ans = 0;
    dfs(graph, 0, ans, strengths);
    cout << ans << endl;
    return 0;
}
