#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define ll long long
#define ld long double
#define pii pair <int, int>
#define endl '\n'

using namespace std;

const int N = 2e5 + 5;
const int mod = 1e9 + 7;

vector <int> g[N];
int sz[N];
ll res = 0;
vector <int> all;
int tin[N], tout[N];
int timer = 0;
int a[N];
bool used[N];

void dfs_sz(int v, int pr){
    sz[v] = 1;
    for (int to : g[v]){
        if (to == pr) continue;
        dfs_sz(to, v);
        sz[v] += sz[to];
    }
}

void dfs(int v, int pr){
    all.pb(v);
    tin[v] = timer++;
    for (int to : g[v]){
        if (to == pr) continue;
        dfs(to, v);
    }
    all.pb(v);
    tout[v] = timer++;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    g[0].pb(-1);
    for (int i = 0; i < n - 1; i++){
        int x;
        cin >> x;
        x--;
        g[i + 1].pb(x);
        g[x].pb(i + 1);
    }
    for (int i = 0; i < n - 1; i++){
        cin >> a[i + 1];
    }
    dfs_sz(0, -1);
    dfs(0, -1);
    for (auto x : all){
        if (used[x]) continue;
        if (tin[x] == tout[x] - 1){
            used[x] = 1;
            continue;
        }
        int mn = 1e9, v = 0;
        for (int i = tin[x] + 1; i < tout[x]; i++){
            if (mn > a[all[i]]){
                mn = a[all[i]];
                v = all[i];
            }
        }

        for (int i = tin[x] + 1; i < tin[v]; i++){
            res += mn + a[all[i]];
        }

        for (int i = tout[v] + 1; i < tout[x]; i++){
            res += mn + a[all[i]];
        }

        mn = 1e9;
        int u = 0;
        for (int i = tin[x] + 1; i < tout[x]; i++){
            if (i >= tin[v] && i <= tout[v]) continue;
            if (all[i] == v) continue;
            if (mn > a[all[i]]){
                mn = a[all[i]];
                u = all[i];
            }
        }
       // cerr << u << endl;
        for (int i = tin[v] + 1; i < tout[v]; i++){
            res += mn + a[all[i]];
        }

        used[x] = 1;
    }
    cout << res / 2 << endl;
    return 0;
}


