#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int hashes1[5000000][2];
int hashes2[500000][26];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, i;
    string s;
    cin >> s;
    n = s.size();

    int maxchar = -1;
    for (i = 0; i < n; i++)
        maxchar = max(maxchar, s[i] - 'a' + 1);

    int ans = 0;
    if (maxchar == 2)
    {
        for (i = 0; i < n; i++)
            hashes1[i + 1][s[i] - 'a']++;

        for (i = 0; i < n; i++)
        {
            hashes1[i + 1][0] += hashes1[i][0];
            hashes1[i + 1][1] += hashes1[i][1];
        }

        for (int k = 1; k <= n; k++)
        {
            if (n % k != 0)
                continue;

            bool ok = true;
            for (i = k; i < n; i += k)
            {
                if ((hashes1[i + k][0] - hashes1[i][0]
                    != hashes1[i][0] - hashes1[i - k][0]) ||
                        (hashes1[i + k][1] - hashes1[i][1]
                         != hashes1[i][1] - hashes1[i - k][1]))
                {
                    ok = false;
                    break;
                }
            }

            if (ok)
            {
                ans = n / k;
                break;
            }
        }
    }
    else
    {
        for (i = 0; i < n; i++)
            hashes2[i + 1][s[i] - 'a']++;

        for (i = 0; i < n; i++)
        {
            hashes2[i + 1][0] += hashes2[i][0];
            hashes2[i + 1][1] += hashes2[i][1];
        }

        for (int k = 1; k <= n; k++)
        {
            if (n % k != 0)
                continue;

            bool ok = true;
            for (i = k; i < n; i += k)
            {
                if ((hashes2[i + k][0] - hashes2[i][0]
                     != hashes2[i][0] - hashes2[i - k][0]) ||
                    (hashes2[i + k][1] - hashes2[i][1]
                     != hashes2[i][1] - hashes2[i - k][1]))
                {
                    ok = false;
                    break;
                }
            }

            if (ok)
            {
                ans = n / k;
                break;
            }
        }
    }

    cout << ans << endl;

    return 0;
}
