#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int LOG = 70;

ll div1(ll n, ll p) {
    return n / p + (n % p != 0);
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    ll n, q;
    cin >> n >> q;
    vector<ll> cnt(LOG);
    ll sum = div1(n, 2ll);
    cnt[0] = sum;
    for (int i = 1;sum < n;++i) {
        cnt[i] = div1(cnt[i - 1], 2ll);
        sum += cnt[i];
    }
    vector<ll> pref_sums(LOG + 1);
    for (int i = 1; i <= LOG; ++i) {
        pref_sums[i] = pref_sums[i - 1] + cnt[i - 1];
    }
    for (ll i = 0; i < q; ++i) {
        ll x, p = 0;
        cin >> x;
        for (;; ++p) {
            if (x % (1 << p) == 0 && x % (1 << (p + 1)) != 0) {
                break;
            }
        }
        cout << pref_sums[p] + div1(x, ll((1 << (p + 1)))) << "\n";
    }

    return 0;
}
