#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int alp = 26;
const int INF = 2e9;

int n;
vector<vector<int>> cnts(alp);
inline bool can(const int &len) {
    bool flag = 0, res = 1;
    vector<int> need(alp);
    for (int i = 1; i + len <= n + 1; i += len) {
        int l = i - 1, r = i + len - 1;
        if (!flag) {
            for (int j = 0; j < alp; ++j) {
                need[j] = cnts[j][r] - cnts[j][l];
            }
            flag = 1;
        }
        else {
            bool f = 1;
            for (int j = 0; j < alp; ++j) {
                f &= need[j] == cnts[j][r] - cnts[j][l];
            }
            res &= f;
        }
    }
    return res;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    string s;
    cin >> s;
    n = s.length();
    for (int i = 0; i < alp; ++i) {
        cnts[i].resize(n + 1);
    }
    for (int i = 1; i <= n; ++i) {
        int c = int(s[i - 1] - 'a');
        for (int j = 0; j < alp; ++j) {
            cnts[j][i] = cnts[j][i - 1] + (j == c);
        }
    }
    int ans = 1;
    for (int len = 1; len * len <= n; ++len) {
        if (n % len == 0) {
            if (can(len)) {
                ans = max(ans, n / len);
            }
            if (can(n / len)) {
                ans = max(ans, len);
            }
        }
    }
    cout << ans;

    return 0;
}
