#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int alp1 = 26;
const int alp2 = 2;
const int INF = 2e9;

int n;
vector<vector<int>> cnts;
inline bool can(const int &len, const int &alp) {
    bool flag = 0, res = 1;
    vector<int> need(alp);
    for (int i = 1; i + len <= n + 1; i += len) {
        int l = i - 1, r = i + len - 1;
        if (!flag) {
            for (int j = 0; j < alp; ++j) {
                need[j] = cnts[j][r] - cnts[j][l];
            }
            flag = 1;
        }
        else {
            bool f = 1;
            for (int j = 0; j < alp; ++j) {
                f &= need[j] == cnts[j][r] - cnts[j][l];
            }
            res &= f;
        }
    }
    return res;
}

inline int solver1(const string &s) {
    n = s.length();
    cnts.resize(alp1);
    for (int i = 0; i < alp1; ++i) {
        cnts[i].resize(n + 1);
    }
    for (int i = 1; i <= n; ++i) {
        int c = int(s[i - 1] - 'a');
        for (int j = 0; j < alp1; ++j) {
            cnts[j][i] = cnts[j][i - 1] + (j == c);
        }
    }
    int ans = 1;
    for (int len = 1; len * len <= n; ++len) {
        if (n % len == 0) {
            if (can(len, alp1)) {
                ans = max(ans, n / len);
            }
            if (can(n / len, alp1)) {
                ans = max(ans, len);
            }
        }
    }
    return ans;
}

inline int solver2(const string &s) {
    n = s.length();
    cnts.resize(alp2);
    for (int i = 0; i < alp2; ++i) {
        cnts[i].resize(n + 1);
    }
    for (int i = 1; i <= n; ++i) {
        int c = int(s[i - 1] - 'a');
        for (int j = 0; j < alp2; ++j) {
            cnts[j][i] = cnts[j][i - 1] + (j == c);
        }
    }
    int ans = 1;
    for (int len = 1; len * len <= n; ++len) {
        if (n % len == 0) {
            if (can(len, alp2)) {
                ans = max(ans, n / len);
            }
            if (can(n / len, alp2)) {
                ans = max(ans, len);
            }
        }
    }
    return ans;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    string s;
    cin >> s;
    bool fl1 = 1;
    for (char c : s) {
        fl1 &= (c < 'c');
    }
    if (!fl1) {
        cout << solver1(s);
    }
    else {
        cout << solver2(s);
    }

    return 0;
}
