#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 2e3 + 11;
vector<vector<int>> g(N);
int n, global_ans = 0;
vector<int> c(N), st(N);

inline int calc(const int &v) {
    multiset<int> have;
    for (int to : g[v]) {
        have.insert(st[to]);
    }
    int ans = 0;
    while(have.size() > 1) {
        multiset<int>::iterator it = have.end();
        --it;
        int max1 = *it;
        --it;
        int max2 = *it;
        have.erase(have.find(max1));
        have.erase(have.find(max2));
        max2 -= max1;
        ans += max1 * 2;
        if (max2 > 0) {
            have.insert(max2);
        }
    }
    if (!have.empty()) {
        ans += *have.begin() * 2;
    }
    return ans;
}

void dfs(int v) {
    for (int to : g[v]) {
        dfs(to);
    }
    st[v] = 1;
    for (int to : g[v]) {
        st[v] += st[to];
    }
    global_ans += calc(v);
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int p;
        cin >> p;
        g[p - 1].push_back(i + 1);
    }
    dfs(0);
    cout << global_ans;

    return 0;
}
