#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <string>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <ctime>

#define X first
#define Y second
#define pb push_back
#define is insert
#define mp make_pair
#define MEM(x, y) memset(x, y, sizeof(x))
#define pii pair<int, int>
using namespace std;

typedef long long ll;

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	///open-2018-169
	///s9zmhh2j
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}


const int maxn = 200200;
int n;
int p[maxn];
int c[maxn];
int absmin[maxn];
vector<int> e[maxn];
ll ans;
multiset<int> s[maxn];
multiset<int> m;
bool comps(int a, int b) {
	return s[a].size() > s[b].size();
}


/*
		while (u.size() > 1) {
			int i = *u.rbegin();
			u.erase(u.find(i));
			int j = *u.rbegin();
			u.erase(u.find(j));
			ans += 2;
			--i;
			--j;
			if (i > 0)u.insert(i);
			if (j > 0)u.insert(j);
		}
		if(!u.empty())ans += *u.begin() * 2;
		return pw + 1;
*/


bool one = true;
int dfs(int v) {
	set<pii> u;
	vector<pii> f;
	for (auto i : e[v]) {
		int uu = dfs(i);
		u.insert(mp(s[uu].size(), uu));
		for (auto k : s[uu])
			f.push_back(mp(k, uu));
	}
	if (u.empty()) {
		s[v].insert(c[v]);
		absmin[v] = c[v];
		return v;
	}
	sort(f.rbegin(), f.rend());
	int uu = 0;
	int vv = 0;
	int lows = 1000001;
	while (uu < f.size()) {
		
		if (f[uu].first == -1) {
			++uu;
			continue;
		}
		vv = max(vv, uu);
		while (vv < f.size() && (f[vv].second == f[uu].second || f[vv].first == -1))
			++vv;
		if (vv == f.size()) {
			ans += 1ll * lows + f[uu].first;
			++uu;
			continue;
		}
		ans += f[uu].first + f[vv].first;
		s[v].insert(f[uu].first);
		s[v].insert(f[vv].first);
		s[f[uu].second].erase(s[f[uu].second].find(f[uu].first));
		s[f[vv].second].erase(s[f[vv].second].find(f[vv].first));
		if (s[f[vv].second].empty())lows = min(lows, absmin[f[vv].second]);
		if (s[f[uu].second].empty())lows = min(lows, absmin[f[uu].second]);
		f[uu].first = -1;
		f[vv].first = -1;
		++uu;
	}

	s[v].insert(c[v]);
	absmin[v] = *s[v].begin();
	return v;

}

void solve() {
	cin >> n;
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
		e[p[i]].push_back(i);
	}
	for (int i = 1; i < n; ++i)
		cin >> c[i];
	dfs(0);
	cout << ans << endl;
}