#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

typedef long long ll;

using namespace std;

ll ans = 0;

ll dfs(int v, vector<vector<int>> &g) {
    ll sum = 0;
    ll maxi = 0;
    for (int &to : g[v]) {
        ll curr = dfs(to, g);
        sum += curr;
        maxi = max(curr, maxi);
    }
    if (maxi > sum - maxi) {
        ans += 2 * (sum - maxi) + 2 * (maxi - (sum - maxi));
    } else {
        ans += (sum + 1) / 2 * 2;
    }
    return sum + 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        g[x].push_back(i);
    }

    vector<ll> c(n);
    ll sumc = 0;
    for (int i = 1; i < n; ++i) {
        cin >> c[i];
        sumc += c[i];
    }
    if (sumc > n - 1) {
        cout << 25;
        return 0;
    }

    dfs(0, g);
    cout << ans;
    return 0;
}