
#include <vector>
#include <iostream>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <math.h>
#include <deque>

using namespace std;

typedef long long ll;
//ll Q = (n / 2 - (n + 1) % 2);
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	int n = s.size();
	int mx = 0;
	for (int i = 0; i < s.size(); i++) {
		mx = max(mx, (s[i] - 'a'));
	}
	mx++;
	vector<vector<int>> preSum(n, vector<int>(mx));
	for (int i = 0; i < n; i++) {
		if (i == 0) {
			preSum[i][s[i] - 'a'] += 1;
		} else {
			for (int j = 0; j < mx; j++) {
				preSum[i][s[j] - 'a'] += preSum[i - 1][s[j] - 'a'];
			}
			preSum[i][s[i] - 'a'] += 1;
		}
	}
	for (int i = 0; i < n/2 + 1; i++) {
		bool flag = false;
		if (n % (i + 1) != 0) {
			continue;
		}
		for (int j = i+1; j + i < n; j += i+1) {
			for (int g = 0; g < mx; g++) {
				int val = preSum[j + i][g] - preSum[j - 1][g];
				if (val != preSum[i][g]) {
					flag = true;
					break;
				}
			}
			if (flag) {
				break;
			}
		}
		if (!flag) {
			cout << n/(i + 1);
			system("pause");
			return 0;
		}
	}
	cout << 1;
	system("pause");
}