#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <string>
#include <bitset> 
using namespace std;
#define int long long
#define INF 1791791791


int get(int n, int x, map<int, int> & dp)
{
	if (x % 2)
		return x / 2 + 1;
	if (!dp.count(x))
		return dp[x] = get(n, x / 2 + n, dp);
	return dp[x];
}

signed main()
{
    cin.tie();
    cout.tie();
    ios::sync_with_stdio(false);
	int n, q;
	cin >> n >> q;
	map<int, int> dp;
	for (int i = 0; i < q; ++i) {
		int x;
		cin >> x;
		cout << get(n, x, dp) << '\n';
	}
}

