#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <string>
#include <bitset> 
using namespace std;
#define int long long
#define INF 1791791791


tuple<int, int, int, int> dfs(int v, vector<vector<int>> & g, vector<int> & a)
{
	vector<pair<int, int>> ver;
	int s = 0;
	int n = 0;
	int r = 0;
	int mr = INF;
	for (int to : g[v]) {
		auto cr = dfs(to, g, a);
		s += get<0>(cr);
		n += get<1>(cr);
		r += get<2>(cr);
		mr = min(mr, get<3>(cr));
		ver.push_back({ get<1>(cr), get<3>(cr) });
	}
	r += s;
	bool nd = true;
	for (int i = 0; i < ver.size(); ++i) {
		if (ver[i].first > n - ver[i].first) {
			int mv = INF;
			for (int j = 0; j < ver.size(); ++j) {
				if (i != j)
					mv = min(mv, ver[j].second);
			}
			r += mv * (2 * ver[i].first - n);
			nd = false;
			break;
		}
	}
	if (nd && n % 2)
		r += mr;
	++n;
	s += a[v];
	mr = min(mr, a[v]);
	return { s, n, r, mr };
}

signed main()
{
    cin.tie();
    cout.tie();
    ios::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<vector<int>> g(n);
	vector<int> a(n);
	for (int i = 1; i < n; ++i) {
		int x;
		cin >> x;
		g[x - 1].push_back(i);
	}
	for (int i = 1; i < n; ++i)
		cin >> a[i];
	cout << get<2>(dfs(0, g, a));
}

