#include <bits/stdc++.h>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int maxn = 2e5 + 123;
const ld eps = 1e-9;
const int inf = 1e9 + 1234;
const ll infll = 1e18 + 1243;
const ll mod = 1e9 + 9;

vector<int> g[maxn];
ll c[maxn];
ll sum[maxn];
ll cnt[maxn];
ll mn[maxn];
//ll sum2[2002][2002];
ll ans;

void dfsPrecalc1(int v){
    cnt[v] = 1;
    sum[v] = c[v];
    mn[v] = inf;
    for(int to : g[v]){
        dfsPrecalc1(to);
        cnt[v] += cnt[to];
        sum[v] += sum[to];
        mn[v] = min(mn[v], min(mn[to], c[to]));
    }
}

bool comp(int a, int b){
    if(cnt[a] > cnt[b])
        return 1;
    else if(cnt[b] > cnt[a])
        return 0;
    return a > b;
}

void dfs1(int v){
    ll cn = 0;
    for(int to : g[v]){
        dfs1(to);
        cn += cnt[to];
    }
    if(g[v].size() > 0)
        if(cnt[g[v][0]] > cn/2){
            ans += 2 * (cn - cnt[g[v][0]]);
            cn -= 2 * (cn - cnt[g[v][0]]);
            ans += 2 * cn;
        }
        else{
            ans += ((cn + 1) / 2) * 2;
        }
}

//void dfsPrecalc2(int v){
//    sum2[v][1] = c[v];
//    int sz = 1;
//    for(int to : g[v]){
//        dfsPrecalc2(to);
//        int l = 1;
//        for(int i = sz + 1; i <= sz + cnt[to]; i++){
//            sum2[v][i] = sum2[to][l];
//            l++;
//        }
//        sz += cnt[to];
//    }
//    sort(sum2[v], sum2[v] + sz);
//    for(int i = 2; i <= cnt[v]; i++)
//        sum2[v][i] += sum2[v][i - 1];
//}

void dfs2(int v){
    ll cn = 0, sm = 0;
    for(int to : g[v]){
        dfs2(to);
        cn += cnt[to];
        sm += sum[to];
    }
    if(g[v].size() > 0)
        if(cnt[g[v][0]] > cn/2){
            ans += sm;
            cn -= 2 * (cn - cnt[g[v][0]]);
            ll mn1 = inf;
            for(int i = 1; i < g[v].size(); i++)
                mn1 = min(mn1, min(mn[g[v][i]], c[g[v][i]]));
//            if(mn1 == inf)
//                cout << "KEK" << endl;
            ans += cn * mn1;
        }
        else{
            ans += sm;
            if(cn & 1)
                ans += mn[v];
        }
}

void solve(){
    int n;
    cin >> n;
    for(int i = 2; i <= n; i++){
        int x = i - 1;
        if(i & 1)
            x--;
        cin >> x;
        g[x].pb(i);
    }
    ll mx = 0;
    for(int i = 2; i <= n; i++){
        c[i] = 1000000;
        cin >> c[i];
        mx = max(mx, c[i]);
    }
    if(mx == 1){
        dfsPrecalc1(1);
        for(int i = 1; i <= n; i++)
            sort(g[i].begin(), g[i].end(), comp);
        dfs1(1);
    }
    else{
        dfsPrecalc1(1);
//        dfsPrecalc2(1);
        for(int i = 1; i <= n; i++)
            sort(g[i].begin(), g[i].end(), comp);
        dfs2(1);
    }
    cout << ans;
}

int main()
{
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
