//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");


int dfs(int v, vector <vector <int> > &g, vector <int> &ans, vector <int> &balance) {
	int subtree = 1;
	int cnt = 0;
	int bal = 0;
	for (int i = 0; i < g[v].size(); i++) {
		int cnst = dfs(g[v][i], g, ans, balance);
		subtree += cnst;
		cnst = cnst - (ans[g[v][i]] / 2 - balance[g[v][i]]);
		if (cnst > bal) {
			cnt += (cnst - bal);
		}
		bal = abs(cnst - bal);
	}
	ans[v] = 2 * cnt;
	balance[v] = cnt;
	return subtree;
}

void solve() {
	int n;
	cin >> n;
	vector <vector <int> > g(n);
	for (int i = 0; i < n - 1; i++) {
		int temp;
		cin >> temp;
		g[temp - 1].push_back(i + 1);
	}
	vector <int> c(n);
	int sum = 0;
	for (int i = 0; i < n; i++) {
		cin >> c[i];
		sum += c[i];
	}
	if (sum == n - 1) {
		vector <int> ans(n);
		vector <int> balance(n);
		dfs(0, g, ans, balance);
		long long ansl = 0;
		for (int i = 0; i < n; i++) {
			ansl += ans[i];
		}
		cout << ansl;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}