#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>

using namespace std;

bool two = true;

bool check(string& s, int k)
{
	vector<int> cnt(26, 0);
	for (int i = 0 ; i < k; i++)
	{
		cnt[s[i] - 'a']++;
	}
	if (s.size() % k)
	{
		assert(0);
	}
	int m = s.size() / k;
	for (int i = 0; i < m; i++)
	{
		vector<int> temp(26, 0);
		for (int j = 0; j < k; j++)
		{
			temp[s[i * k + j] - 'a']++;
		}
		if (two)
		{
			if (temp[0] != cnt[0] || temp[1] != cnt[1])
			{
				return false;
			}
		}
		else if (temp != cnt)
		{
			return false;
		}
	}
	return true;
}

int main()
{
	vector<int> need;
	int n = 0;
	string s;
	cin >> s;
	n = s.size();
	int ca = 0, cb = 0;
	for (int i = 0; i < n; i++)
	{
		if (s[i] >= 'b') two = false;
		ca += (s[i] == 'a');
		cb += (s[i] == 'b');
	}
	for (int i = 1; i <= n; i++)
	{
		if (n % i == 0 && (!two || (ca % i == 0 && cb % i == 0)))
		{
			need.push_back(i);
		}
	}
	vector<int> res;
	for (int i = need.size() - 1; i >= 0; i--)
	{
		bool good = true;
		for (auto j : res)
		{
			if (j != n && j % need[i] == 0)
			{
				good = false;
				break;
			}
		}
		if (good)
		{
			res.push_back(need[i]);
		}
	}
	need = res;
	//reverse(need.begin(), need.end());
	// for (auto i : need)
	// {
	// 	cerr << i << ' ';
	// }
	// cerr << endl;
	for (int i = 0; i < need.size(); i++)
	{
		if (check(s, n / need[i]))
		{
			cout << need[i] << endl;
			return 0;
		}
	}
}

