#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

const long long INF = 1000000000;

vector<vector<long long>> g;
vector<long long> c;
vector<long long> summ, mn, sz, smn;

long long ans;

void dfs(long long v)
{
	for (auto i : g[v])
	{
		dfs(i);
		summ[v] += c[i] + summ[i];
		sz[v] += sz[i] + 1;
		//переделать пересчет
		if (min(mn[i], c[i]) < mn[v])
		{
			smn[v] = mn[v];
			mn[v] = min(mn[i], c[i]);

		}
		else if (min(mn[i], c[i]) < smn[v])
		{
			smn[v] = min(mn[i], c[i]);
		}
		//mn[v] = min(mn[v], min(mn[i], c[i]));
	}
	bool dominant = false;
	int ind = 0, mx = 0;
	for (auto i : g[v])
	{
		if (sz[i] + 1 > mx)
		{
			ind = i;
			mx = sz[i] + 1;
		}
		if (sz[i] + 1 > sz[v] - sz[i] - 1)
		{
			dominant = true;
			break;
		}
	}
	ans += summ[v];
	//cerr << v << " " << ans << " " << dominant << endl;
	if (dominant)
	{
		if (summ[ind] + c[ind] == mn[v])
		{
			ans += smn[v] * (2 *(sz[ind] + 1) - sz[v]);
		}
		else
		{
			ans += mn[v] * (2 *(sz[ind] + 1) - sz[v]);
		}
	}
	else
	{
		ans += mn[v] * (sz[v] % 2);
	}
}

int main()
{
	long long n = 0;
	cin >> n;
	g.resize(n);
	c.resize(n);
	summ.resize(n, 0);
	mn.resize(n, INF);
	sz.resize(n, 0);
	smn.resize(n, INF);
	for (int i = 1; i < n; i++)
	{
		int p = 0;
		cin >> p;
		g[p - 1].push_back(i);
	}
	for (int i = 1; i < n; i++)
	{
		cin >> c[i];
	}
	dfs(0);
	cout << ans <<endl;
}