#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <functional>
#include <numeric>
#include <complex>

using namespace std;
typedef long long nagai;

vector<int> c;
vector<vector<int>> ch;

struct st
{
    nagai sum;
    int mn;
    int cnt;
};

st merge(st a, st b)
{
    return { a.sum + b.sum, min(a.mn, b.mn), a.cnt + b.cnt };
}
nagai ans = 0;
st d(int u)
{
    vector<st> sts;
    for (int v : ch[u])
        sts.push_back(d(v));
    if (sts.size())
    {
        int indmx = max_element(sts.begin(), sts.end(), [&](const st& a, const st& b)
        {
            return a.cnt < b.cnt;
        }) - sts.begin();
        int indmn = min_element(sts.begin(), sts.end(), [&](const st& a, const st& b)
        {
            return a.mn < b.mn;
        }) - sts.begin();
        int sum = accumulate(sts.begin(), sts.end(), 0LL, [&](nagai x, const st& a) { return x + a.cnt; });
        sum -= sts[indmx].cnt;
        if (sum < sts[indmx].cnt)
        {
            int mn = sts[indmn].mn;
            if (indmn == indmx)
            {
                mn = 1e9;
                for (int i = 0; i < sts.size(); ++i)
                    if (i != indmn)
                        mn = min(mn, sts[i].mn);
            }
            ans += 1LL * mn * (sts[indmx].cnt - sum);
        }
        else if (sum + sts[indmx].cnt & 1)
            ans += sts[indmn].mn;
        for (auto x : sts)
            ans += x.sum;
    }
    st s = { c[u], c[u], 1 };
    for (auto x : sts)
        s = merge(s, x);
    return s;
}

int main()
{
    ios::sync_with_stdio(false);
    int n;
    cin >> n;
    c.resize(n);
    ch.resize(n);
    for (int i = 1; i < n; ++i)
    {
        int p;
        cin >> p;
        --p;
        ch[p].push_back(i);
    }
    for (int i = 1; i < n; ++i)
        cin >> c[i];
    d(0);
    cout << ans << '\n';
}