class Point:
    def __init__(self, x, y):
        self.x = x
        self.y = y


class Line:
    def __init__(self, p1, p2):
        self.a = p2.y - p1.y
        self.b = p1.x - p2.x
        self.c = p1.x * (p1.y - p2.y) + p1.y * (p2.x - p1.x)
        
    def __add__(self, other):
        d = self.a * other.b - other.a * self.b
        dx = self.b * other.c - other.b * self.c
        dy = other.a * self.c - self.a * other.c
        if d == 0:
            return 0
        x = dx / d
        y = dy / d
        return Point(x, y)


def solve(k, p = Point(-10 ** 7, -10 ** 7), f = True):
    global lines, s, ans
    if k == 0:
        if f:
            return
        if ans == 'No':
            ans = ('Yes', '\n', int(p.x), ' ', int(p.y))
    for i in range(2 * n):
        for j in range(2 * n):
            if i in s or j in s or i == j:
                continue
            l = Line(points[i], points[j])
            if f and k <= n - 1:
                P = l + lines[0]
                if not P or ans != 'No':
                    return
                elif ((P.x, P.y) not in setpoints) and (P.x == int(P.x) and P.y == int(P.y)) and (abs(P.x) <= 10 ** 6 and abs(P.y) <= 10 ** 6):
                    f = False
                    p = P
            lines.append(Line(points[i], points[j]))
            s.add(i)
            s.add(j)
            solve(k - 1, p, f)
            lines.pop()
            s.discard(i)
            s.discard(j)


n = int(input())
points = []
ans = 'No'
setpoints = set()
for i in range(2 * n):
    x, y = map(int, input().split())
    points.append(Point(x, y))
    setpoints.add((x, y))
lines = []
s = set()
solve(n)
if ans != 'No':
    if ans[0] != 'Yes'or str(ans[2]) != str(int(ans[2])) or str(ans[4]) != str(int(ans[4])) or ans[1] != '\n' or ans[3] != ' ':
        0 / 0
print(*ans, sep='')