#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(),(x).end()
//#define int long long

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> vi;
typedef vector <ll> vll;
typedef vector <pii> vpii;
typedef long double ld;

template <typename T1, typename T2> bool umax(T1 &x, const T2 &y){if(x<y)return x=y,true;else return false;}
template <typename T1, typename T2> bool umin(T1 &x, const T2 &y){if(x>y)return x=y,true;else return false;}

template <typename T>
T getint() {
    T x = 0, p = 1;
    char c = getchar();
    while(c == '\n' || c == ' ')
        c = getchar();
    if(c == '-') p = -1, c = getchar();
    while('0' <= c && c <= '9') {
        x = x*10+c-'0';
        c = getchar();
    }
    return x*p;
}

const int N = (int)4e3+10;
const int mod = (int)1e9+9;
const int INF = (int)2e9+10;
const ll LLINF = (ll)1e18+10;
const ld pi = acos(-1.0);
const ld eps = (ld)1e-2;

const int u = 529423148;

int hash_line(pii a, pii b) {
    if(a.F == b.F) return u;
    ld kk = ld(a.S-b.S)/(a.F-b.F);
    ld bb = ld(a.S)-a.F*kk;
    int f = kk*1000;
    int s = bb*1000;
    return ll(53ll*(f+19)+87ll*(s+43))%mod;
}

pii inter(pii a1, pii a2, pii b1, pii b2) {
    if(a1.S == a2.F && b1.F == b2.F) return {u, u};
    if(a1.F==a2.F) {swap(a1, b1); swap(a2, b2);}

    ld k1 = ld(a1.S-a2.S)/(a1.F-a2.F);
    ld bb1 = ld(a1.S)-a1.F*k1;
    ld x, y;

    if(b1.F == b2.F) {
        x = b1.F;
        y = k1*x+bb1;
    } else {
        ld k2 = ld(b1.S-b2.S)/(b1.F-b2.F);
        ld bb2 = ld(b1.S)-b1.F*k2;
        if(k1 == k2) return {u, u};
        x = ld(bb2-bb1)/(k1-k2);
        y = k1*x+bb1;
    }

    if(abs(x-int(x))>eps) return {u, u};
    if(abs(y-int(y))>eps) return {u, u};
    return {int(x), int(y)};
}

int n;
map <int, vi> m[N];
pii p[N];
int l[N];
bool used[N];
set <int> q;

void precalc() {
    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= n; ++j) {
            if(i == j) continue;
            m[i][hash_line(p[i],p[j])].pb(j);
        }
    }
}

void try_point(pii c) {
//    cout << c.F << ' ' << c.S << '\n';
    if(abs(c.F)>(int)1e6) return;
    if(abs(c.S)>(int)1e6) return;
    for(int i = 1; i <= n; ++i) {
        if(c == p[i]) return;
        if(!m[i].count(l[i])) return;
    }
    for(int i = 1; i <= n; ++i) {
        l[i] = hash_line(p[i], c);
        used[i] = false;
    }
    q.clear();
    for(int i = 1; i <= n; ++i) {
        if(used[i]) continue;
        if(q.count(l[i])) return;
        vi &a = m[i][l[i]];
        q.insert(l[i]);
        bool flag = false;
        for(auto x: a) {
            if(!used[x]) {
                used[x] = true;
                flag = true;
                break;
            }
        }
        if(!flag) return;
        used[i] = true;
    }
    cout << "Yes\n";
    cout << c.F << ' ' << c.S << '\n';
    exit(0);
}

auto fix = clock();
set <pii> was;

void solve(pii a, pii b) {
    for(int i = 1; i <= n; ++i) {
        if(p[i] == a || p[i] == b)
            continue;
        for(int j = 1; j <= n; ++j) {
            if(ld(clock()-fix)/CLOCKS_PER_SEC>4.7) {
                cout << "No\n";
                exit(0);
            }
            if(p[j] == a || p[j] == b)
                continue;
            pii c = inter(a, p[i], b, p[j]);
            if(c == mp(u, u)) continue;
            if(was.count(c)) continue;
            was.insert(c);
            try_point(c);
        }
    }
}

int main()
{
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n;
    n *= 2;
    for(int i = 1; i <= n; ++i) {
        cin >> p[i].F >> p[i].S;
    }
    random_shuffle(p+1, p+n+1);

    precalc();
    for(auto f: m[1]) {
        if(f.S.size()==n-1) {
            cout << "No\n";
            return 0;
        }
    }
    for(int i = 0; i < 7; ++i) {
        int r1 = rand()%n+1;
        int r2 = rand()%n+1;
        if(r1 == r2) {--i; continue;}
        solve(p[r1], p[r2]);
    }
    solve(p[1], p[2]);
    solve(p[1], p[3]);

    cout << "No\n";
    return 0;
}
