//~ #pragma GCC optimize("O3")
//~ #pragma GCC target("popcnt,tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 1e6 + 123;
const ll LINF = (ll) 1e18 + 1e9 + 123;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back

template<typename A, typename B> bool mini(A &x, const B &y) {
	if (y < x) {
		x = y;
		return 1;
	}
	return 0;
}

template<typename A, typename B> bool maxi(A &x, const B &y) {
	if (y > x) {
		x = y;
		return 1;
	}
	return 0;
}

void run();

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int K = 30;

int n, k;
string s;
int cnt[K];
vector<int> pos[K];
int tmp[K];
vector<int> have;

bool check(int d) {
	rep(i, 0, K) {
		tmp[i] = cnt[i] / d;
	}
	rep(i, 1, d + 1) {
		int mx = 0;
		for (int j : have) {
			maxi(mx, pos[j][i * tmp[j] - 1]);
		}
		for (int j : have) {
			if (pos[j][i * tmp[j]] <= mx) {
				return 0;
			}
		}
	}
	
	return 1;
}

void run() {
	cin >> s;
	n = sz(s);
	rep(i, 0, n) {
		cnt[s[i] - 'a']++;
		pos[s[i] - 'a'].pb(i);
	}
	rep(i, 0, K) {
		pos[i].pb(INF);
		if (cnt[i] > 0) have.pb(i);
	}
	
	int ans = 1;
	int g = 0;
	rep(i, 0, K) g = __gcd(g, cnt[i]);
	vector<int> divs;
	
	for (int d = 1; d * d <= g; d++) {
		if (g % d != 0) continue;
		divs.pb(d);
		if (g / d != d) divs.pb(g / d);
	}
	
	sort(all(divs));
	reverse(all(divs));
	for (int d : divs) {
		if (check(d)) {
			ans = d;
			break;
		}
	}
	
	cout << ans << "\n";
}
