//~ #pragma GCC optimize("O3")
//~ #pragma GCC target("popcnt,tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 1e6 + 123;
const ll LINF = (ll) 1e18 + 1e9 + 123;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back

template<typename A, typename B> bool mini(A &x, const B &y) {
	if (y < x) {
		x = y;
		return 1;
	}
	return 0;
}

template<typename A, typename B> bool maxi(A &x, const B &y) {
	if (y > x) {
		x = y;
		return 1;
	}
	return 0;
}

void run();

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

#define int long long
const int N = (int) 4e5 + 123;

int n;
int p[N];
ll c[N];
vector<int> g[N];
ll ans[N];
ll mi[N], sum[N];
int cnt[N];

void dfs(int v) {
	mi[v] = INF;
	sum[v] = 0;
	cnt[v] = 0;
	ll ma = -INF;
	int ma_u = -1;
	
	for (int u : g[v]) {
		dfs(u);
		ans[v] += ans[u];
		mini(mi[v], mi[u]);
		sum[v] += sum[u];
		cnt[v] += cnt[u];
		if (maxi(ma, cnt[u])) {
			ma_u = u;
		}
	}
	
	if (sz(g[v])) {
		assert(sz(g[v]) >= 2);
		if (ma <= cnt[v] - ma) {
			ans[v] += sum[v];
			if (cnt[v] % 2 == 1) ans[v] += mi[v];
		} else {
			ans[v] += sum[v];
			ll qq = ma - (cnt[v] - ma);
			ll kek = INF;
			for (int u : g[v]) {
				if (u != ma_u) {
					mini(kek, mi[u]);
				}
			}
			ans[v] += kek * qq;
		}
	}
	
	mini(mi[v], c[v]);
	sum[v] += c[v];
	cnt[v]++;
}

void run() {
	cin >> n;
	rep(i, 2, n + 1) {
		cin >> p[i];
		g[p[i]].pb(i);
	}
	rep(i, 2, n + 1) {
		cin >> c[i];
	}
	dfs(1);
	cout << ans[1] << "\n";
}
