#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<stack>
#include<cmath>
#include<list>
#include<ctime>
using namespace std;
#define elif else if
#define int long long
class point
{
public:
	double x, y;
	point operator +(point a)
	{
		return { a.x + x,a.y + y };
	}
	point operator -(point a)
	{
		return { x - a.x,y - a.y };
	}
	point operator *(double k)
	{
		return { k*x,k*y };
	}
	point operator /(double k)
	{
		return { x / k,y / k };
	}
	double operator *(point a)
	{
		return a.x*x + a.y*y;
	}
	double operator %(point a)
	{
		return x * a.y - y * a.x;
	}
	double lensqr()
	{
		return x * x + y * y;
	}
	double len()
	{
		return sqrt(lensqr());
	}
	point norm()
	{
		return { x / len(),y / len() };
	}
};
int32_t main()
{
	ios_base::sync_with_stdio(0);
    int n, q;
    cin >> n >> q;
    vector<int>a(n * 2, -1);
    set<int>m1;
    for (int i = 0; i < a.size(); i += 2)
    {
        a[i] = i / 2 + 1;
        m1.insert(i + 1);
    }
    auto c = m1.end();
    m1.erase(--c);
    for (int i = a.size() - 2; i >= 0 && m1.size(); --i)
    {
        c = m1.end();
        --c;
        a[*c] = a[i];
        a[i] = -1;
        m1.erase(c);
    }
    for (int i = 0; i < q; ++i)
    {
        int x;
        cin >> x;
        cout << a[x - 1] << '\n';
    }
	return 0;
}