#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef vector<int> vi;

#define X first
#define Y second
#define inb push_back
#define all(v) (v).begin(), (v).end()

const int M = 5e5 + 5;

int n, dd[27][M], dad[2][M];
string s;

void solve()
{
	dd[s[0] - 'a'][0] = 1;
	for (int i = 1; i < n; ++i)
	{
		for (int j = 0; j < 27; ++j)
			dd[j][i] = dd[j][i - 1];
		dd[s[i] - 'a'][i]++;
	}
	bool f = 0;
	for (int i = 1; i <= n; ++i)
		if (n % i == 0)
		{
			f = 0;
			for (int k = i; k < n; k += i)
			{
				for (int j = 0; j < 27; ++j)
					if (dd[j][k + i - 1] - dd[j][k - 1] != dd[j][i - 1])
					{
						f = 1;
						break;
					}
				if (f)
					break;
			}
			if (!f)
				cout << n / i, exit(0);
		}
	cout << 1;
	exit(0);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> s;
	n = s.size();
	if (n <= 5e5)
		solve();

	dad[s[0] - 'a'][0] = 1;
	for (int i = 1; i < n; ++i)
	{
		for (int j = 0; j < 2; ++j)
			dad[j][i] = dad[j][i - 1];
		dad[s[i] - 'a'][i]++;
	}
	bool f = 0;
	for (int i = 1; i <= n; ++i)
		if (n % i == 0)
		{
			f = 0;
			for (int k = i; k < n; k += i)
			{
				for (int j = 0; j < 2; ++j)
					if (dad[j][k + i - 1] - dad[j][k - 1] != dad[j][i - 1])
					{
						f = 1;
						break;
					}
				if (f)
					break;
			}
			if (!f)
				cout << n / i, exit(0);
		}
	cout << 1;
}