#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <assert.h>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef vector<int> vi;

#define X first
#define Y second
#define inb push_back
#define all(v) (v).begin(), (v).end()

const int M = 5e5 + 5, N = 5e6 + 5;

int n, dd[27][M], dad[27], us[N], pr[N];
string s;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> s;
	n = s.size();
	bool f = 0;
	vi c(27), d(27);
	for(int i = 1; i < n; ++i)
		if (n % i == 0)
		{
			if (i <= 10000)
			{
				f = 0;
				for (int i = 0; i < 27; ++i) d[i] = 0;
				for (int k = 0; k < i; ++k) d[s[k] - 'a']++;
				for (int j = i; j < n; j += i)
				{
					for (int i = 0; i < 27; ++i) c[i] = 0;
					for (int k = j; k < j + i; ++k) c[s[k] - 'a']++;
					if (c != d)
					{
						f = 1;
						break;
					}
				}
				if (!f) cout << n / i, exit(0);
				continue;
			}
			for (int j = 0; j < n; j += i)
				us[j] = 1;
		}

	dad[s[0] - 'a'] = 1;
	dd[s[0] - 'a'][0] = 1;
	int k = 1;
	for (int i = 1; i < n; ++i) if (us[i]) us[i - 1] = 1;
	for (int i = 1; i < n; ++i)
	{
		dad[s[i] - 'a']++;
		if (us[i])
		{
			pr[i] = k++;
			for (int j = 0; j < 27; ++j)
				dd[j][pr[i]] = dad[j];
		}
	}
	for (int i = 10001; i < n; ++i)
		if (n % i == 0)
		{
			f = 0;
			for (int k = i; k < n; k += i)
			{
				for (int j = 0; j < 27; ++j)
					if (dd[j][pr[k + i - 1]] - dd[j][pr[k - 1]] != dd[j][pr[i - 1]])
					{
						f = 1;
						break;
					}
				if (f)
					break;
			}
			if (!f)
				cout << n / i, exit(0);
		}
	cout << 1;
}