#include <bits/stdc++.h>

const int N = 500100;

int globalCnt[26][N];
int cnt[26], curCnt[26];

void getCnt(int* need, int l, int r) {
    for (int i = 0; i < 26; ++i) {
        need[i] = globalCnt[i][r];
        if (l != 0) {
            need[i] -= globalCnt[i][l - 1];
        }
    }
}

bool eq(int* c1, int* c2) {
    for (int i = 0; i < 26; ++i) {
        if (c1[i] != c2[i]) {
            return false;
        }
    }
    return true;
}

bool zero(int* c) {
    for (int i = 0; i < 26; ++i) {
        if (c[i] != 0) {
            return false;
        }
    }
    return true;
}

void build(std::string& str) {
    for (int i = 0; i < str.size(); ++i) {
        if (i != 0) {
            for (int j = 0; j < 26; ++j) {
                globalCnt[j][i] = globalCnt[j][i - 1];
            }
        }
        ++globalCnt[str[i] - 'a'][i];
    }
}

int main(void) {
    std::string str;
    std::cin >> str;
    build(str);
    int ans = 1;
    for (int pref = 0; pref < str.size(); ++pref) {
        ++cnt[str[pref] - 'a'];
        if (str.size() % (pref + 1) != 0) {
            continue;
        }
        int curAns = str.size() / (pref + 1);
        bool fl = true;
        int pos = pref + 1;
        while (pos < str.size()) {
            memset(curCnt, 0, 26 * sizeof(int));
            getCnt(curCnt, pos, pos + pref);
            if (!eq(cnt, curCnt)) {
                fl = false;
                break;
            }
            pos += pref + 1;
        }
        if (fl) {
            ans = std::max(ans, curAns);
        }
    }
    std::cout << ans << '\n';
    return 0;
}