
#include <iostream>
#include <stdio.h>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

string s;
int ans[26];
vector <int > p;

int gcd(int a, int b)
{
	while (b != 0)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}


bool check(int x)
{
	int qq = s.size() / x;
	int a1[26], a2[26];
	for (int i = 0; i < 26; i++)
		a1[i] = 0;
	for (int i = 0; i < qq; i++)
		a1[int(s[i] - 'a')]++;
	for (int i = qq; i < s.size(); i += qq)
	{
		for (int i = 0; i < 26; i++)
			a2[i] = 0;
		for (int j = 0; j < qq; j++)
			a2[int(s[i + j] - 'a')]++;
		for (int i = 0; i < 26; i++)
			if (a1[i] != a2[i])
				return false;
	}
	return true;
}

int main()
{
	ifstream cin("input.txt");
	//ofstream cout("output.txt");
	ios_base::sync_with_stdio(0), cin.tie(0);
	cin >> s;
	for (int i = 0; i < s.size(); i++)
		ans[int(s[i] - 'a')]++;
	int gd = ans[0];
	for (int i = 1; i < 26; i++)
		gd = gcd(gd, ans[i]);
	if (gd == s.size() || gd == 1)
	{
		cout << gd;
		return 0;
	}
	for (int i = gd; i >= 1; i--)
		if (gd % i == 0)
			if (check(i))
			{
				cout << i;
				return 0;
			}

	return 0;
}
