#pragma comment(linker, "/stack:200000000") 
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <immintrin.h>
#include <bits/stdc++.h>
using namespace std;
#define x first
#define y second
#define int long long
typedef long long ll;
typedef long double ld;
#ifdef SUBIRD
	#define cout cerr
#endif
const int LINF = 2e9, BINF = 9e18, mod = 1e9 + 7, P = 179, Q = 1791791791;
typedef pair<int, int> pt;
const int MAXN = 2600;
pt pts[MAXN];
pt ptsc[MAXN];
int n;
int gcd(int a, int b) {
	a = abs(a);
	b = abs(b);
	if (!a)
		return b;
	else if (!b)
		return a;
	else
		return __gcd(a, b);
}
int place(pt a) {
	if (a.y >= 0 && a.x > 0)
		return 0;
	else if (a.y > 0 && a.x <= 0)
		return 1;
	else if (a.y <= 0 && a.x < 0)
		return 2;
	else
		return 3;
}
pt operator-(pt a, pt b) {
	return {a.x - b.x, a.y - b.y};
}
pt operator+(pt a, pt b) {
	return {a.x + b.x, a.y + b.y};
}
int operator*(pt a, pt b) {
	return a.x * b.y - b.x * a.y;
}
pt md;
bool cmp(pt a, pt b) {
	a = a - md;
	b = b - md;
	int pla = place(a);
	int plb = place(b);
	if (pla != plb)
		return pla < plb;
	else 
		return a * b > 0;
}
bool online(pt a, pt b) {
	return a * b == 0;
}
bool online(pt a, pt b, pt c) {
	return a * b == 0 && b * c == 0;
}
bool check(pt mid) {
	md = mid;
	for (int i = 0; i < n; ++i) {
		if (pts[i] == mid)
			return false;
		ptsc[i] = pts[i];
		if (ptsc[i].y - md.y < 0 || (ptsc[i].y - md.y == 0 && ptsc[i].x - md.x < 0)) {
			ptsc[i] = md - (pts[i] - md);
		}
	}
	sort(ptsc, ptsc + n, cmp);
	/*for (int i = 0; i < n; ++i) {
		cout << ptsc[i].x << " " << ptsc[i].y << "\n";
	}*/
	if (!online(ptsc[0] - md, ptsc[1] - md))
		return false;
	for (int i = 2; i < n; ++i)
		if (online(ptsc[i] - mid, ptsc[i - 1] - mid, ptsc[i - 2] - mid))
			return false;
		else if (i % 2 == 1 && !online(ptsc[i] - md, ptsc[i - 1] - md))
			return false;
	return true;
}
pt operator*(pt p, int x) {
	return {p.x * x, p.y * x};
}
bool in(pt p) {
	return max(abs(p.x), abs(p.y)) <= (int)1e6;
}
const int MAXL = 1e7 + 1e5;
pt nw[MAXL];
pt all[MAXL];
pt nall[MAXL];
int ptr = -1;
void fix(int l) {
	if (ptr == -1) {
		ptr = l;
		for (int i = 0; i < l; ++i)
			all[i] = nw[i];
		sort(all, all + l);
	} else {
		sort(nw, nw + l);
		int p = 0, lp = 0;
		for (int i = 0; i < l; ++i) {
			while (p < ptr && all[p] < nw[i])
				++p;
			if (all[p] == nw[i])
				nall[lp++] = all[p];
		}
		ptr = lp;
		for (int i = 0; i < ptr; ++i)
			all[i] = nall[i];
	}
}
set<pt> used;
void solve2() {
	for (int i = 0; i < n; ++i)
		cin >> pts[i].x >> pts[i].y;
	mt19937 rnd(253566);
	shuffle(pts, pts + n, rnd);
	for (int i = 0; i < min(3ll, n); ++i) {
		used.clear();
		int ptr = 0;
		for (int j = 0; j < n; ++j) {
			if (i != j) {
				pt vec = pts[j] - pts[i];
				int g = gcd(vec.x, vec.y);
				if (vec.y < 0 || (vec.y == 0 && vec.x < 0))
					vec = vec * -1;
				vec.x /= g;
				vec.y /= g;
				if (used.find(vec) != used.end())
					continue;
				used.insert(vec);
				for (int c = 1; in(pts[i] + vec * c); ++c) {
					nw[ptr++] = pts[i] + vec * c;
					if (ptr >= 1e7) {
						break;
					}
				}
				for (int c = -1; in(pts[i] + vec * c); --c) {
					nw[ptr++] = pts[i] + vec * c;
					if (ptr >= 1e7) {
						break;
					}
				}
			}
		}
		fix(ptr);
	}
	for (int i = 0; i < ptr; ++i)
		if (check(all[i])) {
			cout << "Yes\n";
			cout << all[i].x << " " << all[i].y << "\n";
			return;
		}
	cout << "No";
	return;
}
struct line {
	int a, b, c;
	line(pt p, pt q) {
		a = q.y - p.y;
		b = p.x - q.x;
		c = -p.x * q.y + q.x * p.y; 
	}
};
bool line_intersection(line l1, line l2, pt &ans) {
	int detDown = l2.a * l1.b - l1.a * l2.b;
	int detX = (l1.a * l2.c - l2.a * l1.c);
	int detY = -(l1.b * l2.c - l2.b * l1.c);
	if (!detDown)
		return false;
	if (detX % detDown != 0 || detY % detDown != 0)
		return false;
	ans = {detY / detDown, detX / detDown};
	return true;
}
bool inter(pt a, pt b, pt c, pt d, pt &ans) {
	line l1(a, b);
	line l2(c, d);
	return line_intersection(l1, l2, ans);
}
void solve1() {
	for (int i = 0; i < n; ++i)
		cin >> pts[i].x >> pts[i].y;
	mt19937 rnd(635656);
	shuffle(pts, pts + n, rnd);
	pt p;
	int i = 0;
	int k = 1;
	for (int j = i + 1; j < n; ++j) 
		if (k != i && k != j) {
			if (j % 5 == 0 && (double)clock() / CLOCKS_PER_SEC > 4.0) {
				cout << "No";
				return;
			}
			for (int l = k + 1; l < n; ++l)
				if (l != i && l != j) {					;
					if (inter(pts[i], pts[j], pts[k], pts[l], p))
						if (in(p) && check(p)) {
							cout << "Yes\n";
							cout << p.x << " " << p.y << "\n";
							return;
						}
					if (inter(pts[i], pts[k], pts[j], pts[l], p))
						if (in(p) && check(p)) {
							cout << "Yes\n";
							cout << p.x << " " << p.y << "\n";
							return;
						}
				}

		}
	cout << "No";
}
signed main() {
	ios_base::sync_with_stdio(false);
	#ifdef SUBIRD
		freopen("B.in", "r", stdin);
	#endif
	
	cin >> n;
	n *= 2;
	solve1();
	
	return 0;
}