#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7, MAXN = 5e6 + 7;
const ld EPS = 1e-9, PI = acos(-1);

int n;
string s;
vector<int> pos[26], for_check;
int counter[26] = {0};

int gcd(int a, int b)
{
    if (a < b)
        swap(a, b);
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

bool check(int len)
{
    for (int poss = len; poss <= n; poss += len)
        for (int elem : for_check)
            if (n * (lower_bound(all(pos[elem]), poss) - lower_bound(all(pos[elem]), poss - len)) != len * counter[elem])
                return false;

    return true;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> s;
    n = s.size();
    for (int i = 0; i < n; ++i) {
        pos[s[i] - 'a'].pb(i);
        counter[s[i] - 'a']++;
        if (counter[s[i] - 'a'] == 1)
            for_check.pb(s[i] - 'a');
    }
    if (for_check.size() == 1) {
        cout << n << endl;
        return 0;
    }

    int g = 0;
    for (int i = 0; i < 26; ++i)
        g = gcd(g, counter[i]);
    int ans = 1;
    for (int i = g; i > 1; --i) {
        if (n % i == 0 && check(n / i)) {
            ans = i;
            break;
        }
    }

    cout << ans << endl;

    return 0;
}
