#include <bits/stdc++.h>
using namespace std;
#define M make_pair
#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef pair <int, int> pii;

int gcd(int a, int b) {
	a = abs(a); b = abs(b);
	if (a == 0 || b == 0) return 1;
	while (a > 0 && b > 0) {
		if (a > b) a %= b;
			else b %= a;
	}
	if (a > 0) return a;
		else return b;
}

vector <pii> moon;

void new_moon(pii st1, pii fin1, pii st2, pii fin2) {
	int x1 = st1.F, y1 = st1.S, x2 = st2.F, y2 = st2.S,
		dx1 = fin1.F - st1.F, dy1 = fin1.S - st1.S,
		dx2 = fin2.F - st2.F, dy2 = fin2.S - st2.S,
		g1 = gcd(dx1, dy1), g2 = gcd(dx2, dy2);
	dx1 /= g1; dy1 /= g1;
	dx2 /= g2; dy2 /= g2;
	if ((dx2*dy1 - dx1*dy2) == 0) return;
	if (dx1 == 0 && dx2 == 0) return;
	if (dx1 == 0) {
		new_moon(st2, fin2, st1, fin1);
		return;
	} 
	double  Kk = (double) (dx1*y2 - dx1*y1 - dy1*x2 + dy1*x1) / (dx2*dy1 - dx1*dy2),
			kk = (double) (x2 + Kk*dx2 - x1) / dx1;
	if (Kk - trunc(Kk) > 0) return;
	if (kk - trunc(kk) > 0) return;
	
	int K = (int) Kk, k = (int) kk,
		X = x1 + k*dx1, Y = y1 + k*dy1;
	
	if (X - trunc(X) > 0 || abs(X) > 1000000) return;
	if (Y - trunc(Y) > 0 || abs(Y) > 1000000) return;
	
	moon.pb(M(X,Y));
	//cerr << X << " " << Y << endl;
}

int n;
pii a[1000000];
map <pii, int> cnt[10000];

int fast_check(pii A, int kol) {
	for (; kol > 0; kol--) {
		int j = (rand()*rand()) % n;
		int dx = a[j].F - A.F,
			dy = a[j].S - A.S,
			g = gcd(dx, dy);
		dx /= g; dy /= g;
		int sm = cnt[j][M(dx, dy)] + cnt[j][M(-dx, -dy)];
		if (sm != 1) return 1;
	}
	return 0;
}

void check_all(pii A) {
	for (int j = 0; j < n; j++) {
		int dx = a[j].F - A.F,
			dy = a[j].S - A.S,
			g = gcd(dx, dy);
		dx /= g; dy /= g;
		int sm = cnt[j][M(dx, dy)] + cnt[j][M(-dx, -dy)];
		if (sm != 1) return;
	}
	cout << "Yes" << endl << A.F << " " << A.S << endl;
	exit(0);
}

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();
	
	cin >> n; n *= 2;
	for (int i = 0; i < n; i++) {
		cin >> a[i].F >> a[i].S;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j) continue;
			int dx = a[i].F - a[j].F,
				dy = a[i].S - a[j].S,
				g = gcd(dx, dy);
			dx /= g; dy /= g;
			cnt[i][M(dx, dy)]++;
		}
	}
	
	for (int i = 2; i < n; i++) {
		for (int j = 2; j < n; j++) {
			if (i == j) continue;
			new_moon(a[0], a[i], a[1], a[j]);
		}
	}
	for (int i = 3; i < n; i++) {
		new_moon(a[0], a[1], a[2], a[i]);
	}
	for (int i = 0; i < moon.size(); i++) {
		if (fast_check(moon[i], 2) == 1) {
			swap(moon[i], moon[moon.size()-1]);
			moon.pop_back();
		}
	}
	for (auto i : moon) {
		check_all(i);
	}
	cout << "No" << endl;
	
    return 0;
}
