#include <bits/stdc++.h>
using namespace std;
#define M make_pair
#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef pair <int, int> pii;

int gcd(int a, int b) {
	a = abs(a); b = abs(b);
	if (a == 0 && b == 0) return 1;
	while (a > 0 && b > 0) {
		if (a > b) a %= b;
			else b %= a;
	}
	if (a > 0) return a;
		else return b;
}

vector <pii> moon;
map <pii, int> th;

int X1, Y1, x2, y2, dX1, dY1, dx2, dy2, g1, g2;
double Kk, K, X, Y, k, kk;
void new_moon(pii st1, pii fin1, pii st2, pii fin2) {
		X1 = st1.F; Y1 = st1.S; x2 = st2.F; y2 = st2.S;
		dX1 = fin1.F - st1.F; dY1 = fin1.S - st1.S;
		dx2 = fin2.F - st2.F; dy2 = fin2.S - st2.S;
		g1 = gcd(dX1, dY1); g2 = gcd(dx2, dy2);
	if ((dx2*dY1 - dX1*dy2) == 0) return;
	if (dX1 == 0) return;
	dX1 /= g1; dY1 /= g1;
	dx2 /= g2; dy2 /= g2;
			Kk = (double) (dX1*y2 - dX1*Y1 - dY1*x2 + dY1*X1) / (dx2*dY1 - dX1*dy2);
			kk = (double) (x2 + Kk*dx2 - X1) / dX1;
	/*if (Kk - trunc(Kk) > 0) return;
	if (kk - trunc(kk) > 0) return;*/
	
			K = Kk; k = kk;
			X = X1 + k*dX1; Y = Y1 + k*dY1;
	
	if (X - trunc(X) > 0 || abs(X) > 1000000) return;
	if (Y - trunc(Y) > 0 || abs(Y) > 1000000) return;
	
	if (th[M(X,Y)] == 1) return;
	moon.pb(M(X,Y));
	th[M(X,Y)] = 1;
	//cerr << X << " " << Y << endl;
}

int n;
pii a[1000000];
map <pii, int> cnt[10000];

int dx, dy, sm, g;
int fast_check(pii A, int kol) {
	int j;
	for (; kol > 0; kol--) {
			j = (rand()) % n;
			dx = a[j].F - A.F;
			dy = a[j].S - A.S;
			g = gcd(dx, dy);
		dx /= g; dy /= g;
			sm = cnt[j][M(dx, dy)];
		if (sm != 1) return 1;
	}
	return 0;
}

void check_all(pii A) {
	for (int j = 0; j < n; j++) {
			dx = a[j].F - A.F;
			dy = a[j].S - A.S;
			g = gcd(dx, dy);
		dx /= g; dy /= g;
			sm = cnt[j][M(dx, dy)];
		if (sm != 1) return;
	}
	cout << "Yes" << endl << A.F << " " << A.S << endl;
	exit(0);
}

int main()
{
	srand(time(0));
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();
	
	cin >> n; n *= 2;
	for (int i = 0; i < n; i++) {
		cin >> a[i].F >> a[i].S;
		th[a[i]] = 1;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j) continue;
			int dx = a[i].F - a[j].F,
				dy = a[i].S - a[j].S,
				g = gcd(dx, dy);
			dx /= g; dy /= g;
			cnt[i][M(dx, dy)]++;
			cnt[i][M(-dx, -dy)]++;
		}
	}
	
	for (int i = 2; i < n; i++) {
		for (int j = 2; j < n; j++) {
			if (i == j) continue;
			new_moon(a[0], a[i], a[1], a[j]);
			new_moon(a[1], a[j], a[0], a[i]);
		}
	}
	for (int i = 3; i < n; i++) {
		new_moon(a[0], a[1], a[2], a[i]);
		new_moon(a[2], a[i], a[0], a[1]);
	}
	for (int i = 0; i < 100000; i++) {
		int st1 = rand()%n, fin1 = rand()%n,
			st2 = rand()%n, fin2 = rand()%n;
		if (st1 == fin1 || st1 == st2 || st1 == fin2 || fin1 == st2 || fin1 == fin2 || st2 == fin2) continue;
		new_moon(a[st1], a[fin1], a[st2], a[fin2]);
	}
	for (int i = 0; i < moon.size(); i++) {
		if (fast_check(moon[i], 40) == 1) {
			swap(moon[i], moon[moon.size()-1]);
			moon.pop_back();
		}
	}
	
	for (auto i : moon) {
		check_all(i);
	}
	cout << "No" << endl;
	
    return 0;
}
