#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int)1e9;
const int MAXN = (int)1e5;
const int LOGN = (int)30;

vector<vector<int>> gr;
vector<int> cost, sum, mc, sz;

int ans = 0;

void dfs(int v) {
    sz[v] = 1;
    mc[v] = cost[v];
    pair<int, int> min1 = {INF, 0}, min2 = {INF, 0}, maxsz = {0, 0};
    for (int to: gr[v]) {
        dfs(to);
        mc[v] = min(mc[to], mc[v]);
        sum[v] += sum[to];
        sz[v] += sz[to];
        if (maxsz.first < sz[to]) {
            maxsz.first = sz[to];
            maxsz.second = to;
        }
        if (min1.first > mc[to]) {
            min2.first = min1.first;
            min2.second = min2.second;
            min1.first = mc[to];
            min1.second = to;
        } else if (min2.first > mc[to]) {
            min2.first = mc[to];
            min2.second = to;
        }
    }
    if (gr[v].empty()) {
        sum[v] += cost[v];
        return;
    }
    ans += sum[v];
    int diff = 2 * sz[maxsz.second] - sz[v] + 1;
    if (diff <= 0) {
        if (sz[v] % 2 == 0) {
            ans += sum[v] + min1.first + min2.first;
        }
    } else {
        if (maxsz.second == min1.second) {
            ans += diff * min2.first;
        } else {
            ans += diff * min1.first;
        }
    }
    sum[v] += cost[v];
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    cost.resize(n);
    gr.resize(n);
    sum.resize(n, 0);
    mc.resize(n);
    sz.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        gr[p].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        cin >> cost[i];
    }
    dfs(0);
    cout << ans << "\n";
}