#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

mt19937 rnd(1235);

int mysqrt(int x){
    int l = 0, r = 1e4;
    while (r - l > 1){
        int m = (l + r) / 2;
        if (m * m <= x)
            l = m;
        else
            r = m;
    }
    return l;
}

const int maxn = 5e6 + 100, maxw = 1e6 + 100, inf = 1e9 + 100, mod = 1e9 + 7, sq = 300, LG = 18;

int a[26], b[26];

string s;

int n;

vector<int> del;

int main()
{
    #ifdef ONPC
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
    #endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> s;
    n = s.size();
    for (auto &i : s)
        i -= 'a';
    del.reserve(2 * ((int)mysqrt(n) + 1));
    int sqrs = mysqrt(n);
    for (int i = 1; i <= sqrs; i++)
    if (n % i == 0){
        del.push_back(i);
        if (i * i != n)
            del.push_back(n / i);
    }
    sort(del.begin(), del.end());
    for (auto len : del){
        for (int i = 0; i < 26; i++)
            a[i] = 0, b[i] = 0;
        for (int i = 0; i < len; i++)
            a[s[i]]++;
        bool is = 1;
        for (int i = len; i < n; i += len){
            for (int j = 0; j < len; j++){
                b[s[i + j]]++;
                if (b[s[i + j]] > a[s[i + j]]){
                    is = 0;
                    break;
                }
            }
            if (!is)
                break;
            for (int j = 0; j < 26; j++)
                b[j] = 0;
        }
        if (is){
            cout << n / len;
            return 0;
        }
    }
}
