#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <climits>
#include <fstream>

using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");


int main() {

    string s;
    cin >> s;
    int ans = 1;
    vector<vector<int>> a(26, vector<int>(s.size() + 1));
    for (int i = s.size() - 1; 0 <= i; i--) {
        for (int j = 0; j < 26; j++) {
            a[j][i] = a[j][i + 1];
        }
        a[s[i] - 'a'][i]++;
    }
    for (int i = 1; i < s.size(); i++) {
        if (s.size() % i != 0)continue;
        vector<int> stalph(26);
        for (int j = 0; j < 26; j++) {
            stalph[j] = a[j][0] - a[j][i];
        }
        int tempi = 0, outflag = 1;
        while (tempi < s.size()) {
            bool flag = 0;
            for (int ch = 0; ch < 26; ch++) {
                if (stalph[ch] != (a[ch][tempi] - a[ch][tempi + i])) {
                    flag = 1;
                }
            }
            tempi += i;
            if (flag) {
                outflag = 0;
                break;

            }
        }
        if (outflag) {
            ans = max(ans, int(s.size() / i));
        }
    }
    cout << ans;
    return 0;
}