#include <iostream>

using namespace std;

const int maxn = 5e6 + 7;

int pref[maxn][26];

int main()
{
    string s;
    cin >> s;
    int n = s.size();
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < 26; ++j)
            pref[i][j] = (i == 0 ? 0 : pref[i - 1][j]) + (s[i] == 'a' + j);
    }

    for (int d = 1; d <= n; ++d){
        if (n % d != 0)
            continue;
        bool fl = 0;
        for (int i = 0; i < n; i += d){
            for (int j = 0; j < 26; ++j){
                if (pref[i + d - 1][j] - (i == 0 ? 0 : pref[i - 1][j]) != pref[d - 1][j]){
                    fl = 1;
                    break;
                }
                if (fl)
                    break;
            }
            if (fl)
                break;
        }

        if (!fl){
            cout << n / d << '\n';
            return 0;
        }
    }
    return 0;
}
