#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <chrono>

using namespace std;

typedef long long LL;

#define _TEST

const int MAXL = 500050;

const int SIGMA = 26;

/*
int mindiv[MAXL];
vector<int> primes;
*/

int main() {
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  cin.tie(0);
  cin.sync_with_stdio(0);
/*
  primes.reserve(350000);

#ifdef _TEST
  auto tstart = chrono::high_resolution_clock::now();
#endif
  for (int i = 2; i < MAXL; ++i) {
    if (mindiv[i] == 0) {
      mindiv[i] = i;
      primes.push_back(i);
    }
    for (int j = 0; j < primes.size() && primes[j] <= mindiv[i] && i * 1ll * primes[j] < MAXL; ++j) {
      mindiv[i * 1ll * primes[j]] = primes[j];
    }
  }
#ifdef _TEST
  {
    auto tend = chrono::high_resolution_clock::now();
    chrono::duration<double> tmp = tend - tstart;
    double kek = tmp.count();
    fprintf(stderr, "Primes precalc took %lf s\n", kek);
    fprintf(stderr, "primes: %d\n", (int)primes.size());
  }
#endif
*/
  vector<char> s;
  {
    string _s;
    cin >> _s;
    s.resize(_s.length());
    for (int i = 0; i < _s.length(); ++i) {
      s[i] = _s[i] - 'a';
    }
  }
  
  vector<int> cnt(SIGMA);

  for (int i = 0; i < s.size(); ++i) {
    cnt[s[i]]++;
  }

  int n = s.size();

  vector<int> possible;

  int bad = 0;
  for (int i = 0; i < SIGMA; ++i)
    if (cnt[i]) bad++;

  const int BAD = bad;

  {
    vector<int> cur(SIGMA);
    vector<int> curR(SIGMA);
    int badR = BAD;

    for (int i = 0; i < n / 2; ++i) {
      {
        int t = cnt[s[i]];
        int &c = cur[s[i]];

        if (c == 0 || (t % c != 0 && t % (c + 1) == 0)) bad--;
        if (c != 0 && t % c == 0 && t % (c + 1) != 0) bad++;
        ++c;
      }
      {
        int t = cnt[s[n - i - 1]];
        int &c = curR[s[n - i - 1]];

        if (c == 0 || (t % c != 0 && t % (c + 1) == 0)) badR--;
        if (c != 0 && t % c == 0 && t % (c + 1) != 0) badR++;
        ++c;
      }

      if (bad == 0 && badR == 0 && n % (i + 1) == 0) {
        bool kok = 1;
        int ggg = n / (i + 1);
        for (int c = 0; c < SIGMA; ++c) {
          if (cur[c] * 1ll * ggg != cnt[c]) {
            kok = 0;
            break;
          }
          if (curR[c] * 1ll * ggg != cnt[c]) {
            kok = 0;
            break;
          }
        }
        if (kok)
          possible.push_back(i + 1);
      }
    }
  }

#ifdef _TEST
  fprintf(stderr, "possible size: %d\n", (int)possible.size());
#endif

  // KOKOKOPTIMIZATION

  int KOKOANS = 1;

  for (int tries = 0; tries < 3; ++tries) {
    if (possible.size() > 20) {
      int len = possible[possible.size() / 2 + rand() % (possible.size() / 4)];
      bool ok = 1;
      vector<int> mcur(SIGMA);
      for (int i = 0; i < len; ++i) {
        ++mcur[s[i]];
      }
      for (int j = 1; j < n / len - 1; ++j) {
        vector<int> cur(SIGMA);

        for (int i = j * len; i < len * (j + 1); ++i) {
          ++cur[s[i]];
        }

        if (cur != mcur) {
          ok = 0;
          break;
        }
      }
      if (!ok) {
        vector<int> impossible;
        for (int j : possible) {
          if (len % j != 0)
            impossible.push_back(j);
        }
        possible = impossible;
      }
      else {
        KOKOANS = n / len;
        vector<int> impossible;
        for (int j : possible) {
          if (j < len)
            impossible.push_back(j);
        }
        possible = impossible;
      }
    }
  }

  // END OF KOKOKOPTIMIZATION

  for (auto len : possible) {
    bool ok = 1;
    vector<int> mcur(SIGMA);
    for (int i = 0; i < len; ++i) {
      ++mcur[s[i]];
    }
    for (int j = 1; j < n / len - 1; ++j) {
      vector<int> cur(SIGMA);
      
      for (int i = j * len; i < len * (j + 1); ++i) {
        ++cur[s[i]];
      }

      if (cur != mcur) {
        ok = 0;
        break;
      }
    }
    if (ok) {
      cout << n / len << '\n';
      return 0;
    }
  }

  cout << KOKOANS << '\n';

  return 0;
}