#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <iterator>
#include <time.h>

using namespace std;

const long long MOD = 1e9 + 7 ;


long long kek[3][28], pref[3][5123456] ;
string s ;
int n, ans ;

void check ( int curr )
{
    long long x, y, z ;

    x = pref[0][curr] ;
    y = pref[1][curr] ;
    z = pref[2][curr] ;

    for ( int j=0; j+curr<=n; j += curr )
    {
        if ( ( pref[0][j + curr] - pref[0][j] )   != x )
            return ;

        if ( ( pref[1][j + curr] - pref[1][j] )   != y )
            return ;

        if ( ( pref[2][j + curr] - pref[2][j] )   != z )
            return ;
    }

    ans = max ( ans, n / curr ) ;

    return ;
}

int main()
{
    ios_base :: sync_with_stdio ( false ) ;

    int i ;

    srand ( time( NULL ) ) ;

    cin >> s ;


    n = s.length() ;
    for ( i=0; i<28; i++ )
    {
        kek[0][i] = (((long long)rand()) << 45ll)  +  (( (long long)rand()) << 30ll )
        +  ( ( (long long)rand()) << 15ll) + ((long long)rand()) ;

        kek[1][i] = (((long long)rand()) << 45ll)  +  (( (long long)rand()) << 30ll )
        +  ( ( (long long)rand()) << 15ll) + ((long long)rand()) ;

        kek[2][i] = (((long long)rand()) << 45ll)  +  (( (long long)rand()) << 30ll )
        +  ( ( (long long)rand()) << 15ll) + ((long long)rand()) ;
    }

    pref[0][0] = pref[1][0] = pref[2][0] = 0 ;
    for ( i=1; i<=n; i++ )
    {
        pref[0][i] = ( pref[0][i-1] + kek[0][ (int)s[i-1] - (int)'a' ] ) ;
        pref[1][i] = ( pref[1][i-1] + kek[1][ (int)s[i-1] - (int)'a' ] ) ;
        pref[2][i] = ( pref[2][i-1] + kek[2][ (int)s[i-1] - (int)'a' ] ) ;
    }

    ans = 0 ;
    for ( i=1; i*i<=n; i++ )
    {
        if ( n % i == 0 )
        {
            check ( i ) ;
            check ( n / i ) ;
        }
    }

    cout << ans ;

    return 0;
}
