#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <iterator>

using namespace std ;

int n, cost[212345] ;
vector <int> a[212345] ;

long long ans ;

int dfs ( int v )
{
    int cnt = 1, curr = 0 ;

    for ( int i=0; i<a[v].size(); i++ )
    {
        int to = a[v][i] ;

        int kek = dfs(to) ;

        cnt += kek ;

        if ( kek >= curr )
        {
            ans += curr ;
            curr = kek - curr ;
        }
        else
        {
            ans += kek ;
            curr -= kek ;
        }
    }

    ans += curr ;

    return cnt + 1 ;
}

int main()
{
    ios_base :: sync_with_stdio ( false ) ;

    int i, j ;

    cin >> n ;
    for ( i=2; i<=n; i++ )
    {
        cin >> j ;
        a[j].push_back ( i ) ;
    }

    bool flag = true ;
    for ( i=2; i<=n; i++ )
        {
            cin >> cost[i] ;
            if ( cost[i] > 1 )
                flag = false ;
        }

    if ( flag )
    {
        ans = 0 ;
        dfs ( 1 ) ;

        cout << ans ;

        return 0 ;
    }


    return 0;
}
