#include <iostream>
#include <vector>
#include <bitset>
#include <cassert>
#include <algorithm>
#include <map>
#include <set>

using namespace std;
typedef unsigned int index;

pair<long long, pair<int, size_t>> dfs(index v, const vector<vector<index>> &g, const vector<int> &a, long long &ans)
{
    vector<pair<long long, pair<int, size_t>>> cur;
    for (auto i: g[v])
        cur.push_back(dfs(i, g, a, ans));
    if (cur.size() == 0)
        return {a[v], {a[v], 1}};
    for (index i = 1; i < cur.size(); i++)
        if (cur[i].second.second < cur[0].second.second)
            swap(cur[i], cur[0]);
    size_t sz_sum = 0;
    int minl = INT_MAX;
    long long sum = 0;
    for (index i = 1; i < cur.size(); i++)
    {
        sz_sum += cur[i].second.second;
        sum += cur[i].first;
        minl = min(minl, cur[i].second.first);
    }
    if (sz_sum < cur[0].second.second)
    {
        ans += sum + cur[0].first + (cur[0].second.second - sz_sum) * (long long)minl;
    }
    else
    {
        if ((sz_sum + cur[0].second.second) % 2 == 0)
        {
            ans += sum + cur[0].first;
        }
        else
        {
            ans += sum + cur[0].first + min(minl, cur[0].second.first);
        }
    }
    for (index i = 1; i < cur.size(); i++)
    {
        cur[0].first += cur[i].first;
        cur[0].second.first = min(cur[0].second.first, cur[i].second.first);
        cur[0].second.second += cur[i].second.second;
    }
    cur[0].first += a[v];
    cur[0].second.first = min(cur[0].second.first, a[v]);
    cur[0].second.second += 1;
    return cur[0];
}

int main()
{
    assert(freopen("C:\\Users\\olymp\\Olymp\\a.in", "r", stdin));
    assert(freopen("C:\\Users\\olymp\\Olymp\\a.out", "w", stdout));
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    size_t n;
    cin >> n;
    vector<vector<index>> g(n);
    for (index i = 1; i < n; i++)
    {
        index x;
        cin >> x;
        g[x - 1].push_back(i);
    }
    vector<int> a(n);
    for (index i = 1; i < n; i++)
        cin >> a[i];
    long long ans = 0;
    dfs(0, g, a, ans);
    cout << ans << endl;
}
