#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<set>
#include<climits>

using namespace std;

long long cnt = 0;

int dfs(int s, vector<vector<int> > graph)
{
	int curr = 1;
	vector<int> children;
	for (int i : graph[s])
	{
		children.push_back(dfs(i, graph));
		curr += children.back();
	}
	int i = 0, j = 1;
	sort(children.rbegin(), children.rend());
	while (children.size() > 1 && i < children.size() && j < children.size())
	{
		cnt += (long long)min(children[j], children[i]);
		int tmp = children[i];
		children[i] = max(children[i] - children[j], 0);
		children[j] = max(0, children[j] - tmp);
		while (i < children.size() && children[i] == 0)
			++i;
		while (j < children.size() && children[j] == 0)
			++j;
		if (i > j)
			swap(i, j);
		if (i == j)
		{
			++j;
			while (j < children.size() && children[j] == 0)
				++j;
		}
	}
	while (children.size() > 1 && i < children.size())
	{
		cnt += (long long)children[i];
		++i;
	}
	return curr;
}

int main()
{
	int n, x;
	cin >> n;
	vector<vector<int> > graph(n);
	vector<int> c(n);
	for (int i = 0; i < n - 1; ++i)
	{
		cin >> x;
		graph[x - 1].push_back(i + 1);
	}
	for (int i = 0; i < n - 1; ++i)
		cin >> c[i + 1];
	dfs(0, graph);
	cout << 2 * cnt;
//	system("pause");
	return 0;
}