#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
using namespace std;
const int N = 2e7;

int tree[N], m = 1;
string s;

void build_tree(int n = s.length()) // b
{
    while (m < n)
        m *= 2;
    for (int i = 2*m-1; i; --i)
        if (i >= m)
            tree[i] = i-m < n ? s[i-m]-'a' : 0;
        else
            tree[i] = tree[2*i] + tree[2*i+1];
}

int count(int id, int l, int r, int tl = 0, int tr = m)
{
    if (l == tl && r == tr)
        return tree[id];
    int tm = (tl + tr) / 2;
    if (r <= tm)
        return count(2*id, l, r, tl, tm);
    if (l >= tm)
        return count(2*id+1, l, r, tm, tr);
    return count(2*id, l, tm, tl, tm) + count(2*id+1, tm, r, tm, tr);
}

int main()
{
    cin >> s;
    int n = s.length();
    vector<int> chk;
    int K = count(s.begin(), s.end(), 'a') + count(s.begin(), s.end(), 'b') == n ? 2 : 26;
    int gans[K];
    for (int i = 0; i < K; ++i)
        gans[i] = count(s.begin(), s.end(), 'a'+i);
    for (int i = 2; i < sqrt(n); ++i)
    {
        if (n % i)
            continue;
        bool h = true;
        for (int j = 0; j < K && h; ++j)
            h &= gans[j] % i == 0;
        if (h)
            chk.push_back(n / i);
        h = true;
        for (int j = 0; j < K && h; ++j)
            h &= gans[j] % (n / i) == 0;
        if (h)
            chk.push_back(i);
    }
    int d = sqrt(n);
    bool h = d * d == n;
    for (int i = 0; i < K && h; ++i)
        h &= gans[i] % d == 0;
    if (h)
        chk.push_back(sqrt(n));
    sort(chk.begin(), chk.end());
    if (count(s.begin(), s.end(), s[0]) == n)
    {
        cout << n;
        return 0;
    }
    if (K == 2)
    {
        build_tree();
        for (int l: chk)
        {
            bool h = true;
            for (int i = l; i < n && h; i += l)
                h &= count(1, 0, l) == count(1, i, i + l);
            if (h)
            {
                cout << n / l;
                return 0;
            }
        }
        cout << 1;
        return 0;
    }
    for (int l: chk)
    {
        bool h = true;
        int ans[K];
        for (int i = 0; i < K; ++i)
            ans[i] = count(s.begin(), s.begin() + l, 'a'+i);
        for (int i = l; i < n && h; i += l)
            for (int j = 0; j < K && h; ++j)
                h &= count(s.begin() + i, s.begin() + i + l, 'a'+j) == ans[j];
        if (h)
        {
            cout << n / l;
            return 0;
        }
    }
    cout << 1;
    return 0;
}
