#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define FILE ""

struct pt
{
    long double x, y;
};

struct line
{
    long double a, b, c;
};

const long double EPS = 1e-15;

long double det(long double a, long double b, long double c, long double d)
{
    return a * d - b * c;
}

bool inter(line m, line n, pt &res)
{
    long double zn = det(m.a, m.b, n.a, n.b);
    if (abs(zn) < EPS)
        return 0;
    res.x = -det(m.c, m.b, n.c, n.b) / zn;
    res.y = -det(m.a, m.c, n.a, n.c) / zn;
    return 1;
}

int main()
{
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen(FILE".in", "r", stdin);
    //freopen(FILE".out", "w", stdout);
#endif // LOCAL
    long long n;
    cin >> n;
    n *= 2;
    long long x[n], y[n];
    for (long long i = 0; i < n; ++i)
    {
        cin >> x[i] >> y[i];
    }
    for (long long i = 1; i < n; ++i)
    {
        long long A = y[0] - y[i];
        long long B = x[i] - x[0];
        long long C = -A * x[0] - B * y[0];
        long long g = __gcd(A, __gcd(B, C));
        A /= g;
        B /= g;
        C /= g;
        if (A < 0 || (A == 0 && B < 0))
        {
            A *= -1;
            B *= -1;
            C *= -1;
        }
        line l1 = {A, B, C};
        bool f = 0;
        long long u = (i == 1 ? 2 : 1);
        for (long long v = 1; v < n; ++v)
        {
            if (v == i || v  == u)
                continue;
            long long a = y[u] - y[v];
            long long b = x[v] - x[u];
            long long c = -a * x[u] - b * y[u];
            g = __gcd(a, __gcd(b, c));
            a /= g;
            b /= g;
            c /= g;
            if (a < 0 || (a == 0 && b < 0))
            {
                a *= -1;
                b *= -1;
                c *= -1;
            }
            pt p;
            line l2 = {a, b, c};
            if (inter(l1, l2, p) == 0)
            {
                continue;
            }
            if (abs(p.x - ceil(p.x)) > EPS
                    || abs(p.y - ceil(p.y)) > EPS )
            {
                continue;
            }
            map<pair<long long, pair<long long, long long> >, long long > mp;
            mp[ {A, {B, C}}] = 2;
            mp[ {a, {b, c}}] = 2;
            long long xx = p.x;
            long long yy = p.y;
            bool f = 0;
            for (long long j = 0; j < n; ++j)
            {
                if (x[j] == xx && y[j] == yy)
                {
                    f = 1;
                    break;
                }
                if (j == 0 || j == i || j == u || j == v)
                    continue;
                long long aa = yy - y[j];
                long long bb = x[j] - xx;
                long long cc = -aa * yy - bb * xx;
                g = __gcd(aa, __gcd(bb, cc));
                aa /= g;
                bb /= g;
                cc /= g;
                if (aa < 0 || (aa == 0 && bb < 0))
                {
                    aa *= -1;
                    bb *= -1;
                    cc *= -1;
                }
                if (mp[ {aa, {bb, cc}}] > 1)
                {
                    f = 1;
                    break;
                }
                mp[ {aa, {bb, cc}}]++;
            }
            int sum = 0;
            for (auto q:mp)
            {
                if (q.S == 1)
                {
                    f = 1;
                    break;
                }
                sum += q.S;
            }
            if (sum != 2 * n) f = 1;
            if (f == 0 && abs(xx) <= 1e6 && abs(yy) <= 1e6)
            {
                cout << "Yes" << endl;
                cout << xx << ' ' << yy << endl;
                return 0;
            }
        }
    }
    cout << "No";
    return 0;
}
