#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <random>
#include <set>
#include <unordered_map>

using namespace std;

#define endl '\n'

vector<map<int, int> > kol;
int n;

bool can(int len) {
	for (int i = len * 2 - 1; i < n; i += len) {
		for (auto j : kol[i]) {
			if (kol[len - 1].find(j.first) != kol[len - 1].end() && j.second != kol[i - len][j.first] + kol[len - 1][j.first]) {
				return false;
			}
		}
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	string s;
	cin >> s;

	n = s.size();
	kol.resize(n);
	for (int i = 0; i < n; i++) {
		kol[i] = i == 0 ? kol[i] : kol[i - 1];
		kol[i][s[i] - 'a']++;
	}

	int ans;
	for (int i = 1; i * i <= n; i++) {
		if (n % i == 0) {
			if (can(i)) {
				cout << n / i;
				return 0;
			}
			if (can(n / i)) {
				ans = i;
			}
		}
	}
	cout << ans;
}