#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

#define endl '\n'

vector<vector<int> > kol;
vector<int> kol1;
vector<int> kol2;
int n;

bool can(int len) {
	for (int i = len * 2 - 1; i < n; i += len) {
		for (int j = 0; j < 26; j++) {
			if (kol[i][j] != kol[i - len][j] + kol[len - 1][j]) {
				return false;
			}
		}
	}
	return true;
}

bool can2(int len) {
	for (int i = len * 2 - 1; i < n; i += len) {
		if ((kol1[i] != kol1[i - len] + kol1[len - 1]) || (kol2[i] != kol2[i - len] + kol2[len - 1])) {
			return false;
		}
	}
	return true;
}

void func2(string s) {
	kol1.resize(n);
	kol2.resize(n);
	for (int i = 0; i < n; i++) {
		kol1[i] = i == 0 ? kol1[i] : kol1[i - 1];
		kol2[i] = i == 0 ? kol2[i] : kol2[i - 1];
		if (s[i] == 'a') {
			kol1[i]++;
		}
		else {
			kol2[i]++;
		}
	}

	int ans;
	for (int i = 1; i * i <= n; i++) {
		if (n % i == 0) {
			if (can2(i)) {
				cout << n / i;
				return;
			}
			if (can2(n / i)) {
				ans = i;
			}
		}
	}
	cout << ans;
	return;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	string s;
	cin >> s;

	n = s.size();
	if (n > 500000) {
		func2(s);
		return 0;
	}
	else {
		kol.resize(n, vector<int>(26));
	}
	for (int i = 0; i < n; i++) {
		kol[i] = i == 0 ? kol[i] : kol[i - 1];
		kol[i][s[i] - 'a']++;
	}

	int ans;
	for (int i = 1; i * i <= n; i++) {
		if (n % i == 0) {
			if (can(i)) {
				cout << n / i;
				return 0;
			}
			if (can(n / i)) {
				ans = i;
			}
		}
	}
	cout << ans;
}