#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <random>
#include <ctime>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 5000100, ALF = 26;
string s;
int n;
bool used[ALF];
bool mon[MAXN];
int kol[MAXN], tec;

bool chek(int sh)
{
	if (tec == 0)
		return false;
	if ((kol[n - 1] % tec == 0)
		&& (kol[n - 1] / tec == n / sh))
		return true;
	return false;
}

bool cok(int sh)
{
	for (int i = sh; i < n; i += sh)
	{
		if (kol[i + sh - 1] - kol[i - 1] != tec)
			return false;
	}
	return true;
}

void solve(int buk)
{
	kol[0] = 0;
	for (int i = 0; i < n; i++)
	{
		if (i)
			kol[i] = kol[i - 1];
		if (s[i] - 'a' == buk)
			kol[i]++;
	}
	tec = 0;
	for (int i = 0; i < n; i++)
	{
		if (s[i] - 'a' == buk)
			tec++;
		if (n % (i + 1))
		{
			mon[i] = true;
			continue;
		}
		if (!chek(i + 1))
		{
			mon[i] = true;
			continue;
		}
		if (!cok(i + 1))
		{
			mon[i] = true;
		}
	}
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin >> s;
	n = s.size();
	for (int i = 0; i < n; i++)
	{
		used[s[i] - 'a'] = true;
	}
	for (int buk = 0; buk < ALF; buk++)
	{
		if(used[buk])
			solve(buk);
	}
	for (int i = 0; i < n; i++)
	{
		if (mon[i] == false)
		{
			cout << n / (i + 1);
			return 0;
		}
	}
	return 0;
}