#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <random>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <bitset>
using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for (int j = 0; j < m; ++j)
#define sqr(a) ((a)*(a))

typedef long long ll;
typedef short int sint;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<ll> vll;
typedef vector<pair<int, int> > vpint;

mt19937 rnd;

void gen() {
	int n;
	cin >> n;
	vector<int> test(2 * n, -1);
	for (int i = 0; i < n; ++i)
		test[2 * i] = i + 1;
	while (true) {
		while (test.back() == -1)
			test.pop_back();
		int pos;
		for (pos = test.size() - 1; pos >= 0; --pos)
			if (test[pos] == -1) {
				test[pos] = test.back();
				test.back() = -1;
				break;
			}
		if (pos == -1)
			break;
	}
	for (int a : test) {
		bitset<10> b = a;
		cout << a << ' ';
	}
	cout << '\n';
}

long long rec(long long n, long long pos, ll start = 0) {
	if (start % 2 == pos % 2)
		return pos / 2;
	else {
		ll dist = (n - start + 1) / 2;
		ll last = (dist - 1) * 2 + start;
		ll tstart;
		if (last == n - 1)
			tstart = 1;
		else
			tstart = 0;

		ll v = rec(n - dist, pos / 2, tstart);
		return v + dist;
	}
		
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	//gen();
	long long n;
	cin >> n;
	int q;
	cin >> q;
	while (q--) {
		ll pos;
		cin >> pos;
		cout << rec(n, pos - 1) + 1 << '\n';
	}
	//cout << '\n';
	//cout << fixed << setprecision(6) << (double)clock() / CLOCKS_PER_SEC << '\n';
	return 0;
}

