#include <bits/stdc++.h>

using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

long long dfs(int v, vector<vector<int>>& G, long long& result)
{
    long long qua = 0;
    for (auto u : G[v])
    {
        qua += dfs(u, G, result);
    }
    if (qua != 0)
    {
        result += qua - 1;
    }
    return qua + 1;
}

int main()
{
    ios_base::sync_with_stdio(false);
    in.tie(nullptr);
    int n, p;
    in >> n;
    vector<vector<int>> G(static_cast<unsigned int>(n + 1));
    for (int i = 2; i <= n; ++i)
    {
        in >> p;
        G[p].push_back(i);
    }
    vector<int> c(static_cast<unsigned int>(n + 1));
    for (int i = 2; i <= n; ++i)
    {
        in >> c[i];
    }
    long long result = 0;
    dfs(1, G, result);
    out << result * 2 << '\n';
    in.close();
    out.close();
    return 0;
}