#include <bits/stdc++.h>

using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

const long long INF = 1000000000000000000;

pair<long long, pair<long long, long long>> dfs(int v, vector<vector<int>>& G, long long& result, vector<long long>& c, vector<long long>& minv)
{
    long long qua = 0, sum = 0;
    multiset<pair<long long, int>, greater<>> s;
    pair<long long, long long> mini = {INF, INF};
    for (auto u : G[v])
    {
        auto p = dfs(u, G, result, c, minv);
        long long tmp = p.first;
        if (p.second.first < mini.first)
        {
            mini.second = mini.first;
            mini.first = p.second.first;
        }
        else if (p.second.first < mini.second)
        {
            mini.second = p.second.first;
        }
        sum += p.second.second;
        s.insert({tmp, u});
        qua += tmp;
        minv[u] = p.second.first;
    }
    if (s.empty())
    {
        return {1, {c[v], c[v]}};
    }
    long long maxi = s.begin()->first;
    s.erase(s.begin());
    if (maxi > qua - maxi)
    {
        result += sum;
        maxi -= qua - maxi;
        if (minv[s.begin()->second] > mini.first)
        {
            result += mini.first * maxi;
        }
        else
        {
            result += mini.second * maxi;
        }
    }
    else
    {
        result += sum + (qua % 2) * mini.first;
    }
    return {qua + 1, {mini.first, sum + c[v]}};
}

int main()
{
    ios_base::sync_with_stdio(false);
    in.tie(nullptr);
    int n, p;
    in >> n;
    vector<vector<int>> G(static_cast<unsigned int>(n + 1));
    for (int i = 2; i <= n; ++i)
    {
        in >> p;
        G[p].push_back(i);
    }
    vector<long long> c(static_cast<unsigned int>(n + 1));
    for (int i = 2; i <= n; ++i)
    {
        in >> c[i];
    }
    long long result = 0;
    vector<long long> minv(static_cast<unsigned int>(n + 1), INF);
    dfs(1, G, result, c, minv);
    out << result << '\n';
    in.close();
    out.close();
    return 0;
}