#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <time.h>
#include <random>
#include <algorithm>

using namespace std;
#define int long long

const int MAXN = 2e5 + 7;

vector <int> g[MAXN];

int ans = 0;
int c[MAXN];
int cnt[MAXN];
int mn[MAXN];
int sum[MAXN];

int getmin(int u, int v) {
    if (u == -1) return v;
    if (v == -1) return u;

    if (mn[u] < mn[v]) return u;
    else return v;
}

void dfs(int u, int parent) {
    cnt[u] = 1;
    mn[u] = c[u];
    sum[u] = c[u];
    for (int v : g[u]) {
        if (v == parent) continue;
        
        dfs(v, u);
        cnt[u] += cnt[v];
        sum[u] += sum[v];
        mn[u] = min(mn[u], mn[v]);
    }

    int counter = 0;
    for (int v : g[u]) {
        if (v == parent) continue;
        else ++counter;
    }
    if (!counter) return;

    int mx = -1;
    for (int v : g[u]) {
        if (v == parent) continue;
        if (mx == -1 || cnt[mx] < cnt[v]) mx = v;
    }

    int cntsum = 0;
    for (int v : g[u]) {
        if (v == parent) continue;
        if (v != mx) cntsum += cnt[v];
    }

    int mn1 = -1, mn2 = -1;
    for (int v : g[u]) {
        if (v == parent) continue;
        mn2 = getmin(mn2, v);
        mn1 = getmin(mn1, mn2);
    }

    int k = cnt[u] - 1;
    int psum = sum[u] - c[u];
    if (cnt[mx] <= cntsum) {
        ans += psum;

        if (k % 2) {
            if (!(mn1 == mx && cntsum - 1 < cnt[mx])) {
                ans += mn[mn1];
            }
            else {
                exit(1);
                ans += mn[mn2];
            }
        }
    }
    else {
        ans += psum;
        if (mx != mn1) {
            ans += (cnt[mx] - cntsum) * mn[mn1];
        }
        else {
            exit(1);
            ans += (cnt[mx] - cntsum) * mn[mn2];
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    freopen("input.txt", "r", stdin);

    int n;
    cin >> n;

    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v;
        --v;
        g[i].push_back(v);
        g[v].push_back(i);
    }

    for (int i = 1; i < n; ++i) cin >> c[i];

    dfs(0, -1);

    cout << ans << '\n';
    return 0;
}