#include <iostream>
#include <fstream>
#include <vector>
#include <queue>
using namespace std;

#define pb push_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n, q; fin >> n >> q;
    queue<int> pos;
    vector<int> arr;
    int item;
    for (int i=0; i<n; i++) {
        item = i+1;
        arr.pb(item);
        if (i!=n-1) arr.pb(-1);
    }

    for (int i=arr.size()-1; i>=0; i--)
        if (arr[i] == -1)
            pos.push(i);

    for (int i=arr.size()-1; i>=0; i--) {
        if (arr[i]!=-1 && !pos.empty()) {
            arr[pos.front()] = arr[i];
            arr[i] = -1;
            pos.pop();
        }
    }

    for (int i=0; i<q; i++) {
        fin >> item;
        item--;
        fout << arr[item] << endl;
    }

    fin.close();
    fout.close();
    return 0;
}
