//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include <stdio.h>
#include <bits/stdc++.h>

#define uint unsigned int
#define ll long long
#define ull unsigned long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, r, l) for (int i = r; i > l; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second
#define mp(a, b) make_pair(a, b)
#define y1 dhwjdshg

using namespace std;

const int N = 3000 * 2;
const int inf = (int)1e9 + 1;
const ll big = (ll)1e18 + 1;
const int P = 239;
const int MOD = (int)1e9 + 7;
const int MOD1 = (int)1e9 + 9;
const double eps = 1e-9;
const double pi = atan2(0, -1);
const int ABC = 26;

struct Point
{
    int x, y;
    Point() {}
    Point(int x, int y) : x(x), y(y) {}
};

bool operator == (Point &p1, Point &p2)
{
    return p1.x == p2.x && p1.y == p2.y;
}

bool operator == (pair<int, int> &p1, pair<int, int> &p2)
{
    return p1.fi == p2.fi && p1.se == p2.se;
}

int n;
Point a[N];
pair<int, int> vect[N];

bool check(Point p)
{
    rep(i, 0, n)
    {
        if (a[i] == p)
            return false;
        int dx = a[i].x - p.x;
        int dy = a[i].y - p.y;
        if (dx < 0 || dx == 0 && dy < 0)
        {
            dx = -dx;
            dy = -dy;
        }
        int g = __gcd(abs(dx), abs(dy));
        dx /= g; dy /= g;
        vect[i] = {dx, dy};
    }
    sort(vect, vect + n);
    /*if (p.x == 2 && p.y == 2)
    {
        rep(i, 0, n)
            cout << vect[i].fi << " " << vect[i].se << "   ";
        cout << "\n";
    }*/
    rep(i, 1, n)
    {
        if (i % 2 == 0)
        {
            if (vect[i] == vect[i - 1])
                return false;
        }
        else
        {
            if (vect[i] != vect[i - 1])
                return false;
        }
    }
    return true;
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    //ll TL = 0.95 * CLOCKS_PER_SEC;
    //clock_t time = clock();
    cin >> n;
    n *= 2;
    rep(i, 0, n)
        cin >> a[i].x >> a[i].y;
    if (true)
    {
        set<pair<int, int> > was;
        set<pair<int, int> > points;
        rep(i, 1, n)
        {
            int dx = a[i].x - a[0].x;
            int dy = a[i].y - a[0].y;
            if (dx < 0 || dx == 0 && dy < 0)
            {
                dx = -dx;
                dy = -dy;
            }
            int g = __gcd(abs(dx), abs(dy));
            dx /= g; dy /= g;
            if (was.find(mp(dx, dy)) != was.end())
                continue;
            was.insert(mp(dx, dy));
            int x = a[0].x, y = a[0].y;
            //cout << x << " " << y << " " << dx << " " << dy << endl;
            while (true)
            {
                x += dx; y += dy;
                if (abs(x) > 1000000 || abs(y) > 1000000)
                    break;
                if (points.find(mp(x, y)) == points.end())
                {
                    points.insert(mp(x, y));
                    if (check(Point(x, y)))
                    {
                        //cout << sz(points) << endl;
                        cout << "Yes\n";
                        cout << x << " " << y << "\n";
                        return 0;
                    }
                }
            }
            x = a[0].x; y = a[0].y;
            while (true)
            {
                x -= dx; y -= dy;
                if (abs(x) > 1000000 || abs(y) > 1000000)
                    break;
                if (points.find(mp(x, y)) == points.end())
                {
                    points.insert(mp(x, y));
                    if (check(Point(x, y)))
                    {
                        //cout << sz(points) << endl;
                        cout << "Yes\n";
                        cout << x << " " << y << "\n";
                        return 0;
                    }
                }
            }
        }
    }
    cout << "No\n";
    return 0;
}