//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include <stdio.h>
#include <bits/stdc++.h>

#define uint unsigned int
#define ll long long
#define ull unsigned long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, r, l) for (int i = r; i > l; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second
#define mp(a, b) make_pair(a, b)
#define y1 dhwjdshg

using namespace std;

const int N = 3000 * 2;
const int inf = (int)1e9 + 1;
const ll big = (ll)1e18 + 1;
const int P = 239;
const int MOD = (int)1e9 + 7;
const int MOD1 = (int)1e9 + 9;
const double eps = 1e-9;
const double pi = atan2(0, -1);
const int ABC = 26;

struct Point
{
    ll x, y;
    Point() {}
    Point(ll x, ll y) : x(x), y(y) {}
};

bool operator == (Point &p1, Point &p2) { return p1.x == p2.x && p1.y == p2.y; }

bool operator != (Point &p1, Point &p2) { return p1.x != p2.x || p1.y != p2.y; }

Point operator - (Point p1, Point p2) { return Point(p1.x - p2.x, p1.y - p2.y); }

ll operator * (Point p1, Point p2) { return p1.x * p2.x + p1.y * p2.y; }

ll operator % (Point p1, Point p2) { return p1.x * p2.y - p2.x * p1.y; }

Point zero = {inf, inf};

struct Line
{
    ll a, b, c;
    Line() {}
    Line(ll a, ll b, ll c) : a(a), b(b), c(c) {}
    Line(Point p1, Point p2)
    {
        a = p2.y - p1.y;
        b = -(p2.x - p1.x);
        c = p2 % p1;
    }
};

Point LIL(Line l1, Line l2)
{
    ll v = l1.a * l2.b - l2.a * l1.b, v1, x, y;
    if (v == 0)
        return zero;
    v1 = -(l1.c * l2.b - l2.c * l1.b);
    if (v1 % v != 0)
        return zero;
    x = v1 / v;
    v1 = (l1.c * l2.a - l2.c * l1.a);
    if (v1 % v != 0)
        return zero;
    y = v1 / v;
    return Point(x, y);
}

bool operator == (pair<int, int> &p1, pair<int, int> &p2)
{
    return p1.fi == p2.fi && p1.se == p2.se;
}

int n;
Point a[N];
pair<int, int> vect[N];

bool check(Point p)
{
    rep(i, 0, n)
    {
        if (a[i] == p)
            return false;
        int dx = a[i].x - p.x;
        int dy = a[i].y - p.y;
        if (dx < 0 || dx == 0 && dy < 0)
        {
            dx = -dx;
            dy = -dy;
        }
        int g = __gcd(abs(dx), abs(dy));
        dx /= g; dy /= g;
        vect[i] = {dx, dy};
    }
    sort(vect, vect + n);
    /*if (p.x == 2 && p.y == 2)
    {
        rep(i, 0, n)
            cout << vect[i].fi << " " << vect[i].se << "   ";
        cout << "\n";
    }*/
    rep(i, 1, n)
    {
        if (i % 2 == 0)
        {
            if (vect[i] == vect[i - 1])
                return false;
        }
        else
        {
            if (vect[i] != vect[i - 1])
                return false;
        }
    }
    return true;
}

void get_lines(int pos, vector<Line> &lines)
{
    set<pair<int, int> > was;
    rep(i, 0, n)
        if (i != pos)
        {
            int dx = a[i].x - a[pos].x;
            int dy = a[i].y - a[pos].y;
            if (dx < 0 || dx == 0 && dy < 0)
            {
                dx = -dx;
                dy = -dy;
            }
            int g = __gcd(abs(dx), abs(dy));
            dx /= g; dy /= g;
            if (was.find({dx, dy}) != was.end())
                continue;
            was.insert({dx, dy});
            lines.push_back(Line(a[i], a[pos]));
        }
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    //ll TL = 0.95 * CLOCKS_PER_SEC;
    //clock_t time = clock();
    cin >> n;
    n *= 2;
    rep(i, 0, n)
        cin >> a[i].x >> a[i].y;
    int p1 = 0, p2 = 1, p3 = -1;
    rep(i, 2, n)
        if ((a[i] - a[p1]) % (a[p2] - a[p1]) != 0)
        {
            p3 = i;
            break;
        }
    if (p3 == -1)
    {
        cout << "No\n";
        return 0;
    }
    /*Line l1 = Line(a[0], a[1]);
    Line l2 = Line(a[2], a[3]);
    cout << l1.a << " " << l1.b << " " << l1.c << "\n";
    cout << l2.a << " " << l2.b << " " << l2.c << "\n";
    Point p = LIL(l1, l2);
    cout << p.x << " " << p.y << "\n";*/
    vector<Line> l1, l2, l3;
    get_lines(p1, l1);
    get_lines(p2, l2);
    get_lines(p3, l3);
    set<pair<int, int> > poss, poss1;
    for (auto i : l1)
        for (auto j : l2)
        {
            Point p = LIL(i, j);
            if (p != zero)
                poss.insert({p.x, p.y});
        }
    /*for (auto it : poss)
        cout << it.fi << " " << it.se << "   ";
    cout << "\n";*/
    for (auto i : l1)
        for (auto j : l3)
        {
            Point p = LIL(i, j);
            if (p != zero && ((p - a[p1]) % (a[p2] - a[p1]) == 0 || poss.find({p.x, p.y}) != poss.end()))
                poss1.insert({p.x, p.y});
        }
    /*for (auto it : poss1)
        cout << it.fi << " " << it.se << "   ";
    cout << "\n";*/
    for (auto it : poss1)
        if (check(Point(it.fi, it.se)))
        {
            cout << "Yes\n";
            cout << it.fi << " " << it.se << "\n";
            return 0;
        }
    cout << "No\n";
    return 0;
}