#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#define FOR(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;
std::vector<std::vector<int>>g;
std::vector<ll>a, dp;
ll answ = 0;
int dfs(int v) {
	if (dp[v] != -1) {
		return dp[v];
	}
	dp[v] = 1;
	std::multiset<ll> cur;
	FOR(i, g[v].size()) {
		dp[v] += dfs(g[v][i]);
		cur.insert(dp[g[v][i]]);
	}
	while (cur.size() > 1) {
		auto it = cur.begin();
		auto it2 = cur.end();
		--it2;
		ll first = *it, second = *it2;
		cur.erase(it);
		cur.erase(it2);
		answ += std::min(first, second) * 2;
		if (second > first) {
			cur.insert(second - first);
		}
	}
	if (cur.size() == 1) {
		answ += *cur.begin() * 2;
	}
	return dp[v];
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	int n;
	std::cin >> n;
	g.resize(n);
	a.resize(n);
	dp.resize(n, -1);
	FOR(i, n - 1) {
		int x;
		std::cin >> x;
		--x;
		g[x].push_back(i + 1);
	}
	FOR(i, n - 1) {
		std::cin >> a[i + 1];
	}
	dfs(0);
	std::cout << answ;
	return 0;
}