#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all (x).begin(), (x).end()
#define pb push_back
#define ft first
#define st second
#define forn(i, n) for(int i = 0;i < n;i++)
#define int long long
// FAST READ
inline long long readInt(){
	ll read = getchar(), sign = 1, x = 0;
	while (read != '-' && (read < '0' || read > '9')) read = getchar();
	if (read == '-') sign = -1, read = getchar();
	while (read >= '0' && read <= '9') x = 10 * x + read - '0', read = getchar();
	return x * sign;
}

inline void writeInt(long long x){
	if (x < 0) putchar('-'), x = -x;
	long long reverse = 0;
	do{
		reverse = reverse * 10 + (x % 10);
		x /= 10;
	} while (x > 0);
	do{
		putchar(reverse % 10 + '0');
		reverse /= 10;
	} while(reverse > 0);
}
//END FAST READ

struct Solver{
	int n = 0;
	vector<int> dp, size_, c;
	vector<vector<int>> g;
	void dfs(int v){
		size_[v] = 1;
		ll ost = 0;
		bool fir = 1;
		for (int u : g[v]){
			dfs(u);
			dp[v] += dp[u];
			size_[v] += size_[u];
			if (fir){
				ost = size_[u];
				fir = 0;
				continue;
			}
			dp[v] += 2 * min(ost, size_[u]);
			if (ost < size_[u]) ost = size_[u] - ost;
			else ost -= size_[u];
//			cout << v << ' ' << u << ost << '\n';
		}
//		cout << v << ' ' << ost << '\n';
		dp[v] += 2 * ost;
//		dp[v] -= 2;
//		dp[v] = max(0LL, dp[v]);
//		cout << v << ' ' << dp[v] << '\n';
		if (g[v].size() == 1) assert(0);
	}
	Solver() {
		cin >> n;
		g.resize(n), dp.resize(n), size_.resize(n), c.resize(n);
		for (int i = 1;i < n;i++){
			int p;
			cin >> p;
			g[--p].pb(i);
		}
		forn(i, n - 1){
			cin >> c[i + 1];
		}
		dfs(0);
		cout << dp[0] << '\n';
	}
};

signed main(){
	int t = 1;
#ifdef LOCAL

	assert(freopen("input.txt", "r", stdin));
	cin >> t;
#else
	ios_base::sync_with_stdio(0);
	cout.tie(0);
#endif
	while(t--){
#ifdef LOCAL
		clock_t gg = clock();
#endif
		Solver a = Solver();
#ifdef LOCAL
		cout << setprecision(5) << fixed <<"Elapsed " << fabs(gg - clock()) / CLOCKS_PER_SEC << " sec.\n";
#endif
	}
}

