#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

#define all (x).begin(), (x).end()
#define pb push_back
#define ft first
#define st second
#define forn(i, n) for(int i = 0;i < n;i++)
#define int long long
// FAST READ
inline long long readInt(){
	ll read = getchar(), sign = 1, x = 0;
	while (read != '-' && (read < '0' || read > '9')) read = getchar();
	if (read == '-') sign = -1, read = getchar();
	while (read >= '0' && read <= '9') x = 10 * x + read - '0', read = getchar();
	return x * sign;
}

inline void writeInt(long long x){
	if (x < 0) putchar('-'), x = -x;
	long long reverse = 0;
	do{
		reverse = reverse * 10 + (x % 10);
		x /= 10;
	} while (x > 0);
	do{
		putchar(reverse % 10 + '0');
		reverse /= 10;
	} while(reverse > 0);
}
//END FAST READ

struct Solver{
	int n = 0;
	vector<vector<int>> g;
	vector<int> dp, sum, c, sz;
	int dfs(int v, int p = -1){
		sz[v] = 1;
		sum[v] = c[v];
		vector<pii> ost;
		int mn = INT_MAX, mn1 = INT_MAX, ind = -1, ind1 = -1;
		for (int u : g[v]){
			if (u == p) continue;
			int tmp = dfs(u, v);
			if (tmp < mn){
				mn1 = mn;
				ind1 = ind;
				mn = tmp;
				ind = u;
			}
			else if (tmp < mn1){
				mn1 = tmp;
				ind1 = u;
			}
			dp[v] += dp[u] + sum[u];
			sum[v] += sum[u];
			sz[v] += sz[u];
			tmp = sz[u];
			while (ost.size() && tmp > 0){
				if (ost.back().st > tmp){
					ost.back().st -= tmp;
					tmp = 0;
				}
				if (ost.back().st == tmp){
					ost.pop_back();
					tmp = 0;
					break;
				}
				if (ost.back().st < tmp){
					tmp -= ost.back().st;
					ost.pop_back();
				}
			}
//			cout << v << ' ' << u << ' ' << sz[u] << ' ' << dp[v] << '\n';
			if (!ost.size()){
				ost.pb({u, tmp});
				continue;
			}

		}
//		cout << v << ' ' << dp[v] << '\n';
		for (auto i : ost){
//			cout << "(" << i.ft << ", " << i.st << ")\n";
			if (i.ft == ind) dp[v] += mn1 * i.st;
			else dp[v] += mn * i.st;
		}
		return min(mn, c[v]);
	}
	Solver() {
		cin >> n;
		g.resize(n);
		sz.resize(n);
		sum.resize(n);
		c.resize(n);
		dp.resize(n);

		for (int i = 1;i < n;i++){
			int p;
			cin >> p;
			g[--p].pb(i);
			g[i].pb(p);
		}
		for (int i = 1;i < n;i++) cin >> c[i];
		dfs(0);
//		for (auto i : dp) cout << i << ' ';
//		cout << '\n';
//		for (auto i : sz) cout << i << ' ';
//		cout << '\n';
		cout << dp[0] << '\n';

	}
};

signed main(){
	int t = 1;
#ifdef LOCAL

	assert(freopen("input.txt", "r", stdin));
	cin >> t;
#else
	ios_base::sync_with_stdio(0);
	cout.tie(0);
#endif
	while(t--){
#ifdef LOCAL
		clock_t gg = clock();
#endif
		Solver a = Solver();
#ifdef LOCAL
		cout << setprecision(5) << fixed <<"Elapsed " << fabs(gg - clock()) / CLOCKS_PER_SEC << " sec.\n";
#endif
	}
}

