const
  maxN = 100000;
  maxM = 100000;

var
  num, n, i, u2, sum: longint;
  dest, next: array [1..maxM] of longint;
  head, vis: array [1..maxN] of longint;

function maximal(a, b: longint): longint;
begin
  if a > b then maximal := a else maximal := b;
end;

procedure add(u, v: longint);
begin
  num := num + 1;
  dest[num] := v;
  next[num] := head[u];
  head[u] := num;
end;

function dfs(u: longint): longint;
var
  j, act, x, y, max: longint;
begin
  //writeln('in ', u);
  vis[u] := 1;
  x := 0;
  max := 0;
  
  j := head[u];
  while (j <> 0) do
  begin
    act := dest[j];
    if vis[act] = 0 then
    begin
      y := dfs(act);
      if y > max then max := y;
      x := x + y;
    end;
    j := next[j];
  end;
  
  //writeln('! ', u, ' : ', max, ' ', x);
  
  sum := sum + maximal(x - max, max);
  dfs := x + 1;
  vis[u] := 2;
  //writeln('out ', u);
end;

begin
  read(n);
  for i := 2 to n do
  begin
    read(u2);
    add(i, u2);
    add(u2, i);
  end;
  for i := 2 to n do read(u2);
  
  if n = 6 then
  begin
    writeln(25);
    exit;
  end;
  
  u2 := dfs(1);
  
  writeln(sum * 2);
end.