#include <iostream>

using namespace std;

struct line
{
    long double a, b, c; //b = 1
};

int main()
{
    const int SIZE = 1000;
    static int points[SIZE][2], n;
    static line lines[SIZE][SIZE];
    static bool check;
    long double p[2], cross_p;

    cin >> n;
    for (int i = 0; i < 2 * n; i++)
        cin >> points[i][0] >> points[i][1];
    for (int i = 0; i < 2 * n; i++)
        for (int j = 0; j < 2 * n; j++)
        {
            if (i == j)
                continue;
            if (points[i][0] == points[j][0])
            {
                lines[i][j].b = 0;
                lines[i][j].a = 1;
                lines[i][j].c = -points[i][0];
                continue;
            }
            lines[i][j].a = (points[j][1] - points[i][1]) / (points[i][0] - points[j][0]);
            lines[i][j].c = -(points[i][0] * lines[i][j].a + points[i][1]);
        }
    
    for (int i = 0; i < 2 * n; i++)
        for (int j = 0; j < 2 * n; j++)
            for (int i2 = 0; i2 < 2 * n; i2++)
                for (int j2 = 0; j2 < 2 * n; j2++)
                {
                    if (i == j || j == i2 || i2 == j2 || i == i2 || i == j2 || j == j2)
                        continue;
                    p[0] = (lines[i2][j2].c - lines[i][j].c) / (lines[i][j].a - lines[i2][j2].a);
                    p[1] = -lines[i][j].c - lines[i][j].a * p[0];
                    if (p[0] != int(p[0]) || p[1] != int(p[1]))
                        continue;
                    check = 0;
                    for (int k = 0; k < 2 * n; k++)
                        if (int(p[0]) == points[k][0] && int(p[1]) == points[k][1])
                        {
                            check = 0;
                            break;
                        }
                    if (!check)
                        continue;
                    cout << "Yes" << endl;
                    cout << p[0] << ' ' << p[1];
                    cin >> n;
                    return 0;
                }
    cout << "No";
}