#undef __STRICT_ANSI__
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,popcnt,tune=native")
#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())
#define fst first
#define snd second
#define pb push_back
#define eb emplace_back

using namespace std;
using ll = long long; using ld = long double; using ull = unsigned ll; using pii = pair<int, int>;
const int infi = 1e9+100, mod = 1e9+7; const ll infl = 1e18L+1000; const ld infd = INFINITY;
template <typename T> bool mind(T &x, const T &y) {if (y < x) return x = y, true; else return false;}
template <typename T> bool maxd(T &x, const T &y) {if (x < y) return x = y, true; else return false;}
int log2f(int x) {return 32 - __builtin_clz(x) - 1;}
int log2c(int x) {return 32 - __builtin_clz(x) - !!(x&(x-1));}

const ll LIM = 1e6;
using G = int;

struct point {
    G x, y;
    point operator+(const point &z) {return {x+z.x, y+z.y};}
    point operator-(const point &z) {return {x-z.x, y-z.y};}
    G operator*(const point &z) {return x*z.x + y*z.y;}
    G operator^(const point &z) {return x*z.y - y*z.x;}
    bool operator==(const point &z) const {return x==z.x && y==z.y;}
};

istream& operator>>(istream &is, point &p) {return is >> p.x >> p.y;}
ostream& operator<<(ostream &os, const point &p) {return os << p.x << ' ' << p.y;}

inline int gcd(int a, int b) {
    while(b) a %= b, swap(a, b);
    return a;
}

void toabc(point p1, point p2, ll &a, ll &b, ll &c) {
    a = p1.y-p2.y, b = p2.x-p1.x, c = (ll)-p2.x*p1.y+(ll)p2.y*p1.x;
}

bool isctabc(ll a1, ll b1, ll c1, ll a2, ll b2, ll c2, point &res) {
    ll d = a1*b2 - a2*b1, dx = b1*c2 - b2*c1, dy = a2*c1 - a1*c2;
    if (!d || (dx%d) || (dy%d)) return false;
    ll x = dx/d, y = dy/d;
    if (abs(x) > LIM || abs(y) > LIM) return false;
    res = {x, y};
    return true;
}

bool isct(point p1, point p2, point f1, point f2, point &res) {
    ll a1, b1, c1, a2, b2, c2;
    toabc(p1, p2, a1, b1, c1);
    toabc(f1, f2, a2, b2, c2);
    //cout << "toabctest: " << p1 << ' ' << p2 << ": " << a1 << ' ' << b1 << ' ' << c1 << endl;
    return isctabc(a1, b1, c1, a2, b2, c2, res);
}

pii normalize(point piv, point a) {
    point d = a-piv;
    if (d.x < 0 || (d.x == 0 && d.y < 0)) d = {-d.x, -d.y};
    int g = gcd(abs(d.x), abs(d.y));
    d.x /= g, d.y /= g;
    return {d.x, d.y};
}

const int SH = 1e6;
inline ull convert(int a, int b) {
    return ((a+SH)<<20) + (b+SH);
}

struct hashmap {
    int z = 4;
    static const int LEN = 20011;
    ull h[LEN];
    int val[LEN];
    int pos(ull x) {
        int p = x%LEN;
        while(val[p] >= z && h[p] != x) if (++p == LEN) p = 0;
        if (val[p] < z) val[p] = z, h[p] = x;
        return p;
    }
    void clear() {z += 4;}
};

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout << fixed << setprecision(10);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int n; cin >> n;
    srand(2283221337);
    vector<point> a(2*n); for(auto &p : a) cin >> p;
    random_shuffle(all(a));
    hashmap mp;
    for(int p0 = 1; p0 < 2*n; ++p0) {
        int f; do f = rand()%(2*n); while(f == 0 || f == p0);
        for(int pf = 1; pf < 2*n; ++pf) {
            if (pf == p0 || pf == f) continue;
            point piv;
            if (!isct(a[0], a[p0], a[f], a[pf], piv)) continue;
            //cout << "0 " << p0 << ' ' << f << ' ' << pf << ": " << piv << endl;
            mp.clear();
            int cnt = 0;
            for(int i = 0; i < 2*n; ++i) {
                point &p = a[i];
                if (piv == p) goto bad;
                pii key = normalize(piv, p);
                ull lkey = convert(key.fst, key.snd);
                int pos = mp.pos(lkey);
                int cur = (++mp.val[pos]) - mp.z;
                if (cur == 3) goto bad;
                cnt += (cur == 2);
                if (n+cnt-i-1 < 0) goto bad;
            }
            if (cnt == n) return cout << "Yes\n" << piv, 0;
            bad:;
        }
    }
    cout << "No";
}
