// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define len(v) ((int)v.size())
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return false;
	}
	return true;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return false;
	}
	return true;
}

void run();

int main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

set<int> solve_for_letter(const string &s, int l)
{
	int n = len(s);
	vector<int> pref(n + 1, 0);
	set<int> res;
	for (int i = 0; i < n; ++i)
		pref[i + 1] = pref[i] + (s[i] - 'a' == l);
	int cnt = pref.back();
	for (int i = 1; i <= n; ++i)
	{
		if (n % i)
			continue;
		int k = n / i;
		if (cnt % k)
			continue;
		cnt /= k;
		bool good = true;
		for (int j = 0; j < n; j += i)
			if (pref[j + i] - pref[j] != cnt)
			{
				good = false;
				break;
			}
		if (good)
			res.insert(i);
		cnt *= k;
	}
	return res;
}

set<int> intersect(const set<int> &s1, const set<int> &s2)
{
	set<int> s;
	if (len(s1) > len(s2))
	{
		for (auto &x : s2)
			if (s1.count(x))
				s.insert(x);
	}
	else
		for (auto &x : s1)
			if (s2.count(x))
				s.insert(x);
	return s;
}

void run()
{
	string s;
	cin >> s;
	set<int> asdf;
	for (int i = 0; i < len(s); ++i)
		asdf.insert(i + 1);
	for (int i = 0; i < 26; ++i)
		asdf = intersect(asdf, solve_for_letter(s, i));
	cout << len(s) / *asdf.begin() << endl;
}