// d2t42.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <string>

using namespace std;

string s;

bool can(long long i)
{
	vector<long long> bal(26), need(26);
	for (long long j = 0; j < i; j++)
	{
		need[s[j] - 'a']++;
	}
	long long cur = 0;
	bool flag = 0;
	for (long long j = 0; j < s.size(); j++)
	{
		bal[s[j] - 'a']++;
		cur++;
		if (cur == i)
		{
			cur = 0;
			for (long long k = 0; k < 26; k++)
			{
				if (bal[k] != need[k])
				{
					flag = 1;
					break;
				}
				bal[k] = 0;
			}
		}
		if (flag)
		{
			break;
		}
	}
	return flag;
}


int main()
{
	cin >> s;
	long long n = s.size();
	vector<long long> nums;
	for (long long i = 2; i <= n; i++)
	{
		while (!(n % i))
		{
			n /= i;
			nums.push_back(i);
		}
	}
	long long cnt = 0;
	if (!can(1))
	{
		cout << s.size();
	}
	else
	{
		n = s.size();
		vector<long long> have;
		long long maxel = 1;
		for (long long i = 0; i < nums.size(); i++)
		{
			for (auto &x : have)
			{
				x *= nums[i];
				if (can(n / x))
				{
					x /= nums[i];
				}
				maxel = max(maxel, x);
			}
			if (!can(n / nums[i]))
			{
				have.push_back(nums[i]);
				maxel = max(maxel, nums[i]);
			}
		}
		cout << maxel;
	}
	cin >> n;
    return 0;
}

