// d2t2.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

struct minel
{
	long long m1 = 1e6 + 7, m2 = 1e6 + 7, i1 = -1, i2 = -1;
	void insert(long long num, long long tind)
	{
		if (i1 == -1 || m1 > num)
		{
			if (tind != i1)
			{
				i2 = i1;
				m2 = m1;
			}
			m1 = num;
			i1 = tind;
		}
		else if (tind != i1 && (i2 == -1 || m2 > num))
		{
			m2 = num;
			i2 = tind;
		}
	}
	long long get(long long ind)
	{
		if (i1 == ind)
			return m2;
		return m1;
	}
	long long geti(long long ind)
	{
		if (i1 == ind)
			return i2;
		return i1;
	}
};


/*long long dfs(long long v, vector<vector<long long> > &g, vector<minel> &mnum, vector<long long> &sum, vector<long long> &c, vector<long long> &cnt)
{
	long long answ = 0;
	for (long long i = 0; i < g[v].size(); i++)
	{
		answ += dfs(g[v][i], g, mnum, sum, c, cnt);
		sum[v] += sum[g[v][i]];
		mnum[v].insert(mnum[g[v][i]].m1, i);
		cnt[v]+= cnt[g[v][i]];
	}
	for (long long i = 0; i < g[v].size(); i++)
	{
		if (!g[g[v][i]].empty())
		{
			long long res1 = sum[g[v][i]] + c[g[v][i]] * cnt[g[v][i]], res2 = sum[g[v][i]] + c[g[v][i]] + mnum[v].get(i) * (cnt[g[v][i]] + 1);
			if (res1 < res2)
			{
				answ = res1;
			}
			else
			{
				res2 = 
			}
		}
		else
			answ += c[g[v][i]] + mnum[v].get(i);
		sum[v] += c[g[v][i]];
		cnt[v]++;
	}
	mnum[v].insert(c[v], 0);
	return answ;
}
*/

long long dfs(long long v, vector<vector<long long> > &g, vector<long long> &cnt)
{
	long long answ = 0;
	for (long long i = 0; i < g[v].size(); i++)
	{
		answ += dfs(g[v][i], g, cnt);
		cnt[v] += cnt[g[v][i]];
	}
	long long to_base = 0;
	bool m_two = 0;
	for (long long i = 0; i < g[v].size(); i++)
	{
		if (cnt[g[v][i]] > 2)
		{
			m_two = 1;
			answ += cnt[g[v][i]] * 2 - 2;
		}
		if (cnt[g[v][i]] == 1)
		{
			to_base++;
		}
	}
	answ += to_base - to_base % 2;
	if ((to_base % 2) && !m_two)
	{
		answ += 2;
	}
	cnt[v]++;
	return answ;
}

int main()
{
	long long n;
	cin >> n;
	vector<vector<long long> > g(n);
	for (long long i = 1; i < n; i++)
	{
		long long p;
		cin >> p;
		g[p - 1].push_back(i);
	}
	vector<long long> c(n);
	for (long long i = 1; i < n; i++)
	{
		cin >> c[i];
	}
	vector<minel> mnum(n);
	vector<long long> sum(n), cnt(n);
	cout << dfs(0, g, cnt);
	cin >> n;
    return 0;
}

