#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("a.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

void $main(ll testId) {
    int n, q;
    cin >> n >> q;
    vector<int> a(2*n - 1, -1);
    for (int i = 0; i < n; ++i) {
        a[2*i] = i;
    }
    while (true) {
        int nextToMove = -1;
        for (int i = 0; i < 2*n -1 ; ++i) {
            if (a[i] != -1) nextToMove = i;
        }
        if (nextToMove == n-1) break;
        int moveTo = -1;
        for (int i = 0; i < nextToMove; ++i) {
            if (a[i] == -1) moveTo = i;
        }
        swap(a[nextToMove], a[moveTo]);
    }
    for (int i = 0; i < q; ++i) {
        int x;
         cin >> x;
         --x;
         cout << a[x] + 1 << "\n";
    }
}
