#include <bits/stdc++.h>

#define pii pair<int, int>
#define f first
#define s second
#define ll long long
#define pll pair<ll, ll>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define sz(a) int(a.size())
#define output(a) for (auto el : a) cout << el << ' '; cout << '\n';

using namespace std;

const int MAXN = 1000;

int gcd(int a, int b) {
    while (b != 0) {
        int t = a % b;
        a = b;
        b = t;
    }
    return a;
}

vector<int> divs(int n) {
    vector<int> ans;
    int i = 1;
    while (i * i <= n) {
        if (n % i == 0) {
            ans.emplace_back(i);
            if (i != n / i) {
                ans.emplace_back(n / i);
            }
        }
        ++i;
    }
    sort(rall(ans));
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    string s;
    cin >> s;
    int n = sz(s);
    int cnt[26] = {};
    for (auto el : s) {
        ++cnt[int(el - 'a')];
    }
    int blank = 0;
    for (auto el : cnt) {
        if (!el) {
            ++blank;
        }
    }
    int g = 0;
    for (auto el : cnt) {
        g = gcd(g, el);
    }
    vector<int> d = divs(g);
    for (int i = 0; i < sz(d); ++i) {
        bool ok = 1;
        const int psz = n / d[i];
        int cur[26] = {};
        //cout << i << ' ' << d[i] << ' ' << c << '\n';
        int block = 1;
        int c = blank;
        bool check[26] = {};
        for (int j = 0; j < n; ++j) {
            char el = s[j];
            ++cur[int(el - 'a')];
            if (cur[int(el - 'a')] == cnt[int(el - 'a')] / d[i] * block) {
                ++c;
            }
            else if (cur[int(el - 'a')] > cnt[int(el - 'a')] / d[i] * block) {
                ok = 0;
                break;
            }
            //cout << j << ' ' << c << '\n';
            if ((j + 1) % psz == 0) {
                ++block;
                if (c != 26) {
                    ok = 0;
                    break;
                }
                c = blank;
            }
        }
        if (ok) {
            cout << d[i];
            return 0;
        }
    }
    return 0;
}
