#include <bits/stdc++.h>

using namespace std;

#define size(s) (int)(s).size()

typedef long long ll;

const int INF = 1e9;

void bye() {
    cout << "\n";
    exit(0);
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n, q;
    cin >> n >> q;
    vector<ll> num(2 * n + 1);
    for (int i = 1; i <= n; i++) {
        num[2 * i - 1] = i;
    }
    ll rmost = 2 * n - 1;
    vector<bool> used(2 * n + 1);
    while (rmost > n) {
        ll now = num[rmost];
        ll to = 0;
        for (ll i = 1; i <= 2 * n - 1; i++) {
            if (!num[i] && !used[i]) {
                to = i;
            }
        }
        used[rmost] = 1;
        num[to] = now;
        rmost--;
    }
    while (q--) {
        ll pos;
        cin >> pos;
        if (n % 2 == 0) {
            ll pw = 0;
            ll done = 0;
            while (pos / (1LL << pw) % 2 == 0) {
                pw++;
                done += n / (1LL << pw);
            }
            cout << done + (pos / (1LL << pw) + 1) / 2 << "\n";
        } else {
            ll pw = 0;
            ll done = 0;
            int f = 0;
            while (pos / (1LL << pw) % 2 == f) {
                // cout << f << " ";
                pw++;
                f ^= 1;
                done += (n) / (1LL << (pw)) + f;
                // cout << done << "\n";
            }
            cout << done + (pos / (1LL << pw) + !f) / 2 << "\n";
        }
    }
    bye();
}
