#include <iostream>
#include <vector>

using namespace std;

void dfs1(vector<vector<int> >& g, int v, vector<int>& c, vector<long long>& num, vector<long long>& q, vector<int>& mi)
{
    num[v] = 1;
    q[v] = c[v];
    mi[v] = c[v];
    for (int i = 0; i < g[v].size(); i++)
    {
        dfs1(g, g[v][i], c, num, q, mi);
        num[v] += num[g[v][i]];
        q[v] += q[g[v][i]];
        mi[v] = min(mi[v], mi[g[v][i]]);
    }
}

long long dfs(vector<vector<int> >& g, int v, vector<int>& c, vector<long long>& num, vector<long long>& q, vector<int>& mi)
{
    if (g[v].size() == 0)
        return 0;
    long long ma = -1;
    int ma_id;
    long long sum = 0;
    long long sum1 = 0;
    long long ans = 0;
    for (int i = 0; i < (int) g[v].size(); i++)
    {
        ans += dfs(g, g[v][i], c, num, q, mi);
        if (num[g[v][i]] > ma)
        {
            ma = num[g[v][i]];
            ma_id = g[v][i];
        }
        sum += q[g[v][i]];
        sum1 += num[g[v][i]];
    }
    if (ma * 2 > sum1)
    {
        int mi1 = 1000000000;
        for (int i = 0; i < (int) g[v].size(); i++)
        {
            if (g[v][i] == ma_id)
                continue;
            mi1 = min(mi1, mi[g[v][i]]);
        }
        return ans + sum + (ma - (sum1 - ma)) * mi1;
    }
    if (sum1 % 2 == 0)
        return ans + sum;
    int mi1 = 1000000000;
    int mi2 = 1000000000;
    for (int i = 0; i < (int) g[v].size(); i++)
    {
        if (mi[g[v][i]] < mi1)
        {
            mi2 = mi1;
            mi1 = mi[g[v][i]];
        }
        else if (mi[g[v][i]] < mi2)
        {
            mi2 = mi[g[v][i]];
        }
    }
    return ans + sum + mi1;
}

int main()
{
    int n;
    cin >> n;
    vector<vector<int> > g(n);
    vector<long long> num(n);
    vector<long long> q(n);
    vector<int> mi(n);
    for (int i = 1; i < n; i++)
    {
        int a;
        cin >> a;
        a--;
        g[a].push_back(i);
    }
    vector<int> c(n);
    for (int i = 1; i < n; i++)
        cin >> c[i];
    dfs1(g, 0, c, num, q, mi);
    cout << dfs(g, 0, c, num, q, mi);
}
