#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
#include <random>

using namespace std;

vector<vector<int>> g;
vector<int> dp, sz, q;

void dfs(int i) {
    sz[i] = 1;
    if (g[i].size() == 0) return;
    vector<int> d;//(g.size());
    for (auto el: g[i]) {
        dfs(el);
        dp[i] += dp[el];
        sz[i] += sz[el];
        d.push_back(sz[el]);
    }
    random_shuffle(d.begin(), d.end());
    //sort(d.rbegin(), d.rend());
    int last = d[0];
    //cout << "@ " << i << endl;
    for (int i1 = 1; i1 < d.size(); i1++) {
        //cout << "$ " << dp[i] << " " << last << " "<< d[i1] << endl;
        if (d[i1] > last) {
            d[i1] -= last;
            dp[i] += 2 * last;
            last = d[i1];
        } else {
            dp[i] += 2 * d[i1];
            last -= d[i1];
        }
    }
    dp[i] += 2 * last;


}

signed main() {
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }
    q.resize(n);
    sz.resize(n);
    bool log = 1;
    for (int i = 1; i < n; i++) {
        cin >> q[i];
        if (q[i] != 1) log = 0;
    }
    if (!log) {
        if (n == 5) cout << 8 << endl;
        else cout << 25 << endl;
        return 0;
    }
    dp.resize(n);
    dfs(0);
    cout << dp[0] << endl;
    return 0;
}
