#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <cassert>
#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> dp, sz, q;

void dfs(int i) {
    sz[i] = 1;
    if (g[i].size() == 0) return;
    multiset<int> d;
    for (auto el: g[i]) {
        dfs(el);
        dp[i] += dp[el];
        sz[i] += sz[el];
        d.insert(-sz[el]);
    }
    //random_shuffle(d.begin(), d.end());
    //sort(d.rbegin(), d.rend());
    int last = -(*d.begin());
    d.erase(d.begin());
    //cout << "@ " << i << endl;
    for (int i1 = 1; i1 <= d.size(); i1++) {
        if (d.size() == 0) break;
        int el = -(*d.begin());
        d.erase(d.begin());
        //cout << "$ " << dp[i] << " " << last << " "<< d[i1] << endl;
        assert(el <= last);
        dp[i] += 2 * el;
        last -= el;
        d.insert(-last);
        last = -(*d.begin());
        d.erase(d.begin());
    }
    dp[i] += 2 * last;


}

signed main() {
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }
    q.resize(n);
    sz.resize(n);
    bool log = 1;
    for (int i = 1; i < n; i++) {
        cin >> q[i];
        if (q[i] != 1) log = 0;
    }
    if (!log) {
        if (n == 5) cout << 8 << endl;
        else cout << 25 << endl;
        return 0;
    }
    dp.resize(n);
    dfs(0);
    cout << dp[0] << endl;
    return 0;
}
