#include <bits/stdc++.h>
using namespace std;

const int alp = 26;

string s;

vector<int> diviser(int x)
{
    if(x == 0)
        return {0};
    vector<int> ans;
    for(int i = 1; i <= sqrt(x); i++)
    {
        if(x % i == 0)
        {
            ans.push_back(i);
            if(x / i != i)
                ans.push_back(x / i);
        }
    }
    return ans;
}

vector<vector<int>> d(alp);

int check(vector<int> &used)
{
    vector<int> was(alp);
    int t = 0;
    for(int i = 0; i < alp; i++)
        t += used[i] == 0;
    int k = t, ans = 0;
    for(char c : s)
    {
        int i = c - 'a';
        was[i]++;
        if(was[i] == used[i])
            k++;
        if(was[i] > used[i])
            return 1;
        if(k == alp)
        {
            ans++;
            k = t;
            for(int i = 0; i < alp; i++)
                was[i] = 0;
        }
    }
    int mn = s.length();
    for(int i : was)
        mn = min(mn, i);
    if(mn == 0)
        return ans;
    return 1;
}

int start()
{
    int ind = 0;
    while(ind + 1 < s.length() && s[ind + 1] == s[ind])
        ind++;
    return ind + 1;
}

int finish()
{
    int ind = s.length() - 1;
    while(ind > 0 && s[ind - 1] == s[ind])
        ind++;
    return s.length() - ind;
}

int main()
{
    cin >> s;
    vector<int> a(alp);
    for(char c : s)
        a[c - 'a']++;
    int all = 0;
    for(int i = 0; i < alp; i++)
        all += a[i] > 0;
    if(all == 1)
    {
        cout << s.length();
        exit(0);
    }
    int st = s.length() / max(start(), finish());
    for(int i = 0; i < alp; i++)
        d[i] = diviser(a[i]);
    int ind = -1, answer = 1;
    for(int i = 0; i < alp; i++)
    {
        if(d[i].size() == 1 && d[i][0] == 0)
            continue;
        if(ind == -1 || d[i].size() < d[ind].size())
            ind = i;
    }
    sort(d[ind].begin(), d[ind].end());
    for(int i = 0; i < d[ind].size(); i++)
    {
        int y = a[ind] / d[ind][i];
        if(y > st)
            continue;
        vector<int> used(alp);
        bool fit = true;
        for(int i = 0; i < alp; i++)
        {
            if(a[i] % y)
            {
                fit = false;
                break;
            }
            used[i] = a[i] / y;
        }
        if(fit == false)
            continue;
        answer = max(answer, check(used));
        if(answer > 1)
            break;
    }
    cout << answer << endl;
}
