#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse2,ssse3,sse4,avx,abm,mmx,tune=native")


#include<bits/stdc++.h>
#define endl '\n'
#define mp make_pair

using namespace std;
void solve();
signed main(){

    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    solve();

    return 0;
}

struct point{
    int x, y;
    point (int xx = 0, int yy = 0) {x = xx, y = yy;}
};
ostream& operator <<(ostream& out, const point& a){
    out << a.x << ' ' << a.y;
    return out;
}
istream & operator >>(istream& in, point& a){
    in >> a.x >> a.y;
    return in;
}



struct line{
    int a, b, c;
    line(const point& p, const point& q){
        a = p.y - q.y;
        b = q.x - p.x;
        c = -a * p.x - b * p.y;
        int g = __gcd(a, __gcd(b, c));
        a /= g, b /= g, c /= g;
        if (a < 0 || (a == 0 && b < 0))
            a *= -1, b *= -1, c *= -1;
    }
};
int det (int a, int b, int c, int d) {
    return a * d - b * c;
}
bool intersect (line m, line n, point & res) {
    int  zn = det (m.a, m.b, n.a, n.b);
    if (zn == 0 ||  det (m.c, m.b, n.c, n.b) % zn != 0 || det (m.a, m.c, n.a, n.c) % zn != 0)
        return false;
    res.x = - det (m.c, m.b, n.c, n.b) / zn; res.y = - det (m.a, m.c, n.a, n.c) / zn;
    return true;
}
bool operator == (const line &a, const line &b){
    return a.a == b.a && a.b == b.b && a.c == b.c;
}
bool operator <(const line &a, const line &b){
    return mp(mp(a.a, a.b), a.c) < mp(mp(b.a, b.b), b.c);
}

vector<point> points;
int n;
const int MAXN = 1000 * 1000;
bool check(point moon){
    for (auto i : points)
        if (i.x == moon.x && i.y == moon.y)
            return false;
    if (abs(moon.x) > MAXN || abs(moon.y) > MAXN)
        return false;
    vector<line> chr;
    for (auto i : points)
        chr.push_back(line(i, moon));
    sort(chr.begin(), chr.end());
    for (int i = 0; i < n; ++++i){
        if (!(chr[i] == chr[i + 1]))
            return false;
        if (i + 2 != n && (chr[i] == chr[i + 2]))
            return false;
    }
    return true;
}

void solve(){
    cin >> n; n *= 2; points.resize(n);
    for (int i = 0; i < n; ++i) cin >> points[i]; random_shuffle(points.begin(), points.end());
    point moon;
    for (int i = 2; i < min(500, n); ++i)
        for (int j = i + 1; j < min(500, n); ++j){
            if (intersect(line(points[i], points[j]), line(points[0], points[1]), moon) && check(moon)){
                cout << "Yes" << endl;
                cout << moon << endl;
                exit(0);
            }
        }
    random_shuffle(points.begin(), points.end());
    for (int i = 2; i < min(n, 500); ++i) {
        for (int j = 2; j < min(n, 500); ++j) {
            if (i != j && intersect(line(points[i], points[0]), line(points[j], points[1]), moon) && check(moon)) {
                cout << "Yes" << endl;
                cout << moon;
                exit(0);
            }
        }
    }
    cout << "No";
}











































