#include <bits/stdc++.h>

using namespace std;

struct Point
{
    int x, y;

    Point(){}
    Point(int _x, int _y) : x(_x), y(_y){}
};

struct Vect
{
    int x, y;

    Vect(){}
    Vect(int _x, int _y) : x(_x), y(_y){}
    Vect(Point a, Point b) : x(b.x - a.x), y(b.y - a.y){}

    int operator %(Vect v)
    {
        return x * v.y - y * v.x;
    }

    Vect operator -(Vect v)
    {
        return {x - v.x, y - v.y};
    }

    Vect operator +(Vect v)
    {
        return {x + v.x, y + v.y};
    }

    Vect operator *(int k)
    {
        return {x * k, y * k};
    }
};

struct line
{
    Vect p, d;
    ///int k;

    line(){}
    line(Point a, Point b)
    {
        p.x = a.x;
        p.y = a.y;
        d.x = b.x - a.x;
        d.y = b.y - a.y;
    }
};

int main()
{
    int n;
    cin >> n;
    n *= 2;
    vector <Point> pts(n, {0, 0});
    for (int i = 0; i < n; i++)
    {
        cin >> pts[i].x >> pts[i].y;
    }

    Point a = pts[0], b, c, d;

    for (int bi = 1; bi < n; bi++) /// pair for first_point - ind = 0
    {
        int ci = 1;
        b = pts[bi];
        for (; ci < n; ci++)
        {
            if (ci != bi)
            {
                c = pts[ci];
                break;
            }
        }

        for (int di = 1; di < n; di++)
        {
            if (di != bi && di != ci)
            {
                d = pts[di];
                line m(a, b);
                line N(c, d);
                if (m.d % N.d != 0)
                {
                    int f_part = ((m.p - N.p) % m.d), s_part = (N.d % m.d);
                    if ((((m.p - N.p) % m.d) * N.d.x) % (N.d % m.d) == 0 && (((m.p - N.p) % m.d) * N.d.y) % (N.d % m.d) == 0){
                        int kx = (N.d.x * ((m.p - N.p) % m.d)) / (N.d % m.d);
                        int ky = (N.d.y * ((m.p - N.p) % m.d)) / (N.d % m.d);
                        Point K({N.p.x + kx, N.p.y + ky});
                        bool good_ans = true;
                        for (int i = 0; i < n; i++)
                        {
                            if (pts[i].x == K.x && pts[i].y == K.y)
                            {
                                good_ans = false;
                            }
                        }

                        if (good_ans && abs(K.x) <= 1e6 && abs(K.y) <= 1e6){
                            vector <int> partner(n, -1);
                            int nb = n;
                            for (int i = 0; i < n && good_ans; i++)
                            {
                                line check(pts[i], K);
                                for (int j = i + 1; j < n && good_ans; j++)
                                {
                                    if (Vect(pts[i], pts[j]) % check.d == 0)
                                    {
                                        if (partner[i] != -1 || partner[j] != -1){
                                            good_ans = false;
                                        }
                                        partner[i] = j;
                                        partner[j] = i;
                                        nb-= 2;
                                    }
                                }
                            }

                            if (nb == 0 && good_ans)
                            {
                                cout << "Yes\n";
                                cout << K.x << " " << K.y;
                                return 0;
                            }
                            //return 0;
                        }
                    }
                }
            }
        }
    }

    cout << "No";
}
