#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define F first
#define S second


typedef long long ll;
typedef pair < ll, ll > pii;

const ll N = 2e3 + 5, inf = 1e9;
vector < ll > lst[N];
ll ans = 0;
bool dp[N][N];

ll dfs (ll v) {
    ll res = 0;
    vector < ll > heh;
    for (ll i = 0; i < lst[v].size(); ++i) {
        ll u = lst[v][i];
        ll m = dfs(u);
        res += m;
        heh.pb(m);
    }
    ll m = heh.size();
    for (ll i = 1; i <= m; ++i) {
        dp[i][heh[i - 1]] = 1;
        for (ll j = 0; j <= res; j++) {
            dp[i][j] = max(dp[i][j], dp[i - 1][j]);
            if (j >= heh[i - 1])
                dp[i][j] = max(dp[i][j], dp[i - 1][j - heh[i - 1]]);
        }
    }
    ll p = inf;
    for (ll i = 0; i <= res / 2; ++i) {
        if (dp[m][i]) {
            if (i + abs(res - 2 * i) < p) {
                p = i + abs(res - 2 * i);
            }
        }
    }
    if (p == inf) p = 0;
    ans += p;
    for (ll i = 1; i <= m; ++i) {
        for (ll j = 0; j <= res; j++)
            dp[i][j] = 0;
    }

    return res + 1;
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n;
    cin >> n;
    for (ll i = 1; i < n; ++i) {
            ll x;
        cin >> x;
        lst[x - 1].pb(i);
    }
    dfs(0);
    cout << ans * 2;
    return 0;
}

