#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define mp make_pair
#define pb push_back
#define f first
#define s second
#define all(x) x.begin(), x.end()

const int MAXN = 2e5 + 5;
int n;
vector<int> g[MAXN];
int c[MAXN];
ll sum[MAXN];
ll mn[MAXN];
int sz[MAXN];
ll res[MAXN];

void dfs(int v) {
	sum[v] = c[v];
	mn[v] = c[v];
	sz[v] = 1;
	for (auto to : g[v]) {
		dfs(to);
		sz[v] += sz[to];
		sum[v] += sum[to];
		mn[v] += mn[to];
	}

	if (g[v].size() < 2) {
		return;
	}

	int mxsz = 0, smsz = 0;
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (sz[g[v][i]] > sz[g[v][mxsz]]) {
			mxsz = i;
		}
		smsz += sz[to];
	}
	smsz -= sz[g[v][mxsz]];
	swap(g[v][0], g[v][mxsz]);

	if (sz[g[v][0]] > smsz) {
		ll mnval = INT_MAX;
		for (int i = 1; i < g[v].size(); ++i) {
			mnval = min(mnval, mn[g[v][i]]);
		}
		res[v] = sum[v] - c[v] + (sz[g[v][0]] - smsz) * mnval;
	} else {
		smsz += sz[g[v][0]];
		if (smsz & 1) {
			ll mnval = INT_MAX;
			for (int i = 0; i < g[v].size(); ++i) {
				mnval = min(mnval, mn[g[v][i]]);
			}
			res[v] = sum[v] - c[v] + mnval;
		} else {
			res[v] = sum[v] - c[v];
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	cin >> n;
	rep(i, n - 1) {
		int p;
		cin >> p;
		g[p - 1].push_back(i + 1);
	}
	rep(i, n - 1) {
		cin >> c[i + 1];
	}

	dfs(0);

	ll ans = 0;
	rep(i, n) {
		ans += res[i];
	}
	cout << ans << endl;
}