#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define all(x) x.begin(), x.end()

int cnt[2][26];

bool check(string &s, int a)
{
	for (int i = 0; i < 26; i++)
	{
		cnt[0][i] = cnt[1][i] = 0;
	}
	for (int i = 0; i < s.size(); i+=a)
	{
		for (int j = 0; j < a; j++)
		{
			cnt[i % 2][s[j + i] - 'a']++;
		}
		if (i != 0)
		{
			for (int j = 0; j < 26;j++)
			{
				if (cnt[0][j] != cnt[1][j])
					return false;
				cnt[(i+1)%2][j] = 0;
			}
		}
	}
	return true;
}

signed main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	string s;
	cin >> s;
	int n = s.size();
	int ans = n;
	for (int i = 1; i * i <= n && i < ans; i++)
	{
		if (n % i == 0)
		{
			if (check (s, i))
			{
				ans = min(i, ans);
			}
			if(check (s, n / i))
			{
				ans = min(n / i, ans);
			}
		}
	}
	cout << ans;
	return 0;
}