#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>


using namespace std;

#define int long long

int gcd(int a, int b) {
	while(b != 0) {
		a %= b;
		int tmp = a;
		a = b;
		b = tmp;
	}
	return a;
}

pair<int, int> co(int x1, int y1, int x2, int y2) {
	int x = x2 - x1, y = y2 - y1;
	int t = gcd(abs(x), abs(y));
	if (t == 0)
		return pair<int, int>(0, 0);
	x /= t;
	y /= t;
	if (x == 0)
		y = abs(y);
	else
		if (x < 0)
			x = 0 - x, y = 0 - y;
	return pair<int, int>(x, y);
}

signed main() {
	int n;
	cin >> n;
	n <<= 1;
	vector<int> x(n), y(n);
	vector<bool> used(n, false);
	for (int i = 0; i < n; ++i)
		cin >> x[i] >> y[i];
	used[0] = true;
	for (int i = 1; i < n; ++i) {
		used[i] = true;
		int j;
		if (i == 1)
			j = 2;
		else
			j = 1;
		used[j] = true;
		for (int k = 2; k < n; ++k) {
			if (used[k])
				continue;
			auto a1 = co(x[i], y[i], x[0], y[0]);
			auto a2 = co(x[k], y[k], x[j], y[j]);
			if (a1 == a2)
				continue;
			int a = ((x[j] - x[0]) * -1 * a2.second  + (y[j] - y[0]) * a2.first) / (a1.first * -1 * a2.second + a1.second * a2.first);
			int xa = x[0] + a1.first * a;
			int ya = y[0] + a1.second * a;
			auto a3 = co(x[k], y[k], xa, ya);
			if (a3 != a2)
				continue;
			vector<pair<int, int>> t(n);
			bool r = true;
			for (int i = 0; i < n; ++i) {
				if (xa == x[i] && ya == y[i]) {
					r = false;
					break;
				}
				t[i] = co(xa, ya, x[i], y[i]);
			}
			if (!r)
				continue;
			sort(t.begin(), t.end());
			for (int i = 1; i < n; i += 2)
				if (t[i] != t[i - 1] || (i > 1 && t[i - 1] == t[i - 2])) {
					r = false;
					break;
				}
			if (r) {
				cout << "Yes\n" << xa << ' ' << ya;
				return 0;
			}
		}
		used[i] = used[j] = false;
	}
	cout << "No\n";
	return 0;
}