#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#define DEBUG1

#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <numeric>
#include <stack>
#include <cstring>
#include <cstdlib>
#include <string>

using namespace std;

string s;

int pref1[(int)5e+5 + 100][26];
int pref2[(int)5e+6 + 100][2];
int n;

bool ab;

inline void init(const string &s)
{
	if (ab) {
		pref2[0][s[0] - 'a'] = 1;
		for (int i = 1; i < n; i++) {
			memcpy(pref2[i], pref2[i - 1], 2 * sizeof(int));
			pref2[i][s[i] - 'a']++;
		}
	}
	else {
		pref1[0][s[0] - 'a'] = 1;
		for (int i = 1; i < n; i++) {
			memcpy(pref1[i], pref1[i - 1], 26 * sizeof(int));
			pref1[i][s[i] - 'a']++;
		}
	}
}

inline bool check(const int &x)
{
	int cnt = s.size() / x;

	if (ab) {
		for (int i = 2; i <= x; i++)
			for (int j = 0; j < 2; j++)
				if (pref2[cnt - 1][j] != pref2[i * cnt - 1][j] - pref2[(i - 1) * cnt - 1][j])
					return false;

		return true;
	}
	else {
		for (int i = 2; i <= x; i++)
			for (int j = 0; j < 26; j++)
				if (pref1[cnt - 1][j] != pref1[i * cnt - 1][j] - pref1[(i - 1) * cnt - 1][j])
					return false;

		return true;
	}
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cin >> s;
	n = s.size();
	char maxal = 0;

	for (int i = 0; i < n; i++)
		maxal = max(maxal, s[i]);
	if (maxal == 'b')
		ab = true;
	else
		ab = false;

	init(s);

	vector<int> d;
	d.reserve(10000);
	for (int i = 1; i * i <= n; i++)
		if (n % i == 0) {
			
			d.push_back(i);
			if (i * i < n)
				d.push_back(n / i);
		}

	sort(d.begin(), d.end());

	for (int i = d.size() - 1; i >= 0; i--)
		if (check(d[i])) {
			cout << d[i];
			return 0;
		}
}
