#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <stack>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Inf = 1e9;
const double eps = 1e-9;
const ll Linf = 2e18;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    int n, q;
    cin >> n >> q;
    vector <int> a(2 * n - 1);
    int cnt = 0;
    for (int i = 0; i < 2 * n - 1; i += 2) {
        a[i] = ++cnt;
    }
    while (true) {
        for (int i = 2 * n - 2; i >= 0; --i) {
            if (a[i]) {
                bool flag = false;
                for (int j = i; j >= 0; --j) {
                    if (!a[j]) {
                        swap(a[i], a[j]);
                        flag = true;
                        break;
                    }
                }
                if (!flag) {
                    for (int k = 0; k < q; ++k) {
                        int x;
                        cin >> x;
                        --x;
                        cout << a[x] << endl;
                    }
                    return 0;
                }
                else {
                    break;
                }
            }
        }
    }
}
