#define _CRT_SECURE_NO_WARNINGS
#define REL

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>
#include <queue>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)1e6 + 7;
const int INF = (int)2e9;

typedef long long LL;

using namespace std;

int arr[N], cnt[N]; 
LL sum[N], ans = 0;
vector <int> gr[N];

void dfs(int v) {
	priority_queue <int> q;
	cnt[v] = 1;
	for (int i = 0; i < (int)gr[v].size(); i++) {
		int to = gr[v][i];
		dfs(to); cnt[v] += cnt[to];
		q.push(cnt[to]);
	}
	if (!q.empty()) {
		while (true) {
			int c1 = q.top(); q.pop();
			int c2 = q.top(); q.pop();
			if (c2 == 0) {
				q.push(c1);
				break;
			}
			ans += 2;
			c1--, c2--;
			q.push(c1); q.push(c2);
		}
		int rest = q.top();
		ans += 2 * rest;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	int n; cin >> n;
	for (int i = 1; i < n; i++) {
		int fr; cin >> fr; fr--;
		gr[fr].push_back(i);
	}
	for (int i = 1 ; i < n; i++)
		cin >> arr[i];
	dfs(0);
	cout << ans;
}