#include <bits/stdc++.h>

using namespace std;

const int maxn = 5e5;
const int maxs = 5e6;

char s[maxs + 5];
int n, fr[maxn + 5][26], d[maxs + 5][ 2 ];

int gcd(int a, int b) {
    int r;
    while (b) {
        r = a % b;
        a = b;
        b = r;
    }
    return a;
}

bool check(int bucket) {
    int length = n / bucket;
    for (int i = 1; i <= n; i += length) {
        for (int j = 0; j < 26; j++)
            if (fr[i + length - 1][ j ] - fr[i - 1][ j ] != fr[ n ][ j ] / bucket)
                return false;
    }
    return true;
}

bool checkSpecial(int bucket) {
    int length = n / bucket;
    for (int i = 1; i <= n; i += length) {
        if (d[i + length - 1][ 0 ] - d[i - 1][ 0 ] != d[ n ][ 0 ] / bucket)
            return false;
        if (d[i + length - 1][ 1 ] - d[i - 1][ 1 ] != d[ n ][ 1 ] / bucket)
            return false;
    }
    return true;
}

int main()
{
    ios::sync_with_stdio( false );
    //freopen( "leonardo.in", "r", stdin);
    //freopen( "leonardo.out","w",stdout);

    cin >> (s + 1);
    n = strlen(s + 1);

    if (n <= maxn) {
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j < 26; j++)
                fr[ i ][ j ] = fr[i - 1][ j ];
            fr[ i ][s[ i ] - 'a']++;
        }

        int div = n;
        for (int i = 0; i < 26; i++)
            if (fr[ n ][ i ])
                div = gcd(div, fr[ n ][ i ]);

        if (div == 1) {
            cout << 1;
            return 0;
        }

        if (check(div)) {
            cout << div;
            return 0;
        }

        for (int i = div/2; i > 1; i--)
            if (div % i == 0) {
                if (check( i )) {
                    cout << i;
                    return 0;
                }
            }

        cout << 1;
        return 0;
    }

    int nra, nrb, nrother;

    nra = nrb = nrother = 0;
    for (int i = 1; i <= n; i++) {
        if (s[ i ] == 'a')
            nra++;
        if (s[ i ] == 'b')
            nrb++;
        if (s[ i ] != 'a' && s[ i ] != 'b')
            nrother++;
    }

    if (nrother) {
        cout << 1;
        return 0;
    }

    for (int i = 1; i <= n; i++) {
        d[ i ][ 0 ] = d[i - 1][ 0 ];
        d[ i ][ 1 ] = d[i - 1][ 1 ];
        if (s[ i ] == 'a')
            d[ i ][ 0 ]++;
        else
            d[ i ][ 1 ]++;
    }

    int div = n;
    div = gcd( gcd(nra, nrb), n );

    if (div == 1) {
        cout << 1;
        return 0;
    }

    if (checkSpecial(div)) {
        cout << div;
        return 0;
    }

    for (int i = div/2; i > 1; i--)
        if (div % i == 0) {
            if (checkSpecial( i )) {
                cout << i;
                return 0;
            }
        }

    cout << 1;

    return 0;
}
