#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5 + 5;

vector <int> g[maxn], sons;

int h[maxn], n, t[maxn], cost[maxn], subtree[maxn];
long long answer;

void dfs(int node, int dad) {
    subtree[ node ] = 1;
    for (int son: g[ node ]) {
        if (son != dad) {
            dfs(son, node);
            subtree[ node ] += subtree[ son ];
        }
    }
}

void computeTree(int node, int dad) {
    if (g[ node ].empty())
        return;

    sons.clear();
    for (int son: g[ node ]) {
        if (son == dad)
            continue;
        sons.push_back(subtree[ son ]);
        answer += subtree[ son ];
    }

    sort(sons.begin(), sons.end());

    int crt = sons[ 0 ];
    for (int i = 1; i < sons.size(); i++) {
        if (sons[ i ] <= crt)
            crt -= sons[ i ];
        else
            crt = sons[ i ] - crt;
    }

    answer += crt;
    for (int son: g[ node ]) {
        if (son != dad)
            computeTree( son, node );
    }
}

int main()
{
    //freopen( "raphael.in", "r", stdin );
    //freopen( "raphael.out","w", stdout);

    cin >> n;

    for (int i = 2; i <= n; i++) {
        cin >> t[ i ];
        g[ t[ i ] ].push_back( i );
    }

    int ok = 1;
    for (int i = 2; i <= n; i++) {
        cin >> cost[ i ];
        if (cost[ i ] != 1)
            ok = 0;
    }

    if (ok == 0) {
        cout << "sorry";
        return 0;
    }

    dfs(1, 0);
    computeTree(1, 0);

    cout << answer;

    return 0;
}
