#include <bits/stdc++.h>
#define MAXN 200000

int c[1 + MAXN], min[1 + MAXN];
std::vector <int> G[1 + MAXN];
int fth[1 + MAXN];
int dim[1 + MAXN];
long long sum[1 + MAXN];
long long dfs(int node){
    dim[node] = 1;
    min[node] = sum[node] = c[node];
    int max = 0;
    long long acc = 0;
    if(G[node].size()){
        for(auto y: G[node]){
            acc += dfs(y);
            dim[node] += dim[y];
            sum[node] += sum[y];
            if(min[y] < min[node]) min[node] = min[y];
            if(dim[y] > dim[max]) max = y;
        }
        int sz = dim[node] - 1;
        acc += sum[node] - c[node];
        if(dim[max] > sz / 2){
            int rem = dim[max] - (sz - dim[max]);
            int mn = 1000000000;
            for(auto y: G[node]) if(y != max && min[y] < mn) mn = min[y];
            acc += 1LL * rem * mn;
        }
        else if(sz % 2 == 1){
            int mn = 1000000000;
            for(auto y: G[node]) if(min[y] < mn) mn = min[y];
            acc += 1LL * mn;
        }
    }
    return acc;
}
int main(){
    FILE*fi,*fo;
    //fi = fopen("a.in", "r");
    //fo = fopen("a.out", "w");
    fi = stdin;
    fo = stdout;

    int n;
    fscanf(fi,"%d", &n);
    for(int i = 2; i <= n; i++){
        fscanf(fi,"%d", &fth[i]);
        G[fth[i]].push_back(i);
    }
    for(int i = 2; i <= n; i++) fscanf(fi,"%d", &c[i]);
    fprintf(fo,"%lld", dfs(1));

    return 0;
}
