#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
const int MAXN = (1 << 20);

int n;
vector<int> adj[MAXN];
int64_t val[MAXN];

void read()
{
    cin >> n;
    for(int i = 2; i <= n; i++)
    {
        int p;
        cin >> p;
        adj[p].push_back(i);
    }

    for(int i = 2; i <= n; i++)
        cin >> val[i];
}

int tr_sz[MAXN];
int64_t answer, sum[MAXN];
int64_t mn[MAXN];

void dfs(int u)
{
    int64_t cnt_all = 0;
    vector<pair<int64_t, int64_t> > li;

    tr_sz[u] = 1;
    sum[u] = val[u];
    mn[u] = val[u];

    for(int v: adj[u])
    {
        dfs(v);

        tr_sz[u] += tr_sz[v];
        cnt_all += tr_sz[v];
        sum[u] += sum[v];
        answer += sum[v];
        chkmax(mn[u], mn[v]);

        li.push_back({tr_sz[v], v});
    }

    sort(li.begin(), li.end());
    if(li.empty()) return;

    int s1 = 0;
    for(int i = 0; i < (int)li.size() - 1; i++)
        s1 += li[i].first;

    if(s1 <= li.back().first)
    {
        int64_t nw_mn = (int64_t)1e17;
        for(int v: adj[u])
            if(v != li.back().second)
                chkmin(nw_mn, mn[v]);

        answer += (li.back().first - s1) * 1ll * nw_mn;
        return;
    }

    int64_t nw_mn = (int64_t)1e17;
    for(int v: adj[u])
        chkmin(nw_mn, mn[v]);

    if(cnt_all % 2 == 1)
        answer += nw_mn;
}

void solve()
{
    dfs(1);
    cout << answer << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
