#include <iostream>
#include <string>

using namespace std;

const int MAX_N = 5e6 + 1;
const int SGM = 26;
long long f[MAX_N];
long long p;

long long hsh( char c ) {
    return 1LL << ( c * 2 );
}

int main() {
    freopen( "input.txt", "r", stdin );
    string s;
    cin >> s;
    int i = 0, n = s.size();
    for ( int i = 0; i < n; i ++ ) {
        f[i + 1] = f[i] + hsh( s[i] );
    }

    int d;
    for ( d = 1; d < n; d ++ ) {
        if ( n % d != 0 )
            continue;

        int i = 0;

        p = f[d];

        i = d * 2;
        while ( i <= n && f[i] - f[i - d] == p ) {
            i += d;
        }

        if ( i > n )
            break;
    }
    cout << n / d;
    return 0;
}
