#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 2e5 + 1;
int fat[MAX_N];
int perf[MAX_N];
int sz[MAX_N];
int mn[MAX_N];
long long sm[MAX_N];
vector<int> fils[MAX_N];

long long ans;
void dfs( int n ) {
    sz[n] = 1;
    if ( fils[n].size() == 0 ) {
        sm[n] = perf[n];
        mn[n] = perf[n];
        return;
    }

    mn[n] = 1e9;

    int mx = 0;
    for ( int i : fils[n] ) {
        dfs( i );
        sz[n] += sz[i];
        sm[n] += sm[i];
        mn[n] = min( mn[n], mn[i] );
        mx = max( mx, sz[i] );
    }

    if ( mx * 2 <= sz[n] - 1 ) {
        ans += sm[n] + ( sz[n] - 1 ) % 2 * mn[n];
    } else {
        int mn2 = 1e9;
        for ( int i : fils[n] )
            if ( sz[i] != mx && mn[i] < mn2 )
                mn2 = mn[i];
        ans += sm[n] + 1LL * ( 2LL * mx - sz[n] + 1 ) * mn2;
    }
//    cout << n << ' ' << ans << endl;

    mn[n] = min( mn[n], perf[n] );
    sm[n] += perf[n];
}

int main() {
    freopen( "input.txt", "r", stdin );
    int n;
    cin >> n;
    for (int i = 2; i <= n; i ++ ) {
        cin >> fat[i];
        //fat[i] = i / 2;
        fils[fat[i]].push_back( i );
    }

    for ( int i = 2; i <= n; i ++ ) {
        cin >> perf[i];
        //perf[i] = 1e6;
    }

    dfs( 1 );
    cout << ans;

    return 0;
}
