#include <bits/stdc++.h>
#pragma optimize("O3")

using namespace std;

#define fi first
#define se second
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

typedef vector<int> vint;
typedef long double ld;
typedef unsigned long long ll;
typedef string str;

const int MX = 1e7;

int n;

map<int, map<char, int>> p;

bool check(int len) {
    map<char, int> b = p[len];
    for (int i = len + 1; i + len - 1 <= n; i += len) {
        for (auto x : b) {
            char c = x.fi;
            if (p[i + len - 1][c] - p[i - 1][c] != b[c]) {
                return 0;
            }
        }
    }
    return 1;
}

main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    str s;
    cin >> s;
    s = " " + s;
    n = sz(s) - 1;
    for (int i = 1; i <= n; ++i) {
        p[i] = p[i - 1];
        ++p[i][s[i]];
    }
    int ans = -1;
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            if (check(i))
                ans = max(ans, n / i);
            if (check(n / i))
                ans = max(ans, i);
        }
    }
    cout << ans;
}
