#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long MOD = 1000 * 1000 * 1000 + 7;
const int MAX_N = 5 * 1000 * 1000 + 5;
long long hsh[MAX_N], hsher[50];
int a[50];

int gcd(int a, int b){
    if(a == 0)
        return b;
    return gcd(b % a, a);
}

int main(){
    string s;
    cin >> s;
    fill(a, a + 50, 0);
    for(int i = 0; i < s.size(); i++)
        ++a[s[i] - 'a'];
    int now = s.size(), maxcnt = 0;
    for(int i = 0; i <= 'z' - 'a'; i++)
        if(a[i] > 0){
            now = gcd(now, a[i]);
            //cout << now << ' ';
            maxcnt = max(maxcnt, a[i]);
        }
    ++maxcnt;
    hsher[0] = 1;
    for(int i = 1; i <= 'z' - 'a'; i++)
        hsher[i] = (hsher[i - 1] * maxcnt) % MOD;
    hsh[0] = hsher[s[0] - 'a'];
    //cout << '\n' << hsh[0] << ' ';
    for(int i = 1; i < s.size(); i++){
        hsh[i] = (hsh[i - 1] + hsher[s[i] - 'a']) % MOD;
    //    cout << hsh[i] << ' ';
    }
    //    cout <<'\n';
    vector<int> check;
    for(int i = 1; i <= now; i++)
        if(now % i == 0)
            check.push_back(s.size() / i);
    //for(int i = 0; i < check.size(); i++)
    //    cout << check[i] << ' ';
    //cout << '\n';
    int l = 0, r = check.size();
    while(l != r - 1){
        int m = (l + r) / 2;
        bool good = true;
        for(int i = 2 * check[m] - 1; i < s.size(); i += check[m])
        if(((MOD + hsh[i] - hsh[i - check[m]]) % MOD) != hsh[check[m] - 1]){
            good = false;
            break;
        }
        if(good) l = m;
        else r = m;
    }
    cout << s.size() / check[l];
    return 0;
}
