#include <bits/stdc++.h>
using namespace std;

const int MAXN = 500005;
char s[MAXN];
int n;
int pref[26][MAXN];

bool check(int len) {
    for (int i = 0; i < n; i += len) {
        for (int j = 0; j < 26; j++) {
            if (pref[j][i + len] - pref[j][i] != pref[j][len]) {
                return false;
            }
        }
    }
    return true;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    fread(s, 1, MAXN - 4, stdin);
    n = 0;
    while ('a' <= s[n] && s[n] <= 'z') n++;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 26; j++) {
            pref[j][i + 1] = pref[j][i];
        }
        pref[s[i] - 'a'][i + 1]++;
    }

    int mx = 1;
    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            if (check(i)) {
                mx = max(mx, n / i);
            }

            if (i * i != n && check(n / i)) {
                mx = max(mx, i);
            }
        }
    }

    cout << mx << endl;

    return 0;
}
