#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

const int maxn = 2000;
vector<int> g[maxn];
int n, sz[maxn];

ll ans = 0;

void dfs(int v) {
    sz[v] = 1;

    for (auto u : g[v]) {
        dfs(u);
        sz[v] += sz[u];
    }
    while (!g[v].empty()) {
        g[v].erase(partition(all(g[v]), [](int a) { return sz[a] != 0; }), g[v].end());
        sort(all(g[v]), [](int a, int b) { return sz[a] > sz[b]; });
        for (int i = 0; i < size(g[v]) - 1; i += 2) {
            ans += sz[g[v][i + 1]] * 2;
            sz[g[v][i]] -= sz[g[v][i + 1]];
            sz[g[v][i + 1]] = 0;
        }
        if (size(g[v]) == 1) {
            ans += sz[g[v].front()] * 2;
            g[v].pop_back();
        }
    }
}

int main() {
    //freopen("inp2.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int x; cin >> x;
        g[x - 1].push_back(i + 1);
    }
    int c;
    for (int i = 0; i < n - 1; ++i) {
        cin >> c;
    }
    if (c != 1) {
        cout << "25";
        return 0;
    }
    dfs(0);
    cout << ans;
    return 0;
}