#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <iterator>
#include <functional>
#include <ctime>
#include <random>
#include <map>
#include <set>
#include <bitset>
#include <cinttypes>
#include <unordered_map>
#include <unordered_set>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <cmath>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define sqr(x) ((x)*(x))
#define cube(x) (sqr(x)*(x))
#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define vii vector<int>
#define vll vector<ll>
#define vpii vector<pii>
#define vpll vector<pll>
#define vvii vector<vii>
#define vvll vector<vll>
#define vvpii vector<vpii>
#define vvpll vector<vpll>
#define forn(i,n) for(int i=0;i<n;i++)
#define forab(i,a,b) for(int i=a;i<=b;i++)
#define fornout(i,n,c) for(int i=0;i<n;i++,cout<<c)

const ld PI = acos(-1);
const ll INF = 1e18;
const short int MOD1 = 101;
const short int MOD2 = 103;
const short int MOD3 = 107;
const short int MOD4 = 109;
const int MAXN = 1e5;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    string s;
    cin >> s;

    int n = s.length();
    vii deg1(26, 1), deg2(26, 1), deg3(26, 1), deg4(26, 1);
    for (int i = 1; i < 26; i++)
        deg1[i] = (deg1[i - 1] * 10) % MOD1,
        deg2[i] = (deg2[i - 1] * 10) % MOD2,
        deg3[i] = (deg3[i - 1] * 10) % MOD3,
        deg4[i] = (deg4[i - 1] * 10) % MOD4;

    vii nxt;
    vector <short int> pref1(n), pref2(n), pref3(n), pref4(n);
    forn(i, n) {
        if (i == 0)
            pref1[i] = deg1[s[i] - 'a'],
            pref2[i] = deg2[s[i] - 'a'],
            pref3[i] = deg3[s[i] - 'a'],
            pref4[i] = deg4[s[i] - 'a'];
        else
            pref1[i] = (pref1[i - 1] + deg1[s[i] - 'a']) % MOD1,
            pref2[i] = (pref2[i - 1] + deg2[s[i] - 'a']) % MOD2,
            pref3[i] = (pref3[i - 1] + deg3[s[i] - 'a']) % MOD3,
            pref4[i] = (pref4[i - 1] + deg4[s[i] - 'a']) % MOD4;

        if (n % (i + 1) == 0)
            nxt.push_back(i + 1);
    }

    int ans = 0;
    for (auto cur : nxt) {
        int ln = n / cur;
        short int check1 = pref1[ln - 1], check2 = pref2[ln - 1], check3 = pref3[ln - 1], check4 = pref4[ln - 1];
        int l = ln, r = 2 * ln - 1;
        int b = 1;
        while (b && l != n) {
            if (check1 != (MOD1 + pref1[r] - pref1[l - 1]) % MOD1 ||
                check2 != (MOD2 + pref2[r] - pref2[l - 1]) % MOD2 ||
                check3 != (MOD3 + pref3[r] - pref3[l - 1]) % MOD3 ||
                check4 != (MOD4 + pref4[r] - pref4[l - 1]) % MOD4)
                b = 0;
            else
                l += ln, r += ln;
        }

        if (b) ans = cur;
    }

    cout << ans;

    return 0;
}