#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 200001;

vector<int> g[MAXN];
int n;
int c[MAXN];
int sz[MAXN];
ll res = 0;

pair<int, int> findMax(vector<int> v) {
    pair<int, int> res = {0, 1};
    if(v[0] < v[1])
        swap(res.first, res.second);

    for(int i = 2; i < v.size(); ++i) {
        if(v[i] > v[res.second])
            res.second = i;
        if(v[res.first] < v[res.second])
            swap(res.first, res.second);
    }
    return res;
}

void dfs(int v, int p = -1) {
    vector<int> sizes;

    sz[v] = 1;
    for (int e : g[v]) {
        if (e != p) {
            dfs(e);
            sz[v] += sz[e];
            sizes.push_back(sz[e]);
        }
    }


    while (sizes.size() > 1) {
        auto x = findMax(sizes);

        int can = min(sizes[x.first], sizes[x.second]);
        sizes[x.first] -= can;
        sizes[x.second] -= can;
        res += can;

        if(sizes[x.first] == 0)
            sizes[x.first] = sizes.back();
        else
            sizes[x.second] = sizes.back();
        sizes.pop_back();
    }
    if(sizes.size())
        res += sizes[0];
}

int main() {
#ifndef ONLINE_JUDJE
    freopen("input.txt", "r", stdin);
#endif

    cin >> n;

    int x;
    for(int i = 1; i < n; ++i) {
        cin >> x;
        g[x - 1].push_back(i);
    }

    for(int i = 0; i < n; ++i)
        cin >> c[i];

    dfs(0);

    cout << res * 2;
}