#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 2600, INF = 1e9;
using ld = double;
const ld eps = 1e-7;

struct line {
    ld A, B, C;
};

inline bool eq(ld a, ld b) {
    return abs(a - b) < eps;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);

    int n; cin >> n; n *= 2;
    vector<int> x(n), y(n);
    set<pair<int, int>> checked;
    for(int i = 0; i < n; i++) cin >> x[i] >> y[i], checked.insert({x[i], y[i]});
    /*bitset<maxn> ban[maxn];
    for(int A = 0; A < n; A++)
        for(int j = B + 1; j < n; j++) {

        }
    */
/*
    ld x1 = 6, y1 = 6, x2 = 9, y2 = 8;
    ld A1 = y1 - y2, B1 = x2 - x1, C1 = x1 * y2 - x2 * y1;
    x1 = 1, y1 = -4, x2 = 5, y2 = 12;
    ld A2 = y1 - y2, B2 = x2 - x1, C2 = x1 * y2 - x2 * y1;
    ld dx = B1 * C2 - B2 * C1;
    ld dy = -(A1 * C2 - A2 * C1);
    ld d = A1 * B2 - A2 * B1;
    cout.precision(5);
    cout << fixed << dx / d << ' ' << fixed << dy / d << endl;
*/

    /*for(int A = 0; A < n; A++)
        for(int B = A + 1; B < n; B++)
            for(int C = A + 1; C < n; C++) if(C != B)
                for(int D = C + 1; D < n; D++) if(D != B) {
    */
    for(int A = 0; A < n; A++)
        for(int B = A + 1; B < n; B++)
            for(int C = 0; C < n; C++) if(C != A && C != B)
                for(int D = C + 1; D < n; D++) if(D != A && D != B) {
                    //cout << A << ' ' << B << endl << C << ' ' << D << endl;
                    line l1 = {y[A] - y[B], x[B] - x[A], ld(x[A]) * y[B] - ld(x[B]) * y[A]};
                    line l2 = {y[C] - y[D], x[D] - x[C], ld(x[C]) * y[D] - ld(x[D]) * y[C]};;
                    ld dx = l1.B * l2.C - l2.B * l1.C;
                    ld dy = -(l1.A * l2.C - l2.A * l1.C);
                    ld d = l1.A * l2.B - l2.A * l1.B;
                    if(eq(d, 0)) continue;
                    ld xx = dx / d, yy = dy / d;
                    if(abs(xx) > 1000000 || abs(yy) > 1000000) continue;
                    int X = int(round(xx)), Y = int(round(yy));
                    if(!eq(xx, X) || !eq(yy, Y)) continue;
                    if(checked.find({X, Y}) != checked.end()) continue;
                    checked.insert({X, Y});
                    bitset<maxn> busy;
                    busy[A] = busy[B] = busy[C] = busy[D] = 1;
                    bool ok = true;
                    vector<line> tok;
                    for(int i = 0; ok && i < n; i++) if(!busy[i]) {
                        for(int j = i + 1; !busy[i] && j < n; j++) if(!busy[j]) {
                            line l1 = {y[i] - y[j], x[j] - x[i], ld(x[i]) * y[j] - ld(x[j]) * y[i]};
                            if(!eq(l1.A * X + l1.B * Y + l1.C, 0)) continue;
                            busy[i] = busy[j] = 1;
                            for(line l2 : tok) {
                                ld dx = l1.B * l2.C - l2.B * l1.C;
                                ld dy = -(l1.A * l2.C - l2.A * l1.C);
                                ld d = l1.A * l2.B - l2.A * l1.B;
                                if(eq(d, 0)) { ok = false; break; }
                            }
                            tok.push_back(l1);
                        }
                        if(!busy[i]) ok = false;
                    }
                    if(ok) {
                        return cout << "Yes\n" << X << ' ' << Y, 0;
                    }
                }
    cout << "No";
}


/*
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 5e5, INF = 1e9;

vector<int> poses[26];
string s;

inline int get(int c, int x) {
    if(poses[c].empty() || poses[c][0] > x) return 0;
    int lf = 0, rg = sz(poses[c]) - 1;
    while(lf < rg) {
        int md = (lf + rg + 1) >> 1;
        if(poses[c][md] <= x) lf = md;
        else rg = md - 1;
    }
    return lf + 1;
}

inline int get(int c, int l, int r, vector<int> &cnt) {
    int x = cnt[r] - (l ? cnt[l - 1] : 0);
    if(c) x = r - l + 1 - x;
    return x;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    cin >> s; int n = sz(s);
    vector<int> tot(26, 0);
    bool ab = true;
    for(int i = 0; i < n; i++) {
        poses[s[i] - 'a'].push_back(i);
        tot[s[i] - 'a']++;
        ab &= (s[i] == 'a' || s[i] == 'b');
    }
    if(!ab) {
        for(int len = 1; len <= n; len++) {
            if(n % len) continue;
            bool ok = true;
            vector<int> c(26);
            for(int i = 0; ok && i < 26; i++) {
                c[i] = get(i, len - 1);
                if(!tot[i]) continue;
                if(c[i] == 0 || tot[i] % c[i]) ok = false;
            }
            if(!ok) continue;
            int pos = len;
            while(ok && pos < n) {
                for(int i = 0; ok && i < 26; i++) ok &= (get(i, pos + len - 1) - get(i, pos - 1) == c[i]);
                pos += len;
            }
            if(ok) return cout << n / len, 0;
        }
    } else {
        vector<int> cnt(n, 0);
        for(int i = 0; i < n; i++) {
            cnt[i] = (i ? cnt[i - 1] : 0) + (s[i] == 'a');
        }
        for(int len = 1; len <= n; len++) {
            if(n % len) continue;
            bool ok = true;
            vector<int> c(2);
            for(int i = 0; ok && i < 2; i++) {
                c[i] = get(i, 0, len - 1, cnt);
                if(!tot[i]) continue;
                if(c[i] == 0 || tot[i] % c[i]) ok = false;
            }
            if(!ok) continue;
            int pos = len;
            while(ok && pos < n) {
                for(int i = 0; ok && i < 2; i++) ok &= (get(i, pos, pos + len - 1, cnt) == c[i]);
                pos += len;
            }
            if(ok) return cout << n / len, 0;
        }
    }
}
*/


/*
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 2e5, INF = 1e9;

struct segTree {
    int n; vector<int> t;
    segTree(vector<int> &a) {
        n = sz(a);
        t.resize(2 * n);
        for(int i = 0; i < n; i++) t[i + n] = a[i];
        for(int i = n - 1; i; i--) t[i] = min(t[i * 2], t[i * 2 + 1]);
    }
    int get(int l, int r) {
        int ret = INF;
        for(l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
            if(l & 1) ret = min(ret, t[l]);
            if(!(r & 1)) ret = min(ret, t[r]);
        }
        return ret;
    }
};

int n, a[maxn], b1[maxn], b2[maxn], tik_tak = -1, tsz[maxn];
vector<int> g[maxn];
vector<int> ord;
ll ans, sum[maxn];

void dfs(int v) {
    b1[v] = ++tik_tak;
    ord.push_back(v);
    sum[v] = a[v];
    tsz[v] = 1;
    for(int to : g[v]) dfs(to), sum[v] += sum[to], tsz[v] += tsz[to];
    b2[v] = tik_tak;
}

void dfs2(int v, segTree &t) {
    if(g[v].empty()) return;
    int kid = g[v][0];
    for(int to : g[v]) {
        dfs2(to, t);
        if(tsz[to] > tsz[kid]) kid = to;
    }
    ans += sum[v] - a[v];
    if(2 * tsz[kid] > tsz[v] - 1) {
        ll lo = min(t.get(b1[v] + 1, b1[kid] - 1), t.get(b2[kid] + 1, b2[v]));
        ans += (2 * tsz[kid] - tsz[v] + 1) * lo;
    } else if((tsz[v] - 1) & 1) ans += t.get(b1[v] + 1, b2[v]);
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    cin >> n;
    for(int i = 1; i < n; i++) {
        int x; cin >> x; x--; g[x].push_back(i);
    }
    for(int i = 1; i < n; i++) cin >> a[i];
    dfs(0);
    vector<int> vals(n);
    for(int i = 0; i < n; i++) vals[i] = a[ord[i]];
    segTree t(vals);
    dfs2(0, t);
    cout << ans;
}
*/
