#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

mt19937 rnd(228);

const int N = 2e5 + 7;

int c[N];
int sz[N];
ll sum[N];
vector <int> g[N];

ll ans = 0;

void dfs(int v)
{

    int a = 1e9, b = 1e9;
    sz[v] = 1;
    sum[v] = c[v];
    for (int to : g[v])
    {
        dfs(to);
        sum[v] += sum[to];
        sz[v] += sz[to];
        c[v] = min(c[v], c[to]);
        int x = c[to];
        if (x < a)
        {
            swap(a, x);
        }
        if (x < b)
        {
            swap(b, x);
        }
    }
    if (a != 1e9)
    {
        vector <ll> dp(sz[v], 1e18);
        dp[0] = 0;
        int cur = 0;
        for (int to : g[v])
        {
            vector <ll> ndp(sz[v], 1e18);
            for (int me = 0; me <= cur; me++)
            {
                for (int there = 0; there <= sz[to] && there <= me; there++)
                {
                    ndp[me + sz[to] - 2 * there] = min(ndp[me + sz[to] - 2 * there], dp[me] + sz[to]);
                }
            }
            dp = ndp;
            cur += sz[to];
        }
        ll best = 1e18;
        for (int i = 0; i <= cur; i++) best = min(best, dp[i] + i);
        ans += best;
        /*
        ll best = 1e18;
        {
            set <pair <int, int> > s;
            for (int to : g[v])
            {
                s.insert({sz[to], to});
                ans += sum[to];
            }
            while (s.size() > 1)
            {
                auto x = *prev(--s.end());
                auto y = *prev(s.end());
                s.erase(x);
                s.erase(y);
                y.first -= x.first;
                if (y.first != 0)
                {
                    s.insert(y);
                }
            }
            if (!s.empty())
            {
                int ind = s.begin()->second;
                if (c[ind] == a)
                {
                    best = min(best, b * (ll) s.begin()->first);
                }
                else
                {
                    best = min(best, a * (ll) s.begin()->first);
                }
            }
            else
            {
                best = 0;
            }
        }
        /*
        {
            set <pair <int, int> > s;
            int x = -1;
            for (int to : g[v])
            {
                if (c[to] == a)
                {
                    x = to;
                    break;
                }
            }
            int mine = sz[x];
            for (int to : g[v])
            {
                if (to != x)
                {
                    s.insert({sz[to], to});
                }
            }
            while (s.size() > 0 && mine)
            {
                auto it = *s.begin();
                s.erase(s.begin());
                if (mine >= it.first)
                {
                    mine -= it.first;
                }
                else
                {
                    s.insert({it.first - mine, it.second});
                    mine = 0;
                }
            }
            if (!mine)
            {
                while (s.size() > 1)
                {
                    auto x = *s.begin();
                    auto y = *s.rbegin();
                    s.erase(s.begin());
                    s.erase(--s.end());
                    y.first -= x.first;
                    if (y.first != 0)
                    {
                        s.insert(y);
                    }
                }
                if (!s.empty())
                {
                    int ind = s.begin()->second;
                    if (c[ind] == a)
                    {
                        best = min(best, b * (ll) s.begin()->first);
                    }
                    else
                    {
                        best = min(best, a * (ll) s.begin()->first);
                    }
                }
                else
                {
                    best = 0;
                }
            }
        }
        ans += best;
        */
    }
}


int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
   // freopen("a.out", "w", stdout);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    for (int i = 1; i < n; i++) cin >> c[i];
    dfs(0);
    cout << ans << '\n';
}
