#include <bits/stdc++.h>
#pragma GCC optimize("O3")


typedef long long ll;

#define forn(i, n) for (ll i = 0; i < n; ++i)
#define x first
#define y second
#define point pair<ll, ll>

using namespace std;

const ll N = 1e5 + 3, BIG = 1e9 + 7, MOD = 1e9 + 7;
ll P = ll('z' - 'a' + 1);

// code2

ll gcd(ll a, ll b) {
	while (a > 0) {
		b %= a;
		swap(a, b);
	}
	return b;
}

ll n;
vector<vector<ll>> dp;

bool can(ll k) {
	// cout << k << " - k\n";
	for (ll i = 0; i < k; ++i) {
		ll L = i * n / k - 1;
		ll R = L + n / k;
		// cout << L << " " << R << "\n";
		if (R >= n)
			break;
		forn(j, P)
			if (dp[R][j] - (L > 0 ? dp[L][j] : 0) != dp[n - 1][j] / k)
				return false;
	}
	return true;
}


int main() {
	// freopen("a.in", "r", stdin), freopen("a.out", "w", stdout);
	// code 2
	ios_base:: sync_with_stdio(0), cin.tie(0), cout.tie(0);
	string s;
	cin >> s;
	n = s.size();
	P = 0;
	forn(i, n)
		P = max(P, (ll)s[i] - 'a' + 1);
	dp.resize(n, vector<ll> (P));
	forn(i, n) {
		forn(j, P) 
			dp[i][j] = (i > 0 ? dp[i - 1][j] : 0) + (s[i] - 'a' == j);
	}
	/*/
	forn(i, n) {
		forn(j, P)
			cout << dp[i][j] << " ";
		cout << "\n";
	}
	cout << endl;
	//*/

	ll d = n;
	forn(j, P)
		if (dp[n - 1][j] > 0) {
			// cout << dp[n - 1][j] << " - dp n - 1\n";
			d = gcd(d, dp[n - 1][j]);
		}
	// cout << d << " - d" << endl;

	ll ans = 0;
	for (ll k = 1; k * k <= d; ++k) {
		if (d % k == 0) {
			if (can(k))
				ans = max(ans, k);
			if (can(d / k))
				ans = max(ans, d / k);
		}
	}
	cout << ans;
	return 0;
}