#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;
typedef long double ld;

const int N = 300001;
vector<int> g[N];
vector<ll> c, d, sum, siz;

ll dfs(int v)
{
   // cerr << v << endl;
    if (sz(g[v]) == 0)
    {
        d[v] = 0;
        siz[v] = 1;
        sum[v] = c[v];
        return c[v];
    }
    ll min1 = 1e9, min2 = 1e9;
    vector<int> kek;
    sum[v] = 0;
    siz[v] = 0;
    for (int u : g[v])
    {
        ll x = dfs(u);
        if (x < min1)
        {
            min2 = min1;
            min1 = x;
        }
        else if (x < min2)
        {
            min2 = x;
        }
        kek.push_back(x);
        sum[v] += sum[u];
        siz[v] += siz[u];
    }
    d[v] = sum[v];
    bool mem = 0;
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i];
        if (siz[u] * 2 >= siz[v])
        {
            if (kek[i] == min1)
                min1 = min2;
            d[v] += (siz[u] - (siz[v] - siz[u])) * min1;
            mem = 1;
            break;
        }
    }
    int best = 0;
    for (int i = 1; i < g[v].size(); i++)
        if (siz[g[v][i]] > siz[g[v][best]])
            best = i;
    if (kek[best] != min1)
        min1 = min2;
    if (!mem && siz[v] % 2)
        d[v] += min1;
    siz[v]++;
    sum[v] += c[v];
    return min(min1, c[v]);
}

int solve()
{
    ios::sync_with_stdio(0);
    int n;
    if (!(cin >> n))
        return 1;
    for (int i = 2; i <= n; i++)
    {
        int x;
        cin >> x;
        g[x].push_back(i);
    }
    c.assign(n + 1, 0);
    for (int i = 2; i <= n; i++)
        cin >> c[i];
    d.assign(n + 1, 0);
    sum.assign(n + 1, 0);
    siz.assign(n + 1, 0);
    dfs(1);
    ll ans = 0;
    for (int i = 1; i <= n; i++)
        ans += d[i];
    cout << ans << endl;
    return 0;
}

//#define KEK
int main()
{
    #ifdef KEK
        freopen("in.txt", "r", stdin);
    #endif
    for (int i = 1;; i++)
    {
        #ifdef KEK
            cerr << "Test #" << i << endl;
        #endif
        if (solve())
            break;
    }
    #ifdef KEK
        cerr << "finished in " << clock() * 1000LL / CLOCKS_PER_SEC << " ms";
    #endif
    return 0;
}
