#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <fstream>
#include <string>
#include <math.h>

using namespace std;

#define int long long

vector< vector<int> > ch;
vector<int> c;
long long sm = 0;
vector<long long> s;
vector<long long> cnt;
vector<int> mn;

void dfs(int v)
{
    mn[v] = c[v];
    s[v] = c[v];
    cnt[v] = 1;
    int mxi = -1;
    int mn1 = 10000000, mn2 = 10000000;
    int m = ch[v].size();
    for (int i = 0; i < m; i++) {
        dfs(ch[v][i]);
        mn[v] = min(mn[v], mn[ch[v][i]]);
        cnt[v] += cnt[ch[v][i]];
        if (mxi == -1 || cnt[ch[v][i]] > cnt[mxi]) {
            mxi = ch[v][i];
        }
        s[v] += s[ch[v][i]];
        int k = mn[ch[v][i]];
        if (k < mn1) {
            mn2 = mn1;
            mn1 = k;
        }
        else if (k < mn2) {
            mn2 = k;
        }
    }
    if (m > 0) {
        int d = cnt[mxi] - (cnt[v] - 1 - cnt[mxi]);
        if (d <= 0) {
            sm += s[v] - c[v];
            if (cnt[v] % 2 == 0) {
                sm += mn1;
            }
        }
        else{
            sm += s[v] - c[v];
            if (mn[mxi] == mn1) {
                sm += d * mn2;
            }
            else {
                sm += d * mn1;
            }
        }
    }
}

main()
{
    ifstream fin("input.txt");
    int n;
    fin >> n;
    c.resize(n);
    mn.assign(n, 20000000);
    cnt.assign(n, 0);
    s.assign(n, 0);
    ch.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int k;
        fin >> k;
        ch[k - 1].push_back(i + 1);
    }
    c[0] = 0;
    for (int i = 0; i < n - 1; i++) {
        fin >> c[i + 1];
    }
    dfs(0);
    cout << sm;
}
