#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string.h>
#include <ctime>
using namespace std;
typedef long long ll;

const int maxn = 5000010, cntlets = 4;
char s[maxn];
int cnt[26], biggcd, cntcur[26], pref[cntlets][maxn];
int norm [maxn];
vector <int> divs;

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int main() {
	scanf("%s", &s);
	int len = strlen(s);
	int lets = 26;
	for (int i = 0; i < len; i++) {
		cnt[s[i] - 'a']++;
		for (int j = 0; j < cntlets; j++) {
			pref[j][i + 1] = pref[j][i];
		}
		if (s[i] - 'a' < cntlets) {
			pref[s[i] - 'a'][i + 1]++;
		}
	}
	biggcd = cnt[0];
	for (int i = 1; i < lets; i++) {
		biggcd = gcd(biggcd, cnt[i]);
	}
	for (int i = 1; i * i <= biggcd; i++) {
		if (biggcd % i == 0) {
			divs.push_back(i);
			if (i * i != biggcd) {
				divs.push_back(biggcd / i);
			}
		}
	}
	sort(divs.begin(), divs.end());
	int ans = 1, counted = 0;
	srand(239);
	while (counted < divs.size()) {
		int i = rand() % divs.size();
		if (norm[i] != 0) continue;

		int sz = len / divs[i];
		for (int j = 0; j < lets; j++) {
			cntcur[j] = 0;
		}
		bool ok = true;

		for (int j = 0; j < cntlets; j++) {
			int need = cnt[j] / divs[i];
			int sz = len / divs[i];
			for (int p = 0; p < len; p += sz) {
				if (pref[j][p + sz] - pref[j][p] != need) {
					ok = false;
					break;
				}
			}
			if (!ok) {
				break;
			}
		}

		vector <int> let;
		for (int j = cntlets; j < lets; j++) {
			if (cnt[j] != 0) {
				let.push_back(j);
			}
		}

		for (int p = 0; p < len; p++) {
			cntcur[s[p] - 'a']++;
			if ((p + 1) % sz == 0) {
				for (int q = 0; q < let.size(); q++) {
					int j = let[q];
					int need = cnt[j] / divs[i];
					if (cntcur[j] != (p + 1) / sz * need) {
						ok = false;
						break;
					}
				}
				if (!ok) {
					break;
				}
			}
		}
		if (ok) {
			norm[divs[i]] = 2;
			counted++;
			ans = max(ans, divs[i]);
			for (int j = 0; j < divs.size(); j++) {
				if (norm[divs[j]] == 0 && divs[i] % divs[j] == 0) {
					norm[divs[j]] = 2;
					counted++;
				}
			}
		}
		else {
			norm[divs[i]] = 1;
			counted++;
			for (int j = 0; j < divs.size(); j++) {
				if (norm[divs[j]] == 0 && divs[j] % divs[i] == 0) {
					norm[divs[j]] = 1;
					counted++;
				}
			}
		}
	}
	printf("%d", ans);
	return 0;
}