//#pragma gcc optimize("OFast")
//#pragma target("sse,sse2,sse3,sse4,tune=native")
//#pragma gcc optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>
#include <cassert>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

ll solve(ll n, ll k, ll add = 0)
{
	if (k % 2 == 1)
	{
		return (k + 1) / 2 + add;
	}
	else
	{
		return solve(n / 2, k / 2, add + n - n / 2);
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, q;
	cin >> n >> q;
	for (int i = 0; i < q; i++)
	{
		ll pos;
		cin >> pos;
		cout << solve(n, pos) << "\n";
	}
	

#ifdef _DEBUG
	while (1);
#endif
}