#include <bits/stdc++.h>

#define int long long

using namespace std;

struct vec {
	int x, y;
	vec(int xx = 0, int yy = 0) {
		x = xx; y = yy;
	}
	vec operator - (vec a) {
		return vec(x - a.x, y - a.y);
	}
	vec operator + (vec a) {
		return vec(x + a.x, y + a.y);
	}
	long long operator * (vec a) {
		return (long long)x * a.x + (long long)y * a.y;
	}
	long long operator % (vec a) {
		return (long long)x * a.y - (long long)y * a.x;
	}
	bool operator < (const vec a) const {
		return make_pair(x, y) < make_pair(a.x, a.y);
	}
	bool operator != (vec a) {
		return x != a.x || y != a.y;
	}
};

struct lin {
	vec x;
	int c;
	lin (vec a, vec b) {
		x = vec((a - b).y, (b - a).x);
		c = a * x;
	}
	vec operator & (lin a) {
		if (x % a.x == 0) {
			return vec(-1e9, -1e9);
		}
		int d, da, db;
		d = x % a.x;
		da = c * a.x.y - a.c * x.y;
		db = x.x * a.c - a.x.x * c;
		// cout << da << ' ' << db << ' ' << d << '\n';
		if (da % d != 0 || db % d != 0) {
			return vec(-1e9, -1e9);
		}
		return vec(da / d, db / d);
	}
};

vec s[10000];

int n;

vector<vec> g;

set<vec> v, vv;

void genp(int a) {
	g.clear();
	for (int b = 0; b < n; b++) {
		if (b == a) continue;
		int c = rand() % n;
		while (c == a || c == b) {
			c = rand() % n;
		}
		for (int d = 0; d < n; d++) {
			if (d == a || d == b || d == c) continue;
			// cout << a << ' ' << b << ' ' << c << ' ' << d << '\n';
			lin ab = lin(s[a], s[b]);
			lin cd = lin(s[c], s[d]);
			vec x = ab & cd;
			// cout << s[a].x << ' ' << s[a].y << '\n';
			// cout << s[b].x << ' ' << s[b].y << '\n';
			// cout << s[c].x << ' ' << s[c].y << '\n';
			// cout << s[d].x << ' ' << s[d].y << '\n';
			// cout << ab.x.x << ' ' << ab.x.y << ' ' << ab.c << ' ' << cd.x.x << ' ' << cd.x.y << ' ' << cd.c << '\n';
			if (abs(x.x) <= 1e6 && abs(x.y) <= 1e6) {
				g.push_back(x);
			}
		}
	}
}

bool cmp(vec a, vec b) {
	return a % b > 0;
}

bool check(vec a) {
	g.clear();
	for (int i = 0; i < n; i++) {
		g.push_back(s[i] - a);
		if (g[i] < vec(0, 0)) {
			g[i] = vec(-g[i].x, -g[i].y);
		}
	}
	sort(g.begin(), g.end(), cmp);
	for (int i = 0; i < n; i += 2) {
		if (g[i] % g[i + 1] != 0) {
			// cout << 0 << '\n';
			return 0;
		}
		if (i > 0 && g[i] % g[i - 1] == 0) {
			return 0;
		}
	}
	// cout << 1 << '\n';
	return 1;
}

set<vec> vvv;

signed main() {
	cin >> n;
	n *= 2;
	for (int i = 0; i < n; i++) {
		cin >> s[i].x >> s[i].y;
		vvv.insert(s[i]);
	}
	genp(rand() % n);
	for (auto i : g) {
		if (!vvv.count(i))
			v.insert(i);
		// cout << i.x << ' ' << i.y << '\n';
	}
	// return 0;
	for (int ii = 0; ii < 1; ii++) {
		genp(rand() % n);
		for (auto i : g) {
			if (v.count(i)) {
				vv.insert(i);
			}
		}
		v.clear();
		for (auto i : vv) {
			v.insert(i);
		}
		vv.clear();
	}
	// cout << 100 << '\n';
	for (auto i : v) {
		// cout << i.x << ' ' << i.y << '\n';
		if (check(i)) {
			cout << "Yes\n" << i.x << ' ' << i.y << '\n';
			return 0;
		}
	}

	cout << "No";
}