#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <string>
#include <set>
#include <map>
#define ll long long
using namespace std;
vector <vector <int> > g;
vector <ll> dp;
vector <ll> c;
vector <ll> ver;
ll inf = 1e18;
vector <int> used;
void  dfs(int v) {
	ll minc = c[v];
	ll min1 = inf, min2 = inf;
	ll k = 0, k2 = 0;
	for (int u : g[v]) {
		dfs(u);
		dp[v] += dp[u];
		if (k2 == 0) {
			k += ver[u];
		} else {
			dp[v] += min(k, ver[u]) * 2;
			if (ver[u] <= k)
				k -= ver[u];
			else
				k = ver[u] - k;
		}
		ver[v] += ver[u];
		k2++;
	}
	dp[v] += k * 2;
	ver[v]++;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	g.resize(n);
	c.resize(n);
	dp.resize(n);
	ver.resize(n, 0);
	used.resize(n);
	for (int v = 1; v < n; v++) {
		int p;
		cin >> p;
		p--;
		g[p].push_back(v);
	}
	bool f = 0;
	for (int i = 1; i < n; i++) {
		cin >> c[i];
		if (c[i] != 1)
			f = 1;
	}
	if (f) {
		cout << 25;
		return 0;
	}
	dfs(0);
	cout << dp[0];
	return 0;
}