#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long
using namespace std;

vector<vector<int> > g;
vector<int> mn;
vector<int> sum;
vector<int> p;
vector<int> size1;

int ans = 0;

void dfs(int v){
    mn[v] = p[v];
    size1[v] = 1;
    vector<pair<int, int> > sz;
    for (auto i : g[v]){
        dfs(i);
        size1[v] += size1[i];
        sz.push_back(make_pair(size1[i], i));
        mn[v] = min(mn[v], mn[i]);
        sum[v] += sum[i];
    }
    sort(sz.begin(), sz.end());
    int mx = sz.size() - 1;
    int cur = sz.size() - 2;
    while (cur >= 0 && sz.size()){
        if (sz[cur].first > sz[mx].first){
            sz[cur].first -= sz[mx].first;
            sz[mx].first = 0;
            mx = cur;
            cur--;
        }else{
            sz[mx].first -= sz[cur].first;
            sz[cur].first = 0;
            cur--;
        }
    }
    ans += sum[v];
    if (mx >= 0 && sz[mx].first > 0){
        int mn1 = 1e9;
        for (auto i : g[v]){
            if (i != sz[mx].second){
                mn1 = min(mn1, mn[i]);
            }
        }
        ans += sz[mx].first * mn1;
    }
    sum[v] += p[v];
}

int main()
{
    int n;
    cin >> n;
    g.resize(n);
    size.resize(n);
    mn.resize(n);
    sum.resize(n);
    p.resize(n);
    int a;
    for (int i = 1; i < n; i++){
        cin >> a;
        g[a - 1].push_back(i);
    }
    for (int i = 1; i < n; i++){
        cin >> p[i];
    }
    dfs(0);
    cout << ans << endl;
    return 0;
}
