#include <iostream>
#include <vector>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
ll sqr(ll a) {
    return a * a;
}


vector < vector < int > > g, up;
vector < int > sz;
int ans;


void dfs(int v) {
    int cnt = 1;
    int mx = 0;
    for (auto to: g[v]) {
        dfs(to);
        cnt += sz[to];
        mx = max(mx, sz[to]);
    }
    ans += mx * 2;
    sz[v] = cnt;
}


int main() {
//    freopen("a.txt", "r", stdin);
//    freopen("b.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    int n;
    cin >> n;
    g.resize(n);

    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[--p].push_back(i);
    }

    for (int i = 0; i < n; i++) {
        assert(g[i].size() != 1);
    }

    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
    }

    sz.resize(n);
    dfs(0);

//    for (auto p: sz) cout << p << " ";
    cout << ans;
}
