#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

struct gem{
    int cnt[26];
    gem(){
        for (int i = 0; i < 26; i++)
            cnt[i] = 0;
    }
    bool operator!=(gem g){
        bool f = 0;
        for (int i = 0; i < 26; i++)
            if (cnt[i] != g.cnt[i]){
                f = 1;
                break;
            }
        return f;
    }
    gem operator+(gem g){
        gem x;
        for (int i = 0; i < 26; i++)
            x.cnt[i] = cnt[i] + g.cnt[i];
        return x;
    }
    gem operator-(gem g){
        gem x;
        for (int i = 0; i < 26; i++)
            x.cnt[i] = cnt[i] - g.cnt[i];
        return x;
    }
};

vector<gem> g;
vector<int> p;
set<char> st;
string s;
int n;

bool check(int x){
    bool f = 1;
    gem gg = g[x] - g[0];
    for (int i = 2 * x; i <= n; i += x)
        if (g[i] - g[i - x] != gg){
            f = 0;
            break;
        }
    return f;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> s;
    n = s.size();
    g.reserve(n + 1);
    gem gg;
    g.push_back(gg);
    for (int i = 0; i < n; i++){
        gg.cnt[s[i] - 'a']++;
        g.push_back(gg);
        st.insert(s[i]);
    }
    if (st.size() == 1)
        return cout << n << endl, 0;
    for (int i = 2; i * i <= n; i++)
        if (n % i == 0){
            if (check(i))
                return cout << n / i << endl, 0;
            p.push_back(n / i);
        }
    for (auto i : p)
        if (check(i))
            return cout << n / i << endl, 0;
    cout << 1 << endl;

    return 0;
}
