#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(s) s.begin(), s.end()

#define bp __builtin_popcountll
#define b_clz __builtin_clzll
#define b_ctz __builtin_ctzll

typedef long long llong;
typedef unsigned long long ullong;

typedef vector <int> vi;
typedef vector <llong> vl;

typedef pair <int, int> pii;

const int MXN = 1e6 + 1;
const int MNN = 1e3 + 1;
const int INF = 1e9;
const llong MOD = 1e9 + 7;
const llong LINF = 1e18;

llong log2 (llong x) {return 64 - b_clz (x) - 1;};
llong __lcm (llong x, llong y) {return x / __gcd (x, y) * y;};

int n;
int p[MXN], c[MXN], cnt[MXN];

bool leaf[MXN];

vi g[MXN];

int get (int v) {
	if (leaf[v]) return 1;
	int sum = 0;
	for (int i : g[v]) {
		sum += get (i);
	}
	return sum;
}

int main () {
	//freopen ("input.txt", "r", stdin);
	cin >> n;
	for (int i = 1; i <= n; ++ i) leaf[i] = 1;
	for (int i = 2; i <= n; ++ i) {
		cin >> p[i];
		leaf[p[i]] = 0;
		g[p[i]].pb (i);
	}
	for (int i = 1; i <= n; ++ i) cin >> c[i];
	for (int i = 1; i <= n; ++ i) {
		cnt[i] = 1;
	}
	for (int i = 1; i <= n; ++ i) {
		for (int it : g[i]) {
			cnt[i] += cnt[it];
		}
	}
	int sum = 0;
	for (int i = 1; i <= n; ++ i) {
		if (!leaf[i]) {
			int mx = 0;
			for (int it : g[i]) {
				mx = max (mx, cnt[it]);
			}
			sum += mx;
		}
	}
	cout << sum * 2;
	return 0;
}