#include <bits/stdc++.h>

using namespace std;

#define sqr(a) ((a)(a))
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int(a.size())
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define x first
#define y second
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const int N = 1e6 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;
const int M = 1e3 + 9;
const ld EPS = 1e-12;
const char C = 'a';

set<int> simp;

bool cmp(int a[], int b[]) {
    forn(i, 26)
        if (a[i] != b[i])
            return 0;
    return 1;
}

bool check(int n, int k, string &s) {
    int cur[26] = {0}, needed[26] = {0};
    forn(i, k)
        needed[s[i] - C]++;
    int i = k;
    while (i < n) {
        fill(cur, cur + 26, 0);
        for (int t = 0; t < k; t++, i++)
            cur[s[i] - C]++;
        if (!cmp(needed, cur))
            return 0;
    }
    return 1;
}

int main()
{
    ios::sync_with_stdio(0);
    string s;
    int n, maxi = 0, n1;
    cin >> s;
    n = sz(s);
    n1 = n;
    for (int i = 2; i * 1ll * i <= n; i++) {
        if (n % i == 0) {
            simp.insert(i);
            n /= i;
        }
    }
    if (n > 1)
        simp.insert(n);
    simp.insert(1);
    simp.insert(n1);
    for (auto k : simp) {
//        cout << k << ' ';
        if (check(n1, k, s))
            maxi = max(maxi, n1 / k);
    }
    cout << maxi;
    return 0;
}
