#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define fi first
#define se second
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

bool check(string s, int n) {
    vector <int> cnt(26);
    for (auto c : s)
        cnt[c - 'a']++;
    for (int i = 0; i < s.size(); i += n) {
        vector <int> cnt2(26);
        for (int j = i; j < i + n; ++j) {
            cnt2[s[j] - 'a']++;
        }
        for (int j = 0; j < 26; ++j) {
            if (cnt[j] / n != cnt2[j]) {
                return false;
            }
        }
    }
    return true;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    string s;
    cin >> s;
    int n = s.size();
    vector <int> cnt(26);
    for (auto c : s) {
        cnt[c - 'a']++;
    }
    int a = n;
    for (auto x : cnt) {
        a = __gcd(a, x);
    }
    int p = 1;
    int ans = 1;
    while (p * p <= a) {
        if (a % p == 0) {
            if (check(s, p)) {
                ans = max(ans, n / p);
            }
            else if (p * p != a) {
                if (check(s, a / p)) {
                    ans = max(ans, n / (a / p));
                }
            }
        }
        ++p;
    }
    cout << ans << endl;
    return 0;
}
