#include <bits/stdc++.h>

using namespace std;

int alph = 26;

const int mod = 1000000007;

int hashed(vector <int> arr) {
    int64_t hashsh = 0;
    for (int i = 0; i < arr.size(); ++i) {
        hashsh *= 37;
        hashsh += arr[i];
        hashsh %= mod;
    }
    return hashsh;
}

unordered_set <int> mapa;
vector <int> cnt;

bool check(int sz, int n) {
    int k = sz / n;
    for (auto & x : cnt)
        x /= k;
    int need = hashed(cnt);
    int now = need;
    for (int i = 1; i <= k; ++i) {
        if (!mapa.count(now)) {
            for (auto & x : cnt)
                x *= k;
            return false;
        }
        now += need;
        now = (now >= mod ? now - mod : now);
    }
    for (auto & x : cnt)
        x *= k;
    return true;
}

int gcd(int a, int b) {
    while (b > 0) {
        int c = a % b;
        a = b;
        b = c;
    }
    return a;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    int t = clock();
    string s;
    cin >> s;
    int n = s.size();
    bool flag = true;
    vector <int> pow(alph);
    pow[0] = 1;
    for (int i = 1; i < pow.size(); ++i)
    {
        pow[i] = ((long long)pow[i - 1] * 37) % mod;
    }
    for (auto c : s)
        if (c != 'a' && c != 'b')
            flag = false;
    if (flag)
        alph = 2;
    cnt.resize(alph);
    int hashn = 0;
    int it = 1;
    for (auto c : s) {
        cnt[c - 'a']++;
        hashn += pow[alph - 1 - (c - 'a')];
        hashn = (hashn >= mod ? hashn - mod : hashn);
        if (gcd(it, n) != 1)
            mapa.insert(hashn);
        it++;
    }
    int a = n;
    for (auto x : cnt) {
        a = gcd(a, x);
    }
    int cntt = 0;
    for (auto x : cnt)
        cntt += (x != 0);
    if (cntt == 1) {
        cout << n << endl;
        return 0;
    }
    int p = 1;
    int ans = 1;
    while (p * p <= a) {
        if (a % p == 0) {
            if (check(s.size(), n / (a / p))) {
                cout << a / p << endl;
                return 0;
            }
        }
        if (clock() - t > 200000) {
            cout << 1 << endl;
            return 0;
        }
        ++p;
    }
    while (p > 1) {
        if (a % p == 0) {
            if (check(s.size(), n / p)) {
                cout << p << endl;
                return 0;
            }
        }

        if (clock() - t > 200000) {
            cout << 1 << endl;
            return 0;
        }
        --p;
    }
    cout << 1 << endl;
    return 0;
}
