#include <bits/stdc++.h>
//#pragma GCC optimize ("Ofast")
//#pragma GCC optimize ("unroll-loops")
using namespace std;
const int N = 2001;
const double e = 1e-7;
const double inf = 1e15;

struct line {
    double k, x1, y1;
};

struct point {
    double x, y;
};

line t[N][N];

bool intersect(line a, line b) {
    return (abs(a.k - b.k) > e);
}

point prs(line a, line b) {
    point p;
    if (a.k == inf) {
        p.x = a.x1;
        p.y = b.k * (p.x - b.x1) + b.y1;
        return p;
    }
    if (b.k == inf) {
        p.x = b.x1;
        p.y = a.k * (p.x - a.x1) + a.y1;
        return p;
    }
    p.x = (a.k * a.x1 - b.k * b.x1 + b.y1 - a.y1) / (a.k - b.k);
    p.y = a.k * (p.x - a.x1) + a.y1;
    return p;
}

bool f[N];
bool g[N][N];
set <pair<double, int > > s[N];
map <int, int> m;
unordered_map <pair<int, double>, int> d;

int st[N], top;

int main() {
    double x[N], y[N];
    int i, j, i1, n, j1, l;
    freopen("input.txt", "r", stdin);
    cin >> n;
    n *= 2;
    for (i = 1; i <= n; ++i) {
        cin >> x[i] >> y[i];
    }
    for (i = 1; i <= n * n; ++i) {
        int p1 = rand() % n + 1;
        int p2 = rand() % n + 1;
        swap(x[p1], x[p2]);
        swap(y[p1], y[p2]);
    }
    for (i = 1; i <= n; ++i)
    for (j = i + 1; j <= n; ++j) {
        t[i][j].x1 = x[i];
        t[i][j].y1 = y[i];
        if (x[j] == x[i])
            t[i][j].k = inf;
        else
            t[i][j].k = (y[j] - y[i]) / (x[j] - x[i]);
        if (t[i][j].k == inf)
            m[t[i][j].x1]++;
        else {
            long long g = t[i][j].k * (-x[i]) + y[i];
            double p = t[i][j].k;
            ++d[{g, p}];
        }
    }
    for (i = 1; i <= n; ++i)
    for (j = i + 1; j <= n; ++j)
    if (t[i][j].k == inf && m[t[i][j].x1] == 1) {
        g[i][j] = true;
        s[i].insert({t[i][j].k, j});
    } else if (t[i][j].k != inf) {
            long long g1 = t[i][j].k * (-x[i]) + y[i];
            double p = t[i][j].k;
            if (d[{g1, p}] == 1) {
                g[i][j] = true;
                s[i].insert({t[i][j].k, j});
            }
         }
    int cnt = 0;
    for (i = 2; i <= n; ++i) {
        if (i == 2)
            j1 = 3;
        else
            j1 = 2;
        for (j = j1 + 1; j <= n; ++j) {
        if (i != j && g[1][i] && g[j1][j] && intersect(t[1][i], t[j1][j])) {
            point center = prs(t[1][i], t[j1][j]);
            int ox, oy;
            if (center.x < 0)
                ox = (int) (center.x - e/2);
            else
                ox = (int) (center.x + e/2);
            if (center.y < 0)
                oy = (int) (center.y - e/2);
            else
                oy = (int) (center.y + e/2);
            if (abs(ox) > 1e6 || abs(oy) > 1e6)
                continue;
            if (abs(center.x - ox) > e || abs(center.y - oy) > e)
                continue;
            f[1] = true;
            f[i] = true;
            f[j] = true;
            f[j1] = true;
            top = 4;
            st[1] = i;
            st[2] = j;
            st[3] = 1;
            st[4] = j1;
            center.x = ox;
            center.y = oy;
            bool can = true;
            for (l = 1; l <= n; ++l)
            if (!f[l]) {
                ++cnt;
                double tk;
                if (center.x == x[l])
                    tk = inf;
                else
                    tk = ((long double) center.y - y[l]) / ((long double)center.x - x[l]);
                set <pair<double, int> > :: iterator it = s[l].lower_bound({tk - e, 0});
                if (it != s[l].end() && abs((*it).first - tk) < e) {
                    f[l] = true;
                    f[(*it).second] = true;
                    ++top;
                    st[top] = l;
                    ++top;
                    st[top] = (*it).second;
                } else {
                    can = false;
                    break;
                }
            }
            for (l = 1; l <= top; ++l)
                f[st[l]] = false;
            if (can) {
                cout << "Yes\n";
                cout << ox << ' ' << oy << "\n";
                return 0;
            }
        }
        }
    }
    j = -1;
    cout << "No";
}
