#include <iostream>
#include <cstring>
#include <unordered_map>
#include <vector>
#include <cmath>

using namespace std;

int gcd(int a, int b) {
    if (a < b) {
        swap(a, b);
    }
    while (a % b) {
        int c = b;
        b = a % b;
        a = c;
    }
    return b;
}

int f(vector<int> a) {
    if (a.size() == 1) {
        return a[0];
    }
    else {
        int x = gcd(a[0], a[1]);
        for (int i = 2; i < a.size(); i++) {
            x = gcd(x, a[i]);
        }
        return x;
    }
}

int main()
{
    string s;
    string s0;
    cin >> s;
    unordered_map<char, int> d;
    int n = s.size();
    for (int i = 0; i < n; i++) {
        if (d.find(s[i]) == d.end()) {
            d[s[i]] = 1;
            s0 += s[i];
        }
        else {
            d[s[i]]++;
        }
    }
    int n0 = s0.size();
    vector<int> a;
    for (int i = 0; i < n0; i++) {
        a.push_back(d[s0[i]]);
    }
    int x = f(a);
    if (x == 1) {
        cout << 1 << endl;
    }
    else if (n0 == 1) {
        cout << n << endl;
    }
    else {
        bool flag1 = true;
        bool flag2;
        int k;
        int c;
        unordered_map<char, int> q;
        vector<int> v;
        for (int i = 1; i <= x; i++) {
            if (x % i == 0) {
                v.push_back(i);
            }
        }
        int left = 0;
        int right = v.size();
        int mid;
        int m;
        while (right - left > 1) {
            mid = (left + right) / 2;
            m = v[mid];
            if (x % m == 0) {
                for (int i = 0; i < n0; i++) {
                    q[s0[i]] = 0;
                }
                flag2 = true;
                k = 0;
                c = 0;
                for (int i = 0; i < n && flag2; i++) {
                    q[s[i]]++;
                    if (q[s[i]] % (d[s[i]] / m) == 0) {
                        k++;
                        if (q[s[i]] / (d[s[i]] / m) > c + 1) {
                            flag2 = false;
                        }
                        else if (k == n0) {
                            k = 0;
                            c++;
                        }
                    }
                    if (q[s[i]] / (d[s[i]] / m) > c && (q[s[i]] / (d[s[i]] / m) > c + 1 || q[s[i]] % (d[s[i]] / m) != 0)) {
                        flag2 = false;
                    }
                }
                if (flag2) {
                    left = mid;
                }
                else {
                    right = mid;
                }
            }
        }
        cout << v[left] << endl;
    }
    return 0;
}
