#include <iostream>
#include <vector>

using namespace std;

vector<int> sub;
vector<vector<int> > g;

int ans = 0;

void dfs(int u) {
    sub[u] = 0;
    int k = 0;
    for (int i = 0; i < g[u].size(); i++) {
        dfs(g[u][i]);
        sub[u] += sub[g[u][i]] + 1;
        k = max(k, sub[g[u][i]] + 1);
    }
    ans += 2 * k;
}

int main()
{
    int n;
    cin >> n;
    vector<int> p(n, 0);
    g.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    sub.resize(n);
    dfs(0);
    cout << ans << endl;
    return 0;
}
