#include <iostream>

using namespace std;

struct point {
    int x, y;
point (long long x0, long long y0) {
    x = x0;
    y = y0;
}
bool operator!= (point a) {
    return x != a.x || y != a.y;
}
};

bool f(point a, point b, point c, point d) {
    long long a1, a2, b1, b2, c1, c2;
    a1 = b.y - a.y;
    a2 = d.y - c.y;
    b1 = a.x - b.x;
    b2 = c.x - d.x;
    c1 = a.y * (b.x - a.x) - a.x * (b.y - a.y);
    c2 = c.y * (d.x - c.x) - c.x * (d.y - c.y);
    long double x1, y1;
    //cout << a1 << " " << a2 << " " << b1 << " " << b2 << " " << c1 << " " << c2;
    long double k1, k2;
    if (a2 == 0) {
        if (a1 == 0) {
            return false;
        }
        x1 = (b1 * c2 - c1 * b2) / (a1 * b2 - b1 * a2);
        y1 = (c1 * a2 - a1 * c2) / (a1 * b2 - b1 * a2);
        if (point(x1, y1) != a && point(x1, y1) != b && point(x1, y1) != c && point(x1, y1) != d) {
            cout << "Yes\n" << x1 << " " << y1;
            return true;
        }
        return false;
    }
    k1 = a1 / a2;
    if (b2 == 0) {
        if (b1 == 0) {
            return false;
        }
        x1 = (b1 * c2 - c1 * b2) / (a1 * b2 - b1 * a2);
        y1 = (c1 * a2 - a1 * c2) / (a1 * b2 - b1 * a2);
        if (point(x1, y1) != a && point(x1, y1) != b && point(x1, y1) != c && point(x1, y1) != d) {
            cout << "Yes\n" << x1 << " " << y1;
            return true;
        }
        return false;
    }
    k2 = b1 / b2;
    if (k1 == k2) {
        return false;
    }
    else {
        x1 = (b1 * c2 - c1 * b2) / (a1 * b2 - b1 * a2);
        y1 = (c1 * a2 - a1 * c2) / (a1 * b2 - b1 * a2);
        if (x1 == int(x1) && y1 == int(y1)) {
            if (point(x1, y1) != a && point(x1, y1) != b && point(x1, y1) != c && point(x1, y1) != d) {
                cout << "Yes\n" << x1 << " " << y1;
                return true;
            }
        }
        return false;
    }
}

int main()
{
    int n;
    cin >> n;
    long long x, y;
    bool flag;
    if (n == 1) {
        cin >> x >> y;
        point a = point(x, y);
        cin >> x >> y;
        point b = point(x, y);
        flag = true;
        long double k;
        for (long long i = 0; i <= 1000 && flag; i++) {
            if (i != a.y && i != b.y) {
                k = (i - a.y) * (b.x - a.x) / (b.y - a.y) + a.x;
                if (k == int(k)) {
                    cout << "Yes\n" << int(k) << " " << i;
                    flag = false;
                }
            }
        }
        if (flag) {
            cout << "No\n";
        }
    }
    else if (n == 2) {
        cin >> x >> y;
        point a = point(x, y);
        cin >> x >> y;
        point b = point(x, y);
        cin >> x >> y;
        point c = point(x, y);
        cin >> x >> y;
        point d = point(x, y);
        flag = true;
        flag = f(a, b, c, d);
        if (!flag) {
            flag = f(a, c, b, d);
            if (!flag) {
                flag = f(a, d, b, c);
                if (!flag) {
                    cout << "No\n";
                }
            }
        }
    }
    else {
        cout << "Yes\n2 2";
    }
    return 0;
}
