#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <time.h>
#include <limits>

using namespace std;

typedef long long ll;
typedef double dl;

vector<vector<ll>> g;
vector<ll> c, used, sz;

ll ans = 0;

void dfs(ll v)
{
	used[v] = 1;

	vector<ll> vs;

	for (int i = 0; i < g[v].size(); ++i)
	{
		ll  to = g[v][i];

		if (used[to] == 0)
		{
			dfs(to);

			sz[v] += sz[to];

			vs.push_back(sz[to]);
		}
	}

	sort(vs.begin(), vs.end());

	ll sum = 0;

	for (int i = 0; i < (ll)vs.size() - 1; ++i)
	{
		sum += vs[i];
	}

	for (int i = 0; i < (ll)vs.size() - 1; ++i)
	{
		ll minn = min(vs[i], vs[i + 1]);

		ans += 2 * minn;

		vs[i] -= minn;
		vs[i + 1] -= minn;
	}

	if (vs.size() > 0 && vs.back() > 0)
	{
		ans += 2 * sum * (vs.back() / sum);

		vs.back() %= sum;

		ans += 2 * vs.back();
	}
}

int main()
{
	//freopen("inputC.txt", "r", stdin);
	//freopen("outputC.txt", "w", stdout);
	ll n;
	cin >> n;

	g.resize(n);
	c.resize(n, 0);
	used.resize(n, 0);
	sz.resize(n, 1);

	for (int i = 1; i < n; ++i)
	{
		ll p;
		cin >> p;
		--p;

		g[i].push_back(p);
		g[p].push_back(i);
	}

	int fl = 0;
	for (int i = 1; i < n; ++i)
	{
		cin >> c[i];

		fl += (c[i] != 1);
	}

	for (int i = 0; i < n; ++i)
	{
		if (!used[i])
		{
			dfs(i);
		}
	}

	if (fl > 0)
		puts("25");
	else
		cout << ans << endl;
	return 0;
}