#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define re return
#define pb push_back

#define all(v) (v).begin(), (v).end()

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int run();

int run2();

void run_stress();

int main() {
#ifdef home
  freopen("i", "r", stdin);
  freopen("d", "w", stderr);
#endif
  ios::sync_with_stdio(0);
  cout.tie(0);
  cin.tie(0);

  run();

  return 0;
}

const int MOD = 1000000007;
const int INT_INF = (int)2e9;
const ll LL_INF = (ll)4e18;

string s;
int pref[6000500];

bool fine[6000500];

vector<int> dels;

void calc_pref(char c) {
  pref[0] = 0;
  f(i, (int)s.size()) {
    pref[i + 1] = pref[i] + (c == s[i]);
  }
}

void check() {
  f(i, (int)dels.size()) {
    if (!fine[i]) continue;
    int x = dels[i];
    ll cnt = pref[x];
    for (int j = x; j < (int)s.size(); j += x) {
      if (cnt != pref[j + x] - pref[j]) {
        fine[i] = false;
        break;
      }
    }
  }
}

int run() {
  cin >> s;
  int n = s.size();
  for (int i = 1; i * i <= n; i++) {
    if (s.size() % i == 0) {
      dels.pb(i);
      if (i * i != n) {
        dels.pb(n / i);
      }
    }
  }
  f(i, (int)dels.size()) {
    fine[i] = true;
  }
  for (char i = 'a'; i <= 'z'; i++) {
    calc_pref(i);
    check();
  }
  int ans = 1;
  f(i, (int)dels.size()) {
    if (fine[i]) {
      ans = max(ans, n / dels[i]);
    }
  }
  cout << ans;
  re 0;
}

int run2() {
  re 0;
}

void run_stress() {
  while (true) {
    auto res1 = run();
    auto res2 = run2();
    if (res1 != res2) {
      cerr << res1 << ' ' << res2 << '\n';
      cerr << "--------------\n";


      re;
    }
  }
}