#include <iostream>
#include <string>
#include <vector>
#include <cstdlib>

using namespace std;

const int MAXN = 5000000 + 50;

int p_sum[26][MAXN];
string s;
int n;

typedef long long ll;

vector <int> d;
int cur = 0;
ll ans = 1;

ll gcd(ll a, ll b) { return (b ? gcd(b, a % b) : a); }

ll lcm(ll a, ll b) { return (a / gcd(a, b) * b); }

void print_ans(int x) {
    cout << n / x << endl;
    exit(0);
}

bool check(int i, int dst) {
    //cout << "check" << dst << endl;
    int x = p_sum[i][dst];
    for (int j = 2 * dst; j <= n; j += dst)
        if (x != p_sum[i][j] - p_sum[i][j - dst]) return false;
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> s; n = s.size();

    for (int i = 1; i <= n; i++)
        if (n % i == 0)
            d.push_back(i);

    for (int i = 0; i < 26; i++)
        p_sum[i][0] = 0;

    for (int j = 0; j < n; j++) {
        for (int i = 0; i < 26; i++)
            p_sum[i][j + 1] = p_sum[i][j];
        p_sum[s[j] - 'a'][j + 1]++;
    }
/*
    for (int i = 0; i < 26; i++) {
        cout << i << " : ";
        for (int j = 0; j <= n; j++)
            cout << p_sum[i][j] << " ";
        cout << endl;
    }
*/
    for (int i = 0; i < 26; i++) {
        while ((cur < d.size()) && (!check(i, d[cur])))
            cur++;
        //cout << cur << endl;
        if (cur == d.size()) print_ans(n);
        //cout << ans << " : " << d[cur] << endl;
        ans = lcm(ans, d[cur]);
        //cout << "!" << ans << " : " << d[cur] << endl;
        if (ans >= n) print_ans(n);
    }
    print_ans(ans);
    return 0;
}
