#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fr first
#define sc second
#define pb push_back
#ifdef TDEF
#define __int128 ll
#endif

const int inf = 1e9 + 88;
const ll infll = 1e18 + 88;
const ld eps = 1e-9;

bool ldeq(ld a, ld b){return fabs(a - b) < eps;}

const int maxn = 2e5 + 88;

int n;
vector<int> gr[maxn];
ll sz[maxn];
ll c[maxn];
bool used[maxn];

void dfs(int v)
{
    if (used[v])
        return;
    used[v] = 1;
    sz[v] = 1;
    for (int i = 0; i < gr[v].size(); i++)
        dfs(gr[v][i]);
    for (int i = 0; i < gr[v].size(); i++)
        sz[v] += sz[gr[v][i]];
}

void solve()
{
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int t;
        cin >> t;
        t--;
        gr[t].pb(i);
    }
    for (int i = 1; i < n; i++)
        cin >> c[i];
    dfs(0);
    ll ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (gr[i].size() > 1)
        {
            vector<ll> tv;
            tv.clear();
            for (ll j = 0; j < gr[i].size(); j++)
            {
                tv.pb(sz[gr[i][j]]);
            }
            sort(tv.begin(), tv.end());
            ll lp = 0;
            ll rp = tv.size() - 1;
            ll cnt = 0;
            while (lp != rp)
            {
                if (tv[lp] < tv[rp])
                {
                    tv[rp] -= tv[lp];
                    cnt += tv[lp];
                    tv[lp] = 0;
                    lp++;
                }
                else
                {
                    tv[lp] -= tv[rp];
                    cnt += tv[rp];
                    tv[rp] = 0;
                    rp--;
                }
            }
            cnt += tv[rp];
            ans += cnt * 2;
        }
    }
    cout << ans;
}

//#define testgen

void testgenv()
{
    int n = rand() % 20 + 1;
    cout << n << endl;
    for (int i = 0; i < n; i++)
    {
        cout << rand() % (i + 1) + 1 << " ";
    }
    cout << endl;
    for (int i = 0; i < n; i++)
        cout << 1 << " ";
}

int main()
{
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef testgen
    freopen("input.txt", "w", stdout);
    testgenv();
    #else
    freopen("input.txt", "r", stdin);
    solve();
    #endif // testgen
    return 0;
}
