#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <iterator>
#include <algorithm>
#include <numeric>
#include <list>
#include <queue>
#include <iomanip>
#define fr first
#define sc second
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

const int maxn = 2*1e5+123; ///!!!
const int inf = 1e9;

ll ans, c[maxn];
int cnt[maxn], n;
vector< vector<int> > g;

void dfs(int v, int pr)
{
    vector<int> t;
    for(int i=0; i<g[v].size(); i++) {
        int to = g[v][i];
        if(to == pr) continue;
        dfs(to, v);
        t.pb(cnt[to]+1);
        cnt[v] += cnt[to]+1;
    }
    sort(t.begin(), t.end());
    reverse(t.begin(), t.end());
    for(int i=0; i<t.size(); i+=2) {
        if(i+1 == t.size()) {
            ans += max(t[i], t[i-1]);
        }
        else ans += max(t[i], t[i+1]);
    }
    t.clear();
}


int main()
{
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n;
    g.resize(n);
    int u;
    for(int i=1; i<n; i++) {
        cin >> u;
        u--;
        g[u].pb(i);
        g[i].pb(u);
    }
    for(int i=1; i<n; i++) {
        cin >> c[i];
    }
    dfs(0, -1);
    cout << 2*ans;
    return 0;
}
