#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

int cnt[31];
int cur1[31], cur2[31];
char s[(int)5e6 + 7];
int  n;

int gcd(int a, int b) {
	while (b) a %= b, swap(a, b);
	return a;
}

bool check(int len) {

	memset(cur1, 0, sizeof(cur1));
	memset(cur2, 0, sizeof(cur2));
	
	int zero1 = 31;
	int zero2 = 31;
	
	for (int i = 0; i < n; i += len) {
		for (int j = i; j < i + len; j++) {
    		if (++cur1[s[n - j - 1] - 'a'] == 1) zero1--;
    		if (i > 0 && --cur2[s[n - j - 1] - 'a'] == 0) zero2++;
    		if (i > 0 && (i + len - j - 1) + zero2 < 31) return 0;
		}	
		swap(zero1, zero2);
		swap(cur1, cur2);
	}
	return true;
}

int main() {
	scanf("%s", s);
	
	n = strlen(s);
	for (int i = 0; i < n; i++) cnt[s[i] - 'a']++;
	
	int t = n;
	for (int i = 0; i < 31; i++) t = gcd(t, cnt[i]);
	
	int ans = 1;
	for (int x = 1; x * x <= t; x++) if (t % x == 0) {
		int len = n / (t / x);
		if (t / x > ans && check(len)) ans = max(ans, t / x);
		
		len = n / x;
		if (x > ans && check(len)) ans = max(ans, x);
	}
	printf("%d\n", ans);
	return 0;
} 