#include <iostream>
#include <vector>

#define MAX(a, b) (((a) > (b)) ? (a): (b))
#define MIN(a, b) (((a) < (b)) ? (a): (b))
#define m_p make_pair
#define m_t make_tuple
#define ft first
#define sd second
#define ll long long
#define ull unsigned long long
#define forn(i, j, n) for(ll i = j; i < n; ++i)
#define forc(i, n, j) for(ll i = n-1; i >= j; --i)
#define forr(i, j, n, d) for(auto i = j; i != n; d)

using namespace std;

vector<vector<long>> g;
vector<bool> used;
vector<ull>  summ;
vector<long> cnt, mini;
vector<long> perf;

ull ans = 0;

void dfs(long v);

int main()
{
	long n;
	cin >> n;

	g.resize(n, vector<long>(0));
	used.resize(n, 0);
	cnt.resize(n, 0); mini.resize(n, 0); summ.resize(n, 0);

	forn(u, 1, n) {
		long a; cin >> a; --a;
		g[a].push_back(u);
	}
	perf.resize(n);

	forn(u, 1, n) {
		cin >> perf[u];
	}
	dfs(0);
	cout << ans << endl;
	cin >> n;

	return 0;
}

void dfs(long v) {
	if (!used[v]) {
		used[v] = true; cnt[v] = 0; summ[v] = 0; mini[v] = perf[v];
		long max_cnt = 0, num_max_cnt = -1, min_zn = 1e9, num_min_zn = -1;
		for (auto u : g[v]) {
			dfs(u);
			summ[v] += summ[u];
			cnt[v] += cnt[u]; mini[v] = MIN(mini[v], mini[u]);
			if (max_cnt < cnt[u]) {
				max_cnt = cnt[u]; num_max_cnt = u;
			}
			if (min_zn > mini[u]) {
				min_zn = mini[u]; num_min_zn = u;
			}
		}
		ans += summ[v];
		if (cnt[v] < 2 * max_cnt) {
			long mi = 1e9;
			for (auto u : g[v]) {
				if (u != num_max_cnt) mi = MIN(mi, mini[u]);
			}
			ans += mi * (2 * max_cnt - cnt[v]);
		} else {
			if (cnt[v] % 2) {
				ans += min_zn;
			}
		}

		++cnt[v]; summ[v] += perf[v];
	}
}