#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second
#define m_p make_pair
#define endl '\n'
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0)

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
/*order_of_key, find_by_order*/

typedef long long ll;
const int MAXN = 1123456;
const int MAXINT = 2146483648;
const ll MAXLL = 9223372035854775808LL;

ll c[MAXN];
vector <pair <int, int> > v[2007];
vector <int> g[MAXN];
bool f[2007][2007];
int have[2007];

void Merge(int V, int to) {
    for (int i = 0; i < v[to].size(); ++i) v[V].push_back(m_p(to, v[to][i].se));
    v[V].push_back(m_p(to, to));

}

void dfs(int v) {
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        dfs(to);
        Merge(v, to);
    }
}

int pos1, pos2;

bool comp(pair <int, int> a, pair <int, int> b) {
    return(have[a.fi] > have[b.fi]);
}

int main()
{
    fast_io;

    int n;

    cin >> n;

    for (int i = 2; i <= n; ++i) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }

    for (int i = 2; i <= n; ++i) cin >> c[i];
    dfs(1);
    ll sum = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) have[j] = 0;
        ll mn = MAXINT, mn1 = MAXINT;
        pos1 = -1, pos2 = -1;
        ll res = 0;

        for (int j = 0; j < v[i].size(); ++j){
            have[v[i][j].fi]++;
            int to = v[i][j].se;
            if (c[to] < mn) mn = c[to], pos1 = v[i][j].fi;
        }

          for (int j = 0; j < v[i].size(); ++j) {
            int to = v[i][j].se;
            if (c[to] >= mn && c[to] <= mn1 && v[i][j].fi != pos1) mn1 = c[to], pos2 = v[i][j].fi;
        }

        sort(v[i].begin(), v[i].end(), comp);

        for (int j = 0; j < v[i].size(); ++j) if (!f[i][j]) {
            int flag = -1;
            for (int j1 = j + 1; j1 < v[i].size(); ++j1) if (!f[i][j1] && v[i][j1].fi != v[i][j].fi) {flag = j1; break;}
            f[i][j] = 1;

            if (flag == -1) {
                res += c[v[i][j].se];
                if (pos1 != v[i][j].fi) res += mn;
                else res += mn1;
            }else {
                f[i][flag] = 1;
                res += c[v[i][j].se];
                res += c[v[i][flag].se];
            }
        }
        sum += res;
    }
    cout << sum << endl;
    return 0;
}
