import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.StringTokenizer;

public class D {

    public String s;

    public int n;

    public Map<Character, Integer> count;

    public int getOrDefault(char key, int defaultValue) {
        Integer val = count.get(key);
        if (val == null)
            return defaultValue;
        else
            return val;
    }

    public void inc(char key) {
        count.put(key, getOrDefault(key, 0) + 1);
    }

    public int get(char key) {
        return getOrDefault(key, 0);
    }

    public boolean check(int lenOfDividing) {
        count.clear();
        int i = 0;
        for (int j = 0; j < n / lenOfDividing; j++) {
            Map<Character, Integer> copy = new HashMap<>(count);
            count.clear();
            for (int k=0; k < lenOfDividing; k++) {
                inc(s.charAt(i++));
            }
            if (j > 0 && !copy.equals(count))
                return false;
        }
        return true;
    }

    public void solve() throws IOException {
        s = br.readLine();
        n = s.length();
        count = new HashMap<>(n, 1f);
        for (int i = 1; i <= n; i++) {
            if (n % i == 0 && check(i)) {
                out.println(n / i);
                return;
            }
        }
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter(System.out);
        solve();
        br.close();
        out.close();
    }

    public String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(br.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public BufferedReader br;
    public PrintWriter out;
    public StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }
}
