#include <bits/stdc++.h>

using namespace std;

string s;
vector< vector<int> > cnt;
int max_char = 0;
	
bool check(int x) {
	for (int i = 1; i < s.size() / x; ++i) {
		for (int j = 0; j < max_char; ++j) {
			if (cnt[(i + 1) * x][j] - cnt[i * x][j] != cnt[x][j]) {
				return false;
			}
		}
	}
	return true;
}

void solve() {
	cin >> s;
	for (char ch : s)
		max_char = max(max_char, (int)ch - 'a');
	cnt.resize(s.size() + 1, vector<int>(max_char));
	for (int i = 0; i < s.size(); ++i) {
		for (int j = 0; j < max_char; ++j)
			cnt[i + 1][j] = cnt[i][j];
		cnt[i + 1][s[i] - 'a']++;
	}
	int ans = 1;
	for (int i = 1; i * i <= s.size(); ++i) {
		if (s.size() % i == 0) {
			if (check(i)) {
				cout << s.size() / i << endl;
				return;
			} else if (check(s.size() / i)) {
				ans = max(ans, i);
			}
		}
	}
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}