#include <bits/stdc++.h>

using namespace std;

vector< vector<int> > g;
vector<int> sz;

long long dfs(int v) {
	sz[v] = 1;
	long long ans = 0;
	int cur_sz = 0;
	for (int to : g[v]) {
		ans += dfs(to);
		sz[v] += sz[to];
	}
	sort(g[v].begin(), g[v].end(), [](int x, int y) {return sz[x] > sz[y];});
	int ptr = int(g[v].size()) - 1;
	for (int i = 0; i < ptr; ++i) {
		int to = g[v][i];
		while (sz[to] > 0) {
			if (ptr <= i) break;
			if (sz[g[v][ptr]] > sz[to]) {
				sz[g[v][ptr]] -= sz[to];
				ans += sz[to] * 2;
				sz[to] = 0;
			} else {
				sz[to] -= sz[g[v][ptr]];
				ans += sz[g[v][ptr]] * 2;
				sz[g[v][ptr]] = 0;
				--ptr;
			}
		}
		ans += sz[to] * 2;
	}
	return ans;
}

void solve() {
	int n;
	cin >> n;
	g.resize(n);
	sz.resize(n);
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		g[p - 1].push_back(i);
	}
	cout << dfs(0) << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}