#include <bits/stdc++.h>

using namespace std;

vector< vector<int> > g;
vector<int> sz;

int dfs(int v) {
	sz[v] = 1;
	int ans = 0;
	int cur_sz = 0;
	for (int to : g[v]) {
		ans += dfs(to);
		sz[v] += sz[to];
	}
	bitset< 2048 > is;
	is[0] = 1;
	for (int to : g[v])
		is |= (is << sz[to]);
	int to_add = 1e9;
	for (int i = 0; i < 2048; ++i) {
		if (is[i]) {
			int s1 = i, s2 = sz[v] - 1 - i;
			to_add = min(to_add, min(s1, s2) * 2 + abs(s1 - s2) * 2);
		}
	} 
	return ans + to_add;
}

void solve() {
	int n;
	cin >> n;
	g.resize(n);
	sz.resize(n);
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		g[p - 1].push_back(i);
	}
	cout << dfs(0) << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}