#include <bits/stdc++.h>

using namespace std;

typedef long double ll;

typedef pair<ll, ll> point;

#define x first
#define y second

ll cp(point a, point b) {
	return a.x * b.y - a.y * b.x;
}

point vect(point a, point b) {
	return point(b.x - a.x, b.y - a.y);
}

point root(point a, point b) {
	ll k = (a.y - b.y) / (a.x - b.x);
	ll bb = a.y - k * a.x;
	return point(k, bb);
}
#undef x
#undef y

void solve() {
	int n = 0;
	cin >> n;
	vector< point > pts(2 * n);
	for (int i = 0; i < pts.size(); ++i)
		cin >> pts[i].first >> pts[i].second;
	
	for (int i = 0; i < 2 * n; ++i) {
		//cout << "AA" << endl;
		for (int j = 0; j < 2 * n; ++j) {
			//cout << "FF" << endl;
			for (int k = 0; k < 2 * n; ++k) {
				//cout << "XX" << endl;
				for (int x = 0; x < 2 * n; ++x) {
					if (k == i || k == j || x == i || x == j) continue;
					//cout << i << " " << j << " " << k << " " << x << endl;
					if (abs(cp(vect(pts[i], pts[j]), vect(pts[x], pts[k]))) < 1e-6) {
						continue;
					}
					point F = root(pts[i], pts[j]), G = root(pts[k], pts[x]);
					ll xc = (G.second - F.second) / (F.first - G.first);
					ll yc = F.first * xc + F.second;
					point center = {xc, yc};
					if (abs(int(xc) - xc) < 1e-6 && abs(int(yc) - yc) < 1e-6 && abs(xc) <= 1e6 + 1e-6 && abs(yc) <= 1e6 + 1e-6) {
						bool test = true;
						center.first = int(center.first);
						center.second = int(center.second);
						for (int z = 0; z < 2 * n; ++z) {
							//cout << "II" << endl;
							if (center == pts[z]) {
								test = false;
								break;
							}
							int cnt = 0;
							for (int h = 0; h < 2 * n; ++h) {
								//cout << "CC" << endl;
								if (z == h) continue;
								if (abs(cp(vect(center, pts[z]), vect(center, pts[h]))) <= 1e-6) {
									cnt++;
								}
							}
							if (cnt != 1) {
								test = false;
								break;
							}
						}
						if (test) {
							//cout << x << " " << k << " " << vect(pts[i], pts[j]).first << " " << vect(pts[i], pts[j]).second << " " << vect(pts[x], pts[k]).first << " " << vect(pts[x], pts[k]).second << " " << cp(vect(pts[i], pts[j]), vect(pts[x], pts[k])) << endl;
							cout << "Yes\n" << int(xc) << " " << int(yc) << endl;
							return;
						}
					}
				}
			}
		}
	}
	cout << "No" << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}