//#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

const int alph = 26;
const int MAXN = (int)5e+6 + 5;
const ll mod1 = 999999751ll;
const ll mod2 = 1000000103ll;
const ll p1 = 999907ll;
const ll p2 = 1000121ll;

ll p1_pows[alph];
ll p2_pows[alph];

ll h1[MAXN], h2[MAXN];

int main()
{
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
	srand(1373737);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	p1_pows[0] = p1;
	p2_pows[0] = p2;
	for (int i = 1; i < alph; i++)
	{
		p1_pows[i] = (p1_pows[i - 1] * p1) % mod1;
		p2_pows[i] = (p2_pows[i - 1] * p2) % mod2;
	}

	string s;
	cin >> s;
	int n = (int)s.size();
	s = '$' + s;

	for (int i = 1; i <= n; i++)
	{
		h1[i] = (h1[i - 1] + p1_pows[s[i] - 'a']) % mod1;
		h2[i] = (h2[i - 1] + p2_pows[s[i] - 'a']) % mod2;
	}

	ll pat1, pat2;
	ll now1, now2;
	for (int d = 1; d <= n; d++)
	{
		if (n % d != 0)
			continue;

		bool flag = true;
		pat1 = h1[d]; pat2 = h2[d];

		for (int i = 2 * d; i <= n; i += d)
		{
			now1 = (h1[i] - h1[i - d] + mod1) % mod1;
			now2 = (h2[i] - h2[i - d] + mod2) % mod2;
			flag &= (now1 == pat1 && now2 == pat2);
			if (!flag)
				break;
		}

		if (flag)
		{
			cout << n / d;
			return 0;
		}
	}

	return 0;
}