#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int main()
{
	ios::sync_with_stdio(0);
	string s;
	cin >> s;
	int n = (int)s.size();
	vector<bool> used(26);
	for (int i = 0; i < n; i++) {
		used[s[i] - 'a'] = 1;
	}
	vector<int> ind(26);
	int sz = 0;
	for (int i = 0; i < 26; i++) {
		if (used[i]) ind[i] = sz++;
	}
	for (int i = 0; i < n; i++) {
		s[i] = ind[s[i] - 'a'] + 'a';
	}
	vector<int> cnt(sz);
	for (int i = 0; i < n; i++) {
		cnt[s[i] - 'a']++;
	}
	vector<int> d;
	for (int i = 1; i <= n; i++) {
		bool f = 1;
		if (n % i != 0) f = 0;
		for (int j = 0; j < sz; j++) {
			if (cnt[j] % (n / i) != 0) f = 0;
		}
		if (f) d.push_back(i);
	}
	vector<int> pr(n + 1);
	vector<bool> ok(d.size(), true);
	for (int z = 0; z < sz; z++) {
		pr[0] = 0;
		for (int i = 0; i < n; i++) {
			if (s[i] == z + 'a') {
				pr[i + 1] = pr[i] + 1;
			}
			else {
				pr[i + 1] = pr[i];
			}
		}
		for (int num = 0; num < (int)d.size(); num++) {
			int div = d[num];
			if (!ok[num]) continue;
			for (int i = 0; i < n; i += div) {
				if (pr[i + div] - pr[i] != cnt[z] / (n / div)) {
					ok[num] = 0;
					break;
				}
			}
		}
	}
	for (int i = 0; i < (int)d.size(); i++) {
		if (ok[i]) {
			cout << n / d[i] << endl;
			break;
		}
	}
	return 0;
}

