#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

vector<vector<int> > g;
vector<vector<ll> > all;
vector<ll> c, sum;
ll ans = 0;
int sz = 0;

void dfs_sz(int u, int p) {
	sum[u] = c[u];
	for (int v : g[u]) {
		if (v != p) {
			dfs_sz(v, u);
			sum[u] += sum[v];
		}
	}
}

bool cmp(int v1, int v2) {
	return all[v1].size() < all[v2].size();
}

int dfs(int u, int p) {
	vector<int> cur_all;
	int ind_mx = -1, mx_v = -1;
	for (int v : g[u]) {
		if (v != p) {
			cur_all.push_back(dfs(v, u));
			if (ind_mx == -1 || !cmp(cur_all.back(), cur_all[ind_mx])) {
				ind_mx = (int)cur_all.size() - 1;
				mx_v = v;
			}
		}
	}
	if (cur_all.empty()) {
		all[sz++].push_back(c[u]);
		return sz - 1;
	}
	int cur_sz = (int)cur_all.size();
	swap(cur_all[0], cur_all[ind_mx]);
	vector<ll> rest;
	for (int i = 1; i < cur_sz; i++) {
		for (ll j : all[cur_all[i]]) {
			rest.push_back(j);
		}
	}
	sort(rest.begin(), rest.end());
	if (all[cur_all[0]].size() > rest.size()) {
		ans += sum[mx_v];
		for (ll i : rest) ans += i;
		ans += rest[0] * (all[cur_all[0]].size() - rest.size());
	}
	else {
		ans += sum[u] - c[u];
		if ((all[cur_all[0]].size() + rest.size()) % 2 == 1) {
			ans += rest[0];
		}
	}
	for (ll i : rest) all[cur_all[0]].push_back(i);
	all[cur_all[0]].push_back(c[u]);
	return cur_all[0];
}

int main()
{
	ios::sync_with_stdio(0);
	int n;
	cin >> n;
	g.resize(n), c.resize(n), sum.resize(n), all.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int x;
		cin >> x;
		g[x - 1].push_back(i + 1);
	}
	for (int i = 0; i < n - 1; i++) {
		cin >> c[i + 1];
	}
	dfs_sz(0, -1);
	dfs(0, -1);
	cout << ans << endl;
    return 0;
}

