#include <iostream>
#include <vector>

using namespace std;

int dfs(vector<int>* graph, int i, int& ans)
{
    int sum = 0;
    int mx = 0;
    for(int j : graph[i])
    {
        int cur = dfs(graph, j, ans);
        sum += cur;
        mx = max(mx, cur);
    }
    if(mx > sum - mx)
        ans += 2 * mx;
    else if(sum % 2)
        ans += sum + 1;
    else
        ans += sum;
    return sum + 1;
}

int main()
{
    int n;
    cin >> n;
    vector<int> graph[n];
    for(int i = 1; i < n; i++)
    {
        int cur;
        cin >> cur;
        graph[cur - 1].push_back(i);
    }
    int ans = 0;
    dfs(graph, 0, ans);
    cout << ans << endl;
    return 0;
}
