#include <iostream>
#include <map>

using namespace std;

struct cmp {
bool operator()(pair<__int128, __int128> a, pair<__int128, __int128> b)
{
    if(a.second < 0)
    {
        a.first *= -1;
        a.second *= -1;
    }
    if(b.second < 0)
    {
        b.first *= -1;
        b.second *= -1;
    }
    return a.first * b.second < b.first * a.second;
}
};

int main()
{
    long long n;
    cin >> n;
    long long xs[2 * n], ys[2 * n];
    for(__int128 i = 0; i < 2 * n; i++)
        cin >> xs[i] >> ys[i];
    for(__int128 a = 0; a < 2 * n; a++)
    for(__int128 b = a + 1; b < 2 * n; b++)
    for(__int128 c = a + 1; c < 2 * n; c++)
    if(c != b)
    for(__int128 d = c + 1; d < 2 * n; d++)
    if(d != b)
    {
        __int128 n1 = ys[a] - ys[b];
        __int128 n2 = xs[b] - xs[a];
        __int128 n3 = n1 * xs[a] + n2 * ys[a];
        __int128 n4 = ys[c] - ys[d];
        __int128 n5 = xs[d] - xs[c];
        __int128 n6 = n4 * xs[c] + n5 * ys[c];
        __int128 det = n1 * n5 - n2 * n4;
        if(det == 0)
            continue;
        swap(n1, n5);
        n2 = -n2;
        n4 = -n4;
        __int128 xnew = n3 * n1 + n6 * n2;
        __int128 ynew = n3 * n4 + n6 * n5;
        if(xnew % det || ynew % det)
            continue;
        xnew /= det;
        ynew /= det;
        if(xnew < -1000000 || xnew > 1000000 || ynew < -10000000 || ynew > 1000000)
            continue;
        map<pair<__int128, __int128>, __int128, cmp> data;
        for(__int128 e = 0; e < 2 * n; e++)
        {
            __int128 dx = xs[e] - xnew;
            __int128 dy = ys[e] - ynew;
            if(dx == 0 && dy == 0)
                goto fail;
            data[make_pair(dx, dy)]++;
        }
        for(const pair<pair<__int128, __int128>, __int128>& it : data)
            if(it.second != 2)
                goto fail;
        cout << "Yes\n" << (long long)xnew << ' ' << (long long)ynew << endl;
        return 0;
    fail:;
    }
    cout << "No\n";
    return 0;
}
