#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector<vector<ll>> g;
vector<ll> num;
vector<ll> sum_ch;
vector<ll> min_ch;
vector<ll> min_ch_sub1;
vector<ll> min_ch_sub2;
vector<ll> tot_ch;
vector<ll> ans_ch;

void calc_values(ll v)
{
    sum_ch[v] = 0ll;
    min_ch[v] = num[v];
    tot_ch[v] = 0ll;
    min_ch_sub1[v] = -1ll;
    min_ch_sub2[v] = -1ll;

    for (ll u : g[v])
    {
        calc_values(u);
        sum_ch[v] += sum_ch[u];
        tot_ch[v] += tot_ch[u];

        if ((min_ch_sub1[v] == -1ll) || (min_ch[u] < min_ch[min_ch_sub1[v]]))
        {
            min_ch_sub2[v] = min_ch_sub1[v];
            min_ch_sub1[v] = u;
        }
        else if ((min_ch_sub2[v] == -1ll) || (min_ch[u] < min_ch[min_ch_sub2[v]]))
            min_ch_sub2[v] = u;
    }

    bool done = false;
    for (ll u : g[v])
    {
        if (tot_ch[u] > (tot_ch[v] - tot_ch[u]))
        {
            if (u == min_ch_sub1[v])
                ans_ch[v] = sum_ch[v] +
                (tot_ch[u] - (tot_ch[v] - tot_ch[u])) * min_ch[min_ch_sub2[v]];
            else
                ans_ch[v] = sum_ch[v] +
                (tot_ch[u] - (tot_ch[v] - tot_ch[u])) * min_ch[min_ch_sub1[v]];

            done = true;
            break;
        }
    }

    if (!done)
    {
        ans_ch[v] = sum_ch[v];
        if (tot_ch[v] % 2ll == 1ll)
            ans_ch[v] += min_ch[min_ch_sub1[v]];
    }

    tot_ch[v]++;
    sum_ch[v] += num[v];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, i;
    cin >> n;

    g.resize(n);
    num.resize(n, 0ll);
    for (i = 0; i < n - 1ll; i++)
    {
        ll a;
        cin >> a;

        g[a - 1ll].push_back(i + 1);
    }

    for (i = 0ll; i < n - 1ll; i++)
        cin >> num[i + 1ll];

    sum_ch.resize(n);
    min_ch.resize(n);
    tot_ch.resize(n);
    min_ch_sub1.resize(n);
    min_ch_sub2.resize(n);
    ans_ch.resize(n);
    calc_values(0ll);

    ll ans = 0ll;
    for (i = 0ll; i < n; i++)
        ans += ans_ch[i];

    cout << ans << endl;

    return 0;
}
