#include <iostream>
#include <iomanip>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <stdio.h>
#include <string>
#include <cstring>
#include <algorithm>
#include <assert.h>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <stack>
#include <fstream>
using namespace std;
using ll = long long;
using ull = unsigned long long;
const int N = 2e5 + 2, oo = 2e9, md = 1e9 + 7, kf = 1e7;
ll ans;
int c[N], cnt[N], snd[N], tree[4 * N], sz = 1, cur_pos, fst[N], mx[N];
ll sum[N];
vector <int> v[N];

void dfs(int cur){
    tree[cur_pos] = c[cur];
    fst[cur] = cur_pos;
    cur_pos++;
    cnt[cur]++;
    sum[cur] += c[cur];
    for (auto x : v[cur]) dfs(x), cnt[cur] += cnt[x], mx[cur] = max(mx[cur], cnt[x]), sum[cur] += sum[x];
    snd[cur] = cur_pos;
    tree[cur_pos] = c[cur];
    cur_pos++;
}

int find_min (int l, int r){
    //cout << l << ' ' << r << endl;
    //l += sz, r += sz;
    int mn = oo;
    while (l <= r){
        if (l & 1) mn = min(mn, tree[l]), l++;
        if (~r & 1) mn = min(mn, tree[r]), r--;
        l /= 2, r /= 2;
    }
    return mn;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(); cout.tie();
    //freopen ("input.txt", 'r', stdin);
    //freopen ("output.txt", 'w', stdout);

    int n;
    ll ans = 0;
    cin >> n;
    while (sz < 2 * n) sz *= 2;
    cur_pos = sz;
    for (int i = 1; i < n; ++i){
        int p;
        cin >> p;
        v[p - 1].push_back(i);
    }
    for (int i = 1; i < n; ++i){
        cin >> c[i];
    }
    dfs(0);
    for (int i = sz + 2 * n; i < 2 * sz; ++i) tree[i] = oo;
    for (int i = sz - 1; i > 0; --i) tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
    for (int i = 0; i < n; ++i){
        int prev = ans;
        ans += sum[i] - c[i];
        int mn = find_min(fst[i] + 1, snd[i] - 1);
        //cout << i << ' ' << mn << endl;
        if (cnt[i] % 2 == 0) ans += mn;
        if (mx[i] > cnt[i] / 2){
            ans += 2 * mx[i] - cnt[i] + 1;
        }
        //cout << i + 1 << ' ' << ans - prev << endl;
        //cout << i << ' ' << cnt[i] << endl << mx[i] << endl;
    }
    if (ans > 70) assert(0);
    cout << ans;

    return 0;
}