#include <iostream>
#include <iomanip>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <stdio.h>
#include <string>
#include <cstring>
#include <algorithm>
#include <assert.h>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <stack>
#include <fstream>
using namespace std;
using ll = long long;
using ull = unsigned long long;
const int N = 5e6 + 2, oo = 2e9, md = 1e9 + 7;
vector <int> del;
bool use[26];
int mas[26][N], let_cnt;

void find_del (int n){
    for (int i = 1; i * i <= n; ++i){
        if (n % i == 0 && i * i == n) del.push_back(i);
        else if (n % i == 0) del.push_back(i), del.push_back(n / i);
    }
}

bool check (string s, int per){
    if (let_cnt > per) return 0;

    //cout << per << endl;
    for (int i = per; i < s.size(); i += per){
        for (int j = 0; j < 26; ++j){
            if (mas[j][i] - mas[j][i - per] != mas[j][i + per] - mas[j][i]) return 0;
        }
    }
    return 1;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(); cout.tie();
    //freopen ("input.txt", 'r', stdin);
    //freopen ("output.txt", 'w', stdout);

    string s;
    cin >> s;
    int sz = s.size();
    for (int j = 0; j < s.size(); ++j) {
        char x = s[j];
        if (!use[x - 'a']) let_cnt++;
        for (int i = 0; i < 26; ++i){
            if (i + 'a' == x) mas[i][j + 1] = mas[i][j] + 1;
            else mas[i][j + 1] = mas[i][j];
        }
        use[x - 'a'] = 1;
    }

    /*for (int i = 0; i < s.size(); ++i){
        cout << mas[0][i] << ' ';
    }
    cout << endl;*/

    //cout << let_cnt << endl;
    find_del(sz);
    sort(del.begin(), del.end());
    for (auto x : del){
        if (check(s, x)){
            cout << sz / x;
            return 0;
        }
    }

    return 0;
}