#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <string>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <ctime>

#define X first
#define Y second
#define pb push_back
#define is insert
#define mp make_pair
#define MEM(x, y) memset(x, y, sizeof(x))
#define pii pair<int, int>
using namespace std;

typedef long long ll;

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	///open-2018-169
	///s9zmhh2j
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}


const int maxn = 200200;
int n;
int p[maxn];
int c[maxn];
int absmin[maxn];
vector<int> e[maxn];
ll ans;
multiset<int> s[maxn];
multiset<int> m;
bool comps(int a, int b) {
	return s[a].size() > s[b].size();
}


/*
		while (u.size() > 1) {
			int i = *u.rbegin();
			u.erase(u.find(i));
			int j = *u.rbegin();
			u.erase(u.find(j));
			ans += 2;
			--i;
			--j;
			if (i > 0)u.insert(i);
			if (j > 0)u.insert(j);
		}
		if(!u.empty())ans += *u.begin() * 2;
		return pw + 1;
*/


bool one = true;
int dfs(int v) {
	set<pii> u;
	for (auto i : e[v]) {
		int uu = dfs(i);
		u.insert(mp(s[uu].size(), uu));
	}
	if (u.empty()) {
		s[v].insert(c[v]);
		absmin[v] = c[v];
		return v;
	}
	int lows = 1000001;
	while (u.size() > 1) {
		pii i = *u.rbegin();
		u.erase(i);
		pii j = *u.rbegin();
		u.erase(j);
		ans += *s[i.second].rbegin() + *s[j.second].rbegin();
		s[v].insert(*s[i.second].rbegin());
		s[v].insert(*s[j.second].rbegin());
		i.first -= 1;
		j.first -= 1;
		s[i.second].erase(s[i.second].find(*s[i.second].rbegin()));
		s[j.second].erase(s[j.second].find(*s[j.second].rbegin()));
		if (i.first > 0)u.insert(i);
		else lows = min(lows, absmin[i.second]);
		if (j.first > 0)u.insert(j);
		else lows = min(lows, absmin[j.second]);
	}
	if (!u.empty()) {
		int i = u.begin()->second;
		ll sum = 0;
		for (auto j : s[i])
			sum += j;
		ans += sum + lows * s[i].size();
	}
	s[v].insert(c[v]);
	absmin[v] = *s[v].begin();
	return v;

}

void solve() {
	cin >> n;
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
		e[p[i]].push_back(i);
	}
	for (int i = 1; i < n; ++i)
		cin >> c[i];
	dfs(0);
	cout << ans << endl;
}