#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>

typedef long long ll;

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    ll n;
    cin >> n;
    if (n > 1e6) {
        return 0;
    }
    vector<ll> a(n + 1);
    for (ll t = n; t > n / 2; --t) {
        ll cr = 2 * t - 1;
        ll i = n - t;
        ll del = 2 * i + 1;
        while (cr > n) {
            cr -= del;
            del *= 2;
        }
        a[cr] = t;
    }
    for (int t = 1; t <= n / 2; ++t) {
        a[t * 2 - 1] = t;
    }
    
    int q;
    cin >> q;
    while (q--) {
        ll cr;
        cin >> cr;
        cout << a[cr] << '\n';
    }


    return 0;
}