#include "bits/stdc++.h"
#define int long long
#define double long double
#pragma GCC optimize("03")
using namespace std;

const int INF = 1e9;
const int MAXN = 2e5 + 100;

int ans = 0;

set<int> fact(int n) {
    set<int> ans;

    for (int i = 1; i <= sqrt(n); ++i) {
        if (n % i == 0) {
            ans.insert(i);
            ans.insert(n / i);
        }
    }
    return ans;
}

bool check(string&s, int sz) {
    vector<int> pat(26);
    for (int i = 0; i < sz; ++i) {
        pat[s[i] - 'a']++;
    }

    vector<int> cur(26);

    for (int i = sz; i < s.size(); ++i) {
        if (cur[s[i] - 'a'] + 1 > pat[s[i] - 'a'] * (i / sz))
            return false;
    }
    return true;
}

signed main() {
    string s;
    cin >> s;
    auto p = fact(s.size());

    for (auto k : p) {
        if (check(s, k)) {
            cout << s.size() / k;
            return 0;
        }
    }
    return 0;
}


