
#include <vector>
#include <iostream>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <math.h>
#include <deque>

using namespace std;

typedef long long ll;


vector<vector<ll>> g;
vector<ll> sz;
vector<ll> cost;
vector<ll> mn;
vector<ll> sum;
vector<bool> been;
vector<ll> indMn;
ll ans = 0;
void dfs(ll id) {
	if (been[id]) {
		return;
	}
	been[id] = true;
	ll size = 1;
	for (ll i = 0; i < g[id].size(); i++) {
		dfs(g[id][i]);
	}
	ll mn1 = 1e18;
	ll mn2 = 1e18;
	ll ind1 = -1;
	ll ind2 = -1;
	ll indId1 = -1;
	ll indId2 = -1;
	sz[id] = 1;
	sum[id] = cost[id];
	mn[id] = 1e9;
	for (ll i = 0; i < g[id].size(); i++) {
		if (mn[g[id][i]] < mn[id]) {
			indMn[id] = indMn[g[id][i]];
			mn[id] = mn[g[id][i]];
		}
		sz[id] += sz[g[id][i]];
		sum[id] += sum[g[id][i]];
		if (mn[g[id][i]] <= mn1) {
			mn2 = mn1;
			ind2 = ind1;
			mn1 = mn[g[id][i]];
			indId2 = indId1;
			indId1 = indMn[g[id][i]];
			ind1 = i;
			continue;
		}
		if (mn[g[id][i]] < mn2) {
			ind2 = i;
			mn2 = mn[g[id][i]];
			indId2 = indMn[g[id][i]];
		}
	}
	if (cost[id] < mn[id]) {
		mn[id] = cost[id];
		indMn[id] = id;
	}
	ll x = 0;
	ll indx = -1;
	vector<pair<ll,ll>> tmp(g[id].size());
	for (ll i = 0; i < g[id].size(); i++) {
		tmp[i].first = sz[g[id][i]];
		tmp[i].second = i;
	}
	vector<pair<ll, ll>> tmp2(g[id].size());
	for (ll i = 0; i < g[id].size(); i++) {
		tmp[i].first = sz[g[id][i]];
		tmp[i].second = -i;
	}
	sort(tmp.begin(), tmp.end());
	ll indx2 = -1;
	ll x2 = 0;
	for (ll i = tmp.size()-1; i >= 0; i--) {
		if (tmp.size() == 0) {
			break;
		}
		if (x2 == 0) {
			x2 = tmp[i].first;
			indx2 = abs(tmp[i].second);
			continue;
		}
		if (x2 < tmp[i].first) {
			x2 = tmp[i].first - x2;
			indx2 = abs(tmp[i].second);
		} else {
			x2 -= tmp[i].first;
		}
	}
	ll din = 0;
	for (ll i = 0; i < g[id].size(); i++) {
		din += sum[g[id][i]];
	}
	if (indx != ind1 || (x == x2 && indx2 != ind1) {
		din += x * mn1;
	} else {
		din += x * mn2;
	}
	ans += din;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	g.resize(n);
	sz.resize(n);
	mn.resize(n);
	been.resize(n);
	sum.resize(n);
	indMn.resize(n);
	cost.resize(n);
	for (ll i = 1; i < n; i++) {
		ll p;
		cin >> p;
		p--;
		g[p].push_back(i);
	}
	for (ll i = 1; i < n; i++) {
		cin >> cost[i];
	}
	dfs(0);
	cout << ans;

	system("pause");
}