//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");

void solve() {
	long long n, q;
	cin >> n >> q;
	vector <int> a(2 * n);
	for (int i = 1; i < a.size(); i+=2) {
		a[i] = i / 2 + 1;
	}
	for (int i = a.size() - 1; i >= 1; i--) {
		for (int j = i; j >= 1; j--) {
			if (a[j] == 0) {
				a[j] = a[i];
				break;
			}
		}
	}
	for (int j = 0; j < q; j++) {
		int query;
		cin >> query;
		cout << a[query] << '\n';
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}