#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>

using namespace std;

bool check(string& s, int k)
{
	vector<int> cnt(26, 0);
	for (int i = 0 ; i < k; i++)
	{
		cnt[s[i] - 'a']++;
	}
	if (s.size() % k)
	{
		assert(0);
	}
	int m = s.size() / k;
	// if (k == 3)
	// {
	// 	for (auto i : cnt)
	// 	{
	// 		cerr << i << " ";
	// 	}
	// }
	// cerr << endl;
	for (int i = 0; i < m; i++)
	{
		vector<int> temp(26, 0);
		for (int j = 0; j < k; j++)
		{
			temp[s[i * k + j] - 'a']++;
		}
		// if (k == 3)
		// {
		// 	for (auto i : temp)
		// 	{
		// 		cerr << i << " ";
		// 	}
		// }
		// cerr << endl << "eof" << endl;
		if (temp != cnt)
		{
			return false;
		}
	}
	return true;
}

int main()
{
	vector<int> need;
	int n = 0;
	string s;
	cin >> s;
	n = s.size();
	for (int i = 1; i * i <= 2 * n; i++)
	{
		if (i <= n && n % i == 0)
		{
			need.push_back(i);
		}
	}
	if (need.back() != n)
	{
		need.push_back(n);
	}
	//reverse(need.begin(), need.end());
	for (int i = 0; i < need.size(); i++)
	{
		if (check(s, need[i]))
		{
			cout << n / need[i] << endl;
			return 0;
		}
	}
}

