//#pragma gcc optimize("Ofast")
//#pragma gcc optimize("unroll-loops")
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <bitset>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cctype>
#include <cmath>
#include <iomanip>
#include <algorithm>

using namespace std;

#define int long long

#define mp make_pair
#define mt make_tuple
#define fr first
#define sc second
#define get0 get<0>
#define get1 get<1>
#define get2 get<2>
#define pb push_back
#define pp pop_back

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tiii;
typedef pair<ll, ll> pll;
typedef tuple<ll, ll, ll> tlll;

const int INF = 1e9 + 7;
const int SZ = 2e5 + 10;
const double EPS = 0.000001;
vector<int> g[SZ];
int c[SZ];
int sm[SZ], sz[SZ], mn[SZ];
int ans = 0;
vector<int> sub[SZ];

void dfs(int v)
{
    sz[v] = 1;
    mn[v] = c[v];
    sm[v] = c[v];
    set<pii> s;
    vector<int> vc;
    for (int u : g[v])
    {
        dfs(u);
        sz[v] += sz[u];
        sm[v] += sm[u];
        ans += sm[u];
        mn[v] = min(mn[v], mn[u]);
        s.insert(mp(sz[u], u));
        vc.pb(sz[u]);
    }
    sort(vc.begin(), vc.end());

    bitset<2001> b1;
    b1[0] = 1;
    for (int u : vc)
    {
        bitset<2001> b;
        for (int i = 0; i <= 2000; i++)
        {
            if (!b1[i]) continue;
            for (int j = 0; j <= min(i, u); j++)
                if ((u - j) + i - j >= 0 && (u - j) + i - j <= 2000)
                    b[(u - j) + i - j] = 1;
        }
        b1 = b;
    }
    int cl = 0;
    while (!b1[cl]) cl++;
    if (vc.size() < 2) return;

    ans += cl;
}


/*
    int i = 0;
    sub[i].clear();
    for (int u : g[v])
    {
        if (sub[u].size() > sub[i].size())
        {
            while (sub[i].size())
            {
                sub[u].pb(sub[i].back());
                sub[i].pp();
            }
            i = u;
        }
        else
        {
            while (sub[u].size())
            {
                sub[i].pb(sub[u].back());
                sub[u].pp();
            }
        }
    }
    sub[i].pb(v);
    while (sub[i].size())
    {
        sub[v].pb(sub[i].back());
        sub[i].pp();
    }
}
*/



int32_t main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //cout.precision(10); cout << fixed;
    int n;
    cin >> n;
    n *= 2;
    vector<pair<ld, ld>> v(n);
    for (int i = 0; i < n; i++)
        cin >> v[i].fr >> v[i].sc;
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            set<int> s = {0, 1, 2, 3};
            s.erase(i); s.erase(j);
            int k = *s.begin();
            s.erase(s.begin());
            int l = *s.begin();
            //cout << i << ' ' << j << ' ' << k << ' ' << l << endl;
            //cout << v[i].fr << ' ' << v[i].sc << ' ' << v[j].fr << ' ' << v[j].sc << endl;
            //cout << v[l].fr << ' ' << v[l].sc << ' ' << v[k].fr << ' ' << v[k].sc << endl;

            ld a1 = v[i].sc - v[j].sc;
            ld b1 = v[j].fr - v[i].fr;
            ld c1 = -a1 * v[i].fr - b1 * v[i].sc;
            //cout << a1 << ' ' << b1 << ' ' << c1 << endl;

            ld a2 = v[k].sc - v[l].sc;
            ld b2 = v[l].fr - v[k].fr;
            ld c2 = -a2 * v[k].fr - b2 * v[k].sc;
            //cout << a2 << ' ' << b2 << ' ' << c2 << endl;

            ld xn = c2 * b1 - c1 * b2;
            ld d = a1 * b2 - a2 * b1;
            ld yn = c1 * a2 - c2 * a1;
            //cout << xn << ' ' << yn << ' ' << d << endl;

            if (fabs(d) > EPS)
            {
                ld x = xn / d;
                ld y = yn / d;
                if ((x == v[0].fr && y == v[0].sc) || (x == v[1].fr && y == v[1].sc) || (x == v[2].fr && y == v[2].sc) || (x == v[3].fr && y == v[3].sc)) continue;
                if (fabs(x) > 1000000 || fabs(y) > 1000000) continue;
                if (fabs(round(x) - x) < EPS && fabs(round(y) - y) < EPS)
                {
                    cout << "Yes" << endl;
                    cout << fabs(x) << ' ' << fabs(y) << endl;return 0;
                }
            }
        }
    }
    cout << "No";
    return 0;
}