#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(),(x).end()
//#define int long long

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> vi;
typedef vector <ll> vll;
typedef vector <pii> vpii;
typedef long double ld;

template <typename T1, typename T2> bool umax(T1 &x, const T2 &y){if(x<y)return x=y,true;else return false;}
template <typename T1, typename T2> bool umin(T1 &x, const T2 &y){if(x>y)return x=y,true;else return false;}

template <typename T>
T getint() {
    T x = 0, p = 1;
    char c = getchar();
    while(c == '\n' || c == ' ')
        c = getchar();
    if(c == '-') p = -1, c = getchar();
    while('0' <= c && c <= '9') {
        x = x*10+c-'0';
        c = getchar();
    }
    return x*p;
}

const int N = (int)1e6+10;
const int mod = (int)1e9+7;
const int INF = (int)2e9+10;
const ll LLINF = (ll)1e18+10;
const ld pi = acos(-1.0);
const ld eps = (ld)1e-5;

int n;
vi g[N];
int c[N];
ll ans[N], sum[N];
int mn[N], sz[N];

void dfs(int v) {
    ans[v] = 0;
    mn[v] = c[v];
    sz[v] = 1;
    sum[v] = c[v];

    int a = INF, b = INF;

    for(auto u: g[v]) {
        dfs(u);
        sz[v] += sz[u];
        ans[v] += ans[u];
        sum[v] += sum[u];
        ans[v] += sum[u];
        umin(mn[v], mn[u]);
        if(a > mn[u]) {b = a; a = mn[u];}
        else if(b > mn[u]) {b = mn[u];}
    }

    int num = 0;
    for(auto u: g[v]) {
        int c = (mn[u]==a?b:a);
        int d = max(0,sz[u]-(sz[v]-1-sz[u]));
        num += sz[u]-d;
        ans[v] += d*c;
    }

    if(num==sz[v]-1 && num%2)
        ans[v] += a;
}

int main()
{
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    n = getint<int>();
    for(int i = 2; i <= n; ++i) {
        int p = getint<int>();
        g[p].pb(i);
    }
    for(int i = 2; i <= n; ++i) {
        c[i] = getint<int>();
    }
    dfs(1);
    printf("%lld\n", ans[1]);
    return 0;
}
