#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>
#include <numeric>
#include <cmath>

using namespace std;

#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back
#define NAP make_pair(-INF, -INF)

typedef long long ll;
typedef long double ld;

template <typename T1, typename T2>
bool mini(T1 &a, const T2 &b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T1, typename T2>
bool maxi(T1 &a, const T2 &b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 2e5 + 123;
const int M = 20;
const int A = 26;
const int MOD = 1e9 + 7;
const ld eps = 1e-5;

int gcd(int a, int b) {
	if (!a)
		return b;
	return gcd(b % a, a);
}

pii intersect(pii a, pii b, pii c, pii d) {
	ld dx1 = b.x - a.x;
	ld dy1 = b.y - a.y;
	ld dx2 = d.x - c.x;
	ld dy2 = d.y - c.y;

	if (!dx1 && !dx2)
		return NAP;
	ld k1 = dy1 / dx1;
	ld k2 = dy2 / dx2;
	if (abs(k1 - k2) < eps)
		return NAP;

	ld a1 = dy1;
	ld b1 = -dx1;
	ld c1 = a.y * dx1 - a.x * dy1;

	ld a2 = dy2;
	ld b2 = -dx2;
	ld c2 = c.y * dx2 - c.x * dy2;

	ld y = (a2 * c1 - a1 * c2) / (a1 * b2 - a2 * b1);
	ld x;
	if (abs(a1) > eps)
		x = -(c1 + b1 * y) / a1;
	else 
		x = x = -(c2 + b2 * y) / a2;

	if (abs(x - roundl(x)) > eps || abs(y - roundl(y)) > eps) {
		return NAP;
	}
	return {(int)roundl(x), (int)(roundl(y))};
}

void run() {

	int n;
	cin >> n;
	/*if (n == 3) {
		cout << "Yes\n2 2";
		return;
	}*/
	vector<pii> pts(2 * n);
	for (int i = 0; i < 2 * n; i++) {
		cin >> pts[i].x >> pts[i].y;
	}

	pii a = pts[0];
	pii b = pts[1];
	pii c = pts[2];
	pii d = pts[3];

	pii tmp;
	if ((tmp = intersect(a, b, c, d)) != NAP) {
		for (int i = 0; i < 2 * n; i++) {
			if (tmp == pts[i])
				goto end1;
		}
		cout << "Yes\n" << tmp.x << ' ' << tmp.y;
		return;
	}
	end1:
	if ((tmp = intersect(a, c, b, d)) != NAP) {
		for (int i = 0; i < 2 * n; i++) {
			if (tmp == pts[i])
				goto end2;
		}
		cout << "Yes\n" << tmp.x << ' ' << tmp.y;
		return;
	}
	end2:
	if ((tmp = intersect(a, d, b, c)) != NAP) {
		for (int i = 0; i < 2 * n; i++) {
			if (tmp == pts[i])
				goto end3;
		}
		cout << "Yes\n" << tmp.x << ' ' << tmp.y;
		return;
	}
	end3:
	cout << "No";

}