#define _CRT_SECURE_NO_WARNINGS
typedef long long ll;
typedef long double ld;
#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<algorithm>
#include<map>
#include<cmath>
#include<math.h>
#include<set>
#include<queue>
#include<deque>
#include<iomanip>
#include<unordered_map>
#include<unordered_set>
#include<bitset>

using namespace std;
ll INF = 1e17;
ld eps = 1e-9;
ll MOD = 1e9 + 7;
ld PI = atan2(0, -1);

vector<vector<ll>>g;
vector<ll>price;
ll ans = 0;

struct str {
	ll sum = 0, cnt = 0, min_el = INF;
	str(ll _sum, ll _cnt, ll _min_el) {
		sum = _sum;
		cnt = _cnt;
		min_el = _min_el;
	}
};

void unite(str &a, str b) {
	a.sum += b.sum;
	a.cnt += b.cnt;
	a.min_el = min(a.min_el, b.min_el);
}

str solve(ll v) {
	str now(0,0,INF);
	str max_cnt(0,0,INF);
	multiset<ll>min_el;
	for (auto to : g[v]) {
		str cur = solve(to);
		unite(now, cur);
		if (cur.cnt > max_cnt.cnt) {
			max_cnt = cur;
		}
		min_el.insert(cur.min_el);
		if (min_el.size() == 3) {
			min_el.erase((--min_el.end()));
		}
	}
	ans += now.sum;

	if (max_cnt.cnt > now.cnt-max_cnt.cnt) {
		if (*min_el.begin() == max_cnt.min_el) {
			min_el.erase(min_el.begin());
		}
		ans += *min_el.begin()* (max_cnt.cnt - (now.cnt - max_cnt.cnt));
	}else if (now.cnt % 2 != 0) {
		ans += now.min_el;
	}
	now.cnt++;
	now.sum += price[v];
	now.min_el = min(now.min_el, price[v]);
	return now;
}

int main() {
	cin.tie(0);
	cin.sync_with_stdio(0);
	cout.tie(0);
	ll n;
	cin >> n;
	g.resize(n + 1);
	price.resize(n + 1);
	ll fl = 1;
	for (ll i = 2; i <= n; i++) {
		ll p;
		cin >> p;
		g[p].push_back(i);
	}
	for (ll i = 2; i <= n; i++) {
		cin >> price[i];
	}
	solve(1);
	cout << ans;



	return 0;
}