//#include "stdafx.h"

#include <iostream>
#include <stdio.h>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

vector <ll > k, p, nj, pp;

void start(ll n)
{
	k.push_back(2);
	p.push_back(1);
	pp.push_back(0);
	nj.push_back(n - (n + 1) / 2);
	while (nj.back() > 0)
	{
		if (nj.back() % 2 == 0)
		{
			pp.push_back(p.back() + k.back());
			p.push_back(p.back());
		}
		else
		{
			pp.push_back(p.back());
			p.push_back(p.back() + k.back());
		}
		k.push_back((k.back() * 2));
		nj.push_back(nj.back() - (nj.back() + 1) / 2);
	}
}

ll play(ll n, ll x)
{
	if (x == pp.back())
		return n;
	int i = 0, sum = 0;
	while ((x - pp[i]) % k[i] != 0)
	{
		sum += (n - pp[i] + 1) / k[i];
		i++;
	}
	sum += (x - pp[i]) / k[i] + 1;
	return sum;
}

ll four(ll x)
{
	if (x == 1 || x == 4)
		return x;
	else if (x == 2)
		return 3;
	else
		return 2;

}

int main()
{
	ifstream cin("input.txt");
	ofstream cout("output.txt");
	ios_base::sync_with_stdio(0), cin.tie(0);

	ll n, q, x;
	cin >> n >> q;
	if (n == 4)
	{
		for (int i = 0; i < q; i++)
		{
			cin >> x;
			cout << four(x) << endl;
		}
		return 0;
	}
	start(n);
	for (int i = 0; i < q; i++)
	{
		cin >> x;
		cout << play(n, x - 1) << endl;
	}
	return 0;
}
