#include <immintrin.h>
#include <bits/stdc++.h>
using namespace std;
#define x first
#define y second
#define int long long
typedef long long ll;
typedef long double ld;
#ifdef SUBIRD
	#define cout cerr
#endif
const int LINF = 2e9, BINF = 9e18, mod = 1e9 + 7, P = 179, Q = 1791791791;
typedef pair<int, int> pt;
const int MAXN = 2600;
pt pts[MAXN];
pt ptsc[MAXN];
int n;
int gcd(int a, int b) {
	a = abs(a);
	b = abs(b);
	if (!a)
		return b;
	else if (!b)
		return a;
	else
		return __gcd(a, b);
}
int place(pt a) {
	if (a.y >= 0 && a.x > 0)
		return 0;
	else if (a.y > 0 && a.x <= 0)
		return 1;
	else if (a.y <= 0 && a.x < 0)
		return 2;
	else
		return 3;
}
pt operator-(pt a, pt b) {
	return {a.x - b.x, a.y - b.y};
}
pt operator+(pt a, pt b) {
	return {a.x + b.x, a.y + b.y};
}
int operator*(pt a, pt b) {
	return a.x * b.y - b.x * a.y;
}
pt md;
bool cmp(pt a, pt b) {
	a = a - md;
	b = b - md;
	int pla = place(a);
	int plb = place(b);
	if (pla != plb)
		return pla < plb;
	else 
		return a * b > 0;
}
bool online(pt a, pt b) {
	return a * b == 0;
}
bool online(pt a, pt b, pt c) {
	return a * b == 0 && b * c == 0;
}
bool check(pt mid) {
	md = mid;
	for (int i = 0; i < n; ++i) {
		if (pts[i] == mid)
			return false;
		ptsc[i] = pts[i];
		if (ptsc[i].y - md.y < 0 || (ptsc[i].y - md.y == 0 && ptsc[i].x - md.x < 0)) {
			ptsc[i] = md - (pts[i] - md);
		}
	}
	sort(ptsc, ptsc + n, cmp);
	/*for (int i = 0; i < n; ++i) {
		cout << ptsc[i].x << " " << ptsc[i].y << "\n";
	}*/
	if (!online(ptsc[0] - md, ptsc[1] - md))
		return false;
	for (int i = 2; i < n; ++i)
		if (online(ptsc[i] - mid, ptsc[i - 1] - mid, ptsc[i - 2] - mid))
			return false;
		else if (i % 2 == 1 && !online(ptsc[i] - md, ptsc[i - 1] - md))
			return false;
	return true;
}
pt operator*(pt p, int x) {
	return {p.x * x, p.y * x};
}
bool in(pt p) {
	return max(abs(p.x), abs(p.y)) <= (int)1e6;
}
const int MAXL = 1e7;
pt nw[MAXL];
pt all[MAXL];
pt nall[MAXL];
int ptr = -1;
void fix(int l) {
	if (ptr == -1) {
		ptr = l;
		for (int i = 0; i < l; ++i)
			all[i] = nw[i];
		sort(all, all + l);
	} else {
		sort(nw, nw + l);
		int p = 0, lp = 0;
		for (int i = 0; i < l; ++i) {
			while (p < ptr && all[p] < nw[i])
				++p;
			if (all[p] == nw[i])
				nall[lp++] = all[p];
		}
		ptr = lp;
		for (int i = 0; i < ptr; ++i)
			all[i] = nall[i];
	}
}
set<pt> used;
signed main() {
	ios_base::sync_with_stdio(false);
	#ifdef SUBIRD
		freopen("B.in", "r", stdin);
	#endif
	
	cin >> n;
	n *= 2;
	for (int i = 0; i < n; ++i)
		cin >> pts[i].x >> pts[i].y;
	mt19937 rnd(234234);
	shuffle(pts, pts + n, rnd);
	for (int i = 0; i < min(3ll, n); ++i) {
		used.clear();
		int ptr = 0;
		for (int j = 0; j < n; ++j) {
			if (i != j) {
				pt vec = pts[j] - pts[i];
				int g = gcd(vec.x, vec.y);
				if (vec.y < 0 || (vec.y == 0 && vec.x < 0))
					vec = vec * -1;
				if (!g) {
					cout << "auvtor pidor(ni ya a avtor zadachi)";
					return 0;
				}
				vec.x /= g;
				vec.y /= g;
				if (used.find(vec) != used.end())
					continue;
				used.insert(vec);
				for (int c = 1; in(pts[i] + vec * c); ++c)
					nw[ptr++] = pts[i] + vec * c;
				for (int c = -1; in(pts[i] + vec * c); --c) 
					nw[ptr++] = pts[i] + vec * c;
			}
		}
		fix(ptr);
	}
	for (int i = 0; i < ptr; ++i)
		if (check(all[i])) {
			cout << "Yes\n";
			cout << all[i].x << " " << all[i].y << "\n";
			return 0;
		}
	cout << "No";
	return 0;
}