#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 30;
const ll INF = 1e16;

vector <int> g[MAXN];

ll c[MAXN];
int n;
ll dp[MAXN];
ll ans[MAXN];
ll sum[MAXN];
ll sz[MAXN];

void dfs(int u)
{
    sum[u] = c[u];
    dp[u] = c[u];
    sz[u] = 1;
    multiset <ll> st;
    for (int v : g[u])
    {
        dfs(v);
        st.insert(dp[v]);
        sz[u] += sz[v];
        dp[u] = min(dp[u], dp[v]);
        ans[u] += ans[v];
        sum[u] += sum[v];
    }

    for (int v : g[u])
    {
        st.erase(st.find(dp[v]));
        ans[u] += sum[v] + sz[v] * (*st.begin());
        st.insert(dp[v]);
    }
    if (!st.empty())
    {
        auto it1 = st.begin();
        ans[u] -= (*it1) + (*(++it1));
    }
}

void dfs2(int u)
{
    sz[u] = 1;
    multiset <int> arr;
    for (int v : g[u])
    {
        dfs2(v);
        sz[u] += sz[v];
        ans[u] += ans[v];
        arr.insert(sz[v]);
    }
    while (arr.size() > 1)
    {
        auto it = --arr.end();
        auto it2 = --it;
        it = --arr.end();
        int x = *it;
        int y = *it2;
        ans[u] += 2 * y;
        arr.erase(arr.find(x));
        arr.erase(arr.find(y));
        if (x - y > 0)
            arr.insert(x - y);
    }
    if (!arr.empty())
        ans[u] += (*arr.begin()) * 2;
}

void solve1()
{
    dfs(1);
    cout << ans[1];
}

void solve2()
{
    dfs2(1);
    cout << ans[1];
}

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);

    cin >> n;
    for (int i = 2; i <= n; i++)
    {
        int p;
        cin >> p;
        g[p].push_back(i);
    }

    bool solve_t = 0;
    for (int i = 2; i <= n; i++)
    {
        cin >> c[i];
        solve_t |= (c[i] != 1);
    }

    if (solve_t)
        solve1();
    else
        solve2();

    return 0;
}

//51
