#include <bits/stdc++.h>

using namespace std;
//F
typedef long long ll;
struct pt
{
	ll x, y;
	pt(ll x_, ll y_): x(x_), y(y_) {}
	pt() {}
	
	pt operator - (pt p)
	{
		return pt(x - p.x, y - p.y);
	}
	ll operator *(pt p)
	{
		return x * p.y - y * p.x;
	}
	
	bool operator == (pt p)
	{
		return x == p.x && y == p.y;
	}
	
};

pt moon;

bool online(pt a, pt b, pt c)
{
	if (a == b || b == c || a == c)
		return false;
	pt ab = b - a;
	ll A = -ab.y;
	ll B = ab.x;
	ll C = -A * a.x - B * a.y;
	return (c.x * A + c.y * B + C == 0);
}

bool check(pt p, vector<pt> &a)
{
	int n = (int)a.size();
	vector<int> used(n);
	for (int i = 0; i < n; i++)
	{
		if (used[i])
			continue;
		used[i] = 1;
		int cnt = 0;
		for (int j = 0; j < n; j++)
		{
			if (used[j])
				continue;
			if (online(p, a[i], a[j]))
			{
				used[j] = 1;
				cnt++;
			}
		}
		if (cnt != 1)
			return false;
	}
	return true;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	//freopen("in.txt", "r", stdin);
	int n;
	cin >> n;
	int m = 2 * n;
	vector<pt> a(m);
	for (int i = 0; i < m; i++)
	{
		cin >> a[i].x >> a[i].y;
	}
	pt s = a[0];
	for (int i = 1; i < m; i++)
	{
		pt q = a[i];
		pt vec = q - s;
		
		ll x = -1000000;
	
		if (q.x == s.x)
		{
			for (ll y = -1000000; y <= 1000000; y++)
			{
				moon = pt(q.x, y);
				if (check(moon, a))
				{
					cout << "Yes\n";
					cout << moon.x << " " << moon.y;
					return 0;
				}
			}
		} else
		for (; x <= 1000000; x++)
		{
			ll A = -vec.y;
			ll B = vec.x;
			ll C = -A * q.x - B * q.y;
			ll y = -(C + A * x) / B;
			moon = pt(x, y);
			if (check(moon, a))
			{
				cout << "Yes\n";
				cout << moon.x << " " << moon.y;
				return 0;
			}
		}		
	}
	cout << "No";
	return 0;
}


