#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <climits>
#include <fstream>

using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");

int kos;

long long sol(long long x, long long k, long long prevk, long long temp) {
    if (x % 2 != 0) {
        return (x + 1) / 2;
    } else {
        if (k % 2 != 0) {
            return sol(k + (x - (prevk - prevk % 2)) / 2, k + temp, k, temp / 2);
        } else {
            return sol(k + (x - (prevk - prevk % 2)) / 2, k + temp, k, temp / 2);
        }
    }
}

int main() {
    long long n, q;
    cin >> n >> q;
    for (int tq = 0; tq < q; tq++) {
        long long x;
        cin >> x;
        kos = 0;
        cout << sol(x, n, 0, n / 2) << "\n";
    }
    return 0;
}