#include <bits/stdc++.h>
#define ll long long
#define null NULL
#pragma GCC optimize("O3")

using namespace std;

const ll MOD = 1e9 + 7;

const int INF = 1e9;
const int K = 26;
const int mx = 5e6 + 20;

int n, cnt[K], pref[mx], rls;
char a[mx];
string s;
vector<int> c1, c2, real_letters;

void build_rl() {
	for (int i = 0; i < K; ++i) {
		if (cnt[i] > 0)
			real_letters.push_back(i);
	}
	rls = real_letters.size();
}

void build_c2() {
	for (int i = 1; i * i <= n; ++i) {
		if (n % i == 0) {
			if (i * i < n) {
				c2.push_back(i);
				c2.push_back(n / i);
			}
			else {
				c2.push_back(i);
			}
		}
	}
}
/*
void build_c2() {
	for (auto x : c1) {
		bool ok = 1;
		for (int i = 0; i < rls; ++i) {
			int l = cnt[real_letters[i]];
			if (l % x != 0) {
				ok = 0;
				break;
			}
		}
		if (ok)
			c2.push_back(x);
	}
}
*/
void build_pref(int ln) {
	//cout << "building pref " << ln << endl;
	for (int j = 1; j <= n; ++j) {
		int up = 0;
		if (a[j - 1] == ln)
			up = 1;
		pref[j] = pref[j - 1] + up;
	}
	/*for (int i = 0; i <= n; ++i) {
		cout << pref[i] << " ";
	}
	cout << endl;*/
}

void check(int ln) {
	vector<int> new_c2;
	for (auto x : c2) {
		//cout << "checking " << x << " with letter " << ln << endl;
		bool ok = 1;
		int block_cnt = n / x;
		int letter_cnt = pref[x];
		//cout << "block_cnt = " << block_cnt << endl;
		//cout << "letter_cnt = " << letter_cnt << endl;
		for (int i = 1; i < block_cnt; ++i) {
			if (pref[(i + 1) * x] - pref[i * x] != letter_cnt) {
				ok = 0;
				break;
			}
		}
		//cout << "ok = " << ok << endl;
		if (ok == 1)
			new_c2.push_back(x);
	}
	c2 = new_c2;
}

int main() {
	cin >> s;
	n = s.length();
	for (int i = 0; i < n; ++i) {
		a[i] = s[i] - 'a';
	}
	for (int i = 0; i < n; ++i) {
		cnt[a[i]]++;
	}
	build_rl();
	//build_c1();
	build_c2();
	/*cout << "c2" << endl;
	for (auto x : c2) {
		cout << x << " ";
	}
	cout << endl;*/
	for (int i = 0; i < rls; ++i) {
		int ln = real_letters[i];
		build_pref(ln);
		check(ln);
	}
	int mn = INF;
	for (auto x : c2) {
		mn = min(mn, x);
	}
	cout << n / mn << endl;
}