import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {
    public class pair implements Comparable<pair> {
        long sum;
        long min;
        int n;

        pair(long a, long b, int c) {
            sum = a;
            min = b;
            n = c;
        }

        public int compareTo(pair p) {
            return Long.compare(p.n, n);
        }
    }

    pair dfs(int v) {
        pair[] x = new pair[q.get(v).size()];
        int b = 0;
        if (q.get(v).size() == 0){
            return new pair(c[v],c[v],1);
        }
        long c1 = 0;
        for (int i = 0; i < q.get(v).size(); i++) {
            x[i] = dfs(q.get(v).get(i));
            c1 += x[i].sum;
            res += x[i].sum;
        }
        Arrays.sort(x);
        long min = Long.MAX_VALUE;
        for (int i = 1; i < q.get(v).size(); i++) {
            b += x[i].n;
            min = Math.min(min,x[i].min);
        }
        int c3 = b + x[0].n + 1;
        long c2 = Math.min(min,x[0].min);
        c1 += c[v];
        c2 = Math.min(c2,c[v]);
        if (b < x[0].n){
            res += min * (x[0].n - b);
        }else {
            b += x[0].n;
            min = Math.min(min,x[0].min);
            if (b % 2 == 1){
                res += min;
            }
        }
        return new pair(c1,c2,c3);
    }

    ArrayList<ArrayList<Integer>> q;
    long res = 0;
    long[] c;

    public void solve() throws IOException {
        int n = nextInt();
        q = new ArrayList<>();
        c = new long[n];
        q.add(new ArrayList<>());
        for (int i = 1; i < n; i++) {
            q.add(new ArrayList<>());
            q.get(nextInt() - 1).add(i);
        }
        for (int i = 1; i < n; i++) {
            c[i] = nextLong();
        }
        dfs(0);
        out.print(res);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
