#ifndef LOCAL
    #pragma GCC optimize("Ofast")
    #pragma GCC target("sse,sse2,sse3,sse4")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#define ll long long
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define F first
#define S second
#define double long double
#define ld double
#define pii pair<int, int>

const int INF = INT_MAX / 2;
const ll LINF = 2e18 + 666, M = 1e9 + 7;
const ld EPS = 1e-10;

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template<class T, class CMP = less<T>>
using ordered_set = tree<T, null_type, CMP, rb_tree_tag, tree_order_statistics_node_update>;

template<class T1, class T2>
bool mini(T1 &x, T2 y)
{
    if (x > y)
    {
        x = y;
        return 1;
    }
    return 0;
}

template<class T1, class T2>
bool maxi(T1 &x, T2 y)
{
    if (x < y)
    {
        x = y;
        return 1;
    }
    return 0;
}

void run();

int main()
{
    srand(time(0));
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(15) << fixed;
    auto start = clock();
    run();
    #ifdef LOCAL
        cout << "\ntime = " << (ld)(clock() - start) / CLOCKS_PER_SEC;
    #endif
}

#define DEBUG
#if defined DEBUG && defined LOCAL
    #define debugdo(x) x
#else
    #define debugdo(x)
#endif
#define debug(x) debugdo(cout << x << endl);
#define debug2(x) debugdo(cout << x << " ");

// ---SOLUTION--- //

int pr[] = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101};

ll pw(ll x, ll y)
{
    if (!y)
        return 1;
    if (y & 1)
        return x * pw(x, y ^ 1) % M;
    ll t = pw(x, y >> 1);
    return t * t % M;
}

void run()
{
    string s;
    cin >> s;
    vector<int> cnt(26);
    for (auto x: s)
        cnt[x - 'a']++;
    vector<ll> h(s.size() + 1);
    h[0] = 1;
    for (int i = 0; i < (int)s.size(); i++)
    {
        h[i + 1] = (h[i] * pr[s[i] - 'a']) % M;
    }
    vector<int> dv, vars;
    int x = s.size();
    int j = 1;
    while (j * j <= x)
    {
        if (x % j == 0)
        {
            vars.pb(j);
            vars.pb(x / j);
        }
        j++;
    }
    sort(all(vars));
    for (int i = 0; i < 26; i++)
    {
        dv.clear();
        int x = cnt[i];
        if (!x)
            continue;
        int j = 1;
        while (j * j <= x)
        {
            if (x % j == 0)
            {
                dv.pb(j);
                dv.pb(x / j);
            }
            j++;
        }
        sort(all(dv));
        vars.resize(set_intersection(all(vars), all(dv), vars.begin()) - vars.begin());
    }
    for (auto &x: vars)
        x = s.size() / x;
    // len > -> <
    int ans = s.size();
    vector<char> g(vars.size());
    for (int i = 0; i < (int)vars.size(); i++)
    {
        int x = vars[i];
        bool f = 1;
        for (int j = 0; j < i && f; j++)
        {
            if (vars[j] % vars[i] == 0 && !g[j])
                f = 0;
        }
        debug(x << "!");
        ll hh = h[x];
        for (int i = x + x; i <= (int)s.size() && f; i += x)
        {
            debug(h[i] * pw(h[i - x], M - 2) % M);
            if (h[i] * pw(h[i - x], M - 2) % M != hh)
                f = 0;
        }
        g[i] = f;
        if (f)
        {
            ans = x;
        }
    }
    cout << s.size() / ans;
}
/*
abbabbbab
*/
