#include <iostream>
#include <vector>

using ll = long long;

std::vector< std::vector<int>> cnt;
std::vector<int> d;

void divs(int n) {
    int i = 1;
    while(i * i <= n) {
        if (n % i == 0) {
            d.push_back(i);
            d.push_back(n / i);
        }
        ++i;
    }
}

int get(char c, int i, int j) {
    return (cnt[c - 'a'][j] - (i == 0 ? 0 : cnt[c - 'a'][i - 1]));
}

int main() {
    std::string s;
    std::cin >> s;
    int n = s.size();
    int l = 1;
    int r = n;
    cnt.resize(26, std::vector<short> (n));
    for (int i = 0; i < n; ++i) {
        for (char c = 'a'; c <= 'z'; ++c) {
            if (i == 0) {
                break;
            }
            cnt[c - 'a'][i] = cnt[c - 'a'][i - 1];
        }
        cnt[s[i] - 'a'][i]++;
    }
    divs(n);
    int m = -1e7;
    for (int i = 0; i < d.size(); ++i) {
        int k = 0;
        bool f = 1;
        for (int j = 0; j < d[i] - 1; ++j) {
            int t = n / d[i];
            for (char c = 'a'; c <= 'z'; ++c) {
                //std::cout << c << " " << k << " " << k + 3 - 1 << " " << get(c, k, k + 3 - 1) << " " << k + 3 << " " << k + 2 * 3 - 1 << " " << get(c, k + 3, k + 2 * 3 - 1) << "\n";
                if (get(c, k, k + t - 1) != get(c, k + t, k + 2 * t - 1)) {
                    f = 0;
                    break;
                }
            }
            if (!f) {
                break;
            }
            k += t;
        }
        if (f) {
            m = std::max(m, d[i]);
        }
    }
    std::cout << m;
    return 0;
}
