#include <iostream>
#include <algorithm>

using namespace std;

int n, q;

int check(int x)
{
    int delta = (n - x) * 2;
    x = x * 2 - 1;
    while (delta < x - 1) {
        x -= delta + 1;
        delta = delta * 2 + 1;
    }
    return x;
}

int find_x(int ind)
{
    if (ind & 1)
        return (ind + 1) / 2;
    int x = (ind + 2) / 2;
    while (check(x) != ind)
        x = rand() % n + 1;
    return x;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> q;
    for (int i = 0; i < q; i++) {
        int a;
        cin >> a;
        cout << find_x(a) << "\n";
    }
    return 0;
}
