#include <iostream>

using namespace std;

const int SZ_OF_ALPHA = 30;
const int SZ = 2e5 + 10;

int n;
int cnt[SZ_OF_ALPHA][SZ];
int need[SZ_OF_ALPHA];
string s;

bool check(int x)
{
    for (int j = 0; j < SZ_OF_ALPHA; j++)
        need[j] = cnt[j][x - 1];
    for (int i = x * 2 - 1; i < n; i += x) {
        for (int j = 0; j < SZ_OF_ALPHA; j++) {
            if (need[j] != cnt[j][i] - cnt[j][i - x])
                return false;
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> s;
    n = s.size();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < SZ_OF_ALPHA; j++)
            cnt[j][i] = cnt[j][i - 1];
        cnt[s[i] - 'a'][i]++;
    }
    int res = n;
    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            if (check(i))
                res = min(res, i);
            if (check(n / i))
                res = min(res, n / i);
        }
    }
    cout << n / res;
    return 0;
}
