#include <iostream>
#include <map>

using namespace std;

const int SZ_OF_ALPHA = 3;
const int SZ = 5e6 + 10;

int n;
int cnt[SZ_OF_ALPHA][SZ];
int need[SZ_OF_ALPHA];
string s;

map<char, int> mp;
map<char, int> need_mp;

bool check(int x)
{
    need_mp.clear();
    for (int i = 0; i < x; i++)
        need_mp[s[i]]++;
    mp.clear();
    for (int i = x; i < n; i++) {
        if (i % x == 0 && i != x) {
            for (auto h : mp) {
                if (h.second != need_mp[h.first])
                    return false;
            }
            mp.clear();
        }
        mp[s[i]]++;
    }
    for (auto h : mp) {
        if (h.second != need_mp[h.first])
            return false;
    }
    mp.clear();
    return true;
}

bool check_20(int x)
{
    for (int j = 0; j < SZ_OF_ALPHA; j++)
        need[j] = cnt[j][x - 1];
    for (int i = x * 2 - 1; i < n; i += x) {
        for (int j = 0; j < SZ_OF_ALPHA; j++) {
            if (need[j] != cnt[j][i] - cnt[j][i - x])
                return false;
        }
    }
    return true;
}

void action_for_20()
{
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < SZ_OF_ALPHA; j++)
            cnt[j][i] = cnt[j][i - 1];
        cnt[s[i] - 'a'][i]++;
    }
    int res = n;
    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            if (check_20(i))
                res = min(res, i);
            if (check_20(n / i))
                res = min(res, n / i);
        }
    }
    cout << n / res;
}

void action_for_51()
{
    int res = n;
    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            if (check(i))
                res = min(res, i);
            if (check(n / i))
                res = min(res, n / i);
        }
    }
    cout << n / res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> s;
    n = s.size();
    for (int i = 0; i < n; i++) {
        if (s[i] != 'a' && s[i] != 'b') {
            action_for_51();
            return 0;
        }
    }
    action_for_20();
    return 0;
}
