#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const int SZ = 2e5 + 10;

int n;
int p[SZ];
int c[SZ];
vector<int> graph[SZ];

int size_of[SZ];
//int min_val[SZ];
int sum[SZ];
int res[SZ];

void dfs(int v)
{
    //min_val[v] = c[v];
    int max_son = 0;
    for (int to : graph[v]) {
        dfs(to);
        //min_val[v] = min(min_val[v], min_val[to]);
        sum[v] += sum[to];
        size_of[v] += size_of[to];
        if (max_son == 0 || size_of[to] > size_of[max_son])
            max_son = to;
    }
    res[v] = sum[v];
    if (size_of[max_son] * 2 > size_of[v])
        res[v] += size_of[max_son] * 2 - size_of[v];
    size_of[v]++;
    sum[v] += c[v];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (ll i = 2; i <= n; i++) {
        cin >> p[i];
        graph[p[i]].push_back(i);
    }
    for (ll i = 2; i <= n; i++)
        cin >> c[i];
    dfs(1);
    int ans = 0;
    for (int i = 1; i <= n; i++)
        ans += res[i];
    cout << ans;
    return 0;
}
