#include <iostream>

using namespace std;

typedef long long ll;

ll n, q;

ll find_x(ll ind)
{
    ll on_left = ind - 1;
    ll on_right = n - ind;
    while (~ind & 1) {
        on_right += on_left / 2;
        ind += on_right + 1;
        on_left = on_right;
        on_right = 0;
    }
    return (ind + 1) / 2;
}

ll check(ll x)
{
    ll delta = (n - x) * 2;
    x = x * 2 - 1;
    while (delta < x - 1) {
        x -= delta + 1;
        delta = delta * 2 + 1;
    }
    return x;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> q;
    for (ll i = 0; i < q; i++) {
        ll a;
        cin >> a;
        if (check(n) == a)
            cout << n << "\n";
        else
            cout << find_x(a) << "\n";
    }
    return 0;
}
