#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 5e5 + 10;

int cnt[26][maxn];

bool check(string s, int sz) {
    int need[26] = {};
    for (int i = 0; i < sz; ++i) {
        need[s[i] - 'a']++;
    }
    int l = 0;
    while (l < s.size()) {
        int r = l + sz - 1;
        int cur[26] = {};
        for (int i = l; i <= r; ++i) {
            cur[s[i] - 'a']++;
        }
        for (int i = 0; i < 26; ++i) {
            if (cur[i] != need[i])
                return false;
        }
        l = r + 1;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    string s;
    cin >> s;
    int n = (int)s.size();
    for (int i = 0; i < n; ++i) {
        cnt[s[i] - 'a'][i + 1]++;
        for (int j = 0; j < 26; ++j)
            cnt[j][i + 1] += cnt[i][j];
    }
    int ans = 1;
    for (int i = 1; i <= n; ++i) if (n % i == 0) {
        if (check(s, i)) {
            ans = n / i;
            break;
        }
    }
    cout << ans;
    return 0;
}
/*
abbabbbab
aabb
*/
