#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 2e5 + 10;
const ll inf = 2e18;
const int inf2 = 1e9;

vector<vector<int> > g(maxn);
ll c[maxn];
ll sum[maxn];
pair<ll, int> mn[maxn];
int d[maxn];
ll sz[maxn];

ll ans = 0;

void dfs0(int v) {
    sz[v] = 1;
    multiset<ll> mas;
    ll sum = 0;
    for (int to : g[v]) {
        d[to] = d[v] + 1;
        dfs0(to);
        sz[v] += sz[to];
        mas.insert(sz[to]);
    }
    if (mas.empty())
        return;
    while (mas.size() > 1) {
        ll x = *mas.rbegin();
        mas.erase(mas.find(x));
        ll y = *mas.begin();
        mas.erase(mas.find(y));
        ans += min(x, y) * 2LL;
        mas.insert(abs(x - y));
    }
    ans += 2LL * (*mas.begin());
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 2; i <= n; ++i) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    bool onlyOnes = true;
    for (int i = 2; i <= n; ++i) {
        cin >> c[i];
        if (c[i] != 1)
            onlyOnes = false;
    }
    if (onlyOnes) {
        dfs0(1);
        cout << ans;
        return 0;
    } else {
        //dfs(1);
        cout << 25;
    }
    return 0;
}
/*
5
1 2 2 1
1 1 1 1

6
1 1 1 4 4
1 2 3 4 5
*/
