#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <set>
#include <iterator>
#include <map>
#include <stack>
#define pb push_back
#define ppb pop_back
#define mp make_pair
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
int const MAXN = 10;
int const INF = 1e9;
int const MOD = 1000000007;

using namespace std;

    ll n, x, y, A, B, C;
    vector <pair <ll, ll> > v;

    bool prov (ll moonx, ll moony){
        map <pair <ll, ll>, int> mw;
        map <pair <ll, ll>, int> :: iterator it;
        for (int i=0; i<n; i++){
            if (moonx==v[i].first && moony==v[i].second)
                return false;
            ll a=moony-v[i].second;
            ll b=v[i].first-moonx;
            ll nod=__gcd(a, b);
            mw[mp(a/nod, b/nod)]++;
            //mw[mp(a*(-1), b*(-1))]++;
        }
        for (it=mw.begin(); it!=mw.end(); it++){
            int kol=it->second;
            if (kol!=2)
                return false;
        }
        return true;
    }

int main()
{
    ifstream cin ("input.txt");
    ofstream cout ("output.txt");
    ios_base::sync_with_stdio(0);

    cin >> n;
    n*=2;
        for (int i=0; i<n; i++){
            cin >> x >> y;
            v.pb(mp(x, y));
        }
    for (int i=1; i<n; i++){
        A=v[0].second-v[i].second;
        B=v[i].first-v[0].first;
        C=-A*v[0].first-B*v[0].second;
        if (B!=0){
            for (ll moonx=-MAXN; moonx<MAXN; moonx++){
                if ((A*moonx+C)%(-B)==0){
                    ll moony=(A*moonx+C)/(-B);
                    if (prov(moonx, moony)){
                        cout << "Yes" << endl;
                        cout << moonx << " " << moony;
                        return 0;
                    }
                }
            }
        }
        else{
            for (ll moony=-MAXN; moony<MAXN; moony++){
                if ((B*moony+C)%(-A)==0){
                    ll moonx=(B*moony+C)/(-A);
                    if (prov(moonx, moony)){
                        cout << "Yes" << endl;
                        cout << moonx << " " << moony;
                        return 0;
                    }
                }
            }
        }
    }
    cout << "No";
    return 0;
}
