#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <random>
#include <ctime>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 500100, ALF = 26;
int n;
string s;
int sl[MAXN][ALF], tec[ALF];
bool f;

bool chek(int v, int sh)
{
	if (sl[n - 1][v] == 0)
		return true;
	if (tec[v] == 0)
		return false;
	if ((sl[n - 1][v] % tec[v] == 0)
		&& (sl[n - 1][v] / tec[v] == n / sh))
		return true;
	return false;
}

bool cok(int sh)
{
	for (int i = sh; i < n; i += sh)
	{
		for (int j = 0; j < ALF; j++)
		{
			if (sl[i + sh - 1][j] - sl[i - 1][j] != tec[j])
				return false;
		}
	}
	return true;
}

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin >> s;
	n = s.size();
	for (int i = 0; i < n; i++)
	{
		if (i)
		{
			for (int j = 0; j < ALF; j++)
			{
				sl[i][j] = sl[i - 1][j];
			}
		}
		sl[i][s[i] - 'a']++;
	}
	for (int i = 0; i < n; i++)
	{
		tec[s[i] - 'a']++;
		f = true;
		if (n % (i + 1) != 0)
			continue;
		for (int j = 0; j < ALF; j++)
		{
			if (!chek(j, i + 1))
			{
				f = false;
				break;
			}
		}
		if (!f)
			continue;
		if (cok(i + 1))
		{
			cout << n / (i + 1);
			return 0;
		}
	}
    return 0;
}