#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll INF = 1e9 + 7;
const ll MAXN = 1e6 + 7;
const double EPS = 1e-6;

vector <ll> w;
vector <vector <ll> > gr;
vector <ll> sum, sz;

ll res = 0;

void dfs(ll v, ll &minw) {
    //cout << v << " " << gr[v].size() << "\n";
    sum[v] = 0;
    sz[v] = 0;
    ll minw1 = INF, minw2 = INF;
    ll p1 = -1, p2 = -1;
    ll max_sz = -1;
    ll pmax = -1;
    for (ll u : gr[v]) {
        ll minu;
        dfs(u, minu);
        if (minu < minw1) {
            p2 = p1;
            minw2 = minw1;
            minw1 = minu;
            p1 = u;
        } else if (minu < minw2) {
            minw2 = minu;
            p2 = u;
        }
        sum[v] += sum[u];
        sz[v] += sz[u];
        if (sz[u] > max_sz) {
            max_sz = sz[u];
            pmax = u;
        }
    }
    if (gr[v].size()) {
        if (max_sz <= sz[v] - max_sz) {
            res += sum[v];
            if (sz[v] % 2) {
                res += minw1;
            }
        } else {
            res += sum[v];
            ll ost = 2 * max_sz - sz[v];
            if (pmax == p1) {
                res += ost * minw2;
            } else {
                res += ost * minw1;
            }
        }
    }
    minw = min(minw1, w[v]);
    sum[v] += w[v];
    sz[v]++;
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    ll n;
    cin >> n;
    w.resize(n, 0);
    gr.resize(n);
    sz.resize(n, 0);
    sum.resize(n, 0);
    for (ll i = 1; i < n; i++) {
        ll p;
        cin >> p;
        p--;
        gr[p].push_back(i);
    }
    for (ll i = 1; i < n; i++) {
        cin >> w[i];
    }
    ll minw = INF;
    dfs(0, minw);
    cout << res;
}
