#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umax(T1& x, const T2& y) {return x<y ? x=y, true : false;}

template <typename T1, typename T2>
bool umin(T1& x, const T2& y) {return x>y ? x=y, true : false;}

template <typename T>
void read(T& x) {
    char ch;
    T p = 1; x = 0;
    do {ch = getchar();} while (ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10+ch-'0';
        ch = getchar();
    }
    x = (p == -1 ? -x : x);
}

void read(char &ch) {
    do {ch = getchar();} while (ch <= ' ');
}

void read(string& x) {
    char ch; x = "";
    do {ch = getchar();} while (ch <= ' ');
    while(ch > ' ') x += ch, ch = getchar();
}

template<typename T, typename... R>
void read(T& x, R&... y) {read(x); read(y...);}

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

const int N = (int)1e6+3;
const int INF = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


int n, q;
int a[N];


int main()
{
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    read(n, q);
    set<int> free;
    set<int> used;
    rep(i, 1, n+1) a[2*i-1] = i;
    rep(i, 1, n+1) used.insert(i*2-1);
    rep(i, 1, 2*n) {
        if (a[i] == 0) free.insert(i);
    }
//    cout << free.size() << endl;
    while (!free.empty()) {
        int p = *prev(used.end());
        int p2 = *prev(free.end());
//        cout << p << ' ' << p2 << endl;
//        cout << a[p] << ' ' << a[p2] << endl;
        swap(a[p], a[p2]);
        used.insert(p2);
        used.erase(p);
        free.erase(p2);
    }
    while (q --> 0) {
        int x;
        read(x);
        printf("%d\n", a[x]);
    }

    return 0;
}
