#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umax(T1& x, const T2& y) {return x<y ? x=y, true : false;}

template <typename T1, typename T2>
bool umin(T1& x, const T2& y) {return x>y ? x=y, true : false;}

template <typename T>
void read(T& x) {
    char ch;
    T p = 1; x = 0;
    do {ch = getchar();} while (ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10+ch-'0';
        ch = getchar();
    }
    x = (p == -1 ? -x : x);
}

void read(char &ch) {
    do {ch = getchar();} while (ch <= ' ');
}

void read(string& x) {
    char ch; x = "";
    do {ch = getchar();} while (ch <= ' ');
    while(ch > ' ') x += ch, ch = getchar();
}

template<typename T, typename... R>
void read(T& x, R&... y) {read(x); read(y...);}

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef long double ld;

const int N = (int)5e6+1;
const int M = (int)4e5+3;
const int INF = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


int n, q;
string s;
int pr[27];
int cur[27];
int ptr[N];
int pref[M][27];


const int SmallLength = 300;


bool checkSmall(int len) {
    rep(i, 0, 26) pr[i] = cur[i] = 0;
    rep(i, 0, len) pr[s[i]-'a']++;
    for(int pos = len+len-1; pos < n; pos += len) {
        rep(i, 0, 26) cur[i] = 0;
        rep(i, pos-len+1, pos+1) cur[s[i]-'a']++;
        rep(i, 0, 26) if (cur[i] != pr[i]) return false;
    }
    return true;
}

bool check(int len) {
    if (n%len != 0) return false;
    if (len <= SmallLength) return checkSmall(len);
    for(int pos = len+len-1; pos < n; pos += len) {
        rep(i, 0, 26) {
//            assert(pref[])
            if (pref[ptr[len-1]][i] != pref[ptr[pos]][i]-pref[ptr[pos-len]][i]) return false;
        }
    }
    return true;
}

int main()
{
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    read(s);
    n = s.length();
    memset(ptr, -1, sizeof(ptr));
    int last = 0;
    rep(i, SmallLength, n/2+1) {
        if (n % i != 0) continue;
        for(int d = i-1; d < n; d += i) {
            if (ptr[d] == -1) ptr[d] = last++;
        }
    }
    rep(i, 0, n) {
        cur[s[i]-'a'] += 1;
        if (ptr[i] != -1) {
            rep(j, 0, 26) pref[ptr[i]][j] = cur[j];
        }
    }
    rep(len, 1, n/2+1) {
        if (check(len)) {
            printf("%d\n", n/len);
            return 0;
        }
    }
    printf("%d\n", 1);

    return 0;
}
