#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define sz(a) int(a.size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int N = 1e6 + 9;
const int M = 1e3 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;

string s;
vector <int> cnt, t;

bool check(int k) {
    fill(cnt.begin(), cnt.end(), 0);
    forn(i, k) ++cnt[s[i] - 'a'];
    for (int i = k; i < sz(s); i += k) {
        t = cnt;
        for (int j = i; j < i + k; ++j)
            --t[s[j] - 'a'];
        forn(j, 26) if (t[j]) return 0;
    }
    return 1;
}

int main()
{
    ios::sync_with_stdio(0);
    cnt.resize(26);
    int ans = 1;
    cin >> s;
    int k = sz(s);
    for (int i = 1; i <= sqrt(k); ++i) {
        if (k % i == 0) {
            if (check(i)) ans = max(ans, k / i);
            if (check(k / i)) ans = max(ans, i);
        }
    }
    cout << ans << endl;
    return 0;
}
