#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#define FOR(i, n) for (int i = 0; i < n; ++i)

int main() {
	std::ios::sync_with_stdio(false);
	std::string s;
	std::cin >> s;
	std::vector<int> divisors;
	int n = s.size();
	for (long long i = 1; i * i <= s.size(); ++i) {
		if (n % i == 0) {
			divisors.push_back(i);
			divisors.push_back(n / i);
		}
	}
	std::sort(divisors.rbegin(), divisors.rend());
	int l = 0, r = divisors.size();
	while (r - l > 1) {
		int tm = (l + r) / 2;
		std::vector<int> cnt(26);

		FOR(i, divisors[tm]) {
			cnt[s[i] - 'a']++;
		}
		bool fl = false;
		for (int i = 0; i < s.size(); i += divisors[tm]) {
			std::vector<int> cnt2(26);
			for (int j = i; j < i + divisors[tm]; ++j) {
				cnt2[s[j] - 'a']++;
			}
			FOR(q, 26) {
				if (cnt[q] != cnt2[q]) {
					fl = true;
					break;
				}
			}
		}
		if (fl) {
			r = tm;
		}
		else {
			l = tm;
		}
	}
	std::cout << n / divisors[l];
}