#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#define FOR(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;

int main() {
	std::ios::sync_with_stdio(false);
	std::string s;
	std::cin >> s;
	std::vector<ll> divisors;
	ll n = s.size();
	for (ll i = 1; i * i <= n; ++i) {
		if (n % i == 0) {
			divisors.push_back(i);
			if (n / i != i)
				divisors.push_back(n / i);
		}
	}
	std::sort(divisors.begin(), divisors.end());
	FOR(i, divisors.size()) {
		std::vector<int> cnt(26);
		FOR(j, divisors[i]) {
			cnt[s[j] - 'a']++;
		}
		bool fl = true;
		for (int q = 0; q < n; q += divisors[i]) {
			std::vector<int> cnt2(26);
			for (int j = q; j < q + divisors[i]; ++j) {
				cnt2[s[j] - 'a']++;
			}
			FOR(z, 26) {
				if (cnt2[z] != cnt[z]) {
					fl = false;
					break;
				}
			}
			if (!fl) {
				break;
			}
		}
		if (fl) {
			std::cout << n / divisors[i];
			return 0;
		}
	}
	std::cout << 1;
	return 0;
}