#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#define FOR(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;
const int MAXN = 5e5;
int pref[MAXN + 10][26];
int pref2[(int)5e6][2];

int main() {
	std::ios::sync_with_stdio(false);
	std::string s;
	std::cin >> s;
	std::vector<ll> divisors;
	ll n = s.size();
	if (n > MAXN) {
		FOR(i, s.size()) {
			pref2[i][s[i] - 'a']++;
			FOR(j, 2) {
				if (i != 0) {
					pref2[i][j] += pref2[i - 1][j];
				}
			}
		}
	}
	else {
		FOR(i, s.size()) {
			pref[i][s[i] - 'a']++;
			if (i != 0)
				FOR(j, 26) {
				pref[i][j] += pref[i - 1][j];
			}
		}
	}
	for (ll i = 1; i * i <= n; ++i) {
		if (n % i == 0) {
			divisors.push_back(i);
			if (n / i != i)
				divisors.push_back(n / i);
		}
	}
	std::sort(divisors.begin(), divisors.end());
	FOR(i, divisors.size()) {
		std::vector<int> cnt(26);
		FOR(j, divisors[i]) {
			cnt[s[j] - 'a']++;
		}
		bool fl = true;
		for (int q = 0; q < n; q += divisors[i]) {
			if (n > MAXN) {
				FOR(z, 2) {
					if (q == 0) {
						if (pref2[q + divisors[i] - 1][z] != cnt[z]) {
							fl = false;
							break;
						}
					} else {
						if (pref2[q + divisors[i] - 1][z] - pref2[q - 1][z] != cnt[z]) {
							fl = false;
							break;
						}
					}
				}
				if (!fl) {
					break;
				}
			}
			else {
				FOR(z, 26) {
					if (q == 0) {
						if (pref[q + divisors[i] - 1][z] != cnt[z]) {
							fl = false;
							break;
						}
					} else {
						if (pref[q + divisors[i] - 1][z] - pref[q - 1][z] != cnt[z]) {
							fl = false;
							break;
						}
					}
				}
				if (!fl) {
					break;
				}
			}
		}
		if (fl) {
			std::cout << n / divisors[i];
			return 0;
		}
	}
	std::cout << 1;
	return 0;
}