#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int MAXN = 300007;

int n, a[MAXN], p[MAXN], c[MAXN], d[MAXN], d2[MAXN];

vector <int> g[MAXN];

void dfs(int s){
    d[s] = 1;
    for (int i = 0; i < g[s].size(); i++){
        int to = g[s][i];
        dfs(to);
        d[s] += d[to];
    }
}

multiset <int> cp;

void solve(int s){
    d2[s] = 0;
    cp.clear();
    for (int i = 0; i < g[s].size(); i++){
        int to = g[s][i];
        solve(to);
        d2[s] += d2[to];
        cp.insert(d[to]);
    }
    while (cp.size() > 1){
        int r = *cp.rbegin();
        int l = *cp.begin();
        cp.erase(cp.find(l));
        cp.erase(cp.find(r));
        d2[s] += 2;
        l--;
        if (l > 0){
            cp.insert(l);
        }
        r--;
        if (r > 0){
            cp.insert(r);
        }
    }
    d2[s] += (*cp.begin()) * 2;
}

int main() {
    cin >> n;
    for (int i = 2; i <= n; i++){
        cin  >> p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 2; i <= n; i++){
        cin >> c[i];
    }
    dfs(1);
    solve(1);
    cout << d2[1] * 2;
    return 0;
}