#include <iostream>
#include <vector>

using namespace std;

struct line
{
    long double a, b, c; //b = 1
};

const int SIZE = 1000;
int points[SIZE][2], n;
line lines[SIZE][SIZE], curr_line;
bool check;
long double ans_p[2], cross_p;

bool check_corr(int p, vector<bool> checked)
{
    bool all_checked = 1, ans = 0;
    long double cross[2];

    checked[p] = 1;
    for (int i = 0; i < 2 * n; i++)
        if (!checked[i])
        {
            cross[0] = (lines[p][i].c - curr_line.c) / (curr_line .a - lines[p][i].a);
            cross[1] = -curr_line .c - curr_line.a * cross[0];
            if (cross[0] != ans_p[0] || cross[1] != ans_p[1])
                continue;
            ans |= check_corr(i, checked);
            all_checked = 0;
        }
    if (all_checked)
        return 1;
}

int main()
{
    cin >> n;
    if (n > 5)
        return 0;
    if (n == 3)
    {
        cout << "Yes" << endl << 2 << ' ' << 2;
        return 0;
    }
    for (int i = 0; i < 2 * n; i++)
        cin >> points[i][0] >> points[i][1];
    for (int i = 0; i < 2 * n; i++)
        for (int j = 0; j < 2 * n; j++)
        {
            if (i == j)
                continue;
            if (points[i][0] == points[j][0])
            {
                lines[i][j].b = 0;
                lines[i][j].a = 1;
                lines[i][j].c = -points[i][0];
                continue;
            }
            lines[i][j].a = (points[j][1] - points[i][1]) / (points[i][0] - points[j][0]);
            lines[i][j].c = -(points[i][0] * lines[i][j].a + points[i][1]);
        }
    
    for (int i = 0; i < 2 * n; i++)
        for (int j = 0; j < 2 * n; j++)
            for (int i2 = 0; i2 < 2 * n; i2++)
                for (int j2 = 0; j2 < 2 * n; j2++)
                {
                    if (i == j || j == i2 || i2 == j2 || i == i2 || i == j2 || j == j2)
                        continue;
                    curr_line = lines[i][j];
                    ans_p[0] = (lines[i2][j2].c - lines[i][j].c) / (lines[i][j].a - lines[i2][j2].a);
                    ans_p[1] = -lines[i][j].c - lines[i][j].a * ans_p[0];
                    if (ans_p[0] != int(ans_p[0]) || ans_p[1] != int(ans_p[1]))
                        continue;
                    check = 1;
                    for (int k = 0; k < 2 * n; k++)
                        if (ans_p[0] == points[k][0] && ans_p[1] == points[k][1])
                        {
                            check = 0;
                            break;
                        }
                    if (!check)
                        continue;
                    cout << "Yes" << endl;
                    cout << ans_p[0] << ' ' << ans_p[1];
                    return 0;
                }
    cout << "No";
}