// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define len(v) ((int)v.size())
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return false;
	}
	return true;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return false;
	}
	return true;
}

void run();

int main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

void run()
{
	string s;
	cin >> s;
	int n = len(s);
	vector<vector<int>> pref(26, vector<int>(n + 1, 0));
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < 26; ++j)
			pref[j][i + 1] = pref[j][i];
		++pref[s[i] - 'a'][i + 1];
	}
	vector<int> must_be(26);
	for (int i = 0; i < 26; ++i)
		must_be[i] = pref[i].back();
	int k = n;
	for (int i = 1; i < n; ++i)
	{
		if (n % i != 0)
			continue;
		int seg_amnt = n / i;
		bool good = true;
		for (int j = 0; j < 26; ++j)
			if (must_be[j] % seg_amnt != 0)
			{
				good = false;
				break;
			}
		if (!good)
			continue;
		for (int j = 0; j < 26; ++j)
			must_be[j] /= seg_amnt;
		for (int j = 0; j < n && good; j += i)
			for (int k = 0; k < 26; ++k)
				if (pref[k][j + i] - pref[k][j] != must_be[k])
				{
					good = false;
					break;
				}
		for (int j = 0; j < 26; ++j)
			must_be[j] *= seg_amnt;
		if (good)
		{
			k = i;
			break;
		}
	}
	cout << n / k << endl;
}