// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define len(v) ((int)v.size())
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return false;
	}
	return true;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return false;
	}
	return true;
}

void run();

int main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

int pr[] = {37482003, 39402861, 93092695, 
86116639, 42442035, 12347613, 26953693, 
37817323, 78992581, 53240001, 10770271, 
65157739, 52547151, 45671149, 25095909, 
87840969, 68049565, 21604831, 41869549, 
35402449, 77974449, 70152001, 88818499, 
72512745, 22498399, 97338675};

void run()
{
	int mod = 1e9 + 7;
	string s;
	cin >> s;
	int n = len(s);
	vector<int> cnt(26, 0);
	for (auto &x : s)
		++cnt[x - 'a'];
	vector<int> pref(n + 1, 0);
	for (int i = 0; i < n; ++i)
		pref[i + 1] = (pref[i] + pr[s[i] - 'a']) % mod;
	int l = n;
	for (int i = 1; i < n; ++i)
	{
		if (n % i)
			continue;
		int k = n / i;
		int hash = 0;
		bool good = true;
		for (int j = 0; j < 26; ++j)
			if (cnt[j] % k)
			{
				good = false;
				break;
			}
		if (!good)
			continue;
		for (int j = 0; j < 26; ++j)
			hash = (1LL * hash + 1LL * pr[j] * (cnt[j] / k)) % mod;
		for (int j = 0; j < n; j += i)
			if (pref[j + i] - pref[j] != hash)
			{
				good = false;
				break;
			}
		if (!good)
			continue;
		l = i;
		break;
	}
	cout << n / l << endl;
}