#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int solve();

int main() {
    ios_base::sync_with_stdio(0);
#ifdef home
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // home
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

int cnt[256];
string s;
const int MOD = 1e9 + 7;
int N = 26;
int ncnt[30], ncnt1[30];

bool go(int x) {
    int n = s.size();

    int X = x;
    x = n / x;

    int H = 0;

    fill(ncnt, ncnt + N, 0);
    for (int i = 0; i < x; i++) {
        H = (H + s[i] * s[i]) % MOD;
        ncnt[s[i] - 'a']++;
    }

    for (int i = 0; i < N; i++) {
        if (ncnt[i] != (cnt[i] / X)) return false;
    }

    for (int i = 0; i < n / x; i++) {
        int h = 0;
        for (int j = i * x; j < (i + 1) * x; j++) {
           h = (h + s[j] * s[j]) % MOD;
        }
        if (H != h) return false;
    }

    cout << n / x;
    return true;
}

int solve() {
    cin >> s;

    int n = s.size();

    if (n > 5e5) N = 2;
    for (int i = 0; i < n; i++) cnt[s[i] - 'a']++;

    int x = 0;
    for (char c = 0; c < N; c++) {
        if (x == 0 && cnt[c] != 0) x = cnt[c];
        if (cnt[c] != 0) x = __gcd(x, cnt[c]);
    }

    vector<int> v;
    for (int i = 1; i <= sqrt(x); i++) if (x % i == 0) v.push_back(i);

    for (int i = 0; i < v.size(); i++) {
        if (go(x / v[i])) return 0;
    }

    for (int i = v.size() - 1; i >= 1; i--) {
        if (go(v[i])) return 0;
    }
    cout << 1;
    return 0;
}




