#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}

const int MAXN = (int)2e5 + 10;
const int INF = 1e9;

vector<int> g[MAXN];
ll c[MAXN];
ll dp[MAXN];
ll sz[MAXN];
ll sum[MAXN];
ll mn[MAXN];

void dfs(int v)
{
    sum[v] = 0;
    mn[v] = INF;
    sz[v] = 1;
    for (int i = 0; i < g[v].size(); i++)
    {
        dfs(g[v][i]);
        sum[v] += sum[g[v][i]];
        sz[v] += sz[g[v][i]];
        dp[v] += dp[g[v][i]];
        mn[v] = min(mn[v], mn[g[v][i]]);
    }
    int ind = -1;
    if (sz[v] % 2 == 0)
        dp[v] += mn[v];
    int x = (sz[v] + 1) % 2;
    for (int i = 0; i < (int)g[v].size(); i++)
        if ((2 * sz[g[v][i]] - x) > sz[v])
        {
            ind = i;
            break;
        }
    mn[v] = min(mn[v], c[v]);
    dp[v] += sum[v];
    sum[v] += c[v];
    if (ind == -1)
    {
        return;
    }
    ll mini = INF;
    for (int i = 0; i < (int)g[v].size(); i++)
        if (i != ind)
            mini = min(mini, mn[g[v][i]]);
    if (mini != INF)
        dp[v] += (2ll * sz[g[v][ind]] - sz[v] + 1 - x) * 1ll * mini;
}

int solve()
{
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++)
    {
        int x;
        cin >> x;
        g[x].pb(i);
    }
    for (int i = 2; i <= n; i++)
        cin >> c[i];
    dfs(1);
    cout << dp[1] << endl;
}
