#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}

struct line
{
    ll A, B, C;
    line(ll A = 0, ll B = 0, ll C = 0): A(A), B(B), C(C){}
    line(pii a, pii b)
    {
        A = a.Y - b.Y;
        B = b.X - a.X;
        C = a.Y * (a.X - b.X) - a.X * (a.Y - b.Y);
    }
};

const int MAXN = 6000;

pii a[MAXN];

int solve()
{
    int n;
    cin >> n;
    for (int i = 0; i < 2 * n; i++)
        cin >> a[i].X >> a[i].Y;
    for (int i = 0; i < 2 * n; i++)
        for (int j = 0; j < 2 * n; j++)
            for (int k = 0; k < 2 * n; k++)
                for (int l = 0; l < 2 * n; l++)
                {
                    if (i == j || i == k || i == l)
                        continue;
                    if (j == k || j == l)
                        continue;
                    if (k == l)
                        continue;
                    pii M = a[i];
                    pii N = a[j];
                    pii P = a[k];
                    pii Q = a[l];
                    line MN = line(M, N);
                    line PQ = line(P, Q);
                    ll a1 = MN.A, a2 = PQ.A, b1 = MN.B, b2 = PQ.B, c1 = MN.C, c2 = PQ.C;
                    if (a1 * b2 - a2 * b1 == 0)
                        continue;
                    if ((b1 * c2 - b2 * c1) % (a1 * b2 - a2 * b1) != 0)
                        continue;
                    ll x = (b1 * c2 - b2 * c1) / (a1 * b2 - a2 * b1);
                    ll b = b1;
                    if (b == 0)
                        b = b2;
                    if (b == 0)
                        continue;
                    if ((a1 * x + c1) % b != 0)
                        continue;
                    ll y = (a1 * x + c1) / b;
                    pii Moon = mp(x, -y);
                    bool f = true;
                    for (int u = 0; u < 2 * n; u++)
                    {
                        line cur = line(Moon, a[u]);
                        int cnt = 0;
                        for (int v = 0; v < 2 * n; v++)
                        {
                            if (a[v].X * cur.A + a[v].Y * cur.B + cur.C == 0)
                                cnt++;
                        }
                        if (cnt != 2)
                        {
                            f = false;
                            break;
                        }
                    }
                    if (f)
                    {
                        cout << "Yes" << endl;
                        cout << Moon.X << " " << Moon.Y << endl;
                        return 0;
                    }
                }
    cout << "No" << endl;
}

