#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define null NULL
#define ld long double
#define left left228
#define right right228
#define index index228
#define prev prev228
#define int long long



const int N = 228, INF = 1e9 + 228;


template<typename T> inline void chkmin(T &x, T y) {
	if (y < x) x = y;
}

template<typename T> inline void chkmax(T &x, T y) {
	if (y > x) x = y;
}





struct point
{
	int x, y;
	point() {}
	point(int _x, int _y) {
		x = _x;
		y = _y;
	}
};



point operator+(point a, point b) {
	return point(a.x + b.x, a.y + b.y);
}


point operator-(point a, point b) {
	return point(a.x - b.x, a.y - b.y);
}


int operator*(point a, point b) {
	return a.x * b.y - a.y * b.x;
}


int operator%(point a, point b) {
	return a.x * b.x + a.y * b.y;
}



struct line
{
	int a, b, c;
	line() {}
	line(int _a, int _b, int _c) {
		a = _a;
		b = _b;
		c = _c;
	}
	int get(int x, int y) {
        return a * x + b * y + c;
	}
};


inline line Get_line(point P0, point P1) {
	int A = P0.y - P1.y;
	int B = P1.x - P0.x;
	int C = P0.x * P1.y - P1.x * P0.y;
	return line(A, B, C);
}


int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}


point intersect(line l1, line l2) {
	int a1 = l1.a, b1 = l1.b, c1 = l1.c;
	int a2 = l2.a, b2 = l2.b, c2 = l2.c;
	if (a2 * b1 == a1 * b2) {
        return point(-INF, -INF);
	}
	if (b2 == 0 || a1 - a2 * b1 / b2 == 0) {
        int y = (c2 * a1 / a2 - c1) / (b1 - b2 * a1 / a2);
        int x;
        if (a1 != 0) {
        	x = -(b1 * y + c1) / a1;
        } else {
        	x = -(b2 * y + c2) / a2;
        }
        if (l1.get(x, y) != 0 || l2.get(x, y) != 0) {
            return point(-INF, -INF);
        }
        return point(x, y);
	}
	int x = (c2 * b1 / b2 - c1) / (a1 - a2 * b1 / b2);
    int y;
    if (b1 != 0) {
        y = (-a1 * x - c1) / b1;
    } else {
        y = (c2 * a1 / a2 - c1) / (b1 - b2 * a1 / a2);
    }
    if (l1.get(x, y) != 0 || l2.get(x, y) != 0) {
            return point(-INF, -INF);
        }

	return point(x, y);
}



point p[N];


inline void read(point &po) {
	cin >> po.x >> po.y;
}


inline void solve() {
    line L1 = Get_line(point(0, 0), point(0, 1));
    line L2 = Get_line(point(1, 1), point(1, 2));
	int n;
	cin >> n;
	if (n == 3) {
        cout << "Yes\n 2 2\n";
        return ;
	}

	for (int i = 1; i <= 2 * n; ++i) {
		read(p[i]);
	}
	if (n == 1) {
        point P = p[1] + (p[2] - p[1]) + (p[2] - p[1]);
        cout << "Yes\n";
        cout << P.x << " " << P.y << endl;
        return ;
	}
	for (int sec = 2; sec <= 2 * n; ++sec) {
		// line 1 -> sec
		line l1 = Get_line(p[1], p[sec]);
		vector<bool> used(2 * n + 1);
		used[1] = used[sec] = true;
		vector< point > kek;
		for (int i = 2; i <= 2 * n; ++i) {
			if (!used[i]) {
				kek.push_back(p[i]);
			}
		}
		line l2 = Get_line(kek[0], kek[1]);
		point P = intersect(l1, l2);
		bool equa = false;
		for (int i = 1; i <= 2 * n; ++i) {
            if (P.x == p[i].x && P.y == p[i].y) {
                equa = true;
                break;
            }
		}
		if (P.x != -INF && !equa && P.x >= -1000000 && P.x <= 1000000 && P.y >= -1000000 && P.y <= 1000000) {
			puts("Yes");
			cout << P.x << " " << P.y << endl;
			return ;
		}
	}
	puts("No");
}


signed main() {
	//freopen("input.txt", "r", stdin);
    //ios_base::sync_with_stdio(false);
    solve();
    return 0;
}
