#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define lp(i,s,e) for(int i = s;i<e;++i)
#define lpi(i,s,e) for(int i = s;i<=e;++i)
typedef pair<int,int> pii;
#define ff first
#define ss second
#define mp(a,b) make_pair(a,b)
#define pb(a) push_back(a)



struct node
{
    int val,sum,y,size;
    node *l,*r;
    node(int val):val(val),sum(val),y(rand()),size(1),l(0),r(0){};
};

typedef node* pnode;

int size(pnode cur)
{
    if(!cur) return 0;
    return cur->size;
}
int sum(pnode cur)
{
    if(!cur) return 0;
    return cur->sum;
}
void upd(pnode cur)
{
    if(!cur) return;
    cur->size = size(cur->l) + 1 + size(cur->r);
    cur->sum = sum(cur->l) + cur->val + sum(cur->r);
}


pnode merge(pnode l,pnode r)
{
    if(!l) return r;
    if(!r) return l;
    if(l->y > r->y){
        l->r = merge(l->r,r);
        upd(l);
        return l;
    }else{
        r->l = merge(l,r->l);
        upd(r);
        return r;
    }
}

void split(pnode cur,int s,pnode& l,pnode& r)
{
    if(!cur){l = r = 0;return;}
    if(size(cur->l) >= s){
        r = cur;
        split(r->l,s,l,r->l);
        upd(r);
        upd(l);
    }else{
        l = cur;
        split(l->r,s-size(cur->l) - 1,l->r,r);
        upd(l);
        upd(r);
    }

}
ll mod;
ll solve(ll n,ll x)
{
    if(x%2 == 1) return (x+1)/2;
    x/=2;
    mod = n/2;
    if(n%2 == 0){
        return n/2 + solve(mod,x);
    }else{
        if(x == 1) return (n+1)/2 + solve(mod,mod);
        return (n+1)/2 + solve(mod,x-1);
    }
}

int main()
{
    //freopen("input.txt","r",stdin);
    //cin.tie(0);
    ios_base::sync_with_stdio(0);
    ll n;
    int q;
    cin>>n>>q;
    while(q--){
        ll x;
        cin>>x;
        cout<<solve(n,x)<<'\n';
    }
    return 0;
}
