// ConsoleApplication3.cpp: определяет точку входа для консольного приложения.
//

#include <cmath>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <string>

#define mp make_pair
#define x first
#define y second
#define sqr(a) ((a) * (a))

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef string str;

const ll INF = 1e15;
const ll N = 2e5 + 10;

inline void start();
inline void stop();

ll dataa[N], proz[32];

int main()
{
	start();

	proz[0] = 1;
	for (int i = 1; i < 32; i++)
		proz[i] = proz[i - 1] * 2;

	ll n, q, a;

	cin >> n >> q;

	for (int i = 1; i <= n; i++)
	{
		if (i <= (n + 1) / 2)
		{
			dataa[2 * i - 2] = i;
			continue;
		}
		ll step = 2 * n - 2 * i + 1;
		int j = 31;
		while (proz[j] * step >= 2 * n)
			j--;
		dataa[2 * n - 1 - proz[j] * step] = i;
		//cout << dataa[2 * n - 1 - proz[j] * step] << ' ' << 2 * n - 1 - proz[j] * step << ' ' << proz[j] << endl;
	}

	for (int i = 0; i < q; i++)
	{
		cin >> a;
		cout << dataa[a - 1] << endl;
	}

	stop();
    return 0;
}

inline void start()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

inline void stop()
{
	//system("pause");
}