#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("a.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

void $main(ll testId) {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    queue<int> q;
    q.push(n-1);
    for (int i = n - 2; i > -1; --i) {
        //hole
        q.push(q.front());
        q.pop();
        //new element
        q.push(i);

    }
    for (int i = n - 1; i > -1; --i) {
        a[i] = q.front();
        q.pop();
    }
    for (int i = 0; i < m; ++i) {
        int x;
         cin >> x;
         --x;
        cout << a[x] + 1 << "\n";
    }
}
