#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("d.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

void $main(ll testId) {
#define int ll
    string s;

    cin >> s;
    int n = s.size();
    vector<vector<int>> m(26, vector<int>(n+1));
    for (char c = 'a'; c <= 'z'; ++c) {
        for (int i = 0; i < n; ++i) {
            m[c - 'a'][i+1] = m[c-'a'][i];
            if (c == s[i]) ++m[c-'a'][i+1];
        }
    }

    for (int c = 0; c < 26; ++c) {
        vector<int> t = m[c];
        for (int i = 0; i <=n; ++i) {
            m[c][i] += t[(n+1) -i - 1];
        }
        //int iMax = (n-1)/2+1;
        //for (int i = 0; i <= iMax; ++i) {
        //    int j = n - i;
        //    ll sum = m[c][i] + m[c][j];
        //    m[c][i] = m[c][j] =sum;
        //}
    }

    for (int k = n; k > 0; --k) {
        if (n % k != 0) continue;
        int l = n / k;
        bool ok = true;
        for (int c = 0; c < 26; ++c) {
            if (!ok) break;
            int expected = m[c][l];
            for (int i = 0; i < k; ++i) {
                int p2 = l * (i+1);
                int act = m[c][p2];
                if (act != expected) {
                    ok = false;
                    break;
                }
            }
        }
        if (ok) {
            cout << k << endl;
            return;
        }
    }
}
