#include <bits/stdc++.h>

#define pii pair<int, int>
#define f first
#define s second
#define ll long long
#define pll pair<ll, ll>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define sz(a) int(a.size())
#define output(a) for (auto el : a) cout << el << ' '; cout << '\n';

using namespace std;

const int MAXN = 300;

vector<int> divs(int n) {
    vector<int> ans;
    int i = 1;
    while (i * i <= n) {
        if (n % i == 0) {
            ans.emplace_back(i);
            if (i != n / i) {
                ans.emplace_back(n / i);
            }
        }
        ++i;
    }
    sort(rall(ans));
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    string s;
    cin >> s;
    int n = sz(s);
    vector<int> d = divs(n);
    bitset<MAXN> cur;
    for (int i = 0; i < MAXN; ++i) {
        cur[i] = 1;
    }
    for (int i = 0; i < 26; ++i) {
        bitset<MAXN> tmp;
        vector<int> sm(n + 1);
        for (int k = 1; k <= n; ++k) {
            sm[k] = sm[k - 1] + (s[k - 1] == char(i + 'a') ? 1 : 0);
        }
        //cout << i << '\n';
        //output(sm);
        for (int i = 0; i < sz(d); ++i) {
            bool ok = 1;
            const int psz = n / d[i];
            const int c = sm[psz] - sm[0];
            //cout << i << ' ' << d[i] << ' ' << c << '\n';
            for (int j = 2 * psz; j <= n; j += psz) {
                if (sm[j] - sm[j - psz] != c) {
                    //cout << j << ' ' << sm[j] - sm[j - psz] << '\n';
                    ok = 0;
                    break;
                }
            }
            if (ok) {
                tmp[i] = 1;
            }
        }
        cur &= tmp;
    }
    for (int i = 0; i < MAXN; ++i) {
        if (cur[i]) {
            cout << d[i];
            break;
        }
    }
    return 0;
}
