#include <bits/stdc++.h>
using namespace std;

const int alp = 26;

string s;
vector<int> a(alp);

vector<int> diviser(int x)
{
    if(x == 0)
        return {0};
    vector<int> ans;
    for(int i = 1; i <= sqrt(x); i++)
    {
        if(x % i == 0)
        {
            ans.push_back(i);
            if(x / i != i)
                ans.push_back(x / i);
        }
    }
    return ans;
}

vector<unordered_map<int, int>> pref;

int check(const vector<int> &used, const int len)
{
    if(alp > len)
    {
        vector<int> was(alp);
        vector<bool> need(alp);
        bool right = 1;
        int t = 0;
        for(int i = 0; i < alp; i++)
            t += used[i] == 0;
        int k = t, ans = 0;
        for(int j = 0; j < s.length(); j++)
        {
            int i = s[j] - 'a';
            if(need[i] == right)
            {
                need[i] = !need[i];
                was[i] = 0;
            }
            was[i]++;
            if(was[i] == used[i])
                k++;
            if(was[i] > used[i])
                return 1;
            if(k == alp)
            {
                right = !right;
                ans++;
                k = t;
                if((j + 1) % len != 0)
                    return 1;
            }
            else if((j + 1) % len == 0)
                return 1;
        }
        return ans;
    }
    for(int i = len - 1, k = 1; i < s.length(); i +=len, k++)
    {
        for(int j = 0; j < alp; j++)
            if(used[j] * k != pref[i][j])
                return 1;
    }
    return s.length() / len;
}

int start()
{
    int ind = 0;
    while(ind + 1 < s.length() && s[ind + 1] == s[ind])
        ind++;
    return ind + 1;
}

int finish()
{
    int ind = s.length() - 1;
    while(ind > 0 && s[ind - 1] == s[ind])
        ind++;
    return s.length() - ind;
}

int gcd(int x, int y)
{
    while(x && y)
    {
        if(x < y)
            swap(x, y);
        x %= y;
    }
    return x + y;
}

int main()
{

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> s;
    for(char c : s)
        a[c - 'a']++;
    pref = vector<unordered_map<int, int>>(s.length());
    for(int i = 0; i < s.length(); i++)
    {
        if(i > 0)
            pref[i] = pref[i - 1];
        pref[i][s[i] - 'a']++;
    }
    int g = 0;
    for(int i = 0; i < alp; i++)
        g = gcd(g, a[i]);
    int all = 0;
    for(int i = 0; i < alp; i++)
        all += a[i] > 0;
    if(all == 1)
    {
        cout << s.length();
        exit(0);
    }
    int st = s.length() / max(start(), finish());
    vector<int> d = diviser(g);
    sort(d.begin(), d.end(), greater<int>());
    int ans = 1;
    for(int i = 0; i < d.size(); i++)
    {
        int y = d[i];
        if(y > st)
            continue;
        vector<int> used(alp);
        bool fit = true, finish = false;
        for(int i = 0; i < alp; i++)
        {
            if(a[i] && a[i] / y == 0)
            {
                finish = true;
                break;
            }
            if(a[i] % y)
            {
                fit = false;
                break;
            }
            used[i] = a[i] / y;
        }
        if(finish)
            break;
        if(fit == false)
            continue;
        ans = max(ans, check(used, s.length() / y));
        if(ans > 1)
            break;
    }
    cout << ans << endl;
}
