#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse2,ssse3,sse4,avx,abm,mmx,tune=native")



#include<bits/stdc++.h>
#define endl '\n'
#define int long long
using namespace std;
void solve();
signed main(){

    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    solve();

    return 0;
}

struct point{
    int x, y;
    point (int xx = 0, int yy = 0) {x = xx, y = yy;}
};
ostream& operator <<(ostream& out, const point& a){
    out << a.x << ' ' << a.y;
    return out;
}
istream & operator >>(istream& in, point& a){
    in >> a.x >> a.y;
    return in;
}



struct line{
    int a, b, c;
    line(const point& p, const point& q){
        a = p.y - q.y;
        b = q.x - p.x;
        c = -a * p.x - b * p.y;
        int g = __gcd(a, __gcd(b, c));
        a /= g, b /= g, c /= g;
    }
};
int det (int a, int b, int c, int d) {
    return a * d - b * c;
}
bool intersect (line m, line n, point & res) {
    int  zn = det (m.a, m.b, n.a, n.b);
    if (zn == 0 ||  det (m.c, m.b, n.c, n.b) % zn != 0 || det (m.a, m.c, n.a, n.c) % zn != 0)
        return false;
    res.x = - det (m.c, m.b, n.c, n.b) / zn; res.y = - det (m.a, m.c, n.a, n.c) / zn;
    return true;
}


vector<point> points;
int n;

bool check(point moon){
    for (auto i : points)
        if (i.x == moon.x && i.y == moon.y)
            return false;
    return true;
}

void solve(){
    cin >> n; n *= 2; points.resize(n);
    for (int i = 0; i < n; ++i) cin >> points[i];
    point moon;
    for (int i = 2; i < n; ++i)
        for (int j = i + 1; j < n; ++j){
            if (intersect(line(points[i], points[j]), line(points[0], points[1]), moon) && check(moon)){
                cout << "Yes" << endl;
                cout << moon;
                exit(0);
            }
        }
    for (int i = 2; i < n; ++i)
        for (int j = 2; j < n; ++j){
            if (i != j && intersect(line(points[i], points[0]), line(points[j], points[1]), moon) && check(moon)){
                cout << "Yes" << endl;
                cout << moon;
                exit(0);
            }
        }
    cout << "No";
}











































