#include <bits/stdc++.h>

using namespace std;

struct Point
{
    int x, y;

    Point(){}
    Point(int _x, int _y) : x(_x), y(_y){}
};

struct Vect
{
    int x, y;

    Vect(){}
    Vect(int _x, int _y) : x(_x), y(_y){}
    Vect(Point a, Point b) : x(b.x - a.x), y(b.y - a.y){}

    int operator %(Vect v)
    {
        return x * v.y - y * v.x;
    }

    Vect operator -(Vect v)
    {
        return {x - v.x, y - v.y};
    }

    Vect operator +(Vect v)
    {
        return {x + v.x, y + v.y};
    }

    Vect operator *(int k)
    {
        return {x * k, y * k};
    }
};

struct line
{
    Vect p, d;
    ///int k;

    line(){}
    line(Point a, Point b)
    {
        p.x = a.x;
        p.y = a.y;
        d.x = b.x - a.x;
        d.y = b.y - a.y;
    }
};

int main()
{
    int n;
    cin >> n;
    n *= 2;
    vector <Point> pts(n, {0, 0});
    for (int i = 0; i < n; i++)
    {
        cin >> pts[i].x >> pts[i].y;
    }

    Point a = pts[0], b, c, d;

    for (int bi = 1; bi < n; bi++) /// pair for first_point - ind = 0
    {
        int ci = 1;
        b = pts[bi];
        for (; ci < n; ci++)
        {
            if (ci != bi)
            {
                c = pts[ci];
                break;
            }
        }

        for (int di = 1; di < n; di++)
        {
            if (di != bi && di != ci)
            {
                d = pts[di];
                line m(a, b);
                line n(c, d);
                if (m.d % n.d != 0)
                {
                    int f_part = ((m.p - n.p) % m.d), s_part = (n.d % m.d);
                    if ((((m.p - n.p) % m.d) * n.d.x) % (n.d % m.d) == 0 && (((m.p - n.p) % m.d) * n.d.y) % (n.d % m.d) == 0){
                        int kx = (n.d.x * ((m.p - n.p) % m.d)) / (n.d % m.d);
                        int ky = (n.d.y * ((m.p - n.p) % m.d)) / (n.d % m.d);
                        Point K({n.p.x + kx, n.p.y + ky});
                        cout << "Yes\n";
                        cout << K.x << " " << K.y << "\n";
                        return 0;
                    }
                }
                ///do our alg
            }
        }
    }

    cout << "No";
}
