#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define F first
#define S second

ostream & operator << (ostream & out, vector < int > & lst) {
    for (auto a : lst)
        out << a << ' ';
    return out;
}

typedef long long ll;
typedef pair < int, int > pii;

const int N = 2e3 + 5, inf = 1e9;
vector < int > lst[N];
int ans = 0;
bool dp[N][N];

int dfs (int v) {
    int res = 0;
    vector < int > heh;
    for (int i = 0; i < lst[v].size(); ++i) {
        int u = lst[v][i];
        int m = dfs(u);
        res += m;
        heh.pb(m);
    }
    int m = heh.size();
    for (int i = 1; i <= m; ++i) {
        dp[i][heh[i - 1]] = 1;
        for (int j = 0; j <= res; j++) {
            dp[i][j] = max(dp[i][j], dp[i - 1][j]);
            if (j >= heh[i - 1])
                dp[i][j] = max(dp[i][j], dp[i - 1][j - heh[i - 1]]);
        }
    }
    int p = inf;
    for (int i = 0; i <= res / 2; ++i) {
        if (dp[m][i]) {
            if (i + abs(res - 2 * i) < p) {
                p = i + abs(res - 2 * i);
            }
        }
    }
    if (p == inf) p = 0;
    ans += p;
    for (int i = 1; i <= m; ++i) {
        for (int j = 0; j <= res; j++)
            dp[i][j] = 0;
    }

    return res + 1;
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
            int x;
        cin >> x;
        lst[x - 1].pb(i);
    }
    dfs(0);
    cout << ans * 2;
    return 0;
}

