#include <bits/stdc++.h>
using namespace std;

#define int long long

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define mp make_pair
#define pb push_back
#define f first
#define s second
#define all(x) x.begin(), x.end()

int n;
vector<pii> a;
set<pii> all;
ll MAX = 10000000;

struct line {
	ll a, b, c;
};

bool operator<(const line &a, const line &b) {
	if (a.a == b.a) {
		if (a.b == b.b) return a.c < b.c;
		return a.b < b.b;
	}
	return a.a < b.a;
}

line get_line(pii a, pii b) {
	line res;
	res.a = b.s - a.s;
	res.b = a.f - b.f;
	res.c = a.s * b.f - a.f * b.s;
	// int amp = INT_MIN;
	// res.a *= amp;
	// res.b *= amp;
	// res.c *= amp;
	if (res.a == 0 && res.b == 0 && res.c == 0) return res;
	int amp = __gcd(abs(res.a), __gcd(abs(res.b), abs(res.c)));
	res.a /= amp;
	res.b /= amp;
	res.c /= amp;
	if (res.a < 0) {
		res.a *= -1;
		res.b *= -1;
		res.c *= -1;
	}
	return res;
}

pii line_inter(line a, line b) {
	// p / q
	ll q = a.b * b.a - b.b * a.a;
	if (q == 0) return {INT_MAX, INT_MAX};
	ll p = b.c * a.a - a.c * b.a;
	ll y = p / q;
	if (y > MAX) return {INT_MAX, INT_MAX};
	if (y * q != p) return {INT_MAX, INT_MAX};

	p = -(a.b * y + a.c);
	q = a.a;

	if (q == 0) return {y, y};
	ll x = p / q;
	if (abs(x) > MAX) return {INT_MAX, INT_MAX};
	if (x * q != p) return {INT_MAX, INT_MAX};
	return {x, y};
}

void solve() {
	auto l1 = get_line(a[0], a[1]);
	auto l2 = get_line(a[2], a[3]);

	if (l1.a == l2.a && l1.b == l2.b && l1.c == l2.c) {
		return;
	}

	auto moon = line_inter(l1, l2);
	if (abs(moon.f) > MAX || abs(moon.s) > MAX) return;

	rep(i, 4) {
		if (moon == a[i]) return;
	}

	cout << "Yes" << endl;
	cout << moon.f << ' ' << moon.s << endl;
	exit(0);
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	cin >> n;
	a.resize(n * 2);
	rep(i, n * 2) {
		cin >> a[i].f >> a[i].s;
		all.insert(a[i]);
	}

	sort(all(a));
	do {
		solve();
	} while (next_permutation(all(a)));


	cout << "No" << endl;
	return 0;


	// auto l1 = get_line(a[0], a[1]);
	// auto l2 = get_line(a[2], a[3]);
	// cout << l1.a << "x + " << l1.b << "y + " << l1.c << " = 0" << endl;
	// cout << l2.a << "x + " << l2.b << "y + " << l2.c << " = 0" << endl;
	// auto p = line_inter(l1, l2);
	// cout << p.f << ' ' << p.s << endl;
}