#define CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF=1e9+9;
const int MAXN=5e6+7;
const int MX=1e6;

void solve();

#define _DEBUG

int main() {
    srand('a'+'l'+'e'+'x'+'X'+'5'+'1'+'2');
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG
    solve();
}

/*----------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------*/

vector<unordered_map<char, int>> vec(4*MAXN);
string s;

void build(int vert, int l, int r){
    if(l==r){
        vec[vert][s[l]]=1;
		return;
    }
    int m=(l+r)/2;
    build(vert*2, l, m);
    build(vert*2+1,m+1,r);
    for(auto it=vec[vert*2].begin();it!=vec[vert*2].end();it++){
        vec[vert][(*it).first]+=(*it).second;
    }
    for(auto it=vec[vert*2+1].begin();it!=vec[vert*2+1].end();it++){
        vec[vert][(*it).first]+=(*it).second;
    }
}

unordered_map<char, int> get(int vert, int tl, int tr, int l, int r){
    if(l>r){
        unordered_map<char,int> m;
        return m;
    }
    if(tl==l && tr==r){
        return vec[vert];
    }
    int tm=(tl+tr)/2;
    unordered_map<char,int> m1=get(vert*2, tl, tm, l, min(r, tm)), m2=get(vert*2+1, tm+1,tr,max(l, tm+1), r);
    if(m1.size()<m2.size()){
        for(auto it=m1.begin();it!=m1.end();it++){
            m2[(*it).first]+=(*it).second;
        }
        return m2;
    }
    for(auto it=m2.begin();it!=m2.end();it++){
        m1[(*it).first]+=(*it).second;
    }
    return m1;
}

bool correct(int &n){
    unordered_map<char, int> v=get(1,0, s.size()-1, 0,n-1);
    for(int i=n;i<s.size();i+=n){
        unordered_map<char, int> v1=get(1,0, s.size()-1, i,i+n-1);
        if(v1!=v) return 0;
    }
    return 1;
}

void solve(){
    cin>>s;
    int n=s.size();
    build(1, 0, n-1);
    vector<int> ans;
    for(int i=1;i*i<=n;i++){
        if(n%i==0){
            ans.emplace_back(i);
            if(n/i!=i){
                ans.emplace_back(n/i);
            }
        }
    }
    sort(ans.begin(),ans.end());
    for(int i=0;i<ans.size();i++){
        if(correct( ans[i])){
            cout<<n/ans[i];
            return;
        }
    }
}

























