#define CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF=1e9+9;
const int MAXN=1e5+7;
const int MX=1e6;

void solve();

#define _DEBUG

int main() {
    srand('a'+'l'+'e'+'x'+'X'+'5'+'1'+'2');
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG
    solve();
}

/*----------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------*/


ll gcd(ll a, ll b){
    return a==0 ? b:gcd(b%a, a);
}

struct line{
    ll a,b,c;
    line(pair<ll,ll> p1, pair<ll,ll> p2){
        a=p2.second-p1.second;
        b=p1.first-p2.first;
        c=-a*p1.first-b*p1.second;
        int gc=gcd(gcd(abs(a),abs(b)),abs(c));
        a/=gc;
        b/=gc;
        c/=gc;
		if(a<0){
			b*=-1;
			c*=-1;
			a*=-1;
		}
		if(a==0 && b<0){
			b*=-1;
			c*=-1;
		}
    }
};

pair<ll,ll> per(line &a, line &b){
    if(a.a==b.a && a.b==b.b){
        return mp(INF, INF);
    }
    ll y=(a.a*b.c-b.a*a.c)/(b.a*a.b-a.a*b.b);
    if((a.a*b.c-b.a*a.c)%(b.a*a.b-a.a*b.b)!=0){
        return mp(INF,INF);
    }
    ll x=(a.b*b.c-b.b*a.c)/(b.b*a.a-a.b*b.a);
    if((a.b*b.c-b.b*a.c)%(b.b*a.a-a.b*b.a)!=0){
        return mp(INF, INF);
    }
    return mp(x, y);
}

bool correct(ll x, ll y){
    return x<=MX && x>=-MX && y<=MX && y>=-MX;
}

void solve(){
    int n;
    cin>>n;
    vector<pair<ll,ll>> v;
    for(int i=0;i<2*n;i++){
        ll x,y;
        cin>>x>>y;
        v.emplace_back(mp(x,y));
    }
    for(int i=0;i<2*n;i++){
        for(int j=i+1;j<2*n;j++){
            line a(v[i],v[j]);
            for(int k=0;k<2*n;k++){
                if(clock()>4999000) break;
				if(k==i || k==j) continue;
                for(int t=k+1;t<2*n;t++){
                    if(t==k || t==i || t==j) continue;
                    line b(v[k],v[t]);
                    pair<ll,ll> vert=per(a,b);
                    if(correct(vert.first, vert.second)){
                        map<pair<ll,pair<ll,ll>>, int> m;
                        bool b1=1;
                        for(int q=0;q<2*n && b1;q++){
							if(vert==v[q]){
								b1=0;
								break;
							}
                            line k(vert, v[q]);
                            m[mp(k.a,mp(k.b,k.c))]++;
                            if(m[mp(k.a,mp(k.b,k.c))]==3){
                                b1=0;
                            }
                        }
                        if(b1 && m.size()==n){
                            cout<<"Yes\n";
                            cout<<vert.first<<" "<<vert.second;
                            return;
                        }
                    }
                }
                break;
            }
        }
        break;
    }
    cout<<"No";
}























