#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define all(x) x.begin(), x.end()

signed main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	vector <int> A(n * 2);
	for (int i = 1; i <= n; i++)
	{
		A[i * 2 - 1] = i;
	}
	vector <int> emp;
	int sz = n * 2;
	for (int i = 1; i < sz; i++)
	{
		if (A[i] == 0)
			emp.push_back(i);
	}
	for (int i = sz - 1; i >= 1 && emp.size() > 0; i--)
	{
		int now = emp[emp.size() - 1];
		emp.pop_back();
		A[now] = A[i];
	}
	vector <int> Answers(n + 1);
	for (int i = 1; i <= n; i++)
	{
		Answers[A[i]] = i;
	}
	for (int j = 0; j < q; j++)
	{
		int x;
		cin >> x;
		cout << Answers[x]<<endl;
	}
	return 0;
}