#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#define DEBUG

#include <iostream>
#include <vector>
#include <climits>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <string>
#include <cmath>

using namespace std;

#define int long long

struct point {
	int x, y;
};

struct line {
	line(point p1, point p2) {
		a = p2.y - p1.y;
		b = p1.x - p2.x;
		c = -p2.y * p1.x + p2.x * p1.y;
	}
	bool online(point p) {
		return a * p.x + b * p.y + c == 0;
	}
	int a, b, c;
};

signed main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
#ifdef DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	n *= 2;
	vector<point> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].x >> a[i].y;

	for (int i = 0; i < n; i++)
		for(int j = 0; j < n; j++) 
			if (i != j) {
				line l1(a[i], a[j]);
				for (int l = 0; l < n; l++)
					if (l != i && l != j)
						for (int r = 0; r < n; r++) 
							if (r != l && r != i && r != j) {
								line l2(a[l], a[r]);

								if (l1.a * l2.b != l1.b * l2.a) {
									point p;
									if ((l2.b - l1.a - l2.a * l1.b) != 0 && l1.a != 0) {
										p.y = (l2.a * l1.c - l1.a * l2.c) / (l2.b * l1.a - l2.a * l1.b);
										p.x = -(l1.b * p.y + l1.c) / l1.a;
										bool can = abs(p.x) <= 1000000 && abs(p.y) <= 1000000;
										for (int k = 0; k < n && can; k++)
											can &= p.x != a[k].x || p.y != a[k].y;

										if (can && l1.online(p) && l2.online(p)) {
											cout << "Yes" << '\n' << p.x << ' ' << p.y;
											return 0;
										}
									}
								}
							}
			}
	cout << "No";
}
