#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <stack>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Inf = 1e9;
const double eps = 1e-9;
const ll Linf = 2e18;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    ll n;
    int q;
    cin >> n >> q;
    for (int i = 0; i < q; ++i) {
        int x;
        cin >> x;
        --x;
        if (x % 2 == 0) {
            cout << x / 2 + 1 << endl;
            continue;
        }
        ll free = 0;
        ll cur_pos = n + x / 2;
        free += x / 2 + 1;
        while (cur_pos % 2 != 0) {
            ll delta = cur_pos / 2 - free + 1;
            cur_pos += delta;
            free += delta;
        }
        cout << cur_pos / 2 + 1 << endl;
    }
}
