#define _CRT_SECURE_NO_WARNINGS
#define REL

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>
#include <queue>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)1e6 + 7;
const int INF = (int)2e9;

typedef long long LL;

using namespace std;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	/*int n; 
	while (cin >> n) {
	vector <int> v(1000, 0);
		for (int i = 1; i <= n; i++) {
			v[2 * i - 1] = i;
		}
		for (int i = 999; i > 0; i--) {
			if (v[i] == 0)
				continue;
			for (int j = i; j > 0; j--)
				if (v[j] == 0) {
					swap(v[i], v[j]);
					break;
				}
		}
		for (int i = 1; i <= n; i++)
			cout << v[i] << ' ';
		cout << endl;
	}*/
	int n, q;
	cin >> n >> q;
	vector <int> v(N);
	for (int i = 1; i <= n; i++) {
		v[2 * i - 1] = i;
	}
	vector <int> em;
	for (int i = 1; i <= 2 * n - 1; i++)
		if (v[i] == 0)
			em.push_back(i);
	for (int i = 2 * n - 1; i > 0 && !em.empty(); i--) {
		swap(v[i], v[em.back()]);
		em.pop_back();
	}
	while (q--) {
		int p; cin >> p;
		cout << v[p] << endl;
	}
}